 






///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////// startup
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////// global variables


var myownurl = function(){
	var url = window.location.href.split('?')[0];
	if (url[url.length-1] == '#')
	   url = url.substring(0,url.length-1);

	return url;
}


var logProcess = function(obj) {
	console.log(obj);
}


var TableHidden = false;

var pakoWorker = true;
var electron = false;
var application; 


var currentPSID = {};
var all_patients = [];

var all_studies = [];

var tempObjectInfo = undefined;
var guestuser = static_info.guestuser;
var projectInfo = {};
var currentModule;
var updatePatientTimerID;

var usercmdlist;
var ViewerSettings;

var storage;
var state = {};
var firstTimeProjectLoad = true;  // only true on startup (F5, login)
var visitedProjects = {};

var time_out;
var standardToolsize = 300;
var hasProxy = (typeof Proxy != "undefined");
var project_user_delim  = "___";

var taglist = {ptags:{}, stags:{}, ftags:{}}; 

var markerProxy;

var isMobile =  detectmob();


var $body = $(document.body);

var ktagpanel;


var ProjectSettingsDefault = 
{
 updateInterval: 60000,
 autoexec: -1
}

if (typeof ProjectSettings === "undefined")
{
	ProjectSettings = ProjectSettingsDefault;

}


KViewer = undefined;


/// notify additional classes
if ($.notify)
{
	$.notify.addStyle('DPX', 
	{
	  html: "<div><span data-notify-text/></div>",
	});
	$.notify.addStyle('DPXMORE', 
	{
	  html: "<div><span data-notify-text/></div>",
	});
}


function startupKView()
{

	////////////// global signalhandler
	signalhandler = new SignalHandler();

	colormap = new KColormap();





	/// settings handling
	presetManager	   	 = new PresetManager();
	stateManager	   = new StateManager();


	////// init the global "state" variable, so KViewer can be created. 
	// this is probably necessary for standalone version only
	stateManager.setDefaultState(); 



	/////////////// sticky header handler


	mirrors = {s: new proto_tableMirror_handler(),
		  	  a:new proto_tableMirror_handler(),
		  	  p:new proto_tableMirror_handler(),
		  	  f:new proto_tableMirror_handler()  };

	patientTableMirror = mirrors[state.viewer.selectionMode[1]];


	if (typeof(fileSelectionFromWC) != "undefined")
	   patientTableMirror.filesSelected.objs = 	fileSelectionFromWC;



	signalhandler.attach("patientTableWidthChanged", function(){autoExpandOneColumn('#patientTableWrap', 2 ,160)} );

	signalhandler.attach('close',function()
	{
		if (typeof loadingQueue != "undefined")
		{
	/*		for (var k = 0; k < loadingQueue.running_queues.length;k++)
			{
				loadingQueue.running_queues[k].disqualified=true;
				console.log('set' + " " +loadingQueue.running_queues[k].id)
			}*/
		}
	})


	////////////// the Viewer
	KViewer = new KView();


	//////////// batchtool
	commandDialog = undefined;


	/////////// Plugins
	pluginList = new Array();

	if(static_info.cfg)
	{
		var cfg = static_info.cfg;
		if(cfg.plugins)
		{
			pList= Object.getOwnPropertyNames(cfg.plugins);
			for(var k=0;k<pList.length;k++)
			{
				pluginList.push( new CAD_uploadPatient(cfg.plugins[pList[k]] ));
			}
		}
	}



	//////////// initial layout
	$("#patientTable").on("contextmenu", patientTableContextMenu);
	setSizes();
	$("#patientTable").width($(document.body).width()*ViewerSettings.sizeTablePercent/100);
	$("#patientTableInnerContainer").width($(document.body).width()*ViewerSettings.sizeTablePercent/100);

}


// layout for local use
if ((moduleList.length == 0  ) |
    (userinfo.username==guestuser && currentModule == "") |
    (userinfo.username==guestuser && !(static_info.public_projects != undefined ) ))
{
    startupKView();

	$('#thetable').hide();
	$('#patientTableEditMode').hide();
	

	KViewer.cacheManager.toggle();
	KViewer.cacheManager.$container.find(".fa-hand-paper-o,.fa-arrows-v,.fa-close,.fa-bars,.fa-window-restore").hide();


 	var pt = $('#patientTableContainer');
    pt.children().width(pt.width());
	ktoolslist[0].resize(pt.height()); //ktoolslist[0].$container.height());

	// only enable local storage for sharedLink
	if( sharedLink !=undefined )
		state.project_user.localstoragesizeMB = 1000;
	
	KViewer.applyState(); 


	finalize_startup();


}
// layout for server use
else
{

	if( currentModule == undefined |  currentModule === 'none'  |  currentModule === ''   ) 
			currentModule = moduleList[0];
	
	var found = false;
	for (var k = 0; k < moduleList.length;k++)
	{
		if (currentModule == moduleList[k])
		{
			found = true;
			break;
		}
	}
	if (!found)
	{
		alertify.error("Project "+ currentModule + " not accessible!");
		setTimeout(function() {
			var url = window.location.href;
			url = url.substring(0,url.search("\\?"))		
			location.replace(url+"?logout&project="+currentModule+"&failed" );
		},3000);

		//currentModule = moduleList[0];		
	}
	else
	{


		setTimeout(function()
		{
			console.time("KView startup");
			startupKView();
			ktoolslist[0].resize(standardToolsize);


			KViewer.initialized = true;
			console.timeEnd("KView startup");

		},0);


		selectProject(currentModule,function()
		{

			patientTableMirror.mirrorState();

			currentJobs = {jobs:{},patients:{}};
			getGridStats(setPatientTableLayout);


			//stickTableHandler =  proto_tableSticky_handler('patientTable');

			$("#patientTableTopTools").css('display','block');
			$(".stickytable").css("visibility","visible");


			finalize_startup();
		})
	}

}


function finalize_startup()
{
    //state.viewer.levelMode = true;
	run_startup_macros()

	if (ViewerSettings.pixelated)
		KViewer.$pixelated.addClass("KView_tool_enabled");
	else
		KViewer.$pixelated.removeClass("KView_tool_enabled");
    if (typeof NORA_SOFTWAREVERSION != "undefined")
    {
    	console.log("NORA version: " + NORA_SOFTWAREVERSION)
    }
	var donot_hide_loadingframe = false;

	allocateLocalstorage(function() {

		function onready()
		{	

			if (typeof extern_call == "object")
			{
				    donot_hide_loadingframe=true;
					executeExternalCall();
			}
					
			if (sharedLink)
			{
			  loadScriptsLazy(function(){
				if( markerProxy == undefined)
					markerProxy = new KMarkerProxy();

				openSharedLink(sharedLink,function(){
					if (!donot_hide_loadingframe)
						$("#KLoadingFrame").css('display','none');
				    if (sharedLink.tour != undefined)
				    {
				    	eval('var x=' + sharedLink.tour);
						startTour(x);
				    }
				

					});
			   })
			}
			else
			{
				if (typeof sharedLinkInvalid != "undefined")
				{
				    $(".sharedLinkLeave").hide();
				    alertify.error("shared link invalid")
				}
				if (!donot_hide_loadingframe)
					$("#KLoadingFrame").css('display','none');
				// load remaining scripts
				loadScriptsLazy(function(){
						if( markerProxy == undefined)
					    	markerProxy = new KMarkerProxy();

				})
			}


			/// init status bar
			updateStatusBar();

		
			if (state.viewer.sizeTablePercent == 0)
			{
			   $("#patientTableTopTools").hide();
			   TableHidden = true;
			}


			// init dialogs
			setTimeout(function() {
				userSettingsDialog	 = new UserSettingsDialog();
				settingsDialog 		 = new SettingsDialog(); 
				authDialog           = new AuthDialog();
            
                if (typeof firstProjectLoad != "undefined")
                {
                	if (firstProjectLoad)
                	{
						settingsDialog.dialog.toggle();
						settingsDialog.selectDialog('projectManagement',"clin_info");        		                		
                	}
                }

			},0);
		} 

		onready();


	});

}

if (!electron_phpserved)
{
  $(window).bind("unload beforeunload",
	function(ev)
	{
		//This function is called automatically on F5 /page reload and will automatically ask the user whether he is sure to leave the page.
		//If we return it before end of function, this dialog does NOT pop up!! (At least in chrome)


		if(userinfo.username == guestuser ) // | projectInfo.rights.readonly == "on" | projectInfo.rights.readonly === false)
			return; 

		// this is done intrinsically in the saveCurrentState
		//presetManager.saveAllPresets() ;
		
		stateManager.saveCurrentState(); 

		var cmdChanges = (typeof commandDialog != "undefined" && commandDialog.isModified && commandDialog.isModified())

		if (!cmdChanges && (typeof dontAskforunload !== "undefined" | isDeveloperMode))		
			return;			

	
		// do not save user settings
		//userSettingsDialog.saveChanges();
		
		if(!location.link_was_clicked)
			return "You are trying to reload the page. Sometimes this is necessary to get the newest code. However, this will reset your view.";
		else
			delete location.link_was_clicked;
			
	}
  ); 

}

function run_startup_macros()
{
	// run startup macros and customscripts
	if(static_info.startup_macros != undefined)
		for(var k=0; k<static_info.startup_macros.length; k++)
			run_macro( static_info.startup_macros[k]);
}


window.onload = function()
{
	$('body').attr('oncontextmenu','return false;')
	$(document.body).on('drop',function(e) { e.preventDefault() });
	$(".KView_DIVCell").on('drop',function(e) {
	e.preventDefault() 

});
}


addKeyboardShortcuts()


/***************************************************************************************
*  global drag and drop indicators / handlers for local file drop
***************************************************************************************/

$body.on('dragenter', body_dragenter)
$body.on('dragleave', body_dragleave)

function body_dragenter(ev)
{
	// only react on drag of local files/folders, not from inside window
	if( $.inArray('Files', ev.originalEvent.dataTransfer.types) === -1 ) // firefox ...types is array
		{ev.preventDefault(); 	ev.stopPropagation();     return false;}

	if( $('.body_dropindicator').length > 0)
		return false;

    if (typeof ongoing_study_patient_creation != "undefined" && ongoing_study_patient_creation==true)
        return;
	
	var $div = $("<div class='body_dropindicator dropindicator_general_vert'></div>");
	$div.position({left:0, top:0})
	$div.css("pointer-events",'none');
	$div.height(window.innerHeight);
	var w = $('#patientTableContainer').width() ;
	if(w < 400)
		w = 400;
	$div.width(w)

	$div.appendTo($body);

	var $inner = ($("<div class=''>Drop local Files/Folders here or into a viewport to load. <br><br> Supported types:<br> nifti, dicom, bruker, mgh, mgz, jpeg, bruker, tck, trk, gifti, stl, json <br><br><br> </div>"))
	$inner.css("pointer-events",'all');
	var $close = $("<span class='' style='pointer-events:all;cursor:pointer;position:absolute;top:20px;right:10px;background:red;padding:10px;border-radius:8px'><i class='fa fa-close'></i> close</span>")
		.click(function(){cleanAllDropIndicators()});
	$inner.append($close);
	$div.append($inner);
	

    $div.on("dragenter dragleave dragover", function(ev) {
        ev.preventDefault();
        ev.stopPropagation();
        return false;
    });
    
    $div.on("drop", function(ev) {
        //cleanAllDropIndicators();
        KViewer.cacheManager.show();
        KViewer.cacheManager.handleDrop(ev);
        cleanAllDropIndicators();
        $inner.off('drop');
        return false;
    });
	
	
	ev.preventDefault(); 	
	ev.stopPropagation();     
	return false;
}

function body_dragleave(ev, force)
{
	//console.log(ev);
	// only react on drag of local files, not from inside window
	if( $.inArray('Files', ev.originalEvent.dataTransfer.types) === -1 ) // firefox ...types is array
		{ev.preventDefault(); 	ev.stopPropagation();     return false;}
	
	// really left? 
	// chrome: clientX = 0 
	// firefox ev.relatedTarget = null
 	if(ev.originalEvent.clientX == 0 || force)
 	{
 		cleanAllDropIndicators();
	} 
	ev.preventDefault(); 	
	ev.stopPropagation();     
	return false;
}



var last_reported_error_time=0;
var numerrors = 0;
window.onerror = function(arg1,arg2,arg3,arg4,arg5)
{
	if (!isDeveloperMode)
	{
		numerrors++;
		if (typeof static_info == "undefined")
		{
			reporterror();
			return;
		}

		if ((static_info && static_info.error_reporting))
		{
			reporterror();
			return;
		}
	}
	
    function reporterror()
    {
    	var t = new Date();
		if (t.getTime()-last_reported_error_time > 5000) // don't allow too high frequency
		{ 
			last_reported_error_time = t.getTime();
			var err = {time:t.toGMTString(),numerror:numerrors,arg1:arg1,arg2:arg2,arg3:arg3,arg4:arg4,arg5:arg5};
			err = JSON.stringify(err);
			if (err.length > 250)
			{
				console.log(err);
				if (userinfo.isadmin == "1")
   		            alertify.error("js error happend, but not reported")
			}
			else
			{
				if (userinfo.isadmin == "1")				
   		            alertify.error("js error happend")
			    ajaxRequest('command=report_js_error&json=' + err , function() {   } );
			}
		}
    }
}










function loadScript(src,done) {
    var url_pref =  ""

    if (src.length > 0)
    {
         var head = document.getElementsByTagName('head')[0];
        var s;
        if (src[0].search("\\.css")> -1)
        {
            s = document.createElement('link');
            s.type = "text/css";
            s.rel = "stylesheet";
            s.href = url_pref + src[0];
        }
        else
        {
            s = document.createElement('script');                        
            s.type = "text/javascript";
            s.src = url_pref + src[0];
        }
        head.appendChild(s);
        s.onload = function() {
            loadScript(src.splice(1),done);
        }        
    }
    else
        done()
}


function loadScriptsConcurrently(src,done)
{
    var ready = [];
    var url_pref = "";
    for (var k = 0; k < src.length;k++)
    {    
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url_pref + src[k] , true);
        xhr.onload = function(k) { return function()
        {
            ready[k] = this.responseText;
            more();

        } }(k);
        xhr.send();
    }
    function more()
    {
            for (var k = 0; k < src.length;k++)
            {
                if (!ready[k])
                    return;
            }

            var css = "";
            var js = "";

            for (var k = 0; k < src.length;k++)
            {
                if (src[k].search("\\.css")> -1)
                   css += ready[k] + "   ";
                else
                    js += ready[k] + " \n  ";
            }
            var s = document.createElement('style');
            var head = document.getElementsByTagName('head')[0];
            s.type = "text/css";
            s.innerHTML= css
            head.appendChild(s);

            var s = document.createElement('script');                        
            s.type = "text/javascript";
            s.text = "function KView_standalone($parent,callback) {" + js + "}";
            s.text = js
            head.appendChild(s);
            done();
    }

}

function KRoiTool() { }
KRoiTool.notyetloaded = true;
function KObject3DTool() { }
KObject3DTool.notyetloaded = true;
function KNavigationTool() { }
KNavigationTool.notyetloaded = true;
function KAtlasTool() { }
KAtlasTool.notyetloaded = true;
function KMedImgCurve() { }
KMedImgCurve.notyetloaded = true;
function KMarkerTool() { }
KMarkerTool.notyetloaded = true;

function loadScriptsLazy(callback)
{


   

    var scripts = [
		"KTools/KRoiTool.js",
		"KTools/KObject3DTool.js",
		"KTools/KAnnotationTool.js",
		"KTools/KNavigationTool.js",
		"KTools/KAtlasTool.js",
		"KView/KMedImgCurve.js",
		"KTools/DBSsimulation.js",
		"dicom/daikon.js",
		"html2canvas.js",
		"sparc.js",
		"balloons.js",
	//	"q.js",
		"gif.js",
		"dicom/dicomweb/dicomweb-client.js",
		"KView/WMQL/KWMQLPanel.js",
		"KView/WMQL/WMQLparser.js",
		"KView/WMQL/KWMQLquery.js",
		"imgproc/kissFFT.js",
		"imgproc/kissFFT_main.js",
		"zip/zip.js",
		"zip/inflate.js",
		"zip/z-worker.js",
		"dicom/dicomReader.js",
		"bruker2nifti.js",
		"dcmnode.js",
		"pacsquery.js",

		]
	for (var k = 0; k < scripts.length;k++) 
		scripts[k] = scripts[k] + "?" + static_info.softwareversion;

	var debug = true //isDeveloperMode;
	var loader = debug?loadScript:loadScriptsConcurrently;

	loader(scripts,function()
	{
		if (callback)
			callback();
	});

}


window.addEventListener("load", () => {
  if ("serviceWorker" in navigator) {
    navigator.serviceWorker.register("pwa-service-worker.js");
  }
});

