<?php


// merge get and post array to $_GET only. Convenience
if(sizeof($_POST)>0) {   $_GET = array_merge($_GET,$_POST);}

$out['success'] = false;
$out['msg'] = "No action request in dcmnode.php";


require_once('settings.php');
require_once('mydbconnection.php');


if(isset($_GET['startAgent']))
    $out = dcmnode_startAgent($_GET['options']);

if(isset($_GET['stopAgent']))
  $out = dcmnode_stopAgent($_GET['processid']);

if(isset($_GET['listAgents']))
  $out = dcmnode_listAgents();

if(isset($_GET['addEntry']))
    $out = dcmnode_addEntry($_GET['json']);

echo json_encode($out);




function dcmnode_startAgent($opt)
{
  $opt['outdir'] = '/DPS/KModules/KStroke/data_temp_storescp';
  $opt['timeout'] = 10;
  $opt['port'] = 1110;
  $opt['caller'] = 1110;


  $cmd = "storescp -v -d -uf -fe .dcm --sort-on-patientname --output-directory " . $opt['outdir'] . "  --exec-on-eostudy 'touch #p.dps'  --eostudy-timeout " . $opt['timeout'] . " " .  $opt['port'] ;
  $msg = shell_exec( 'nohup '.escapeshellcmd( $cmd ) .' > /dev/null & echo $!' );

  return true;
}

function dcmnode_stopAgent($pid)
{
  $msg = shell_exec( 'kill ' . $pid );
}

function dcmnode_addEntry($jsonString)
{

  $db = mydbconnection(ROOTDB);
  $jsonString = $db->real_escape_string($jsonString);

  $query = "INSERT INTO system (type, json) VALUES ('dcmnode', '" . $jsonString. "')  ";
  $a = mysqli_query($db, $query);// or die(mysqli_error($db));;
  if(!$a)
  {
    $out['msg'] = mysqli_error($db);
    $out['success'] = false;
  }
  else
  {
    $out['success'] = true;
  }
  $db->close();
  return $out;
}


function dcmnode_listAgents()
{

  $prototype = Array(  'pid'=>'','user'=>'', 'AETitle'=>'', 'port'=>'', 'outpath'=>'', 'timeout'=>'', 'autoexec'=>'', 'state'=>0);
  $editableElems  = Array( 'AETitle', 'outpath', 'port', 'timeout', 'autoexec');
  $list = Array();
  $db = mydbconnection(ROOTDB);
  $a = mysqli_query($db, "select * from system ");// or die(mysqli_error($db));;
  $db->close();

  if($a!==false)
  {
    $list = array();
    while($row = $a->fetch_assoc())
    {
      $e = json_decode($row['json'], true);
      $list[] = array_extend_first($prototype, $e );
    }
  }
//  var_dump($list);
//  echo "<br />";
//  echo "<br />";





  $msg = shell_exec('ps -aef | grep storescp');
//  echo $msg;
  unset($json);
  $arr = explode("\n", $msg);
  for($k=0; $k<sizeof($arr)-1; $k++)
  {
    $line = $arr[$k];
    if(strpos($line, 'grep') !== false)
     continue;

    $line=preg_replace('/\s+/', ' ', $line); // convert multiple whitepaces to one;
    $vec = explode(' ', $line);
    $out['full_line'] = $line;
    $a = $prototype;
    $a['user'] = $vec[0];
    $a['pid']  =  $vec[1];
    $a['port'] =  $vec[sizeof($vec)-1];
    preg_match('/--output-directory\s([.\S]+)\s--.+/', $line, $match);
    $a['outpath']  = $match[1];
    preg_match('/--eostudy-timeout\s([.\S]+)\s.+/', $line, $match);
    $a['timeout']  = $match[1];
    $a['state'] = 1;

    // check for the list, port is unique identifier
    $found = false;
    foreach($list as $key => $item)
    {
      if($item['port'] == $a['port']) // found this process running
      {
        $list[$key] = array_extend_first($item, $a );
        $found = true;
      }
    }
    if(!$found);
      $list[] = $a;
  }

  $json =  Array();
  $json['editableElems'] = $editableElems;
  $json['list'] = $list;

  $out['json'] = $json;
  $out['success'] = true;
  return $out;
}

function array_extend_first($a1, $a2)
{
  foreach($a1 as $key => $val)
  {
    if(array_key_exists($key,$a2))     $a1[$key] = $a2[$key];
  }
  return $a1;
}


?>
