<?php

// mkdir can throw several errors. Permission errors are important and must be filterd!
// Only abort if no permissions ( error can also occur if file exists)
function mymkdir($targetpath)
{
  if(!@mkdir( $targetpath , 0775,true ) )
  {
    $err = error_get_last();
    if(strpos($err['message'], 'ermission') !== false )
    {
      echo $err['message'] . "NORA_ERROR_SEPARATOR";
      return false;    
    }
  }

  return true;

}


function hashmap($t)
{
	$t = hash('sha1',$t);
	$t = substr($t,0,10);
	return $t;
}

function var_dump_nice($var)
{
  return  '<pre>' . var_export($var, true) . '</pre>';
}

function get_secret()
{
      $secret_command = "";
      try {
        $fi = resolve_Route(DPXROOT . "/conf/.secret");
        if( file_exists($fi)){
			$secret_command=json_decode(file_get_contents($fi));
			$secret_command = $secret_command->command;
        }
      }
      catch (Exception $e)
      {
      }
      return $secret_command;
}


function encrypt_aes($str,$key)
{
  $method = 'AES-256-CBC';
  $length = openssl_cipher_iv_length($method);
  $iv = openssl_random_pseudo_bytes($length);
  $encrypted = openssl_encrypt($str, $method, $key, OPENSSL_RAW_DATA, $iv);
  return base64_encode($encrypted) . '|' . base64_encode($iv);
}


?>