
//var url_pref =  "http://www.nora-imaging.org/nora/"
var url_pref =  ""
var application = "webview"
var electron = false;


var myownurl = function(){
/*	var url = window.location.href.split('?')[0];
	if (url[url.length-1] == '#')
	   url = url.substring(0,url.length-1);
	return url;*/
	return url_pref;
}




var external_scripts = [ "jquery-1.11.2.min.js",
                         "styles_KView.css",
                         "styles_main.css",
                         "font-awesome-4.5.0/css/font-awesome.min.css",
                         "alertify.core.css",
                         "alertify.default.css",
                         "dicom/daikon.js",
                         "dicom/dicomReader.js"
                          ]

var KViewer_scripts = ["KMiscFuns.js","KForms.js","kmath.js",
            "KStateManager.js",
            "KView/KDataManager.js",
            "KView/KViewPort.js",
            "KView/KMedImageViewer.js",
            "KView/KMedImg3D.js",
            "KView/KMiscViewer.js",
            "KView/KTableViewer.js",
            "KView/KMedImgCurve.js",
            "KView/nifti.js",
            "KView/pako.js",
            "alertify.js",
            "notify.js",
            "zip/zip.js",
            "zip/inflate.js",
         //   "zip/z-worker.js",
            "dragster.js",
            "bruker2nifti.js",
            "KTools/DBSsimulation.js",
            "KTools/KTools.js",
            "KTools/KAnnotationTool.js",
            "KTools/KNavigationTool.js",
            "KTools/KRoiTool.js",
            "KTools/KObject3DTool.js",
            "KTools/KCacheManager.js",
            "KTools/KAtlasTool.js",
            "KTableOperator.js",
            "KView/KView.js",
            "standalone_starter.js"]











function loadScript(src,done) {
    if (src.length > 0)
    {
         var head = document.getElementsByTagName('head')[0];
        var s;
        if (src[0].search("\\.css")> -1)
        {
            s = document.createElement('link');
            s.type = "text/css";
            s.rel = "stylesheet";
            s.href = url_pref + src[0];
        }
        else
        {
            s = document.createElement('script');                        
            s.type = "text/javascript";
            s.src = url_pref + src[0];
        }
        head.appendChild(s);
        s.onload = function() {
            loadScript(src.splice(1),done);
        }        
    }
    else
        done()
}


function loadScriptsConcurrently(src,done)
{
    var ready = [];

    for (var k = 0; k < src.length;k++)
    {    
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url_pref + src[k] , true);
        xhr.onload = function(k) { return function()
        {
            ready[k] = this.responseText;
            more();

        } }(k);
        xhr.send();
    }
    function more()
    {
            for (var k = 0; k < src.length;k++)
            {
                if (!ready[k])
                    return;
            }

            var css = "";
            var js = "";

            for (var k = 0; k < src.length;k++)
            {
                if (src[k].search("\\.css")> -1)
                   css += ready[k] + "   ";
                else
                    js += ready[k] + "   ";
            }
            var s = document.createElement('style');
            var head = document.getElementsByTagName('head')[0];
            s.type = "text/css";
            s.innerHTML= css
            head.appendChild(s);

            var s = document.createElement('script');                        
            s.type = "text/javascript";
            s.text = "function KView_standalone($parent,KViewer_init_callback) {" + js + "}";
            head.appendChild(s);
            done();
    }

}



function startKView($noraviews,opts,callback)
{

    // in debug mode ou can have just one viewer per page
    if (opts == undefined)
        opts = {};
    


    loadScript(external_scripts,function()
    {
        kViewLoader = opts.debug?loadScript:loadScriptsConcurrently;
        if ($noraviews==undefined)
           $noraviews = $(".KNoraView");
        if (opts.debug)
        {
            $parent = $($noraviews[0]);
            window.KViewer_init_callback = function(KViewer) { 
                processArgs($parent,KViewer);
                if (callback)
                      callback(KViewer)
                
            }
        }

        kViewLoader(KViewer_scripts,function(){
            if (!opts.debug)
            {
                for (var k = 0; k < $noraviews.length;k++)
                {
                    (function() {
                        var $view = $($noraviews[k]);
                        $(document.body).css('font-family', 'Arial, sans-serif');
                        var $loadingframe = $("<div style='display:block;' id='KLoadingFrame'> <div></div>  <div class='thespinner'><i class='fa-5x fa fa-spinner fa-spin'></i></div> <div id='KLoadingFrameTypeString'></div> <div id='KLoadingFrameText'></div> </div>");
                        $loadingframe.css("width",$view.css("width"));
                        $loadingframe.css("height",$view.css("height"));
                        $view.append($loadingframe);
                        setTimeout(function() {
                            KView_standalone($view,function(KViewer){
                               $loadingframe.css('display','none');
                               processArgs($view,KViewer);
                               if (callback)
                                  callback(KViewer)
                            });
                        },0);
                    })();
                }
            }
        });
    });

}


// to pass arguments to KViewer via html attributes

function processArgs($parent,KViewer)
{

    if ($parent.attr("callback") != undefined)
    {
        eval("callback = " + $parent.attr("callback"));
        callback(KViewer);
        return;
    }


    eval("settings = " + $parent.attr("settings"));
    eval("$.extend(true, state.viewer, " + $parent.attr("settings") + ")");
    var images =$parent.attr("images");

    var local_url =window.location.host

    if (images != undefined)
    {
        eval("images = " + images);

        if( !Array.isArray(images) )
            images = [images];
            
        for(var k=0; k<images.length; k++)
        {
            var filename = images[k].filename;
            var url = images[k].url;
            if (url[0] == "/")
                url = local_url + url;
            KViewer.viewports[k].openFile({fileID:url,filename:filename,URLType:"foreignurl",url:url});
        }
    }

    KViewer.applyState();
    
}






/*




function execScriptsSync(names,src,done) {
    if (src.length > 0)
    {
         var head = document.getElementsByTagName('head')[0];
        var s;
        if (names[0].search("\\.css")> -1)
        {
            s = document.createElement('style');
            s.type = "text/css";
            s.innerHTML= src[0];
        }   
        else
        {
            s = document.createElement('script');                        
            s.type = "text/javascript";
            s.text = src[0];
        }
        head.appendChild(s);
        execScripts(names.splice(1),src.splice(1),done);
    }
    else
        done()
}



function loadScripts(src,done) {
    var isdone = [];
    for (var k = 0; k < src.length;k++)
    {
        isdone[k] = false;
        var head = document.getElementsByTagName('head')[0];
        var s;
        if (src[k].search("\\.css")> -1)
        {
            s = document.createElement('link');
            s.type = "text/css";
            s.rel = "stylesheet";
            s.href = src[k];
        }
        else
        {
            s = document.createElement('script');                        
            s.type = "text/javascript";
            s.src = src[k];
        }
       // head.appendChild(s);
        s.onload = function(k) { return function() {
            isdone[k] = true;
            for (var k = 0; k < src.length;k++)
            {
                if (!isdone[k])
                    return;
            }
            done();

        }        }(k);
    }
}

*/
