
function PACSQuery()
{
	var $found = $('#PACSQueryDialog');
	if( $found.length > 0)
	{
		$found.show();
		return pacsQueryDialog;

	}

	var that = new dialog_generic();

	pacsQueryDialog = that;


	// set true for debugging (always recreate window)
	that.deleteonclose = false;

	that.$frame.show();
	that.$frame.attr('id', 'PACSQueryDialog');

// 	that.$frame.width(1800).height(700);
// 	var pos = getPixelPosition($body);
// 	setPixelPosition(that.$frame, [0,0,pos[2]-40, pos[3]-20] , 0);
// 	that.$frame.css({left:10, top:10} );

	maximizeWindow(that.$frame, 0);

	//that.ontoggle = function(){ that.cancelquery() };
	

	var scripturl  = window.location.href.substr(0, window.location.href.lastIndexOf('/')) + '/pacsquery.php' ;


	var title = "PACS Query";
	that.$menu.append($("<li class='inactive'><a>"+title+"</a></li>"));

	

	/***************************************************************************************
	* load / save functionality
	****************************************************************************************/
	// ************* file menu to be implemented properly **************************** 
	var $filemenuli = $("<li><a>File</a></li>");
	//$filemenuli.appendTo(that.$menu);
	var $filemenu = $("<ul></ul>").appendTo($filemenuli);

    //var loadsearch = $filemenu.append($("<li><span>Load search...</span><i class='fa fa-caret-right'></i></li>").append($loadList))
	var $saveList = $("<ul></ul>").append(  $("<li>... new preset</li>").click(savesearch)   );
	var $savesearch = ($("<li><a>Save search as ...  </a><i class='fa fa-caret-right'></i></li>").append($saveList)).appendTo($filemenu);




	$filemenuli.click(getsavedlist);
	savedsearches = {};
	function getsavedlist()
	{
		jsonTable_loadFormattedList('pacsquery', updatefilemenu)			
	} 

	function updatefilemenu(list)
	{
		$saveList.empty();
		$("<li><a><span> ... new object</span></a></li>").click(function(ev){savesearch()}).appendTo($saveList);
		savedsearches  = list;
		for(var id in list)
		{
			var row = list[id];
			var content = row.content;
			savedsearches[id] = row.content;

			var $li = $("<li><a><span>" + content.name +"</span></a></li>").click( 
				function(row){return function(ev){ savesearch(row.id);  }}(row) ).appendTo($saveList);
			
			$("<i class='fa fa-trash'></i>").click(   
				function(row, $li){return function(ev){
					jsonTable_delete({id: row.id}, function(res)
					{
						if(res.msg=="")
							$li.remove();
							
					})
					return false;
					}}(row, $li) ).appendTo( $li )
		}
	} 

	function savesearch(id)
	{
		if(id == undefined)
		{
			alertify.prompt("Enter name for this query", function(ok, name)
			{
				if(ok && name!="")
				{
					var obj = {};
					obj.id = "temp";
					obj.name =  name; 
					saveit(obj);
				}
			}, "untitled");
		}
		else
		{
			var obj = savedsearches[id]; 
			obj.id = id;
		}
		function saveit(obj)
		{
			obj.total = total;
			jsonTable_save({type: 'pacsquery', project: '', rights: 'r-',  json:obj}, function(res)
			{
				console.log("query saved as " + res.json.id)
			});
		}


	}


	/***************************************************************************************
	* main fields
	****************************************************************************************/
	// LEFTtools
	that.$container.css('display', 'flex', 'flex-direction', 'column');
	var $topbar = $("<div class='pacsquery_tools_container' _style='height:45px;padding:0px;z-index:5;background:hsl(0,0%,33%);'></div>").appendTo(that.$container);

	var $basediv = $("<div class='pacsquery_rightcontainer sbox_vert' _style='display:flex;flex-direction:row;height:100%'></div>").appendTo(that.$container);

	// search stuff
	var $middlebar = $("<div class='sbox_resizable' style='max-height:80%;overflow-y:scroll'></div>").appendTo($basediv);
	// both tables
	var $inner = $("<div class='pacsquery_resultscontainer sbox_resizable sbox_horz' style='background:hsl(0,0%,20%)'></div>").appendTo($basediv);
	var $left = 	$("<div class='sbox_resizable' style='overflow:scroll;'></div>").appendTo($inner);
	var $right = 	$("<div class='sbox_resizable' style='overflow:scroll;position:relative;flex-grow:0;'></div>").appendTo($inner);
	//resizeSplitter($right, $left );


	// the log container
	var $logcontainer = $("<div class='sbox_resizable' style='position:relative;height:90px;'></div>").appendTo($basediv).hide();
	var $log = $("<div style='overflow:auto;height:100%;font-size:10px;background:hsl(0,0%,33%);font-family:Courier New,monospace;-webkit-user-select: text;'>LOG</div").appendTo($logcontainer);
	var $clearlog = $("<div class='modernbutton  small red' style='position:absolute;right:0;top:0'>Clear log</div>").appendTo($logcontainer).click(function(){$log.text("");});
	var $togglelog = $("<div class='modernbutton  small green' style='position:absolute;right:20px;bottom:0'>Show / hide log</div>").appendTo($basediv).click(function(){
		$logcontainer.toggle();	
		  });


	//var $togglerowcolview = $("<div class='modernbutton  tiny green' style='position:absolute;left:10px;bottom:0'>Compact view</div>").click(function(){
	var $togglerowcolview = $("<li style='float:right'><a><i class='fa fa-arrow-left'></i></a></li>").appendTo($basediv).click(function(){
		if($inner.iscolview)
		{
			$inner.iscolview = false;
			$inner.css('flex-direction', 'row');
			if($inner.savedwidth!=undefined)
				that.$frame.animate({width: $inner.savedwidth});
			$togglerowcolview.find('i').removeClass("fa-arrow-right");
		}
		else
		{
			$inner.iscolview = true;
			$inner.css('flex-direction', 'column');	
			$inner.savedwidth = that.$frame.width();
				that.$frame.animate( {width: 500 },180);	
			$togglerowcolview.find('i').addClass("fa-arrow-right");
		}
		  }).appendTo(that.$menu)

	var $deletewindow = $("<li style=''><a><i class='fa fa-close red'></i></a></li>").appendTo(that.$menu).click(function(){ that.$frame.remove(); });

	// these are the fields required for a query
	var queryFields = {
				PatientID: {required:true, defaultval:"*"},
				StudyDate: {required:true, defaultval:"*"},
				PatientName: {required:true, defaultval:"*"},
				//StudyTime: {required:true, defaultval:"*"},
				DaysOffsetA: {required:false, defaultval:"0"},
				DaysOffsetB: {required:false, defaultval:"0"},
				StudyDescription: {required:false, defaultval:"*"},
				AccessionNumber: {required:false, defaultval:"*"},
				SeriesDescription: {required:false, defaultval:"*"},
				Modality:  {required:false, defaultval:"*"},
				ModalitiesInStudy:  {required:false, defaultval:"*"},
				
				MinAge:  {required:false, defaultval:0, no_dicom_field: 1},
				MaxAge:  {required:false, defaultval:999, no_dicom_field:1},

				};

	if(static_info.pacsquery_defaultsearch !=undefined)
		for(var x in static_info.pacsquery_defaultsearch)
			if(queryFields[x]!=undefined)
					queryFields[x].defaultval = static_info.pacsquery_defaultsearch[x];

	var fields = $.extend(true, {}, queryFields );
	var studiesFields			 = [ "SS", "PatientID", "PatientName", "StudyDate", "StudyTime", "StudyDescription", "AccessionNumber","ModalitiesInStudy", "NS"  ];
	var studiesFieldsTitles 	 = [ "SS", "PatientID", "PatientName", "StudyDate", "Time", "StudyDescription", "AccessionNumber","MO", "NS" ];
	
	var seriesFields 			 = [ "maxSeriesNumber",  "SeriesDescription","ProtocolName",  "Modality" , "instudies", "maxNumberOfSeriesRelatedInstances" ];
	var seriesFieldsTitles  	 = [ "sNumbers",  "SeriesDescription","ProtocolName", "MO" , "inStudies", "nimg" ];
				



	var $searchbox = $("<div class='' style=''></div>").appendTo($middlebar);
	
	var singlesearch = [];
	var multisearch = [];

	//************** single search	
	var $searchtableSingle = $("<table cellspacing=0  class='localfiletable' style='width:100%; border:0px solid white; margin:0px;'></table>").appendTo($searchbox); 
	var $searchbodySingle = $("<tbody></tbody>").appendTo($searchtableSingle);
	var $inputs = {};			
	var fieldnames = Object.getOwnPropertyNames(fields);
	var $thead = $("<thead></thead>").appendTo($searchtableSingle);
	var $searchtitle = $("<tr class=''></tr>").appendTo($thead);
	var $searchfields = $("<tr class=''></tr>").appendTo($thead);
	for(var f in fields)
	{
		// min max age only in multi search
//		if( f == "MinAge" || f == "MaxAge")
//			continue

		$("<span>"+f+"</span>").appendTo($("<td></td>").appendTo($searchtitle));
		$inputs[f] = $("<input style='width:100%' class='' type='text' name='"+f+"' value='"+fields[f].defaultval+"' />").appendTo($("<td class='patientTableHeaderSearchCell'></td>").appendTo($searchfields))
	 	$inputs[f].on('keydown', function(ev)   {
    		if(ev.keyCode==13)
    			submitquery();
	 	});
	}

	that.submitquery = submitquery;

	that.setField = function(name,val)
	{

		if ($inputs[name] != undefined)
		{
			$inputs[name].val(val);
			return true;
		}
		else
		{
			console.warn("Invalid Field in PACsquery");
			return false;
		}
	}

	that.getField = function(name)
	{
		if ($inputs[name] != undefined )
			return $inputs[name].val();
	};
	

	that.showMultiSearch = function()
	{
		$showmultisearch.trigger("click")
	}
	that.showSingleSearch = function()
	{
		$showsinglesearch.trigger("click");
	}



	//************** multi search	
	var $multisearchlist = $("affgsagfadagafsd");
	var $inputsMulti = {};
	var $searchtableMulti = $("<table cellspacing=0  class='localfiletable' style='width:100%;margin:3px;resize:both;'></table>");
	var $thead = $("<thead></thead>").appendTo($searchtableMulti);
	var $searchtitleMulti = $("<tr class=''></tr>").appendTo($thead);
	var $searchfieldsMulti = $("<tr class=''></tr>").appendTo($thead);

	// list box is extra
	var $listrow = $("<td style='position:relative;padding:0px;position:relative;' class='patientTableHeaderSearchCell' colspan = '"+ (2+0*(fieldnames.length+0)) +"'></td>").appendTo($searchfieldsMulti);
	var $listarea = $("<textarea style='resize:both;box-sizing:border-box;padding:10px;width:calc(100%); min-width:300px;'>11111117 *\n11111118 *</textarea>").appendTo($listrow)
					 .on('blur', analysePatientList);
	
	for(var f in fields)
	{
// 		if(f == "PatientName")
// 			continue;

		var $temp = $("<span>"+f+"</span>").appendTo($("<td></td>").appendTo($searchtitleMulti));
		if(f!=="PatientID" && f!="StudyDate")
		{
			//$("<textarea style='resize:vertical;box-sizing:border-box;padding:10px;width:calc(100%)' name='multi"+f+"'>"+fields[f].defaultval+"</textarea>").appendTo($("<td class='patientTableHeaderSearchCell'></td>").appendTo($searchfieldsMulti))
		    $inputsMulti[f] = $("<input style='width:100%;height:100%;vertical-align:top;' class='' type='text' name='"+f+"' value='"+fields[f].defaultval+"' />").appendTo($("<td class='patientTableHeaderSearchCell'></td>").appendTo($searchfieldsMulti))
		      .on('blur', analysePatientList)
		      .on('keydown', function(ev)   {
								if(ev.keyCode==13)
									analysePatientList();
	 							});
		}	
			
	}
	$("<td style='padding:0px;text-align:right;width:30px;'></td>").appendTo($searchtitleMulti);
	$("<td style='padding:0px;text-align:right;width:30px;'></td>").appendTo($searchfieldsMulti);

	var $searchbodyMulti = $("<tbody style='position:relative;'></tbody>").appendTo($searchtableMulti);;

	//$("<div class='modernbutton small green' style='position:absolute;right:0;top:0'>render</div>").appendTo($searchbodyMulti).click(analysePatientList);
	$searchtableMulti.hide().appendTo($searchbox)
	var $multiswitchrow = $("<div class='' style='display:flex'</div>").appendTo($searchbox);
	
	// the single / multi switchers
	var searchtype = 'single';
	var $showmultisearch = $("<div class='modernbutton  small gray' style='width:150px'>Multi Patients ...</div>").appendTo($multiswitchrow).click(function()
	{
		$searchtableSingle.hide();
		$searchtableMulti.slideDown(200);
		$showsinglesearch.show();
		$showmultisearch.hide();
		searchtype = 'multi';
		$analysePatientList.show();
	});
	var $showsinglesearch = $("<div class='modernbutton  small gray' style='width:150px'>Single Patient ...</div>").hide().appendTo($multiswitchrow).click(function()
	{
		$searchtableMulti.hide();
		$analysePatientList.hide();
		$searchtableSingle.slideDown(200);
		$showsinglesearch.hide();
		$showmultisearch.show();
		searchtype = 'single';
	});

	var $analysePatientList = $("<div class='modernbutton small green' style='position:absolute;top:1px;right:0px;font-size:14px;'>parse list</div>").hide().appendTo($listrow).click(function(){ analysePatientList()});

	//************** tabber single / multi	
//     tabber = new KList( { $targetcontainer: $searchbox, $menucontainer:$("<ul style='width:200px;'></ul>").appendTo($topbar), classes:["roundish" ] })
//     tabber.append('single', 'single', $searchtableSingle);
//     tabber.append('multi', 'multi' ,  $searchtableMulti);
// 	tabber.updateOrSelectByID();


	sbox.appendResizer($middlebar);
	sbox.appendResizer($inner);
	sbox.appendResizer($left);


	//************** top tools
	var $rt = $right;
	var $toolbar = $("<div class='modernbuttongroup_ pacsquery_tools' ></div>").appendTo($topbar);	

	that.cancelquery = function(){};
	var pacslist = static_info.pacsquery;
	var $dummy = $("<div class='pacsquery_tools_caption'>Search in Pacs</div>").appendTo($toolbar);
	var $pacslist = $("<select name='pacsquerylist' class='' style=''></select>").appendTo($toolbar).click();

	for(var k=0; k<pacslist.length; k++)
	{
		$("<option>"+pacslist[k]+"</option>").appendTo($pacslist);
	}

	// ------------------------------------------------------------------------------------------
	var $dummy = $("<div class='pacsquery_tools_caption' >Import to Project</div>").appendTo($toolbar);
	var $targetProject  = $("<select name='pacsquerymodulelist' ></select>").appendTo($toolbar).on("change", function(){checktarget()});
	$("<option>current_project</option>").appendTo($targetProject);
	$("<option>NONE</option>").appendTo($targetProject);
//	$("<option>LIVEVIEW</option>").appendTo($targetProject);
// 	for(var k=0; k<moduleList.length; k++)
// 	{
// 		$("<option>"+moduleList[k]+"</option>").appendTo($targetProject);
// 	}
	var $targetSubfolder_title = $("<div class='pacsquery_tools_caption' >Move to subfolder</div>").appendTo($toolbar).hide();
	var $targetSubfolder = $("<input type='text' name='pacsquery_targetsubfolder' value='zuser_"+userinfo.username+"'/>").appendTo($toolbar).hide();

	function checktarget()
	{
		if($targetProject.val() =="NONE")
			{$targetSubfolder_title.slideDown();$targetSubfolder.slideDown()}	
		else
			{$targetSubfolder_title.slideUp();$targetSubfolder.slideUp()}	
	}

	that.setTargetProject = function(target)
	{
		$targetProject.val(target);
		checktarget();
	}
	that.setTargetProject('current_project');



	var $dummy = $("<div class='pacsquery_tools_caption' >Queue</div>").appendTo($toolbar);
	
	var $importqueues  = $("<select name='importqueues' ></select>").appendTo($toolbar);
	$("<option>(DEFAULT)</option>").appendTo($importqueues);


	for(var k=0; k<static_info.SLURM_QUEUES.length; k++)
		$("<option>"+static_info.SLURM_QUEUES[k]+"</option>").appendTo($importqueues);
	for(var k=0; k<static_info.SGE_QUEUES.length; k++)
		$("<option>"+static_info.SGE_QUEUES[k]+"</option>").appendTo($importqueues);


	var $dummy = $("<div class='pacsquery_tools_caption' ></div>").appendTo($toolbar);


	
	var $autoexec = $("<input type='checkbox' id='pacsqueryrunautoexec' name='pacsqueryrunautoexec' checked /><label for='pacsqueryrunautoexec'>Run autoexec</label>").appendTo($("<div class='small '></div>").appendTo($toolbar));
	var $overwrite = $("<input type='checkbox' id='pacsqueryoverwrite' name='pacsqueryoverwrite' checked /><label for='pacsqueryoverwrite'>Overwrite</label>").appendTo($("<div class='small '></div>").appendTo($toolbar));

	var $dummy = $("<div class='pacsquery_tools_caption' >Deidentification</div>").appendTo($toolbar);
	var $anonymization  = $("<select name='anonym' ></select>").appendTo($toolbar);
	$("<option>none</option>").appendTo($anonymization);
	$("<option selected>pseudo</option>").appendTo($anonymization);
	$("<option>full</option>").appendTo($anonymization);

    if (projectInfo.jsondesc.anonymization != undefined)
    {
    	$anonymization.addClass("inactive")    	
    }

	var $tagstudy_title = $("<div class='pacsquery_tools_caption' >Study tag</div>").appendTo($toolbar)
	var $tagstudy = $("<input type='text' name='pacsquery_studytag' value=''/>").appendTo($toolbar)
	var $tagpatient_title = $("<div class='pacsquery_tools_caption' >Patient tag</div>").appendTo($toolbar)
	var $tagpatient = $("<input type='text' name='pacsquery_patienttag' value=''/>").appendTo($toolbar)


	
	var $dummy = $("<div class='pacsquery_tools_caption' ></div>").appendTo($toolbar);
	var $seriousmode = $("<input type='checkbox' id='pacsqueryseriousmode' name='pacsqueryseriousmode' checked /><label for='pacsqueryseriousmode'>Serious mode</label>").appendTo($("<div class=' small'></div>").appendTo($toolbar));
    $seriousmode.hide()
    
    /**********************************************
    /* unrestriced wildcard search
    **********************************************/
	var $unrestrictedmode = $("<input type='checkbox' id='pacsqueryunrestrictedmode' name='pacsqueryunrestrictedmode' /><label for='pacsqueryunrestrictedmode'>Unrestricted mode</label>").appendTo($("<div class=' small'></div>").appendTo($toolbar));

    if(userinfo.isadmin)
    {
	    $unrestrictedmode.show();
		$unrestrictedmode.mousedown(function(ev)
		{
			console.log($(this))
			if($unrestrictedmode.is(":checked") && $(this).is("label"))
			{
				//$unrestrictedmode.prop( "checked", false );
			}
			else if(!$unrestrictedmode.is(":checked")){ 
				alertify.confirm("Very dangerous! <br> You can kill your PACS. <br> Only enable if you know what you are doing! <br> Really enable?",function(e)
				{
					if(e)
					{
						$unrestrictedmode.prop( "checked", true );
					}
				})
			}

		})
    }
    else
   	  $unrestrictedmode.hide();


	var $dummy = $("<div class='pacsquery_tools_caption'></div>").appendTo($toolbar);
	var $startsearch = $("<div class='modernbutton  small green'><i style='padding:0px' class='fa fa-binoculars'></i><i style='padding:0px;display:none;' class='fa fa-spinner fa-spin'></i> Run search</div>").appendTo($toolbar).click(submitquery);
	// clear result not needed so far. Right now, we always clear before starting a  new search
	//var $clearsearch = $("<div class='modernbutton  small red'>Clear search</div>").appendTo($toolbar).click(clearResults);

	var $movescu = $("<div class='modernbutton small yellow '><i style='padding:0px' class='fa fa-download'></i><i style='padding:0px;display:none;' class='fa fa-spinner fa-spin'></i> Pull selected</div>").appendTo($toolbar).click(function(){submitmovescu_wrapper() });
	var $cancelsearch = $("<div class='modernbutton  small red'>Stop query</div>").appendTo($toolbar).click(function(){that.cancelquery()});
	var $dryimport = $("<div class='modernbutton small orange '><i style='padding:0px' class=''></i><i style='padding:0px;display:none;' class='fa fa-spinner fa-spin'></i> Dry Import </div>").appendTo($toolbar).click(function(){submitmovescu_wrapper('dryimport')});
	var $downloadRaw = $("<div class='modernbutton small '>Download raw</div>").appendTo($toolbar).click(downloadResultsRaw);
	var $downloadCSV = $("<div class='modernbutton small '>Download csv</div>").appendTo($toolbar).click(downloadResultsCSV);
	var $dumpMissingCases = $("<div class='modernbutton small '>Dump Missing</div>").appendTo($toolbar).click( function(){ PACSQuery.getNotFound() });
	var $subtractList = $("<div class='modernbutton small gray '>Subtract List</div>").appendTo($toolbar).click( function(){ subtractOtherList() });

//     if(!userinfo.isadmin)
//     {
//     	$dryimport.hide();
//     	$downloadRaw.hide();
//     }


	that.$frame.on('dragenter dragover', function(ev){return false;}).on('drop', ondrop);
	var $dropindicator  = {$progress: $("<div></div>")};
	/*	
		that.$frame.on('dragenter dragover', function(ev){return false;}).on('drop', ondrop);
		new Dragster(that.$container.get(0));
		that.$container.get(0).addEventListener('dragenter',showDropIndicators);
		that.$container.get(0).addEventListener('dragster:leave',hideDropIndicators);

		var $dropindicator = $("<div class='pacsquery_dropindicator' style=''><div>Drop to load saved query list.</div></div>").appendTo($toolbar);
		$dropindicator.$progress = $("<div class=''><div>aaa</div></div>").appendTo($dropindicator);
		function showDropIndicators(ev)	{ 		$dropindicator.show();	}
		function hideDropIndicators(ev)	{ 		$dropindicator.hide();	}
	*/

	// ------------------------------------------------------------------------------------------
	var $dummy = $("<div class='pacsquery_tools_caption'>FIND Pause (sec)</div>").appendTo($toolbar);
	var $findSCUPause  = $("<select name='pacsquerymodulelist' ></select>").appendTo($toolbar);
	var ttt = [0.1, 0.2, 0.4, 0.6 , 0.8, 1.0, 4.0, 8.0];
	for(var k=0; k<ttt.length; k++)
		$("<option>"+ ttt[k].toFixed(1) +"</option>").appendTo($findSCUPause);
	$findSCUPause.val("0.6");

	// ------------------------------------------------------------------------------------------
	var $dummy = $("<div class='pacsquery_tools_caption'>MOVE Pause (sec)</div>").appendTo($toolbar);
	var $moveSCUPause  = $("<select name='pacsquerymodulelist' ></select>").appendTo($toolbar);
	var ttt = [1, 2, 3,  5 , 10, 20, 40, 60];
	for(var k=0; k<ttt.length; k++)
		$("<option>"+ ttt[k].toFixed(1) +"</option>").appendTo($moveSCUPause);
	$moveSCUPause.val("3.0");

	var showaggregated_status = 1;
	var $dummy = $("<div class='pacsquery_tools_caption' ></div>").appendTo($toolbar);
	var $showaggregated = $("<input type='checkbox' id='pacsqueryshowaggregated' name='pacsqueryshowaggregated' checked /><label for='pacsqueryshowaggregated'>Show aggregated</label>").appendTo($("<div class='small '></div>").appendTo($toolbar));
	$showaggregated.on('change', function(){
		showaggregated_status = $showaggregated.is(':checked')?1:0;
		updateSummaryTable();
		$studiestableb.find('tr.selected').trigger('click');
	})

	var $graydiv = $("<div class='pacsquery_graydiv_search' ></div>").appendTo($topbar);	
	$("<div style='padding:20px 0px;'><i style='padding:0px;font-size:40px' class='fa fa-spinner fa-spin'></i></div>").appendTo($graydiv); 	
	$("<div style='padding:20px 0px;'>Running Query...</div>").appendTo($graydiv);
	$cancelsearch.appendTo($graydiv).width(120);

	var $cancelmessage = $("<div style='padding:5px 0px; text-align:center;'></div>").appendTo($graydiv).hide();
	$cancelmessage.append("<div><b>Cancelling after next study, please wait</b> ...<br><br>if nothing happens, force stop.</div>")	
	$force_cancel = $("<div class='modernbutton  small blue' style='width:90px;margin:auto;'>Force stop</div>").appendTo($cancelmessage).click(function(){that.cancelquery(1)});
	$graydiv.hide();

	
	var $studiestable = $("<table cellspacing=0  class='localfiletable pacsquery_studiestable ' style='border-left:2px solid white;'></table>").appendTo($left); 
		var $studiestableh = $("<thead></thead>").appendTo($studiestable);
		var $studiestableb = $("<tbody></tbody>").appendTo($studiestable);
		var $dummy = $("<tr></tr>").appendTo($studiestableh);
		addToggler($dummy);
		for(var k=0; k< studiesFields.length; k++)
			$("<td>"+studiesFieldsTitles[k] +"</td>").appendTo($dummy);	 
		addDeleter($dummy);
	
	var $seriestable  = $("<table cellspacing=0  class='localfiletable pacsquery_studiestable' style='margin-left:10px;border-left:0px solid hsl(0,0%,80%);'></table>").appendTo($right);
		var $seriestableh = $("<thead></thead>").appendTo($seriestable);
		var $seriestableb = $("<tbody style='-webkit-user-select: text;'></tbody>").appendTo($seriestable);
		var $dummy = $("<tr></tr>").appendTo($seriestableh);
		addToggler($dummy, countSeries);
		for(var k=0; k< seriesFields.length; k++)
		{
			var $td = $("<td>"+seriesFieldsTitles[k] +"</td>").appendTo($dummy);	 
			if(seriesFieldsTitles[k] == "sNumbers" |seriesFieldsTitles[k] == "inStudies" |seriesFieldsTitles[k] == "nimg"  |seriesFieldsTitles[k] == "MO" )
				$td.attr("initwidth", "14");
		}
		addDeleter($dummy);


	attachTableOperator($right,undefined, true);
//	attachTableOperator($right, undefined, true);
	attachTableOperator($left, undefined, true);

    /**********************************************
    /* add search bar to studies and series table
    **********************************************/
	addSearchBar('studies')
	addSearchBar('series')
	var $seriestablesearchfields = {};	    	 
	var $studiestablesearchfields = {};	    	 

	function addSearchBar(x)
	{
		if(x == 'series')
		{
			var $tableh = $seriestableh;
			var $whichtable = $seriestableb;
			var fieldsTitles = seriesFieldsTitles;
			var tfields = seriesFields;
			var $searchfields =  $seriestablesearchfields;
		}
		else
		{
			var $tableh = $studiestableh;
			var $whichtable = $studiestableb;
			var fieldsTitles = studiesFieldsTitles;
			var tfields = studiesFields;
			var $searchfields =  $studiestablesearchfields;
		}
		
		var $dummy = $("<tr></tr>").appendTo($tableh)
	    $("<td style='width:0px;margin:0px;padding:0px;'>"+ "" +"</td>").appendTo($dummy);
		var $searchfields = {};	    	 
		for(var k=0; k< tfields.length; k++)
		{
			$searchfields[fieldsTitles[k]] =  $("<td><input style='width:100%' class='' type='text' name='"+fieldsTitles[k]+"' value='' /></td>").appendTo($dummy)
				.click(function(ev){ ev.stopPropagation(); return false })
	 			.on('keydown', function(ev)   {
    				if(ev.keyCode==13)
    					seriesTableSearch();
    				ev.stopPropagation();
	 			});
		}
		
		function seriesTableSearch()
		{
			var rr = [0];
			for(var k=0; k<fieldsTitles.length; k++)
			{
				var xx = $searchfields[fieldsTitles[k]].find('input').val().trim();
				if(xx == "")
				{
					rr.push(0);
				}
				else if(xx[0] == ">" | xx[0] == "<" | xx[0] == "=")
				{
					rr.push(xx);
				}
				else
				{
					if(xx[0] != "*")
						xx = "^" + xx;
					xx = xx.replace(/\*/g, '.*');  
					rr.push(new RegExp(xx,'gi'));
				}
			}

			var $lines = $whichtable.children();
			for(var k=0; k<$lines.length; k++)
			{
				var $cc = $lines[k].children;
				var matched = true;
				for(var l=1; l<$cc.length; l++)
				{
					var theregexp = rr[l];
					if(typeof theregexp == "object" )
					{
						if(!$cc[l].innerHTML.match( theregexp ) )
							matched = false;
					}
					else if(theregexp) 
					{
						if(!eval ( $cc[l].innerHTML +theregexp ) )
							matched = false;
					}
				}
				if(!matched)
					$($lines[k]).hide();
				else
					$($lines[k]).show();

			}
		}
	}



	//************** handlers to navigate using keyboard
	var $currentfocus;
    function myhandler(ev) 
    {
    	if($currentfocus)
    	{
    		if(ev.keyCode==38 && $currentfocus.prev().length > 0)
    		   		$currentfocus = $currentfocus.prev();
    		else if(ev.keyCode==40 && $currentfocus.next().length > 0)
    		   		$currentfocus = $currentfocus.next();
    		
    		if($currentfocus)
    			$currentfocus.trigger('click');
    	}
        //ev.preventDefault();
        //return false;
    }
	// put an key event handler to som element, It must have tabindex to work.
	$virtualInput = $inner;
	$virtualInput.attr("tabindex",-1)
	$virtualInput.on('keydown', myhandler);

	// response raw is really too slow with textarea
	//var $responseRaw = $("<textarea  spellcheck=false autocomplete='off' autocorrect='off' autocapitalize='off'  style='width:98%;height:300px;background:hsl(0,0%,43%);font-family:Courier New,monospace;'></textarea").appendTo($right);
	//var $fileDropper = $("<div style='__height:60px;' class='modernbutton'>Drop raw response file</div>").appendTo($right);

	
	/***************************************************************************************
	* contextmenu  (delete elements)
	****************************************************************************************/
	 var ctxmenu = new KContextMenu(
		 function(ev) {
			{
				var $menu = $("<ul class='menu_context'></ul>");
				if(ev.whichtable=='studies')
				{
					$menu.append($("<li onchoice='select_studies_firstvisit"+ "'>select first visits</li>") )
					$menu.append($("<li onchoice='select_studies_lastvisit" + "'>select latest visits</li>") )
				}
				$menu.append($("<li onchoice='invert_selection' style='border-top:1px solid black'>invert selection</li>") )
				$menu.append($("<li onchoice='remove_selected_"+ ev.whichtable +"' style='border-top:0px solid black'>remove selected items</li>") )
				
				return $menu;
			}
		}
		,function(onchoice) 
		{
			if(onchoice=="remove_selected_protocols")
			{
				var list = [];
				 $seriestableb.find('tr.'+selclass).each(function(k,e){ 
						list.push(total.seriessummary[($(e).attr("seriesname") )] );
						$(e).remove();	
				 });
				deleteprotocols(list);
			}
			if(onchoice=="remove_selected_studies")
			{
				var list = [];
				 $studiestableb.find('tr.'+selclass).each(function(k,e){ 
						list.push(total.studies[($(e).attr("StudyInstanceUID") )] );
						//list.push(  $(e).attr("StudyInstanceUID")  );
						$(e).remove();	
				 });
				deletestudies(list);
			}
			if(onchoice=="invert_selection")
			{
				 $studiestableb.find('tr').each(function(k,e){ 
				 var $e = $(e);
						if(!$e.hasClass(selclass))
							toggleRow($e, true);
						else
							toggleRow($e, false);
				 });
				
			}
			if(onchoice=="select_studies_firstvisit")
			{
				selectNthStudy(0);
			}
			if(onchoice=="select_studies_lastvisit")
			{
				selectNthStudy(99);
			}

			function selectNthStudy(x)
			{
				var tstudy 
				for(var p in total.patients)
				{
					tstudy = undefined
					for(var s in total.patients[p].studies)
					{	
						var tt = total.patients[p].studies[s];
						toggleRow($studiestableb.find('tr[studyinstanceuid="'+ tt.StudyInstanceUID +'"]'), false);
						function compfun(x, a, b)
						{
							if(x == 99)
								return (a.StudyDate+a.StudyTime > b.StudyDate+b.StudyTime)
							else
								return (a.StudyDate+a.StudyTime < b.StudyDate+b.StudyTime)
						}

						if(tstudy == undefined || compfun(x, tt, tstudy) )
							tstudy = tt;

					}
					//console.log(tstudy.StudyInstanceUID)
					var $e = $studiestableb.find('tr[studyinstanceuid="'+ tstudy.StudyInstanceUID +'"]')
					toggleRow($e, true);
				}

			}

		}
    ,false, true);
    
    $left.contextmenu(  function(ev){ ev.whichtable = 'studies'; ctxmenu(ev) });
    $right.contextmenu( function(ev){ ev.whichtable = 'protocols'; ctxmenu(ev) });




	var total;

	/***************************************************************************************
	* toggle the rows
	****************************************************************************************/
	function addToggler($row, callback)
	{
		$("<td fixedwidth='8' preventsortable='1'><i style='text-align:center' class='fa fa-square-o fachecker'></i></td>").appendTo($row).click(function(ev){toggleRow($row, undefined, callback,ev);  return false;});	 
	}
	function addDeleter($row, callback)
	{
		$("<td fixedwidth='8'  preventsortable='1' ><i style='text-align:center' class='fa fa-close'></i></td>").appendTo($row).click(function(ev){if(callback==undefined) return false; callback($row);  $row.remove(); return false;});	 
	}


	var selclass = "selectedGray";

	function toggleRow($row, force, callback, ev)
	{
		if($row.parent().is('thead'))
		{
			var $allrows = $row.parent().next().find("tr:visible");
			if(!$row.hasClass(selclass) )
			{
				$row.find('.fachecker').addClass('fa-check-square');
				$row.find('.fachecker').removeClass('fa-square-o');
				$row.addClass(selclass);
				$allrows.addClass(selclass);
				$allrows.find('.fachecker').addClass('fa-check-square');
				$allrows.find('.fachecker').removeClass('fa-square-o');
			}
			else 
			{
				$row.find('.fachecker').removeClass('fa-check-square');
				$row.find('.fachecker').addClass('fa-square-o');
				$row.removeClass(selclass);
				$allrows.removeClass(selclass);
				$allrows.find('.fachecker').removeClass('fa-check-square');
				$allrows.find('.fachecker').addClass('fa-square-o');
			}
		}
		else
		{

			if(ev && ev.shiftKey)
			{
				if($currentfocus== undefined)
					return
				var indlast = $currentfocus.index();
				var indthis = $row.index();
				var diff   = indthis-indlast;
				if(diff > 0)
				{
					var $cc= $currentfocus;
				}
				else if(diff < 0)
				{
					var $cc= $row;
					diff = -diff;
				}
				for(var x=0; x<=diff; x++)
				{
					if($cc.is(':visible'))
						toggleRow($cc, !ev.ctrlKey);
					$cc = $cc.next();
				}
				return false;
			}


			
			if(force!==undefined)
				var newstate = force;
			else
				var newstate = !$row.hasClass(selclass);
				  
			if(!newstate )
			{
				$row.removeClass(selclass);
				$row.children().eq(0).find('.fa').removeClass('fa-check-square');
				$row.children().eq(0).find('.fa').addClass('fa-square-o');
			}
			else 
			{
				$row.addClass(selclass);
				$row.children().eq(0).find('.fa').addClass('fa-check-square');
				$row.children().eq(0).find('.fa').removeClass('fa-check-o');

			}
		}
		if(callback)
			callback()
	}

	/***************************************************************************************
	* processLogAndErrors
	****************************************************************************************/
	function processLogAndErrors(response, $currentstudyrow)
	{
			if(response && response.log != undefined)
			{
				if(response.log.log != undefined)
				{	
					var msg = response.log.log.join("<br>").replace(/\n/g, "<br />");
					$log.html($log.html() + "<br>");
					$log.html($log.html() + msg);
				}
				if(response.log.err != undefined && response.log.err.length > 0)
				{	
					var errors = response.log.err;
					//$log.html($log.html() + "<br> ________  ERRORS : __________ <br>");
					for(var k=0; k<errors.length; k++)
					{
						alertify.error(errors[k]);

						if($currentstudyrow)
						{	
							$currentstudyrow.find('td').eq(1).css('background', "red");
							$currentstudyrow.addClass('pacsquery_failed');
							//errors[k].search("TIMEOUT") > -1
						}				
						//$log.html($log.html() + errors[k].replace(/\n/g, "<br />"));
					}
				}
			}

		
	}



	/***************************************************************************************
	* movescu
	****************************************************************************************/
	function submitmovescu_wrapper(movemode)
	{
		var $selstudies = $studiestableb.find('tr.'+selclass);
		if($selstudies.length > 1)
		{
			alertify.confirm("<b>WARNING</b><br>You are importing data from PACS in batch mode.<br> It is <b>YOUR</b> responsibility to have <b>ethical approval</b> for your project.<br> Continue? ",function(e)
			{
				if(e)
				{
					submitmovescu(movemode)
				}
			})
		}
		else
		{
			submitmovescu(movemode)
		}
	}


	function submitmovescu(movemode)
	{
		var $selstudies = $studiestableb.find('tr.'+selclass);
		var sendstudies = {};
		var skeys = [];
		for(var k=0; k<$selstudies.length; k++)
		{
			var $s = $selstudies.eq(k);
			var StudyInstanceUID = $s.attr('StudyInstanceUID');
			var series = total.studies[StudyInstanceUID].series;
			for(var st in series )
			{
				var cseries = series[st];
				var id2 = cseries.SeriesDescription + cseries.ProtocolName;
				var $match = findRowByID($seriestableb, createID("Series" + id2));
				if($match && $match.hasClass(selclass) )
				{
					if(sendstudies[cseries.StudyInstanceUID] == undefined)
					{
						sendstudies[cseries.StudyInstanceUID] = 
						{
							series:[cseries],
						};
						skeys.push(cseries.StudyInstanceUID);
					}
					else
					{
						sendstudies[cseries.StudyInstanceUID].series.push(cseries);
					}

				}
			}
		}
		
		
		var counter = 0;
		var $currentstudyrow = undefined; 
		// this would be in not so nice order ...
		//var skeys = Object.getOwnPropertyNames(sendstudies);
		var numstudies = skeys.length;

		var obj = {};
		obj.seriousmode = $seriousmode.is(':checked')?1:0;
		obj.runautoexec = $autoexec.is(':checked')?1:0;
		obj.nooverwrite = $overwrite.is(':checked')?0:1;
		obj.anonymization = $anonymization.val();
		obj.tag_study = $tagstudy.val();
		obj.tag_patient = $tagpatient.val();
		obj.pacsid = $pacslist.val();
		obj.targetsubfolder = $targetSubfolder.val();
		obj.targetproject   = $targetProject.val();
		var qu_ = $importqueues.val();
		if (qu_ != "(DEFAULT)")
			obj.queue = qu_;

		if(obj.targetproject == 'current_project')
			obj.targetproject = currentModule;
		
		obj.moveSCUPause = $moveSCUPause.val();

		obj.dryimport = false;

		var delay = 200;

		if(skeys.length == 0)
		{
			alertify.error('no matching study / series selected!');
			$movescu.find('i').eq(1).hide();$movescu.find('i').eq(0).show();
			return;
		}
		
		
		
		that.cancelquery = function(force)
		{
			$cancelmessage.show()
			counter = -100;
			 if(force && xhr !=undefined)
			 {
				xhr.abort();
				whendone();
			 }
		}

		/*******  progress slider ****/
			var $pframe = $("<div class='pacsquery_progressbox'></div>").appendTo($(document.body));
			var $dummy = $("<div class='pacsquery_title'>Receiving DICOMS</div>").appendTo($pframe)
			var $pmsg = $("<div class='pacsquery_progressmsg'></div>").appendTo($pframe);
			var $pmsgtable = $("<table class=''></table>").appendTo($pframe);
			var $tr = $("<tr></tr>").appendTo($pmsgtable).append($("<td>Receiving Study:</td>"));
				var $receivedStudies = $("<td>--</td>").appendTo($tr);
			var $tr = $("<tr></tr>").appendTo($pmsgtable).append($("<td>Current Study Progress:</td>"));
				var $receivedSeries = $("<td>--</td>").appendTo($tr);
			var $tr = $("<tr></tr>").appendTo($pmsgtable).append($("<td>Overall Progress:</td>"));
				var $overallProgess = $("<td>--</td>").appendTo($tr);
			
			var $tr = $("<tr></tr>").appendTo($pmsgtable).append($("<td></td>"));
			var $tr = $("<tr></tr>").appendTo($pmsgtable).append($("<td>Time elapsed:</td>"));
				var $elapsedTime = $("<td>--</td>").appendTo($tr);
			var $tr = $("<tr></tr>").appendTo($pmsgtable).append($("<td>Time remaining (est):</td>"));
				var $remainingTime = $("<td>--</td>").appendTo($tr);

			var starttime = Date.now();
			/******* smooth progress slider ****
			
			var objectsPerSecond = 0;
			var interval = .1;
			var elapsedTime = .1;
			var receivedObjects = 0;
			var $td = $currentstudyrow.children().eq(2);
			//var $progressbar = $("<div class='' style='top:0px;left:0px;height:5px;width:200px;position:absolute;z-index:5;background:red;'></div>").appendTo($currentstudyrow);
			var progressTimer = setInterval(function() 
			{
				elapsedTime+=interval;
				//console.log(objectsPerSecond);
				//$progressbar.width(elapsedTime*100)
				var perc =  math.round(elapsedTime*10);
				//console.log(perc);
				$td.css('background','linear-gradient(90deg, hsla(0,0%,40%,.5) ' +perc+ '%, hsla(0,0%,0%,0) 0' )
			 },  1000*interval);
				
			******* smooth progress slider ****/


		// movescu --> move to virtual patient table
		var xhr;
		if(movemode == 'dryimport')
		{
			obj.dryimport = true;
			obj.studies = sendstudies;
			obj.targetproject = currentModule;
			function whendone(response)
			{
				alertify.success('Successfully imported items to database.');
				cleanupwhendone();
			}
			xhr = ajaxRequest('command=PACSQuery_dryimport&json=' + encodeURIComponent(JSON.stringify(obj)), whendone,  scripturl, undefined, whendone);			
		}
		else
		{
			// show the sending button
			//$movescu.find('i').eq(0).hide(); $movescu.find('i').eq(1).show();
			$graydiv.fadeIn();
			runAjax(sendstudies[skeys[counter]]);
		}

		function runAjax(currentstudy)
		{
			if(currentstudy == undefined)
				return false;

			$currentstudyrow  =	findRowByID($studiestableb, createID('Studies' + currentstudy.series[0].StudyInstanceUID) );
			$currentstudyrow.css('background', 'hsl(206, 64%, 80%)');
			
			console.log(currentstudy.series[0].PatientName + " //  " + currentstudy.series[0].PatientID + " //" + currentstudy.series[0].StudyInstanceUID + " // "+ currentstudy.series[0].SeriesInstanceUID);
			obj.series = currentstudy.series;
			
			// no pause after last study
			if(counter == skeys.length-1)
				obj.moveSCUPause = 0.01;

			xhr = ajaxRequest('command=PACSQuery_movescu&json=' + encodeURIComponent(JSON.stringify(obj)), whendone,  scripturl,function(e)
			{
      			var responsestr = e.currentTarget.response.split("NORA_PROGRESS_SEPARATOR").filter(function(x) {return (x!='');}).pop();
				if(responsestr && responsestr.length < 5 && counter >= 0)
				{
					var prog_overall = "" + math.round((counter+.5)/numstudies*100) + "%";
					var prog_studies = "" + (counter+1) + " / " + numstudies; 
					var prog_series  = "" +  responsestr + "%"; 
					$overallProgess.text(prog_overall);
					$receivedStudies.text(prog_studies);
					$receivedSeries.text(prog_series);
					var el = math.round((Date.now()-starttime)/1000);
					function print_time(tt)
					{
						 var hh = math.floor(tt/60);
						 var mm = "0"+ (tt % 60); mm = mm.substring(mm.length-2,mm.length);
						 return hh +":"+ mm;
					}
					$elapsedTime.text(print_time(el) )
					var remaining = math.round( el/((counter+1) /numstudies) -el);
					if(remaining <1000000)
						$remainingTime.text( print_time(remaining))

				}


			},  whendone);
		}
		function whendone(response)
		{
			//clearInterval(progressTimer)
			if($currentstudyrow)
			{
				$currentstudyrow.css('background', "");
				$currentstudyrow.find('td').eq(1).css('background', "lightgreen");
				$currentstudyrow.removeClass('pacsquery_failed');
			}
			processLogAndErrors(response, $currentstudyrow);
			counter++;
			if(counter < skeys.length && counter >= 0)
			{
				window.setTimeout(function()
				{ 
					var nextstudy = sendstudies[skeys[counter]];
					if(nextstudy != undefined)
						runAjax(nextstudy);
					else
						cleanupwhendone()
				}, delay);
			}
			else
			{
				cleanupwhendone();

				// live view: open file after reception
				if(obj.targetproject == 'LIVEVIEW')
				{
					console.log( response.log.log );
					if( response.json.fileID )
					{
						KViewer.viewports[0].openFile({ fileID: "TEMP://" + response.json.fileID, callback:function(){ }, progressSpinner: function(){} } );
					}
				}
			}

		}
		function cleanupwhendone()
		{
			// finalise
			if($currentstudyrow!=undefined)
				$currentstudyrow.css('background', "");

			$pframe.remove();
			$graydiv.fadeOut();
			$cancelmessage.hide();
		}		
	}



	/***************************************************************************************
	* submitquery
	****************************************************************************************/
	var MinAge, MaxAge;

	function submitquery(callback)
	{
		var searchobj;
		if(searchtype == 'multi')
		{
			searchobj = multisearch;
		}	
		else
		{
			searchobj = {};
			for(var f in fields)
				if($inputs[f])
					searchobj[f] = $inputs[f].val();
			searchobj = [searchobj];	
		}
		
		if(searchobj.length == 0)
		{
			alertify.error('Query is empty, maybe you have click "analyse patient list first?');
			return false;
		}
// 		for(var k=0; k<searchobj.length; k++)
// 		{
// 			searchobj[k].seriousmode = $seriousmode.is(':checked')?1:0;
// 			searchobj[k].pacsid = $pacslist.val();
// 		}
 		
 		// set min and max age
 		MinAge = parseInt(searchobj[0]["MinAge"]);
 		MaxAge = parseInt(searchobj[0]["MaxAge"]);

		var obj = {};
		obj.seriousmode = $seriousmode.is(':checked')?1:0;
		obj.pacsid = $pacslist.val(); 
		obj.findSCUPause = $findSCUPause.val();
		obj.unrestrictedmode = $unrestrictedmode.is(':checked')?1:0;

		// run the search as loop over all patients =>  more responsive and cancellable
		clearResults();
		$multisearchlist.each(function(e,k){$(e).css('background', 'green')});

		var counter = 0;
		//$startsearch.find('i').eq(0).hide();$startsearch.find('i').eq(1).show();
		//if($multisearchlist.length > 0)
			$graydiv.show();

		runAjax(searchobj[counter]);

		that.cancelquery = function(force)
		{
			$cancelmessage.show()
			counter =  searchobj.length + 10;
			 if(force && xhr !=undefined)
			 {
				xhr.abort;
				whendone();
			 }
		}
		
		//// a single ajax for eacht patient
		var xhr;
		function runAjax(current)
		{
			if($multisearchlist.length > 0 )
				$multisearchlist.eq(counter).css('background', 'hsl(206, 64%, 37%)');

			// must remove some fields, no dicom tags
			delete current.MinAge;
			delete current.MaxAge
			
			obj.tags = current;

			// workaround: allow to search by StudyInstanceUID. Try to guess: long and mixture of numbers 
			if( obj.tags.PatientID.length > 20 && !obj.tags.PatientID.match(/[^\d\.]+/g))
			{
				obj.tags.StudyInstanceUID = obj.tags.PatientID;
				obj.tags.PatientID = "";
			}
			
			// no pause after last search 
			if(counter == searchobj.length-1)
				obj.findSCUPause = 0.01;
			xhr = ajaxRequest('command=PACSQuery_findscu&json=' + encodeURIComponent(JSON.stringify([obj])), whendone,  scripturl, undefined, whendone);
		}


		/***************************************************************************************
		* ajax whendone
		****************************************************************************************/
		function whendone(response)
		{
			if($multisearchlist.length >0 )
				$multisearchlist.eq(counter).css('background', 'green');

			processLogAndErrors(response);

			if(response == undefined || response.json == null)
			{
				cleanupwhendone()
				return false;
			}
			var json = response.json;

			/***************************************************************************************
			* process the result
			****************************************************************************************/
			if(response.json.responseRaw == null)
			{
				alertify.error("ResponseRaw was null");
			}
			total.responseRaw += json.responseRaw;
			dicomparse(json.responseRaw, total);
			
			
			counter ++;
			if(counter < searchobj.length)
			{
				runAjax(searchobj[counter]);
			}
			else
			{
				// finalize
				cleanupwhendone()
				updateStudiesTable();
				updateSummaryTable();
				console.log("PACSQuery done");
				if (callback && typeof callback == "function")
					callback();
			}

		}
		function cleanupwhendone()
		{
				$graydiv.fadeOut();
				$cancelmessage.hide();
		}

	}

	/***************************************************************************************
	* clear
	****************************************************************************************/
	function clearResults()
	{
		total = {
					patients:{},
					studies:{},
					seriessummary:{},
					responseRaw:""
				};		

		$seriestableb.empty();
		$studiestableb.empty();
		// do not clear multi body. Needed to indicate which patients are found
		//$searchbodyMulti.empty();
		
		$log.html("");

	}


	/***************************************************************************************
	* update
	****************************************************************************************/
	function updateStudiesTable(selids)
	{

		// store the selected
		selids = selids || $studiestableb.find('tr.'+selclass).each(function(k,e){ selids.push(e.id)});
		$studiestableb.empty();

		//******************* the studies summary **************************/
		for(var syuid in total.studies)
		{
			var s = total.studies[syuid];
			// unique id for this study
			var id =  createID("Studies" + syuid);
			//id += s["StudyDate"];
			var $row = $("<tr id='"+ id+ "' ></tr>");
			addToggler($row);

			$row.attr("StudyInstanceUID", s.StudyInstanceUID);
			for(var k=0; k< studiesFields.length; k++)
			{
				var z = s[studiesFields[k]]; 
				if(z ==undefined || (z instanceof Object) )
					z = "";

				// when offset given, show difference to searched date
				if(searchtype == 'multi' && studiesFields[k] == "StudyDate")
				{
					function makedate(s) {return new Date(s.substring(0,4) + "-" + s.substring(4,6) + "-" + s.substring(6,8))}
					for(var j=0;  j<multisearch.length; j++)
					{
						if( multisearch[j].StudyDate.length == 8 && multisearch[j].PatientID == s.PatientID && z != multisearch[j].StudyDate)
						{
							var ddiff = (makedate(z)-makedate(multisearch[j].StudyDate)) / (1000 * 60 * 60 * 24);
							if(ddiff != 0)
								z  = z + " (" + ddiff + "d)"
						}
					}
						
				}

				var sty = (k==studiesFields.length-1?"style='text-align:right;'":"");	
				$("<td "+sty+">"+ z + "</td>").appendTo($row);
			}
			// show all series contained in this study
			$row.click( function(s){return function(ev)
			{
				if(ev.shiftKey)
				{
					var indlast = $currentfocus.index();
					var indthis = $(this).index();
					var diff = indthis-indlast;
					if(diff > 0)
					{
						var $cc= $currentfocus;
					}
					else if(diff < 0)
					{
						var $cc= $(this);
						diff = -diff;
					}
					for(var x=0; x<diff; x++)
					{
						toggleRow($cc, ev.ctrlKey);
						$cc = $cc.next();
					}
					return false;
				}

				$virtualInput.focus();
				$currentfocus = $(this);
				$studiestableb.find("tr").removeClass("selected");
				$seriestableb.find("tr").removeClass('selected')
				$(this).addClass("selected")
				
				if(!showaggregated_status)
				{
					$seriestableb.find('tr').hide();
				}

				for(var sss in s.series)
				{
					var id2 = s.series[sss].SeriesDescription + s.series[sss].ProtocolName ;
					var $match = findRowByID($seriestableb, createID("Series" + id2));
					if($match)
					{
						if(!showaggregated_status)
							$match.show();

						$match.addClass('selected');
					}
				}
			}
			}(s));

			// restore selection
			if(0)
			{
				for(var k=0; k<selids.length; k++)
				{
					$studiestableb.find("tr[id='"+selids[k]+"']").each(function(z,e){
					toggleRow($(e), true)});
				}
			}
			// delete this study. 
			// Must update the right summary table
			addDeleter($row, function(s)
			{
				return function()
				{ 
					deletestudies([s]);
				}
			}(s));
			
			appendOrUpdateRow($studiestableb, $row, id)

		}


		//******************* the patient list in multi mode  **************************/
		if(searchtype == 'multi')
		{
			for(var k=0; k<multisearch.length; k++ )
			{
				var PatientID = multisearch[k].PatientID;
				var found = false;
				for(var p in total.patients)
				{
					 if(p==PatientID)
					 {
					 	found = true;
					  	break;
					 }
				}
				if(!found)
					$multisearchlist.eq(k).css('background','red').attr('wasnotfound', "");

			}
		}
		//updateSummaryTable();

	}

	/***************************************************************************************
	* delete a study
	****************************************************************************************/
	function deletestudies(studies)
	{
		for(var k=0; k<studies.length; k++)
		{
			var s = studies[k];
			// remove series from this study from patient
			for(var ss in total.studies[s.StudyInstanceUID].series)
				delete total.patients[s.PatientID].series[ss];

			delete total.patients[s.PatientID].studies[s.StudyInstanceUID];
			delete total.studies[s.StudyInstanceUID];  

			// delete empty patient
			if(total.patients[s.PatientID] != undefined &&  Object.getOwnPropertyNames( total.patients[s.PatientID].series ).length == 0 )
				delete total.patients[s.PatientID];

			$studiestableb.find("[studyinstanceuid='"+s.StudyInstanceUID+"']").remove();

		}
		// delete the series summary
		updateSummaryTable();
		
		// this row

	}

	/***************************************************************************************
	* delete certain protocols
	****************************************************************************************/
	function deleteprotocols(serieslist)
	{
		for(var k=0; k<serieslist.length; k++)
		{
			var s=serieslist[k];
			for( var ss in s.seriesList)
			{	
				var series = s.seriesList[ss];
				delete total.studies[series.StudyInstanceUID].series[ss];
				delete total.patients[series.PatientID].series[ss];

				// remove empty studies / patients
				if(Object.getOwnPropertyNames( total.studies[series.StudyInstanceUID].series ).length == 0 )
					delete total.studies[series.StudyInstanceUID];
				
				if( Object.getOwnPropertyNames( total.patients[series.PatientID].series ).length == 0 )
					delete total.patients[series.PatientID];
			}
		}
		updateStudiesTable();
		countSeries();

	}
	
	/***************************************************************************************
	* sort the series
	****************************************************************************************/
	function updateSummaryTable(selids)
	{
		updateSummary();

		var list = Object.getOwnPropertyNames(total.seriessummary);
		list = list.sort();
		
		// store the selected
		if(selids == undefined)
		{
			selids = [];
			$seriestableb.find('tr.'+selclass).each(function(k,e){ selids.push(e.id)});
		}

		
		$seriestableb.empty()
		
		for(var x=0; x<list.length; x++)
		{
			k = list[x];
			var s = total.seriessummary[k];
			var id =  createID("Series" + k);

			var $row = $("<tr draggable=true id='"+ id+ "' ></tr>");
			$row.attr('seriesname', k);
			//$row.attr('seriesList', Object.getOwnPropertyNames(s.seriesList).join(",") );

			$row.on('dragstart', function(s){ return function(ev)
			{
			  	
			  if(ev.originalEvent!== undefined)
				   ev.originalEvent.dataTransfer.setData("fromfiletable","yea");
			  else
		           ev.dataTransfer.setData("fromfiletable","yea");

				var obj = {};
				obj.seriousmode = $seriousmode.is(':checked')?1:0;
				if(!obj.seriousmode)
				{
					alertify.error('You are in TESTMODE. Aborting');
					return false;	
				}
					
				obj.pacsid = $pacslist.val();
				obj.targetsubfolder = $targetSubfolder.val();
				obj.PACSPREVIEW   = 1;
				obj.series = [ $.extend(true, {}, s.firstSeries) ];
				delete obj.series[0].RawString;
				obj.targetproject = currentModule;
		      
		      	var pacsobj = "PACS://" + JSON.stringify(obj);

				  tempObjectInfo = [
				  {
					type: "file",
					sid:  s.firstStudyInstanceUID,
					piz:  s.firstPatientID,
					namecat: "",
					subfolder:   "",
					tag:   "",
					intent:   {},
					filename: s.SeriesDescription,
					fileID:  pacsobj,
					mime:  "nii",
					rowid: undefined
				  } ];     
			}}(s) );

			addToggler($row, countSeries);


			for(var k=0; k< seriesFields.length; k++)
			{
				var z = s[seriesFields[k]]; 
				if(z ==undefined || (z instanceof Object) )
					z = "";
				var sty = (k==seriesFields.length-1?"style='text-align:right;'":"");	
				$("<td "+sty+">"+ z + "</td>").appendTo($row);
			}
			
			$row.click( function(s){return function(ev)
			{

				$virtualInput.focus();
				$currentfocus = $(this);
				$studiestableb.find("tr").removeClass("selected");
				$seriestableb.find("tr").removeClass('selected')
				$(this).addClass("selected")
				for(var sss in total.studies)
				{
					for(var se in  total.studies[sss].series)
					{
						var sdesc = total.studies[sss].series[se].SeriesDescription + total.studies[sss].series[se].ProtocolName;
						if(s.SeriesDescription+s.ProtocolName== sdesc)
						{
							var id2 = total.studies[sss].StudyInstanceUID
							var $match = findRowByID($studiestableb, createID("Studies" + id2));
							if($match)
							{
								$match.addClass('selected');
							}
						}
					}
				}
				
			}
			}(s));

			// delete a certain protocol in all studies and patients
			// must then update the studies table.
			addDeleter($row, function(s) {
				return function()
				{ 
					deleteprotocols([s])
				}
			}(s));
			
			appendOrUpdateRow($seriestableb, $row, id)
		}

		// restore selection
		for(var k=0; k<selids.length; k++)
		{
			$seriestableb.find("tr[id='"+selids[k]+"']").each(function(z,e){
			toggleRow($(e), true)});
		}
		
	}

	/***************************************************************************************
	* count series per study
	****************************************************************************************/
	function countSeries(sid)
	{
		var selstudies = {};
		var $selseries = $seriestableb.find('tr.'+selclass);
		for(var k=0; k<$selseries.length; k++)
		{
			var $s = $selseries.eq(k);
			var StudyInstanceUID = $s.attr('StudyInstanceUID');
			var seriesname = $s.attr('seriesname');
			var studiesList = total.seriessummary[seriesname].studiesList;
			for(var study in studiesList)
			{
				if(selstudies[study] == undefined )
				{
					selstudies[study] = studiesList[study][seriesname];
				}
				else
				{
					selstudies[study] += studiesList[study][seriesname];
				}
			}

		}
		var ind = studiesFields.indexOf("SS")+1;
		$studiestableb.find("tr").each(function(e,k){
			$(k).find('td').eq(ind).html("")});
		
		for(var s in selstudies)
		{
			var $row = findRowByID($studiestableb, createID("Studies" + s));
			var $td = $row.find('td').eq(ind);
			$td.html( parseInt(selstudies[s]) )
		}
	}


	/***************************************************************************************
	* dicomparse
	****************************************************************************************/
	function dicomparse(str, total)
	{
		if(str==null || str ==undefined)
			return;
			
		var baseregexp = (/[WI]:\s\((\w{4}\,\w{4})\)\s\w\w\s\[([^\]]+)\]\s+\#\s+\d+,\s\d\s(\w+)/g);
		
		// originally, we did NOT allow for closing ] in value field. But some series desc have ] ...
		// but we can also allow any char, seq ]  # will take care that closing tag is recognised correctly
		var baseregexp = (/[WI]:\s\((\w{4}\,\w{4})\)\s\w\w\s\[(.+)\]\s+\#\s+\d+,\s\d\s(\w+)/g);

		// "workaround" for syngo via CT perfusion pattern ( SeriesDescription includes [] and study date)
		// not necessary anymore, see above
		// str = str.replace(/\[\d+\]\s\w+\s\#\d+-\d+/g, '');
		
		str.match(/\[\s+\#/)
		var patients = {};
		var studies = {};

		var us = str.split(/[WI]: ---------------------------/);
		var nseries =  us.length;;
		// walk over response blocks == image series. can belong to different patients of full answer string ... 
		// start from one, first block is a DIMSE summary
		for(var z=1; z < nseries; z++)
		{
			var block = us[z];
			var series = {	StudyInstanceUID : 'StudyInstanceUID_missing', 
							SeriesInstanceUID : 'SeriesInstanceUID_missing', 
							SeriesDescription : 'MISSING', 
							StudyDescription : 'MISSING', 
							AccessionNumber : 'MISSING', 
							ProtocolName : 'ProtocolName_missing', 
							StudyDate: "StudyDate_missing",
							StudyTime: "N/A",
							NumberOfSeriesRelatedInstances: -1,
							Modality: "N/A",
							ModalitiesInStudy: "N/A",
							RawString: block,
							//PatientName: "PatientName_missing"
							};
			var lines = block.split("\n");
			for(var k=0; k<lines.length; k++)
			{
				var regexp = new RegExp(baseregexp);
				var m = regexp.exec(lines[k]);
				if(m!==null)
				{
					// set the key / value pairs
					//console.log(m[3]+ " : " +m[2])
					//m[2] = m[2].replace(/\#\[\]/, '');
					series[m[3]] = m[2];
				}
			}
			// this block was not really a series. (String might have been INCOMIMG DIMSE and so on) 
			if(series.PatientID == undefined)
				continue;
// 			if(series.NumberOfSeriesRelatedInstances < 100)
// 				continue;

			// check patient Age
			if( MinAge != 0 || MaxAge != 999 )
			{
				if(series.PatientBirthDate != undefined && series.StudyDate != undefined ) 
				{
					var date1 = parseInt(series.PatientBirthDate.substr(0,4)) + parseInt(series.PatientBirthDate.substr(4,2))/12;
					var date2 = parseInt(series.StudyDate.substr(0,4)) + parseInt(series.StudyDate.substr(4,2))/12;
					var theage = date2-date1;

					if( theage < MinAge || theage > MaxAge+1  )
						continue
				}
			}
			

			// for some pacs, this might be missing, depending on QR model. Use StudyDate then.
			if(series.StudyInstanceUID == "StudyInstanceUID_missing")
				series.StudyInstanceUID = series.StudyDate;

		
			// some problems with strange characters in newer findscu versions ... replace all nonnumeric / dots
			series.StudyInstanceUID   =  series.StudyInstanceUID.replace(/[^\d.]+/, "");
			series.SeriesInstanceUID  =  series.SeriesInstanceUID.replace(/[^\d.]+/, "");


			// do some cleaning
			series.PatientID = series.PatientID.trim();

			//if (series.SeriesDescription != series.ProtocolName)
			//	continue;

			//console.log(series.SeriesDescription);
			
			// create the patient
 			if( patients[series.PatientID] == undefined )
 			{
 				var p = patients[series.PatientID] = {PatientID: series.PatientID, PatientName: series.PatientName, studies: {}, series:{} };
 				total.patients[series.PatientID] = p;
 			}
 			else
 			{
 				var p = patients[series.PatientID]
 			}
			
			// create the study
 			if( studies[series.StudyInstanceUID] == undefined )
 			{
				studies[series.StudyInstanceUID] = 
				{
							PatientID: series.PatientID,
							PatientName: series.PatientName,
							NS: 1,
							StudyDate:  series.StudyDate,
							StudyTime: series.StudyTime.substring(0,2) +":" +series.StudyTime.substring(2,4),
							StudyDescription : series.StudyDescription,
							AccessionNumber : series.AccessionNumber,
							StudyInstanceUID : series.StudyInstanceUID,
							ModalitiesInStudy: series.ModalitiesInStudy,
							series: {}
				};
				total.studies[series.StudyInstanceUID] = studies[series.StudyInstanceUID];
 			}
 			else
 			{
				total.studies[series.StudyInstanceUID].NS ++;
 			}

 			// create the study in in patient
 			if( p.studies[series.StudyInstanceUID] == undefined )
 			{
 				p.studies[series.StudyInstanceUID] = total.studies[series.StudyInstanceUID]
 			}

 			// append series to study
			studies[series.StudyInstanceUID].series[series['SeriesInstanceUID']] = series;
			
 			// append series to patient
			p.series[series['SeriesInstanceUID']] = series;
			
		}
		

		return patients;

	}


// 	/***************************************************************************************
// 	* update summary 
// 	****************************************************************************************/		
// 	function updateSummary()
// 	{
// 		// walk over all patients / series and summarize series infos
// 		var patients = total.patients;

// 		// must clean this first
// 		total.seriessummary = {}

// 		for(var p in patients)
// 		{
// 			for(var s in patients[p].series)
// 			{
// 				var desc = patients[p].series[s].SeriesDescription;
// 				var cs = total.seriessummary[desc]; // thecurrent series
// 				if(cs==undefined)
// 				{
// 					cs = total.seriessummary[desc] = 
// 					{
// 						SeriesDescription:desc  , 
// 						ProtocolName:patients[p].series[s].ProtocolName,
// 						studiesList: {},
// 						seriesList:{},						
// 						instudies: 1,
// 						seriesNumberList: {},
// 						maxSeriesNumber: patients[p].series[s].SeriesNumber,
// 						maxNumberOfSeriesRelatedInstances: patients[p].series[s].NumberOfSeriesRelatedInstances,
// 						Modality: patients[p].series[s].Modality,
// 						firstSeries:patients[p].series[s]
// 					}
// 				}
// 				else
// 				{
// 					var cs =  total.seriessummary[desc]; // thecurrent series
// 					// take the max of NumberOfSeriesRelatedInstances
// 					if( patients[p].series[s].NumberOfSeriesRelatedInstances  > cs.maxNumberOfSeriesRelatedInstances )
// 				   		cs.NI = patients[p].series[s].NumberOfSeriesRelatedInstances;
// 					if( patients[p].series[s].SeriesNumber  > cs.maxSeriesNumber )
// 				   		cs.maxSeriesNumber = patients[p].series[s].SeriesNumber;
// 				}
				
// 				// add referenced studies, and a counter
// 				if(cs.studiesList[patients[p].series[s].StudyInstanceUID] == undefined)
// 					cs.studiesList[patients[p].series[s].StudyInstanceUID] = {};
				
// 				if(cs.studiesList[patients[p].series[s].StudyInstanceUID][desc] == undefined)
// 					cs.studiesList[patients[p].series[s].StudyInstanceUID][desc] = 1;
// 				else
// 					cs.studiesList[patients[p].series[s].StudyInstanceUID][desc] ++;

// 				// add referenced series	
// 				if(cs.seriesList[s] == undefined)
// 					cs.seriesList[s] = patients[p].series[s];


// 			   	cs.instudies = Object.getOwnPropertyNames(cs.studiesList).length;
// 				if(patients[p].series[s].SeriesNumber !== undefined)
// 				{
// 					cs.seriesNumberList[patients[p].series[s].SeriesNumber.trim()] = 1;
// 					//console.log(cs.seriesNumberList);
// 					var seriesNumbers =  Object.getOwnPropertyNames(cs.seriesNumberList).sort(function(a, b){return b-a});
// 					var maxlen = 4;
// 					if(seriesNumbers.length > maxlen)
// 						cs.maxSeriesNumber = seriesNumbers.slice(0,maxlen).toString() + "..." + seriesNumbers[seriesNumbers.length-1];
// 					else
// 						cs.maxSeriesNumber = seriesNumbers.toString();
// 				}
// 			}
// 		}
// 	}
// 	that.updateSummary = updateSummary;
	/***************************************************************************************
	* update summary 
	****************************************************************************************/		
	function updateSummary()
	{
		// walk over all studies / series and summarize series infos
		var studies = total.studies;

		// must clean this first
		total.seriessummary = {}

		for(var p in studies)
		{
			for(var s in studies[p].series)
			{
				var desc = studies[p].series[s].SeriesDescription+studies[p].series[s].ProtocolName //  studies[p].series[s].SeriesDescription;
				var cs = total.seriessummary[desc]; // thecurrent series
				if(cs==undefined)
				{
					cs = total.seriessummary[desc] = 
					{
						SeriesDescription:studies[p].series[s].SeriesDescription  , 
						ProtocolName:studies[p].series[s].ProtocolName,
						studiesList: {},
						seriesList:{},						
						instudies: 1,
						seriesNumberList: {},
						maxSeriesNumber: studies[p].series[s].SeriesNumber,
						maxNumberOfSeriesRelatedInstances: studies[p].series[s].NumberOfSeriesRelatedInstances,
						Modality: studies[p].series[s].Modality,
						firstSeries:studies[p].series[s]
					}
				}
				else
				{
					var cs =  total.seriessummary[desc]; // thecurrent series
					// take the max of NumberOfSeriesRelatedInstances
					if( studies[p].series[s].NumberOfSeriesRelatedInstances  > cs.maxNumberOfSeriesRelatedInstances )
				   		cs.NI = studies[p].series[s].NumberOfSeriesRelatedInstances;
					if( studies[p].series[s].SeriesNumber  > cs.maxSeriesNumber )
				   		cs.maxSeriesNumber = studies[p].series[s].SeriesNumber;
				}
				
				// add referenced studies, and a counter
				if(cs.studiesList[studies[p].series[s].StudyInstanceUID] == undefined)
					cs.studiesList[studies[p].series[s].StudyInstanceUID] = {};
				
				if(cs.studiesList[studies[p].series[s].StudyInstanceUID][desc] == undefined)
					cs.studiesList[studies[p].series[s].StudyInstanceUID][desc] = 1;
				else
					cs.studiesList[studies[p].series[s].StudyInstanceUID][desc] ++;

				// add referenced series	
				if(cs.seriesList[s] == undefined)
					cs.seriesList[s] = studies[p].series[s];


			   	cs.instudies = Object.getOwnPropertyNames(cs.studiesList).length;
				if(studies[p].series[s].SeriesNumber !== undefined)
				{
					cs.seriesNumberList[studies[p].series[s].SeriesNumber.trim()] = 1;
					//console.log(cs.seriesNumberList);
					var seriesNumbers =  Object.getOwnPropertyNames(cs.seriesNumberList).sort(function(a, b){return b-a});
					var maxlen = 4;
					if(seriesNumbers.length > maxlen)
						cs.maxSeriesNumber = seriesNumbers.slice(0,maxlen).toString() + "..." + seriesNumbers[seriesNumbers.length-1];
					else
						cs.maxSeriesNumber = seriesNumbers.toString();
				}
			}
		}
	}
	that.updateSummary = updateSummary;



		
	/***************************************************************************************
	* analysePatientList from excel list or similar
	****************************************************************************************/
	that.analysePatientList = analysePatientList;
	function analysePatientList(excelRow)
	{
		if (excelRow == undefined || excelRow.target != undefined)
			excelRow = $listarea.val().split(String.fromCharCode(10)) ;
		else 
			$listarea.val("");
			
		$searchbodyMulti.empty();
		
		multisearch.length = 0;
		$multisearchlist.length = 0;
		$searchbodyMulti.empty();
			// Loop over the rows
			for (i=0; i<excelRow.length; i++) 
			{
				var r = excelRow[i].trim();
				if(r == "")
					continue;

				if(r == "NULL")
					continue;

				var item = {};
				var $row = $("<tr class='pacsqueryrow'></tr>");
				// must split rows by tab or by empty spaces
				// empty row

				var tabchar = String.fromCharCode(9);

				r = r.replace(/,\s*/, '^');
				var temp = r.match(/([\u00C0-\u017Fa-zA-Z\-]+)\s+([\u00C0-\u017Fa-zA-Z\-]+)/);
				if(temp && temp.length == 3)
					r = r.replace(temp[0],temp[2]+'^'+temp[1] );	

				r = r.split(/[\t\s]+/);

				// loop over all search fields and fill
				var lastfield = '';
				for (var j=0; j<fieldnames.length; j++) 
				{
					//default values
					
					if(r[j] != undefined)
						var val = r[j].trim();
					else if($inputsMulti[fieldnames[j]] != undefined  && fieldnames[j] !='PatientName')
						var val = $inputsMulti[fieldnames[j]].val()
					else
						var val = "*";

					// find out: is it patientID, Name, or date? ID vs Date difficult, assume always ID first
					var thefield = fieldnames[j];
					if( j==0 )
					{
						if( val.search(/\^/) > -1) // is a patient Name
							thefield = 'PatientName';
						else // if first one is not PatienName, must be PatientID
							thefield = 'PatientID';
					}
					else if( j==1)
					{
							thefield = 'StudyDate';
					}
					
					if(thefield != undefined)
					{
						if(thefield=='StudyDate')
						{
							var xx = val;
							if(xx.search(/\//) != -1 ) // USA date
							{
							  xx = xx.split('/');
							  if(xx.length==3)
							  {
							  	xx = zeroPad(xx[2],2) + zeroPad(xx[0],2) + zeroPad(xx[1],2);
							  	val = xx;
							  }
							}
							else if(xx.search(/\./) != -1 ) // german date
							{
							  xx = xx.split('.');
							  if(xx.length==3)
							  {
							  	xx = zeroPad(xx[2],2) + zeroPad(xx[1],2) + zeroPad(xx[0],2);
							  	val = xx;
							  }
							}
							if(  xx.length == 8 ) // already 8 digits, assume this is a YYYMMDD date
							{
							  	val = xx;
							}
							else if(xx.length < 8 && xx.length >1)
							{
								// add a wildcard for less than 8 digits? No, does not work anyhow
								val =  "date_too_short"
							}
							else
							{
								// add a wildcard for less than 8 digits
								val =  '*';
							}
						}
					}
					// everything beyond patient ID and Date: just copy what is in the fields
					else if($inputsMulti[fieldnames[j]] != undefined)
					{
						val =  $inputsMulti[fieldnames[j]].val();	
					}
 					else
 					{
 						val = "*";
 					}

					if(item[thefield]==undefined) // do not overwrite patientname
						item[thefield] = val;

				}
				for (var j=0; j<fieldnames.length; j++) 
				{	
					if(item[fieldnames[j]]==undefined)
						item[fieldnames[j]]='*';
				}
				if(item['PatientID'].length< 4 &&  item['PatientName'] == '*' )
						item['PatientID'] += "_ID_TOO_SHORT";

				for (var j=0; j<fieldnames.length; j++) 
				{	
					var $td = $("<td>"+item[fieldnames[j]]	+"</td>")
					$row.append($td);
				}

				// take piz + study id as unique key
				var uid = "PACSQmultirow" + r[0];
				if(r[1] != undefined)
					uid += r[1];
				uid = uid.replace(/[\*/^]+/g,'_')

				$row.append("<td>"+i+"</td>")
				if( appendOrUpdateRow($searchbodyMulti, $row, uid) == false)
				{
					multisearch.push(item);
				}
			}
		    $multisearchlist = $searchbodyMulti.find("tr.pacsqueryrow");

			
		}

	/***************************************************************************************
	* appendOrUpdateRow in an existing table
	****************************************************************************************/
	function createID(id)
	{
		//return "PACSQuery" + id.replace(/[^\w]/gi, "");
		//return "PACSQuery" + encodeURIComponent(id).replace(/[^\w]/gi, "");
		return "PACSQuery" + btoa(id).replace(/[^\w]/gi, "_");

	}

	function findRowByID($table, subid)
	{
		var id = "" + subid;
		var $row = $table.find("#"+id);
		if($row.length > 0)
			return $row;	
		else
			return false;
	}

	function appendOrUpdateRow($table, $row2, subid)
	{
		//var id = "" + subid.replace(/[^\w]/gi, "");
		var id = "" + subid;
		$row2.attr('id', id);
		var $row = $table.find("#"+id);
		if($row.length==0)
		{
			$table.append($row2);
		}
		else
		{
			$row.replaceWith($row2);
		}
		

		return $row.length > 0;
	}

	/***************************************************************************************
	* upload results to re-parse by drop
	****************************************************************************************/
	function ondrop(ev)
	{
		cleanAllDropIndicators();
		var reader = new FileReader();
		reader.onload = function(e) 
		{
			try
			{
				var res = this.result;
				clearResults();
				$dropindicator.$progress.text('parsing dicom objects ...');
				dicomparse(res, total);

				// selected studies / protocols
				var sep = "::JSON::";
				var lastblock = res;
				var ind = lastblock.search(sep);
				$dropindicator.$progress.text('parsing json and creating list ...');
				var json = JSON.parse( lastblock.substr(ind + sep.length) );

				updateStudiesTable(json.selectedstudies);
				updateSummaryTable(json.selectedprotocols);
				total.responseRaw = res;
			}
			catch(err)
			{
				console.log(err);
				alertify.alert("Error during json parse.");
			}

			$dropindicator.$progress.text('');
			//hideDropIndicators();

		}

		if(ev.originalEvent.dataTransfer.files && ev.originalEvent.dataTransfer.files.length > 0 )
		{
			$dropindicator.$progress.text('loading data ...');
			reader.readAsText(ev.originalEvent.dataTransfer.files[0]);
		}

	}
	
	/***************************************************************************************
	* downloadResultsRaw
	****************************************************************************************/
	function downloadResultsRaw()
	{
		var raw = total.responseRaw;
		var raw = "";
		for(var p in total.studies)
			for(var s in total.studies[p].series)
				raw += ( "W: ---------------------------\n" +  total.studies[p].series[s].RawString );
		
		// save also the selected states
		var struct = {};
		struct.selectedprotocols = []; $seriestableb.find('tr.'+selclass).each(function(k,e){ struct.selectedprotocols .push(e.id)});
		struct.selectedstudies = []; $studiestableb.find('tr.'+selclass).each(function(k,e){ struct.selectedstudies .push(e.id)});

		raw +=  "W: ---------------------------\n";
		raw +=  "::JSON::";
		raw += JSON.stringify(struct);


		var bb =  new Blob([raw], {type: 'text/plain'});
		var url = window.URL.createObjectURL(bb);
		var link = document.createElement('a');
		link.setAttribute('href', url);
		link.setAttribute('download', "PACSQuery_results.txt");
		var event = document.createEvent('MouseEvents');
		event.initMouseEvent('click', true, true, window, 1, 0, 0, 0, 0, false, false, false, false, 0, null );
		link.dispatchEvent(event);
	}

	/***************************************************************************************
	* downloadResultsCSV
	****************************************************************************************/
	function downloadResultsCSV()
	{
		//var fields = ['PatientID', 'StudyDate', 'SeriesDescription', 'ProtocolName', 'NumberOfSeriesRelatedInstances', 'Modality', 'SeriesNumber', 'StudyTime', 'StudyInstanceUID', 'SeriesInstanceUID'];
		var fields = ['PatientID', 'StudyDate', 'SeriesDescription', 'ProtocolName', 'NumberOfSeriesRelatedInstances', 'Modality', 'SeriesNumber', 'StudyTime', 'StudyInstanceUID', 'SeriesInstanceUID', 'PatientSize', 'PatientWeight'];
		csv = "";
		for(var k=0; k<fields.length; k++)
		{
			csv +=  fields[k] + ";"
		}
		csv += "\n";


		for(var p in total.studies)
		{
			for(var s in total.studies[p].series)
			{
				for(var k=0; k<fields.length; k++)
				{
					var temp = total.studies[p].series[s];
					csv +=  temp[fields[k]] + ";"
				}
				csv += "\n";
			
			}
		}
		//console.log(csv);
		//return

		var bb =  new Blob([csv], {type: 'text/plain'});
		var url = window.URL.createObjectURL(bb);
		var link = document.createElement('a');
		link.setAttribute('href', url);
		link.setAttribute('download', "PACSQuery_results.csv");
		var event = document.createEvent('MouseEvents');
		event.initMouseEvent('click', true, true, window, 1, 0, 0, 0, 0, false, false, false, false, 0, null );
		link.dispatchEvent(event);
	}

	
	/***************************************************************************************
	* subtract another list
	****************************************************************************************/
	function subtractOtherList(ll)
	{
		
		// split by enter
		alertify.prompt('Please copy and paste excel list with PatientIDs (and optional StudyDates) to be excluded from current List', function(a,b) 
			{if(a) doit(b) } );
		
		//var fullstring = "23620588 20100903";
		function doit(fullstring)
		{

			var others = {};
			var flist  = [];

			//var excelRow = fullstring.split(String.fromCharCode(10)) ;
			var excelRow = fullstring.split( " " ) ;
			for (i=0; i<excelRow.length; i++) 
			{
				var r = excelRow[i].trim();
				if(r.trim() == "")
					continue;

				r = r.split(/[\t\s]+/);
				//if(r.length>1)
				flist.push(r)	

			}
			//console.log(flist);


			if (flist.length == 0)
				return;

			var todelete_multisearch = 0;
			for(var f=0; f<flist.length;f++)
			{
				var tline = flist[f];
				var tlen = tline.length;
				for(var p=0; p<multisearch.length; p++)
				{
					if(tline[0].indexOf(multisearch[p].PatientID) !== -1)// != -1 && tline[1].indexOf(multisearch[p].StudyDate) != -1)
					{
						multisearch.splice(p,1);
						todelete_multisearch++;
						break;
					}
				}
			}
			if(todelete_multisearch>0)
			{
				var temp = "";
				for(var p=0; p<multisearch.length; p++)
				{
					temp += (multisearch[p].PatientID + String.fromCharCode(9) +  multisearch[p].StudyDate + String.fromCharCode(10) );
				}
				$listarea.val(temp)
				analysePatientList()
			}

			if(total==undefined)
			{
				alertify.alert('Removed ' + (todelete_multisearch) + " search items ");
				return

			}


			var todelete = [];
			for(var f=0; f<flist.length;f++)
			{
				var tline = flist[f];
				var tlen = tline.length;
				for(var p in total.patients)
				{
					for(var s in total.patients[p].studies)
					{
						if( tline[0].indexOf(p) != -1)
						{
							if(tlen == 1 || (tlen>1 && tline[1].indexOf(total.patients[p].studies[s].StudyDate) != -1) )
							{
								todelete.push(total.patients[p].studies[s]);
							}

						}

					}
				}
			}
			deletestudies(todelete);
			alertify.alert('Removed ' + (todelete.length + " serch items and " + todelete_multisearch) + ' studies');
		}
	}


	return that;

}

PACSQuery.retrieve = function(fileID)
{
	console.log(fileID);
	var obj = {};
	obj.PACSPREVIEW = 1;
	obj.project = currentModule;

	KViewer.dataManager.loadData(
	{
		fileID:fileID, 
		URLType:'serverfile',
		callback: whendone,
		progressSpinner:function(){},
		intent:{},
		json: obj
	});

	function whendone(response)
	{

		1
	
	}

}

// get the missing matches and write to console
PACSQuery.getNotFound = function()
{
//	var list = $(".pacsqueryrow[style='background: red;']");
	var list = $(".pacsqueryrow")
	
	var $container = $("<div  style='display:flex;'></div>");
	var $yfound_table  = $("<div class='pacsquery_dumplist'></div>").appendTo($container).append($("<div style='display:flex'>Found Studies</div>"));
	var $nfound_table = $("<div  class='pacsquery_dumplist'></div>").appendTo($container).append($("<div style='display:flex'>Missing Studies</div>"));;
	var $failed_table = $("<div  class='pacsquery_dumplist'></div>").appendTo($container).append($("<div style='display:flex'>Failed Studies</div>"));;

	var str_found = "<table margin = 10px;>";
	var str_nfound = "<table>";
	for(var k=0; k<list.length; k++)
	{
		var c = list.eq(k).children();
		var u = "<tr><td>" + c.eq(0).text() + "</td><td>" + c.eq(1).text() + "</td></tr>";
		if(list.eq(k).attr('wasnotfound') == undefined )
			str_found += u;
		else
			str_nfound += u;
	}
	str_nfound += "</table>";
	str_found += "</table>";

	// *************************** failed ones
	var list = $(".pacsquery_failed")
	var str_failed = "<table margin = 10px;>";
	for(var k=0; k<list.length; k++)
	{
		var c = list.eq(k).children();
		var u = "<tr><td>" + c.eq(2).text() + "</td><td>" + c.eq(4).text() + "</td></tr>";
		str_failed += u;
	}
	str_failed += "</table>";



	var d = new dialog_generic();
	d.deleteonclose = true;
	d.$frame.show().width($(document.body).width()*.8);

	$yfound_table.append($("<div style='user-select:text;-webkit-user-select:all;'>" + str_found + "</div>") )
	$nfound_table.append($("<div style='user-select:text;-webkit-user-select:all;'>" + str_nfound + "</div>") )
	$failed_table.append($("<div style='user-select:text;-webkit-user-select:all;'>" + str_failed + "</div>") )

	d.$container.append( $container );
	

	//console.log(str);

}
