<?php
// ==================== ppatient table  ==========================



/**********************************************************************************
* Time markers
***********************************************************************************/

$GLOBALS['timeMarkersForPatientTable'] = array( 
            array('title'=>'Today',         'addstr' => '',    'scode'=> 'l', 'tcode'=> strtotime('today')                     ),
            array('title'=>'Yesterday',     'addstr' => '',   'scode'=> '', 'tcode'=> strtotime('-1 day')               ),
            array('title'=>'Older than  2 days',     'addstr' => '',   'scode'=> '', 'tcode'=> strtotime('-2 days')               ),
            array('title'=>'Older than 10 days',     'addstr' => '',   'scode'=> '', 'tcode'=> strtotime('-10 days')               ),
            array('title'=>'Older than 30 days',     'addstr' => '',   'scode'=> '', 'tcode'=> strtotime('-30 days')               ),
            array('title'=>'Older than 100 days',     'addstr' => '',   'scode'=> '', 'tcode'=> strtotime('-100 days')               ),
            //array('title'=>'This year',     'addstr' => '' ,    'scode'=> 'Y', 'tcode'=> strtotime('first day of january ' . Date('Y') . ' 00:00:00') ),
            //array('title'=>'Last years','addstr' => '...' ,    'scode'=> Date( intval(Date('Y')) -1), 'tcode'=>  strtotime('first day of january ' . (intval(Date('Y')) )  . ' 00:00:00') )
            );

$thisyearstart = intval(Date('Y')); 
$nyears = 10;
for($k=0; $k<$nyears; $k++)
{
   $temp = array('title'=>'Year ' . Date($thisyearstart -$k -1) ,'addstr' => '' ,   'scode'=> '', 'tcode'=>  strtotime('first day of january ' . ($thisyearstart - $k ) . ' 00:00:00') ) ;   
   if($k==$nyears-1)    $temp['addstr'] = 'and before';
   $GLOBALS['timeMarkersForPatientTable'][] = $temp;
}

// set the current times
foreach( $GLOBALS['timeMarkersForPatientTable'] as &$temp )
{
    $temp['keytime'] = $temp['tcode'];
    $temp['fulltitle'] = $temp['title'] ;
    if(!empty($temp['scode']) | !empty($temp['addstr']))
        $temp['fulltitle'] .=  "<span > (" . ($temp['addstr']=="..."?"":$temp['addstr']) . Date($temp['scode'], $temp['tcode'] ). ($temp['addstr']!="..."?"":$temp['addstr']) .")</span>";
}




/**********************************************************************************
* List of fakenames
***********************************************************************************/

// $GLOBALS['fakenames'] = array("Zack Freeberg","Claudia Carmona","Hattie Cebula","Ezequiel Ramage","Alonzo Holtzen","Eleonore York","Christoper Hasegawa","Edelmira Luechtefeld","Matilde Hank","Jayme Bunton","Karan Teske","Pamila Heilmann","Zita Sessums","Denae Brotzman","Juanita Murnane","Rosamaria Chen","Quincy Giltner","Sherry Gilley","Kathyrn Laraway","Mabel Nordahl","Nina Rutan","Estefana Goff","Cindy Dobyns","Sherron Sidwell","Raven Haran","Kathryn Schutz","Chun Frisina","Mendy Freund","Synthia Scheff","Angelic Mukai","Christian Bauer","Lucy Partain","Tessa Steffey","Sharleen Venturi","Romelia Demmer","Hailey Mahmood","Jarod Miranda","Morgan Bake","Cassidy Hanlon","Tandra Bibeau","Jarrett Michalowski","Lizette Cloutier","Kurtis Reinhard","Cheyenne Thatch","Zelda Koons","Debbi Laiche","Dorothea Peskin","Anissa Lesko","Tawanda Adame","Suk Dulaney","Lakeesha Range","Shawnee Holmes","Leoma Canipe","Jaqueline Homeyer","Pricilla Boots","Neoma Anzalone","Leighann Niles","Xavier Rudloff",
//                    "Maisie Kyllonen" , "Maribel Bradburn","Rubin Lillibridge","Wanetta Fiore","Polly Luedke","Voncile Delano","Kendra Mulhern","Becky Loud","Ardelle Vanwyk","Sang Furry","Roberto Blizzard","Harriette Bowling","Lavelle Tustin","Ettie Wilner","Patria Patricio","Jonie Hauk","Jacque Frisbee","Marilyn Crepeau","Florine Giddings","Kaylene Auten","Ashanti Falconer","Vanessa Leal","Mackenzie Swensen","Willodean Busby","Romona Kohut","Alverta Doepke","Dawne Reising","Heike Shibata","Tish Hagen","Tama Mauriello","Doug Clutts","Jacob Pontious","Birgit Dufrene","Audrea Hillebrand","Lyman Bennington","Alecia Pinckney","Johnnie Halas","Ellamae Margulies","Jordon Maynard","Angie Peachey","Nina Sexton","Victor Holton","Ivana Vanslyke","Nolan Roman","Arica Hwang","Jonell Chand","Ernestine Woodell","Willian Maus","Dottie Heffelfinger","Roscoe Netto","Love Crocket","Jonie Pond","Melinda Sheeley","Sharen Carnell","Alfredia Siu","Asia Pentz","Myrle Bernardi","Doretta Cothran",
//                     "Lily Paige","Noreen Renner","Anabel Travers","Wyatt Tostado","Berneice Friscia","Deneen Kriner","Leonida Busby","Nella Eskridge","Jerome Hollandsworth","Foster Hiltner","Socorro Welk","Debbi Alegria","Claudio Cool","Livia Kielbasa","Mammie Garneau","Erna Bunton","Gudrun Esparza","Felicidad Pinnock","Odette Masse","Maura Oberle","Carmine Rape","Reed Luca","Masako Cofield","Ambrose Linhart","Roselyn Mcelyea","Lu Mcdivitt","Lizzette Kohler","Brandee Fagen","Thuy Priest","Sylvie Felton","Alicia Nicholas","Shannan Laviolette","Chan Mcdow","Tamica Fletcher","Robbin Wagener","Madie Sterling","Sulema Findley","Dagny Chittenden","Luis Dawkins","Patty Czaja","Beaulah Rathburn","Savannah Bravo","Renate Figueroa","Jeff Marion","Rhiannon Mercuri","Paola Labonte","Nikita Devenport","Angelyn Palmeri","Sandie Engelbrecht","Ernest Holston","Vernie Gent","Trula Divis","Jutta Acheson","Everette Hennig","Titus Mckenzie","Carman Bonin","Noe Crupi","Meaghan Tallant","Aaron Eury",
//                     "Forest Evenson","Luanne Knappenberger","Larue Stradley","Kay Coppin","Arlean Hunnicutt","Lamont Sarris","Eveline Gay","Angelic Fikes","Arianna Gin","Jane Prout","Brant Iannuzzi","Rufus Formica","Christiana Kahan","Kittie Wiemann","Maryrose Barnett","Julieann Savage","Bennett Brantner","Roscoe Quillen","Shonna Dingus","Lady Nally","Erline Petteway","Deloris Waldorf","Eldridge Bang","Cristy Mess","Concetta Felan","Robbi Remick","Erich Privett","Tiffanie Lopinto","Tien Mehr","Ethan Metcalfe","Wilmer Gulley","Mammie Robichaud","Chi Sheeler","Evie Manners","Rebbeca Kitson","My Oleson","Ai Boler","Lorina Molden","Claris Kinzer","Randell Follett","Brittaney Deering","Alease Pfeffer","Denisha Heyman","Virgilio Attwood","Agatha Leblanc","Terica Beecham","Luann Sheley","Arletta Nowland","Coralie Pattee","Reggie Hazlett","Hugh Renick","Deeann Simpkins","Elwood Baisley","Carri Defore","Tomi Edinger","Marisa Gaul","Janiece Appelbaum","Kenton Heider","Sarina Suzuki","Brittney Boyland",
//                     "Danna Kosakowski","Deon Lam","Corazon Puffer","Jerri Rojas","Zelda Kiddy","Morton Guerra","Lupe Monn","Beau Penta","Carylon Trower","Maisha Woolard","Erica Casias","Laticia Quijano","Veronique Hannon","Carolin Kimes","Kalyn Hinkle");

// $faknames = array("Mickey Mouse", "Minnie Mouse", "Donald Duck", "Sherlock Holmes", "Dr. Watson", "Gordon Goofy", "Gandalf Ring", "King Arthur", "Jim Knopf", "Tow Sawyer", "Huckleberry Finn", "Moby Dick", "Donald Drump", "Prinz Eugen", "James Bond", "Winnetou the Winner", "Jesse James", "Lucky Luke", "Joe Dalton", "Averell Dalton", "Rantantplan" );
// $GLOBALS['fakenames'] = array_merge($faknames,$faknames,$faknames,$faknames,$faknames,$faknames);

// the new fake names as file, currently 4000 entries
$temp = file_get_contents(dirname(__FILE__) . '/fakenames.txt');
$GLOBALS['fakenames'] = explode("\n", $temp);

// these keep track of the item currently in the sql table, so new items will be found if inserted.
if( !isset($_SESSION["currentStudies"] )) $_SESSION["currentStudies"] =  array();
if( !isset($_SESSION["currentPatients"] )) $_SESSION["currentPatients"] = array();


/**********************************************************************************
* definition of the table structure
***********************************************************************************/
function defineTableHeaders()
{
    $project = $_GET['project'];       
    $thestate = $_SESSION['state'][$project];    

    $field_combined = array("NameCat" => "concat(FamilyName,', ',GivenName)");


    // this defines column header titles and column order (key=>title)
    $_Header = array('selector'=> '', 'PIZ'=> 'PID'  ,'NAME'=> 'Patient',      'DATE' => 'Date','SUID'=>'UID');
    
    // this maps column-keys on db-columnnames
    $pHeader = array('selector'=> '', 'PIZ'=> 'PIZ'   ,'NAME'=> 'NameCat', 'DATE' =>'StudyDate' ,'PTAG' => 'PTag', 'STAG' => 'STag');
    $sHeader = array('selector'=> '', 'PIZ'=> 'StudyID','NAME'=> 'StudyDescription', 'DATE' =>'StudyDate','SUID'=>'StudyInstanceUID', 'STAG' => 'STag');
    $aHeader = array('selector'=> '', 'PIZ'=> 'StudyID','ANAME'=> 'StudyDescription','NAME'=> 'StudyDescription', 'DATE' =>'StudyDate');
    $fHeader = array('PIZ' => 'Tag', 'NAME' => 'Filename','ANAME' => 'Filename','SDESC'=>'filesize','SUID'=>'permission', 'DATE' =>'DateModified');
    $subFolderHeader = array('NAME' =>'SubFolder','PIZ' => 'Tag','SDESC' => 'size','DATE' =>'Date');


    if ($thestate->viewer->selectionMode[1] == "s" )
    {
      $_Header = array('selector' => '', 'PIZ' => 'PSID', 'NAME' => 'Patient','SDESC' => 'Description', 'DATE' => 'Date','SUID'=>'UID');
      $sHeader = array('selector' => '', 'PIZ' =>'StudyID', 'NAME' => 'NameCat','SDESC' =>'StudyDescription','DATE' => 'StudyDate','SUID'=>'StudyInstanceUID','PTAG' => 'PTag', 'STAG' => 'STag');

    }

    if ( $thestate->viewer->selectionMode[1] == "a" )
    {
      $_Header = array('selector' => '',  'PIZ' => 'ID', 'NAME' => 'Analysisgroup','DATE' => 'Date','SDESC' => 'Info','SUID' => 'perm');
 //      $_Header = array('selector' => '', 'PIZ' => 'AID', 'ANAME' => 'Description', 'DATE' => 'Date');
    }

    if ( $thestate->viewer->selectionMode[1] == "f" )
    {
      $_Header = array('selector' => '','PIZ' => 'PSID', 'SF'=>'subfolder','FNAME' => 'Filename',  'TAG' => 'Tag', 
         'FS'=> 'size','DF' => 'Date modified','PERM'=> 'permission', 'NAME'=>'Patient','DATE' =>'StudyDate');
      $fHeader = array('TAG' => 'Tag', 'PIZ' =>'PSID', 'FNAME' => 'Filename','SF' => 'SubFolder','NAME' => 'NameCat', 'FS' => 'filesize','DF' => 'DateModified','PERM'=>'permission','DATE' =>'StudyDate');
    }


    if ($thestate->viewer->selectionMode[1] != "f" && $thestate->viewer->selectionMode[1] != "a" )
    {
      $db = mydbconnection($project);
      $a = $db->query("select * from metaidx where (level='study' or level='patient') AND (metaname LIKE '" . $_SESSION['username'] . "\_%' OR metaname LIKE 'root\_%'  OR metaname LIKE 'XSHARED\_%')");
      while($row = $a->fetch_assoc())
      {

         $idx = json_decode($row['metaidx']);
         $nous = $row['metaname'];
         $splitpos = strpos($nous,"_");
         
         if ($idx[0] == 'PATIENT' || $idx[0] == 'STUDY') // || sizeof($idx) == 1)
            $nous = substr($row['metaname'],$splitpos+1);
  
         $_Header['META_' . $row['metaname']] = substr($row['metaname'],$splitpos+1);
         if ($row['level'] == 'study'  | $thestate->viewer->selectionMode[1] == "s" )
         {
            $sHeader['META_' . $row['metaname']] = $nous;
            $pHeader['META_' . $row['metaname']] = $nous;     
         }
     
         if ($row['level'] == 'patient')         
            $pHeader['META_' . $row['metaname']] = $nous;     

      }
      $db->close();
    }

    $perm = "permstate_" . $thestate->viewer->selectionMode[1];

    if (isset($thestate->table) && isset($thestate->table->$perm))
       $_Header = permute_assoc_array($thestate->table->$perm, $_Header);



     $project_anonym =
                     $_SESSION['moduleInfo'][$project]['forceAnonymize'] != 0 ||  
                    (isset($_SESSION['moduleInfo'][$project]['jsondesc']['forceAnonymize']) &&
                     $_SESSION['moduleInfo'][$project]['jsondesc']['forceAnonymize'] != 0 );

    $usersetting_anonym = $_SESSION['userinfo']['forceanonymize'] != 0 ;
    $user_deanonym = isset($_SESSION['moduleInfo'][$project]['rights']->deanonym) && $_SESSION['moduleInfo'][$project]['rights']->deanonym == "on"; 
    $user_deanonym = $user_deanonym | ($_SESSION['userinfo']['isadmin'] === '1')  ;
    $user_deanonym = $user_deanonym | $_SESSION['moduleInfo'][$project]['role'] == 'admin';

    $GLOBALS['anonym_mode'] = ( $usersetting_anonym | ($project_anonym & !$user_deanonym));
    $GLOBALS['psid_anonym_mode'] = $GLOBALS['anonym_mode'] & ($_SESSION['userinfo']['forceanonymize']==2);


    $GLOBALS['field_combined'] = $field_combined;
    $GLOBALS['_Header'] = $_Header;
    $GLOBALS['aHeader'] = $aHeader;
    $GLOBALS['sHeader'] = $sHeader;
    $GLOBALS['pHeader'] = $pHeader;
    $GLOBALS['fHeader'] = $fHeader;
    $GLOBALS['subFolderHeader'] = $subFolderHeader;

}



function permute_assoc_array($perm,$arr)
{
    $keys = array_keys($arr);
    $newarr = array();
    for ($i=0;$i < sizeof($perm);$i++)
    {
        if(isset($keys[$perm[$i]]))
        {
            $k = $keys[$perm[$i]];
            if ($k != null)
                $newarr[$k] = $arr[$k];
        }
    }
    return $newarr;


}

function pid_hash($anonym,$str)
{
  if ($anonym->type == 'sha1')
     $str = hash('sha1',$str);
  $keylen = 10;
  if (isset($anonym->key_length))
     $keylen = $anonym->key_length;
  $str = substr($str,0,$keylen);
  return $str;

}

function renderPatientTable($fullrender,$project,$isRetry=false)
{
    if($project=='' | $project == null)
      return '';
   
    $studies = array();
    $patients = array();
    $files = array();

    $numfiles = "";
    
    $thestate = $_SESSION['state'][$project]; 
    $sortOrder = $thestate->viewer->sortOrder;
    $sortDirection = $thestate->viewer->sortDirection;
  
    defineTableHeaders();





    /**********************************************************************************
    * header rendering
    ***********************************************************************************/

    $db = mydbconnection($project);
 
    $html = "\r\n";
    $html .= "<div id='patientTableWrap'>";
    $html .= "<table cellspacing=0 id ='patientTable' class='stickytable'  >";
    $html .= "<iframe name='KsearchForms' style='display:none' src='about:blank'></iframe>";
  
    $html .= "<thead>";
    $html .= renderHeaderRow($GLOBALS['_Header']);
    $html .= "</thead>";
    $html .= "<tbody>";


    /**********************************************************************************
    * build main query string
    ***********************************************************************************/

                     
       
    $a = $db->query("select *,concat('meta',level,'.',metaname) as colname from metaidx where (level='study' or level='patient') AND (metaname LIKE '" . $_SESSION['username'] . "\_%' OR metaname LIKE 'root\_%' OR metaname LIKE 'XSHARED\_%'  )");    
    $metaIndices = array();
    while($row = $a->fetch_assoc())
    {
      $row['metaidx'] = json_decode($row['metaidx']);
      $row['native'] = ($row['metaidx'][0] == 'PATIENT' || $row['metaidx'][0] == 'STUDY');
      
      if ($row['native'])
      {
          $splitpos = strpos($row['metaname'],"_");
          $row['colname'] = substr($row['metaname'],$splitpos+1);      
      }
      
      $metaIndices[$row['metaname']] = $row;     
      
    }       
  //    $metaIndices = array();


  /////////////////// new 


    $objWC2 = null;
    if ($thestate->viewer->selectionMode[1] == 'a')
    { 
        if (isset($thestate->SearchText_a))
           $objWC2 = json_decode(str_replace("*","%",$thestate->SearchText_a));  
    }
    else if (isset($thestate->SearchText))
      $objWC2 = json_decode(str_replace("*","%",$thestate->SearchText));

  
    $field_combined = $GLOBALS['field_combined'];

    $astrQ = "";
    $fstrQ = "";
 

    if ($thestate->viewer->selectionMode[1] == 'a')
       $astrQ = " AND (PIZ = 'ANALYSIS')";
    else if ($thestate->viewer->selectionMode[1] == 's' | $thestate->viewer->selectionMode[1] == 'p')
       $astrQ = " AND NOT (PIZ='ANALYSIS')";
    else
       $astrQ = "";
  
    $createtmptab = array();
    $tmpcnt = 0;

    if(isset($objWC2) && $objWC2 !== null)
    {
     foreach($objWC2 as $exp1)
     {
 
      $astr = "";
      $fstr = "";
      foreach($exp1 as $exp2)
      {
           $key = $exp2[0];
           
           // all keys are upper case
           $key_cs = $key;
           $key = strtoupper($key);

           if($key == 'SQL')
           {
			$astr = $exp2[1];
			continue;
           }
				
           //client_log(implode(" ", $exp2));
           // we have to replace quoates, are there more chars killing the SQL string?
           $sstr = str_replace("'","",$exp2[1]);     

           $compop = "LIKE";

           $notstr = "";
           
           // recognize patterns like NOTNAME:sdks
           if (substr($key,0,3) == 'NOT')
           {
              $negated = true;
              $notstr = 'NOT ';
              $key = substr($key,3);
           }
           // recognize patterns like NOTNAME:sdks
           if (substr($key,0,1) == '!')
           {
              $negated = true;
              $notstr = 'NOT ';
              $key = substr($key,1);
           }


           // recognize patterns like "Bach!" meaning LIKE "Bach" insetad of "Bach%"
           $anyending = '%';
           if ($sstr[strlen($sstr)-1] == '!')
           {
              $anyending = '';
              $sstr = substr($sstr,0,strlen($sstr)-1);
           }
           // recognize greater/less 
           if ($sstr[0] == '>' | $sstr[0] == '<')
           {
             $compop = $sstr[0];
             $anyending = '';
             $sstr = substr($sstr,1);
           }


           // map key to dbcol
           $dbcol = null;
           if ($key[0] == '_')
              $dbcol = $GLOBALS[$key[1] . 'Header'][substr($key,3)];
           else if (isset($GLOBALS[$thestate->viewer->selectionMode[1] . 'Header'][$key]))
              $dbcol = $GLOBALS[$thestate->viewer->selectionMode[1] . 'Header'][$key];
           else if (isset($GLOBALS[$thestate->viewer->selectionMode[1] . 'Header'][$key_cs]))
              $dbcol = $GLOBALS[$thestate->viewer->selectionMode[1] . 'Header'][$key_cs];

           // use psid col for sid nd piz
           if ($dbcol == 'StudyID' | $dbcol == 'PSID')
           {
              if ($sstr[0] == '/')
              { 
                 if (isset($_SESSION['moduleInfo'][$project]['anonymization']))
                     $sstr = pid_hash($_SESSION['moduleInfo'][$project]['anonymization'],substr($sstr,1));
              }
              if ($sstr[0] != '#')
                $dbcol = "concat(PIZ,StudyID)";
           }
           else if ($dbcol == 'PIZ')
           {
                  if ($sstr[0] == '/')
                  { 
                     if (isset($_SESSION['moduleInfo'][$project]['anonymization']))
                     {
                         $sstr = pid_hash($_SESSION['moduleInfo'][$project]['anonymization'],substr($sstr,1));
                     }
                  }
                else if ($sstr[0] == '#')
                    $dbcol = "StudyID";
                else 
                    $dbcol = "concat(PIZ,StudyID)";
           }
           
           // map meta cols
           if (substr($key,0,4) == 'META')           
           {
               if ($thestate->viewer->selectionMode[1] == 'f')  
                    continue;               
               $dbcol = $metaIndices[substr($key_cs,5)]['colname'];            
           }


           if ($key == "PTAG" || $key == "STAG" || $key == "FTAG" || $key == "TAG")
           {
             if ($anyending == "")
               $sstr = "%/" . $sstr . "/%";
             else
               $sstr = "%" . $sstr;
           }


           $conj = " OR ";
           if ($dbcol != null)
           {
              if (isset($field_combined[$dbcol]))
                   $dbcol = $field_combined[$dbcol];

              $clause = $conj . $dbcol . " " . $notstr . $compop . " '" . $sstr . $anyending . "'"; 

              $astr .= $clause;
              $fstr .= $clause;

           }
           else
           {

                $sel_f = "concat(patients_id,studies_id)";
                $sel_ps = "concat(tp.PIZ,ts.StudyID)";
                if ($thestate->viewer->selectionMode[1] == 'p')
                {
                    $sel_f = "patients_id";
                    $sel_ps = "tp.PIZ";                    
                }

                if ($key == 'FILE')
                { 
                    $pos = strrpos($sstr,"/");
                    if ($pos !== false)
                        $fclause = " (subFolder LIKE '" . substr($sstr,0,$pos) . "' AND Filename LIKE '". substr($sstr,$pos+1) . $anyending . "')";
                    else 
                        $fclause = " (Filename LIKE '". $sstr . $anyending ."')";
 //                     $fclause = " (Filename LIKE '". $sstr . $anyending ."' OR subFolder LIKE '" . $sstr . $anyending . "')";

                    $theclause = " (SELECT ".$sel_f." from files WHERE " . $fclause . " )";
                    $createtmptab[] = "CREATE TEMPORARY TABLE TMPTABLE$tmpcnt " . $theclause ."; ";
                    $theclause = "(select * from TMPTABLE$tmpcnt)";
                    $tmpcnt++;

                    $astr .= $conj . "(".$sel_ps." ".$notstr." IN " . $theclause . ")";
                    $fstr .= $conj . $notstr . " " . $fclause;
                }
                else if ($key == 'FTAG')
                { 
                    $theclause = " (SELECT ".$sel_f." from files WHERE Tag LIKE '" . $sstr . $anyending . "')";
                    $createtmptab[] = "CREATE TEMPORARY TABLE TMPTABLE$tmpcnt " . $theclause ."; ";
                    $theclause = "(select * from TMPTABLE$tmpcnt)";
                    $tmpcnt++;
                
                    $astr .= $conj . "(".$sel_ps." ".$notstr." IN " . $theclause . ")";
                    $fstr .= $conj . $notstr . " (Tag LIKE '" . $sstr . $anyending . "')";
                }
                else if ($key == 'JOB')
                { 
                    if ($sstr == 'e')
                        $astr .=  $conj . errorquery_to_sql("error is not null");
                    else if ($sstr == 'r')
                        $astr .=  $conj . errorquery_to_sql("error is null AND state LIKE 'r'");
                    else if ($sstr == 'q')
                        $astr .=  $conj . errorquery_to_sql("error is null AND (state LIKE 'q_' or state LIKE 'hq%')");
                    else if ($sstr == 'd')
                        $astr .=  $conj . errorquery_to_sql("");
                }
                else if ($key == 'STAG')
                {
                    $fstr .= $conj . "(STag  ".$notstr." like '" . $sstr . "%')";
                }
                else if ($key == 'PTAG')
                {
                    $fstr .= $conj . "(tp.PTag  ".$notstr." like '" . $sstr . "%')";                    
                }
                else if ($key == 'NSTUDIES')
                {
                    $astr .= " OR patients_id in (select patients_id from studies group by patients_id having count(*) $compop  $sstr )";
                }
           }

       }
      
       if ($astr != "" )
         $astrQ .= " AND (0" . $astr . ")";
       if ($fstr != "" )
         $fstrQ .= " AND (0" . $fstr . ")";
         
     }
   }

    $astrQ = ($astrQ != "")?("(1" . $astrQ . ")"):"1";
    $fstrQ = ($fstrQ != "")?("(1" . $fstrQ . ")"):"1";
       
    $WCLAUSE = " AND " . $astrQ;
    $FCLAUSE = " AND " . $fstrQ;

    if (isset($GLOBALS['pHeader'][$sortOrder]))
        $sortOrder = $GLOBALS['pHeader'][$sortOrder];
    else if (isset($GLOBALS['sHeader'][$sortOrder]))
        $sortOrder = $GLOBALS['sHeader'][$sortOrder];
    else if (isset($GLOBALS['fHeader'][$sortOrder]))
        $sortOrder = $GLOBALS['fHeader'][$sortOrder];
    else
        $sortOrder = "";

        
        
    $field_combined = $GLOBALS['field_combined'];

    $sortkeys = array_keys($field_combined);
    $a = mysqli_query($db, "SHOW COLUMNS from patients");
    $sortkeys_patients = array();
    while($row = $a->fetch_assoc())
    {
        $sortkeys[] = $row['Field'];
        $sortkeys_patients[] = $row['Field'];
    }
    $a = mysqli_query($db, "SHOW COLUMNS from studies");
    $sortkeys_studies = array();
    while($row = $a->fetch_assoc())
    {
        $sortkeys[] = $row['Field'];
        $sortkeys_studies[] = $row['Field'];
    }
      
    $colnames = "";

    $studylevel_indices = array();
    
    foreach($metaIndices as $metaname => $row)
    {
      $colname = $row['colname'];
      $idx = $row['metaidx'];
      if ($idx[0] == 'TAG')
        continue;
     // if (!($idx[0] == 'PATIENT' || $idx[0] == 'STUDY' || sizeof($idx) == 1))
         $colnames .= ',' . $colname ;
      $sortkeys[] = $metaname;
      $sortkeys_studies[] = $metaname;   
      if ($row['level'] == 'study')
        $studylevel_indices[] = $metaname;
    }
    
   // client_log("-->" . $colnames);
    $combined = "";
    foreach ($field_combined as $fname => $combexpr)
        $combined .= $combexpr . " as " . $fname .  ", ";
    

    if (isset($metaIndices[$sortOrder]))
    {
        if ($metaIndices[$sortOrder]['metaidx'][0] == 'TAG')
        {
          $tagfield = "PTag";
          if ($metaIndices[$sortOrder]['level'] == 'study')
            $tagfield = "STag";

          $isnot = '';
          if ($sortDirection == 'DESC')
            $isnot = 'NOT';

          $WCLAUSE .= ' AND ' . $tagfield . ' '.$isnot.' LIKE "%/' . $metaIndices[$sortOrder]['metaidx'][1] . '/%" ';
        }      
    }



 
    if ($thestate->viewer->selectionMode[1] == 'p' )
      $WCLAUSE = "AND ts.patients_id in (SELECT PIZ FROM patients as tp " .
		  "       JOIN studies as ts ON tp.PIZ = ts.patients_id " .
		  "       LEFT  JOIN metacontent as metapatient ON tp.PIZ=metapatient.psid" .
		  "       LEFT  JOIN metacontent as metastudy ON concat(tp.PIZ,ts.StudyID)=metastudy.psid " .
		  " WHERE 1 $WCLAUSE)";
  
    $query = "SELECT $combined ts.*, tp.* $colnames FROM patients as tp " .
                 "       JOIN studies as ts ON tp.PIZ = ts.patients_id " .
                 "       LEFT  JOIN metacontent as metapatient ON tp.PIZ=metapatient.psid" .
                 "       LEFT  JOIN metacontent as metastudy ON concat(tp.PIZ,ts.StudyID)=metastudy.psid " .
                 " WHERE 1 $WCLAUSE";

    if (in_array($sortOrder, $sortkeys))
    {
      if ($thestate->viewer->selectionMode[1] == 'p' &&  in_array($sortOrder, $sortkeys_studies) )
      {
          $aggregate = ($sortDirection == "ASC")?'MIN':'MAX';
          $qf = "(select ".$aggregate."(".$sortOrder.") as maxdate,patients_id from studies LEFT JOIN metacontent ON concat(patients_id,StudyID)=psid  group by patients_id)";
          $query = "SELECT $combined ts.*, tp.*, ms.* $colnames  FROM $qf as ms" . 
                 "       JOIN patients as tp ON tp.PIZ = ms.patients_id " .
                 "       JOIN studies  as ts ON tp.PIZ = ts.patients_id " .
                 "       LEFT JOIN metacontent as metapatient ON tp.PIZ=metapatient.psid" .
                 "       LEFT JOIN metacontent as metastudy ON concat(tp.PIZ,ts.StudyID)=metastudy.psid " .
                 " where 1 $WCLAUSE  ORDER BY ms.maxdate $sortDirection, ts.patients_id $sortDirection,$sortOrder $sortDirection";    
      }
      else
      {
        //$query = $query . " ORDER BY $sortOrder $sortDirection, ts.patients_id $sortDirection, ts.StudyDescription";
        $query = $query . " ORDER BY $sortOrder $sortDirection, ts.patients_id $sortDirection, ts.StudyID";
      }


    }

   // $query = $createtmptab . $query;
    //client_log($WCLAUSE);
 //   client_log($createtmptab);;
   // client_log($query);


    // we need a non LIMITED full list for selections in the webinterface    
    $query_all = $query;

    if ($thestate->viewer->selectionMode[1] == 'f')
    {

      /**********************************************************************************
      * do the file query
      ***********************************************************************************/

        $a = mysqli_query($db, "SHOW COLUMNS from files");
        while($row = $a->fetch_assoc())
           $sortkeys[] = $row['Field'];

        $ORDERCLAUSE = " ORDER BY fileID";
        if (in_array($sortOrder, $sortkeys))
            $ORDERCLAUSE = " ORDER BY $sortOrder $sortDirection, fileID";

        $File_hardLimit = 5000;
        $File_softLimit = 1000;

        if (isset($thestate->viewer->numberDisplayedItemsFileTable))
           $File_softLimit = $thestate->viewer->numberDisplayedItemsFileTable;


        $query_all = "SELECT *, $combined  tf.ID as fileID, concat('x',tp.PIZ,'".riddelim."',ts.StudyID,'".riddelim."',tf.subfolder,'".riddelim."',tf.ID) as rowid FROM files as tf JOIN patients as tp JOIN studies as ts " .
                 "WHERE tp.PIZ = ts.patients_id AND ts.StudyID = tf.studies_id AND tf.filename != 'nodeinfo.json' AND tp.PIZ = tf.patients_id " . $FCLAUSE . $ORDERCLAUSE;
        $query = $query_all . " LIMIT " . $File_softLimit . " OFFSET " . $thestate->viewer->displayOffset;
        $query_all = $query_all . " LIMIT " . $File_hardLimit . " OFFSET " . $thestate->viewer->displayOffset;
       
     
        $pList = $db->query($query);
        if ($pList != NULL)
        {
           while ($row = $pList->fetch_assoc())
                $html .= renderFileRow($row,true);                
        }      

        $pList = $db->query($query_all);
        if ($pList != NULL)
        {
           while ($row = $pList->fetch_assoc())
           {
               $files[] = $row['rowid'];
               $patients[$row['PIZ']] = 1;
               $rowid = $row['PIZ'] . riddelim . $row['StudyID'];            
               $studies[$rowid] = 1;
               
           }
        }
 
        if (sizeof($files) < $File_hardLimit)
            $numfiles = sizeof($files) . " files";
        else
           $numfiles =  sizeof($files) . " files (limit exceeded)" ;

 
    }
    else
    {

      /**********************************************************************************
      * do the patient query
      ***********************************************************************************/
      foreach ($createtmptab as $q)
          $db->query($q,true);

      $pList = $db->query($query_all, true);
      // Patient List query was not successful. 
      // Reason might be SQL error in search string. So clean the full WCLAUSE and retry
      if( $pList == false)  
      {
          if($isRetry==false)
          {
            $db->close();
            $thestate->SearchText = '';
            $thestate->SearchText_a = '';
            echo json_encode( "SQL Error, probably in custom SQL search string WCLAUSE:  " . $WCLAUSE  ) . NORA_ESEP;
            return renderPatientTable($fullrender,$project, true);
            die();
          }
          else
          {
             error_log(mysqli_error($db) . " in query " .  $query);
             $db->close();
             return 'SQL Error' .mysqli_error($db) . "  in query  " . $query ;
          }
      }

   
    //client_log($query);


      /**********************************************************************************
      * a full rendering of the table
      ***********************************************************************************/



      if ($fullrender)
      {

        $_SESSION["currentStudies"][$project] = array();
        $_SESSION["currentPatients"][$project] = array();
        $lastpiz = "";
        $pcnt = 0;
        $scnt = 0;
        $shtml = "";
        
        while (true)
        {
	        $pRow = $pList->fetch_assoc();

	    	   	    	    	   	    
            if ($lastpiz != $pRow['PIZ'] && $lastpiz != "") // render last patient
            {
              
              // check if we have to push a time marker
              if( $thestate->viewer->sortOrder === 'DATE' &  $thestate->viewer->sortDirection === 'DESC'  & sizeof($GLOBALS['timeMarkersForPatientTable']) > 0  &  ( array_key_exists('maxdate',$patientRow) || array_key_exists('StudyDate',$patientRow)) 
               && ($thestate->viewer->numberDisplayedItems == -1 || ($pcnt >= $thestate->viewer->displayOffset && $pcnt <  $thestate->viewer->displayOffset+$thestate->viewer->numberDisplayedItems+1))
              )
              {
                if ($thestate->viewer->selectionMode[1] == 'p')
                    $thetime = strtotime($patientRow['maxdate'] );
                else
                    $thetime = strtotime( $patientRow['StudyDate'] );
                    
                // if this is a demo project. adjust dates such that somebody is from today
                /*
                if( strpos($project, 'DEMO') !== false || $_SESSION['userinfo']['forceanonymize'] != 0 ||  $_SESSION['moduleInfo'][$project]['forceAnonymize'] != 0  )
                {
                  if(!isset($GLOBALS['dayCounter'])) 
                    $GLOBALS['dayCounter'] = -2;
                  $ndays = $GLOBALS['dayCounter']+=2;
                }
                */

                $templine = null;
                foreach($GLOBALS['timeMarkersForPatientTable'] as &$temp)
                {
                    if (!isset($temp['keytime']))
                        continue;
                    $daysapart =   ( $thetime - $temp['keytime']  )/ (3600*24)   ;

                     //$html .= "<tr id='' class ='patientTable_timeMarker'><td colspan=100>".$daysapart ." ". $temp['fulltitle']."</td>";
                    if($daysapart <= 0)
                    {
                        $templine = "<tr id='' class ='patientTable_timeMarker'><td colspan=100>".$temp['fulltitle']."</td>";
                        array_shift($GLOBALS['timeMarkersForPatientTable']);                        
                    }
                    else
                    {
                        break;
                    }
                }
                if($templine != null)
                    $html .= $templine;
              
              }        // end special case : Date      

              
              $phtml = "";
              if ($thestate->viewer->selectionMode[1] == 'p')
              {
                if($thestate->viewer->numberDisplayedItems == -1 || ($pcnt >= $thestate->viewer->displayOffset && $pcnt <  $thestate->viewer->displayOffset+$thestate->viewer->numberDisplayedItems+1))
                {
                  $phtml .= renderRow($patientRow, 'patient',$project,$metaIndices);
                  $phtml .= renderMetaRow(array('patients_id' => $patientRow['PIZ']));
                }
              }                              
              $html .= $phtml . $shtml;


         

  	       }
	    
           if (!$pRow)
              break;

            if ($lastpiz != $pRow['PIZ']) // start new patient 
            {
              
                $patientRow = $pRow;  // gather info of new patient
                $shtml = "";

                $patients[$pRow['PIZ']] = 1;
                $_SESSION["currentPatients"][$project][$pRow['PIZ']] = 1;
                              
                $lastpiz = $pRow['PIZ'];
                $pcnt++;
            }
            else
            {
               foreach($studylevel_indices as $index) // study metaindex aggregate over patients 
                {
                   if ($pRow[$index] != "")
                   {
                     if ($patientRow[$index] != "")
                        $patientRow[$index] .= ", ";
                     $patientRow[$index] .= $pRow[$index];
                   }
                }
              
            }
            
            $rowid = $pRow['PIZ'] . riddelim . $pRow['StudyID'];
            $_SESSION["currentStudies"][$project][$rowid] = 1;
            if ($thestate->viewer->selectionMode[1] == 'p')
            {
              if ($thestate->viewer->numberDisplayedItems == -1 || ($pcnt >= $thestate->viewer->displayOffset && $pcnt <  $thestate->viewer->displayOffset+$thestate->viewer->numberDisplayedItems+1))
                 $shtml .= renderRow($pRow, 'study',$project,$metaIndices);
            }
            else
            {
              if ($thestate->viewer->numberDisplayedItems == -1 || ($scnt >= $thestate->viewer->displayOffset && $scnt <  $thestate->viewer->displayOffset+$thestate->viewer->numberDisplayedItems))
                 $shtml .= renderRow($pRow, 'study',$project,$metaIndices);              
            }

            $rowid = $pRow['PIZ'] . riddelim . $pRow['StudyID'];            
            $studies[$rowid] = 1;
          
          
  
            $scnt++;

        }
      }

      /**********************************************************************************
      * if new studies have arrived we just need to render those
      ***********************************************************************************/

      else
      {
          $json_out = array();
          $after = "";
          $cnt = 0;

          while ($pRow = $pList->fetch_assoc())
          {

            if ($thestate->viewer->selectionMode[1] == 'p')
              if (!array_key_exists($pRow['PIZ'], $_SESSION["currentPatients"][$project]))
              {
                 $json_out[$cnt++] = array("html" => renderRow($pRow,  'patient',$project,$metaIndices),
                                           "after" => $after);
                 $_SESSION["currentPatients"][$project][$pRow['PIZ']] = 1;
                 $after = $pRow['PIZ'];
              }

            $rowid = $pRow['PIZ'] . riddelim . $pRow['StudyID'];

            if (!array_key_exists($rowid, $_SESSION["currentStudies"][$project]))
            {
                $json_out[$cnt++] = array("html" => renderRow($pRow, 'study',$project,$metaIndices),
                                          "after" => $after);
                $_SESSION["currentStudies"][$project][$rowid] = 1;
            }
            $after = $rowid;
          }
          $db->close();
          return $json_out;
      }
    }




    /**********************************************************************************
    * render footer of patientable, patienttablenavigator and statusbar
    ***********************************************************************************/

    $html .= "</tbody>";
    $html .= "</table></div>";
    $html .= "</table>";

    if ($thestate->viewer->selectionMode[1] == 'f')
    {
       $query = "SELECT count(*) as count FROM files as tf JOIN patients as tp JOIN studies as ts " .
                "WHERE tp.PIZ = ts.patients_id AND ts.StudyID = tf.studies_id AND tp.PIZ = tf.patients_id " . $FCLAUSE ;
    
       $a = $db->query($query);
       $numtotalrows = $a->fetch_assoc();  $numtotalrows = $numtotalrows['count'];
    }
    else if ($thestate->viewer->selectionMode[1] == 'p')
        $numtotalrows = $pcnt;
    else
        $numtotalrows = $scnt;
  
    if( ($numtotalrows / $thestate->viewer->numberDisplayedItems) > 1)
    {
       $html .= "<div id='patientTableNavigator'  class='patientTableNavigator'>";
       $html .= " <ul  class='menu_generic tool_menu_generic'>";

       $html .=   "<li id='patientTableNavigatorLeft' onclick='javascript:renderPatientTable(\"begin\");'><i class='fa fa-step-backward'></i></li>";
       $html .=   "<li id='patientTableNavigatorLeft' onclick='javascript:renderPatientTable(\"dec\");'><i class='fa fa-backward'></i></li>";
       $val = $thestate->viewer->displayOffset;
       $last = floor($numtotalrows / $thestate->viewer->numberDisplayedItems)*$thestate->viewer->numberDisplayedItems;
       $html .= '<input onchange="javascript:patientTableOffsetChanged(event)" type="range" name="points" value="'.$val.'" min="0" max="' . $last. '">';

       $html .=   "<li id='patientTableNavigatorRight' onclick='javascript:renderPatientTable(\"inc\");'><i class='fa fa-forward'></i></li>";
       $html .=   "<li id='patientTableNavigatorLeft' onclick='javascript:renderPatientTable(\"end\");'><i class='fa fa-step-forward'></i></li>";
       $html .= " </ul>";
       $html .= " </div>";
    }
    $html .= "<div id='KStatusBar'></div>";
    

    $a = $db->query("select * from studies where patients_id='ANALYSIS'");
    $analysis = [];

    while( $row = $a->fetch_assoc())
      $analysis[$row['StudyID']] = $row;


    $db->close();

    return array('html' => $html, 
                 'studies' =>$studies, 
                 'patients'=> $patients , 
                 'files' => $files , 
                 'analysis' => $analysis, 
                 'numfiles' => $numfiles,
                 'forceanonymize' => $_SESSION['userinfo']['forceanonymize'] 
                 );

   
  }



 /**********************************************************************************
  * Rendering of study content
  ***********************************************************************************/

  function renderStudy($piz,$sid,$db,$showassocs)
  {

    defineTableHeaders();    

    $html = "";
    // sort files somwhow
    $fileSortPattern = "Filename";
    $fileSortPattern = "SUBSTRING(Filename, LOCATE('.', Filename), 5) DESC, BINARY(Filename)";
    

    $project = $_GET['project'];    
    $thestate = $_SESSION['state'][$project];  
    $thequery =  "SELECT *, tf.ID as fileID, 999 as thecount FROM files as tf WHERE patients_id = \"". $piz . "\"  AND studies_id = \"". $sid . "\"  ORDER BY $fileSortPattern  "; 
    if ($showassocs && $thestate->viewer->selectionMode[1] == 'a')
    {
         $astudyList = $db->query("SELECT * from studies where concat(patients_id,StudyID) = '$piz$sid'");

         if ($row = $astudyList->fetch_assoc())
         {
             if ($row['STag'] != "")
             {
                 
                 $tagquery = "STag LIKE '%" . $row['STag'] . "%' AND patients_id != 'ANALYSIS'";
  //             $tagquery = "STag LIKE '%/" . $thetag . "/%'";


                 $initalfileq = "(select * from files
                    where concat(patients_id,studies_id) in 
                    ( select concat(patients_id,StudyID) from studies
                      where $tagquery))";


                    $q = ("SELECT 
                        ''  as ID,Filename,'' as FilePath, SubFolder,
                        concat('/#',COUNT(studies_id),'/') as Tag,
                        'aggregate' as DateModified,
                        '' as permission,
                        MAX(filesize),
                        '0' as MULTIFILE,
                        '$sid' as studies_id,
                        MAX(lastchange),
                        'ANALYSIS' as patients_id, 
                        MAX(ID) as fileID,
                        COUNT(studies_id) as thecount 
                        FROM $initalfileq as f  GROUP BY Filename,SubFolder " ) ;
                                     


                  $q = "select * from (" . $q . ") as dummy where thecount >= 1";

                  $q =  "(" . $q . ")  UNION (" . $thequery . ")";


  
                $fList = $db->query($q);
  
              } 
              else
                $fList = $db->query($thequery);
         }
         else
            $fList = $db->query($thequery);
    


    }
    else
       $fList = $db->query($thequery);


    // now walk over all files to find the subfolders and sort them into the subfolders
    $subFolderArray = array();
    $subFolderArray = array();
    $dateSubFolder = array();
    $sizeSubFolder = array();
  

    while ($fRow = $fList->fetch_assoc())
    {

      $fRow['originalSubFolder'] = $fRow['SubFolder'];
      $subFolderArray[$fRow['SubFolder']][] = $fRow;
      if (!isset($sizeSubFolder[$fRow['SubFolder']]))
         $sizeSubFolder[$fRow['SubFolder']] = $fRow['filesize'];
      else
         $sizeSubFolder[$fRow['SubFolder']] += $fRow['filesize'];
      if (!isset($dateSubFolder[$fRow['SubFolder']]))
         $dateSubFolder[$fRow['SubFolder']] = $fRow['DateModified'];
      else
      {
         if ($dateSubFolder[$fRow['SubFolder']] > $fRow['DateModified'])
           $dateSubFolder[$fRow['SubFolder']] = $fRow['DateModified'];
      }
      //$subFolderArray[$extfold][] = $fRow;

    }
/*
    foreach($extSubFolder as $extfold => $rows)
    {
      if (sizeof($rows)> 1)
      {
          foreach ($rows as $r)
          {
            client_log(";;>" . $extfold);
            $r['SubFolder'] = $extfold;
             $fRow['originalSubFolder'] = $extfold;
          }
      }
    }

*/

//    die(var_dump($subFolderArray));

    // render content of readingresults for this study
    if(isset($_SESSION['moduleInfo'][$project]['hasReadingTable']) && $_SESSION['moduleInfo'][$project]['hasReadingTable'])
    {
        $rquery = "select * from readingresults where patients_id like '$piz' AND studies_id like '$sid' ";
        $a = $db->query($rquery);
        while($row = $a->fetch_assoc())
        {

            $theid   = "READING://". "$row[ID]_$row[formid]";
            $thefilename = "$row[formid]_$row[user]_$row[iterator].reading";
              $xfile = Array(  
              "ID" => $theid,
              "fileID" => $theid,
              "Filename" => $thefilename,
              "FilePath" => "aad",
              "SubFolder"=> "META",
              "Tag"       => "",
              "DateModified" => NULL,
              "permission" => NULL,
              "filesize"   => "",
              "MULTIFILE"  => NULL,
              "studies_id" => $row['studies_id'],
              "patients_id"=> $row['patients_id'],
              "lastchange" => NULL,
              "thecount" => "999",
              "originalSubFolder" => ""
            );

            if(isset($subFolderArray['META']))
                $subFolderArray['META'][] = $xfile;
            else
                $subFolderArray['META'] = Array( $xfile ) ;
        }

    }


//die(var_dump($subFolderArray));

    foreach($subFolderArray as $tSub)
    {
      if($tSub[0]['SubFolder']!=='')
      {
        $tsub0 = $tSub[0];

        $subs = explode("/",$tsub0['SubFolder']);

        if (sizeOf($subs)>0)
        {
          $thesub = $subs[0];
          $k=0;
          for (;;)
          {
            if (!array_key_exists($thesub,$subFolderArray))
            {
                $tmp = $tsub0;
                $tmp['SubFolder'] = $thesub;
                $tmp['Filename'] = ">>dummy<<";
                $subFolderArray[$thesub][] = $tmp;
            }
            $k++;
            if ($k+1 >= sizeOf($subs))
                break;
            $thesub = $thesub . "/" . $subs[$k];
          }
        }

      }
    }

    if ($piz == "ANALYSIS")
    {
        /*{
             $rowid = $piz . riddelim. $sid ;
             if ($showassocs)
                  $html .= "<tr rowid_parent='$rowid' onclick='return hide_associatedfiles(\"$rowid\");' class='patienttable_button' ><td colspan=100><span>hide associated subject files</span></td></tr>";
             else
                  $html .= "<tr rowid_parent='$rowid' onclick='return show_associatedfiles(\"$rowid\");' class='patienttable_button' ><td colspan=100><span>show associated subject files</span></td></tr>";
        }*/
        $html .= renderMetaRow(array('patients_id' => $piz,'studies_id' => $sid));
    }
    else
        $html .= renderMetaRow(array('patients_id' => $piz,'studies_id' => $sid));
        

    ksort($subFolderArray,SORT_STRING); // resort the subfolders,

    foreach($subFolderArray as $key => $tSub)
    {
        if($tSub[0]['SubFolder']!=='')
        {
           $tSub[0]['subfoldercount'] = sizeOf($tSub);
           $date = "";
           $size = "";
           if (isset($dateSubFolder[$key]))
              $date = $dateSubFolder[$key];
           if (isset($sizeSubFolder[$key]))
              $size = $sizeSubFolder[$key];

           $html .= renderSubFolderRow($tSub[0],$date,$size);
        }
        foreach($tSub as $tRow)
        {
          if (array_key_exists('originalSubFolder',$tRow))
            $html .=  renderFileRow($tRow,false);
        }
    }

    return $html;
  }



 /**********************************************************************************
  * Rendering of the Filerow
  ***********************************************************************************/

  function renderFileRow($row,$filemode = false)
  {

  


    if ($row['Filename'] == 'nodeinfo.json')
      return "";

    $_Header = $GLOBALS['_Header'];
    $fHeader = $GLOBALS['fHeader'];

    $sid = '';
    if (isset($row['studies_id']))
       $sid = $row['studies_id'];

    $rowid = $row['patients_id'] . riddelim. $sid . riddelim. $row['SubFolder'] .riddelim. $row['fileID'];
  
    if ($sid == '')
       $rowid_parent = $row['patients_id'];    
    else if($row['SubFolder']==='')
       $rowid_parent = $row['patients_id'] . riddelim. $sid; // for an empty subfolder, set the parent as the study expander
    else
       $rowid_parent = $row['patients_id'] . riddelim. $row['studies_id']. riddelim. $row['SubFolder'];
  
    $datastuff = "data-type='file' data-piz='".$row["patients_id"]."' data-sid='".$sid."' data-tag='".$row["Tag"]."' data-filename='$row[Filename]' data-subfolder='$row[SubFolder]' data-fileID='$row[fileID]'";
    $dragstuff = "draggable='true' ondrop='droponPatienttable(event);'  ondragover='dragover(event);' ondragleave='dragleave(event);'";
   
    $mimetypes = array('.nrrd'=> 'nii','.mgh'=> 'nii','.mgz'=> 'nii', '.nii' => 'nii','.rtstruct' => 'nii','.tck.json' => 'tck','.batch.json' => 'batch','.form.json' => 'form','.ano.json' => 'ano', '.json' => 'json','.pdf' => 'pdf','.mat' => 'mat','.txt' => 'txt', '.tck' => 'tck', '.trk' => 'tck',
                       '.jpeg' => 'img','.jpg' => 'img','.bmp' => 'img','.png' => 'img', '.ipynb' => 'pynb'); 
    $types_sym = array('nii' => 'image imgTag','img' => 'file-image-o', 'pynb'=>'file-text JupyterTag',
                        'ano' => 'comment-o AnoTag', 'form' => 'file-text-o FormTag',
                        'json' => 'file-o','pdf' => 'file-pdf-o' ,'txt' => 'file-text-o' 
                        ,'tck' => 'tree fiberTag', 'batch' => 'file-code-o');
    $symbol =  "<i class='KTreeSymbol fa fa-fw' ></i>";
    foreach($mimetypes as $ext => $mime)
         if (strpos($row['Filename'],$ext) !== false)
         {
            $datastuff = $datastuff . " data-mime='$mime'";
            if (isset($types_sym[$mime]))
              $symbol = "<i class='KTreeSymbol fa fa-".$types_sym[$mime]." fa-fw' ></i>";
            break;
         }
 

    if ( $GLOBALS['anonym_mode'] && ($row['Filename'] == 'patientinfo' || $row['Filename'] == 'studyinfo'))
    {
        $temp = "";
        $datastuff = "";
        $dragstuff = "";
    }
    else
    {
        $temp = " ondblclick='loadDataOndblClick(event);'  onclick='patientTableMirror.fileSelect(event,\"$rowid\"); return false;' href=$_SERVER[PHP_SELF]?fileID=".$row['fileID'];
        $temp .= " ondragstart='setdragstart(event);' ondragend='setdragend(event);'   $datastuff ";
    }


    if ($filemode)
        $display='';
    else
        $display='style="display:none";';
    /*
    $tag = $row['Tag'];
    if (strpos($tag,"[") != False)
    {
        if (strpos($tag,"]") != False)
        {
            $s = strpos($tag,"[");
            $l = strpos($tag,"]")-$s-1;
            $display .= " style='background-color:".substr($tag,$s+1,$l).";' ";
        }
    }
    else
    if (strpos($tag,"problem") != False | strpos($tag,"error") != False)
    {
        $display .= " style='background-color:#F55;' ";
    }
*/
    if (isset($row['DateModified'] ) && $row['DateModified'] == 'aggregate')
        $class = ' class="aggregateRow fileRow" ';
    else
        $class = ' class="fileRow" ';
    
    $out = "<tr $display $dragstuff $temp id='$rowid' rowid_parent='$rowid_parent' $class >";

    $depth = substr_count($row['SubFolder'],"/");


    foreach($_Header as $key => $t)
    {
      if (!isset($fHeader[$key]))
        $out .= "<td class ='fileCell'> </td>";
      else
      {
        $tField = $fHeader[$key];
        if ($tField=="") $tField = $key;
        $content = '';
        $addStyle = '';
        $icon =  ""; //<i class='KTreeSymbol fa fa-fw' ></i> ";
        if (array_key_exists($tField,$row))
          $content = $row[$tField];
        if($tField ==='Filename' ) 
        {
            if ($filemode ) 
              $addStyle = "padding-left:4px;"; 
            else if ($row['Filename'] == 'patientinfo')
              $addStyle = "padding-left:4px;"; 
            else if ($row['SubFolder'] =='') 
              $addStyle = "padding-left:25px;"; 
            else 
              $addStyle = "padding-left:". (25+15*($depth+1)) . "px;";

            if ($row['Filename'] == 'nodeinfo.json')
            {
              $icon = "<i class='KTreeSymbol fa fa-info fa-fw' ></i> ";
            }            
            else if ($row['Filename'] == 'patientinfo' || $row['Filename'] == 'studyinfo')
            {
              $icon = "<i class='KTreeSymbol fa fa-info fa-fw' ></i> ";
              $content = $row['Filename'];
            }            
            else
              $icon = $symbol;
           
           // file is a link to a pacs file => this went to the parent subfolder entry
            if(isset($row['FilePath']) && strpos($row['FilePath'], "PACS://") !== false )
            {
              $content .= "	<a style='color:gray' onclick=\"PACSQuery.retrieve('". $row['fileID'] ."');return false;\" >&#91; PACS &#93;<i class='KTreeSymbol fa fa-download fa-fw' ></i></a>";
              //$content .= "	<a style='color:gray' onclick=\"PACSQuery.retrieve('". $row['fileID'] ."');return false;\" >&#91;<i class='KTreeSymbol fa fa-download fa-fw' >&#93;</i></a>";
              //$icon .= "<i class='KTreeSymbol fa fa-product-hunt fa-fw' onclick=\"PACSQuery.retrieve('". $row['fileID'] ."')\" ></i>";
              $addStyle .= ";color:hsl(0,0%,40%);";
            }

        }
        if($tField =='PSID' )
             $content = $row['patients_id'] . $row['studies_id'] ;
        if($tField =='filesize' )
             $content = renderFilesize($content);
        if($tField =='Tag' )
        {
            $content = renderTags($content,'KTagFile');
        }
        if ($tField=='StudyDate')
        {
          if($content=='0')
             $content = ' &nbsp;N/A&nbsp;  ';
          else   
             $content = sprintf('%s.%s.%s', substr($content, 6,2),substr($content, 4,2),substr($content, 0,4));
        }
             
        if ($content != "")
             $content = "<span>$content </span>";
         $out .= "<td class ='fileCell' style='$addStyle'>$icon $content </td>\n\r";
      }
    }
    $out .= "</tr>";

    return $out;

  } 

  function renderFilesize($content)
  {
	  if ($content == null)
	    return "";
	  else 
	  {
          $sz = intval($content);
          if ($sz > 1000000)
            return  round($sz/1000000) . "M";
          else if  ($sz > 1000)
            return  "<i style='color:#888'>". round($sz/1000) . "K </i>";
          else
            return  "<i style='color:#888'>". $sz . "B </i>";
	  }

  }



  function renderMetaRow($row)
  {


 
     $row['Filename'] = 'patientinfo';


     $sid = '';
     if (isset($row['studies_id']))
     {
        $sid = $row['studies_id'];
        $row['Filename'] = 'studyinfo';
        
     }
     if ($row['patients_id'] == "ANALYSIS")
        $row['Filename'] = 'analysisinfo';

     $rowid = 'meta_' . $row['patients_id'] . $sid ;
      
     $row['SubFolder'] = '';
     $row['Tag'] = '/meta/';
     $row['fileID'] = $rowid  ;
     $row['ID'] = $rowid;
     return renderFileRow($row,false);
  }


 /**********************************************************************************
  * Rendering of the SubFolder row
  ***********************************************************************************/

  function renderSubFolderRow($row,$date,$size)
  {
    $_Header = $GLOBALS['_Header'];    
    $header = $GLOBALS['subFolderHeader'];

    $depth = substr_count($row['SubFolder'],"/");
  
    $rest = "";
    $last = strrchr($row['SubFolder'], "/");
    if ($last)
    {
      $last = substr($last,1);
      $rest = riddelim . substr($row['SubFolder'],0,strlen($row['SubFolder'])-strlen($last)-1);
    }
    $rowid_parent =  $row['patients_id'] . riddelim. $row['studies_id'] .  $rest;
    $rowid = $row['patients_id'] . riddelim. $row['studies_id']. riddelim. $row['SubFolder'];
    if ($last)
      $row['SubFolder'] = $last;

    // drag+drop
    $dragstuff = "draggable='true' ondrop='droponPatienttable(event);'  ondragover='dragover(event);' ondragleave='dragleave(event);'";
    $datastuff = " data-type='subfolder'  data-piz='" . $row["patients_id"] . "' data-sid='".$row["studies_id"]  .  "' data-subfolder='$row[originalSubFolder]' ";       
    //$datastuff = " data-type='subfolder'  data-piz='" . $row["patients_id"] . "' data-sid='".$row["studies_id"]  .  "' data-subfolder='$row[SubFolder]' ";       
    $temp = " ondragstart='setdragstart(event);' ondragend='setdragend(event);'   $datastuff ";    
   


    if ($row['DateModified'] == 'aggregate')
        $class = ' class="aggregateRow subfolderRow" ';
    else
        $class = ' class="subfolderRow" ';
    $out = "<tr style='display:none;' $dragstuff $temp  id='$rowid' rowid_parent='$rowid_parent' $class >";
  
    foreach($_Header as $key => $t)
    {
      if (!isset($header[$key]))
        $out .= "<td class ='subfolderCell'> </td>";
      else
      {
        $tField = $header[$key];
        if ($tField=="") $tField = $key;
        $temp = '';
        $addStyle = '';
        $linkAddColumn = "";
        if (array_key_exists($tField,$row))
           $temp = "<span> $row[$tField] </span>";
        if( $tField =='SubFolder' )
        {
            $temp = "<i class='KTreeExpander fa fa-plus-square-o' ></i><i class='KTreeSymbol fa fa-folder-o '></i> " . $temp;
            $linkAddColumn = "style='padding-left:". (25+15*$depth) . "px;' onclick=\" patientTableMirror.tree_click(event,'$rowid');\" ";

           if(isset($row['FilePath']) && strpos($row['FilePath'], "PACS://") !== false )
           {
             //$temp .= "	<span>&#91;PACS&#93;</span>";
             $addStyle = "style='padding-left:25px;color:hsl(0,0%,40%)'";
           }


        }
        else if($tField == 'size' )
        {
            $temp = renderFilesize($size);   
        }
        else if($tField == 'Date' )
        {   
           if($date=='0') 
              $temp = ' &nbsp;N/A&nbsp;  ';
           else
             $temp = $date;

        }
        else if($tField =='Tag' )
        {   
          $temp = "<span class='patienttable_subfoldercount'>" . $row['subfoldercount'] . "</span>";
        }
        $out .= "<td class ='subfolderCell'$addStyle $linkAddColumn> $temp </td>\n\r";
      }
    }
    $out .= "</tr>";

    return $out;
  }



 /**********************************************************************************
  * Rendering of the Header row
  ***********************************************************************************/


  function renderHeaderRow($header)
  {
     $sortOrder = "";
     $sortDirection = "";
     $searchRow = (object)array();
     if (isset($_GET['project']))
     {
       $project = $_GET['project'];    
       $thestate = $_SESSION['state'][$project];    
       $sortOrder = $thestate->viewer->sortOrder;
       $sortDirection = $thestate->viewer->sortDirection;

       $s = "search_row";
       if ($thestate->viewer->selectionMode[1] == 'a')
          $s = "search_row_a";
        else
          $s = "search_row";

       if (isset($thestate->$s))
          $searchRow = $thestate->$s;
     }

     $fieldstoshow = array_keys($header);
     $rowtype = 'patientTableHeaderSearch';
     $out = "<tr id=$rowtype class='".$rowtype."'> ";
     foreach($header as $tKey => $tName)
     {
        if (isset($searchRow->$tKey))
          $value = $searchRow->$tKey;
        else
          $value = "";
        if ($tKey !='selector' )
        {
          $temp =   "<form  onsubmit='return false;' target='KsearchForms'> <input class='KSearchFields' autocomplete='on' oncontextmenu='patientHeaderSearchBar(event);' name='$tKey' value='$value' onkeyup='patientSearch(event);' /> </form>";
          $out .= "<td class ='".$rowtype."Cell'> $temp </td>";
        }
        else
        {
          $temp = "<i id='patientTableToolsWrench' class='KCheckBox fa fa-wrench'></i> ";
          $out .= "<td fixedwidth='24' class ='".$rowtype."Cell hover_bg_gray' onclick=\"patientHeaderBarSelector(event)\" oncontextmenu=\"patientHeaderBarSelector(event)\"> $temp </td>";
        }
     }
     $out .= "</tr>";

     $rowtype = 'patientTableHeader';
     $out .= "<tr id=$rowtype class='".$rowtype." ".$rowtype."Row'> ";

     $index = 0;
     foreach($header as $tKey => $tName)
     {
        if ($tKey !='selector' )
        {
            $seq=explode('_', $tName);  
            if ($seq[0] == 'tag')
                $tName = implode(array_slice($seq,1),"_");

            $temp = "<span><span> $tName </span></span>";
            if($tKey === $sortOrder)
            {
              $temp = "<span><span> $tName <i style='margin-left:12px' class='fa fa-caret-" . ($sortDirection==='ASC'?"up":"down") .  "'></i></span></span>";
              $args = "{sortDirection: ". ($sortDirection==='ASC'?"'DESC'":"'ASC'") ."}";
            }
            else
              $args = "{sortOrder:'$tKey'}";

            if ($tKey == "NAME")
                $addonclass = "nottoggable";
            else
                $addonclass = "";
            $out .= "<td index=$index ondragenter='dragenter_ptable_col(event)'   ondragleave='dragleave_ptable_col(event)'  ondrop='drop_ptable_col(event)' ondragstart='move_ptable_col(event)' draggable=true colkey=$tKey onclick=\"sortPatientTable(event,$args);\"; class ='".$rowtype."Cell $addonclass'> $temp </td>";
        }
        else
            $out .= "<td class ='".$rowtype."Cell'><i class='Kcaretmenu KCheckBox fa fa-square'></i></td>";

        $index++;

     }
     $out .= "</tr>";
     return $out;

  }


 /**********************************************************************************
  * Rendering of the study/patient rows
  ***********************************************************************************/


  function renderRow($row,  $rowtype, $project,$metaIndices)
  {
    $thestate = $_SESSION['state'][$project]; 
    $sortOrder = $thestate->viewer->sortOrder;
    $sortDirection = $thestate->viewer->sortDirection;

    $_Header = $GLOBALS['_Header'];    
    $pHeader = $GLOBALS['pHeader'];
    if ($thestate->viewer->selectionMode[1] == 'a')
      $sHeader = $GLOBALS['aHeader'];
    else 
      $sHeader = $GLOBALS['sHeader'];

    $out="";

    if($rowtype=='patient')
    {
      $rowid_parent = '';
      $rowid = $row['PIZ'];
    }
    else if($rowtype=='study')
    {
      $rowid_parent = $row['patients_id'];
      $rowid = $row['patients_id'] . riddelim. $row['StudyID'];
    }


    $out .= "<tr  ";

  
    if( !( ($rowtype === 'study' & ($thestate->viewer->selectionMode[1] == 's' | $thestate->viewer->selectionMode[1] == 'a')) | $rowtype === 'patient' ))
        $out .= " style='display:none;' ";

    // drag+drop
    $dragstuff = "draggable='true' ondrop='droponPatienttable(event);'  ondragover='dragover(event);' ondragleave='dragleave(event);'";
    if ( $rowtype == 'study')
    {
         $datastuff = "data-type='study' data-piz='" . $row["patients_id"] . "' data-sid='".$row["StudyID"]  .  "'  data-tag='".$row["STag"]."' data-filename='$row[StudyDescription]'   data-date='$row[StudyDate]'";       
         $tag = $row["STag"];
    }
    else if ($rowtype=='patient')
    {
         $datastuff = "data-type='patient'  data-piz='$row[PIZ]'  data-tag='".$row["PTag"]. "'";
        $tag = $row["PTag"];
    }

    if (strpos($tag,"[") != False)
    {
        if (strpos($tag,"]") != False)
        {
            $s = strpos($tag,"[");
            $l = strpos($tag,"]")-$s-1;
            $out .= " style='background-color:".substr($tag,$s+1,$l).";' ";
        }
    }
    else
    if (strpos($tag,"problem") != False | strpos($tag,"error") != False)
    {
        $out .= " style='background-color:#F55;' ";
    }


    $temp = " ondragstart='setdragstart(event);' ondragend='setdragend(event);'   $datastuff ";    
    $out .= "$dragstuff $temp  id='$rowid' rowid_parent='$rowid_parent' class ='$rowtype ".$rowtype."Row' >";


    if ($rowtype == "study")
       $header = $sHeader;
    else
       $header = $pHeader;

    foreach($_Header as $key => $t)
    {
      if (!isset($header[$key]) )
         $out .= "<td class ='".$rowtype."Cell'> </td>";
      else
      {
        $tField = $header[$key];
        if ($tField=="") $tField = $key;
        $linkAddColumn = '';
        $temp = '';
        $edithandler = "";
        $content = '';
        $addClass = "";

        if (array_key_exists($tField,$row))
          $content = $row[$tField];
         
        $seq=explode('_', $key);  
        if ($seq[0] == 'META' && $seq[2] == 'tag')
        {
             $idx = $metaIndices[substr($key,5)];
             if ($idx)
             {
               $tag = implode("_",array_slice($seq,3));
               if ($idx['level'] == 'study' && $rowtype == 'study')
               {
                  if (strpos($row['STag'],'/'.$tag.'/') !== false)
                    $content = '<i onclick="tagcol_click(\'' . $tag . '\',\'' . $rowid . '\',true, this)"  class="fa fa-fw fa-circle"> </i>';
                  else 
                    $content = '<i onclick="tagcol_click(\'' . $tag . '\',\'' . $rowid . '\',false, this)"  class="fa fa-fw fa-circle-o"> </i>';

               }
               else if ($idx['level'] == 'patient' && $rowtype == 'patient')
               {
                  if (strpos($row['PTag'],'/'.$tag.'/') !== false)
                    $content = '<i onclick="tagcol_click(\'' . $tag . '\',\'' . $rowid . '\',true, this)"  class="fa fa-fw fa-circle"> </i>';
                  else 
                    $content = '<i onclick="tagcol_click(\'' . $tag . '\',\'' . $rowid . '\',false, this)"  class="fa fa-fw fa-circle-o"> </i>';

               }
             }
        }
        else if ($seq[0] == 'META' &&  $rowtype == 'study')
        {
          $edithandler = ' ondblclick="editMetaContent(event,\'' . $rowid . '\',\'' . $key . '\');" ';
          $addClass .= " cellEditable";

        }

        $temp .= $content;

        if($tField =='selector' )
        {
          if (( $thestate->viewer->selectionMode == 'mp' & $rowtype == 'patient')
            | ( ($thestate->viewer->selectionMode == 'ma' | $thestate->viewer->selectionMode == 'ms') & $rowtype == 'study'))
    //          $temp =  "<i class='KCheckBox fa fa-square-o fa-fw' onclick='return patientTableMirror.toggle(\"$rowid\");'></i> ";
              $temp =  "<i class='KCheckBox fa fa-square-o fa-fw' onclick='return patientTableMirror.studypatientSelect(event,\"$rowid\");'></i> ";
          else
              $temp = "<i class='KCheckBox fa fa-fw' ></i>";
        }

        $addStyle = "";

        if($tField == 'NameCat')
        {
           if ($GLOBALS['anonym_mode'] )
           {
                 $rpiz =  $row['PIZ'];
                 if ($row['GivenName'] != "anonym")
                 {
                    if ($GLOBALS['psid_anonym_mode'] )
                        $rpiz = pid_hash((object) ["type" => "sha1"] ,$rpiz);

                    $temp= "<span>" . $rpiz . ", <i> anonym </i> </span>";                  
                 }

           }   
                   
           if (isset($_SESSION['moduleInfo'][$project]['anonymization']))
           {
               if ($row['GivenName'] == "")
                  $temp .= "<i> ANONYM </i>";

           }
        }

       
        if($key === 'PIZ') 
        {
            
           $addStyle =   "font-size:10px;text-align:right;";   
           if ($GLOBALS['psid_anonym_mode'] && $row['GivenName'] != "anonym")
                $temp = pid_hash((object) ["type" => "sha1"] ,$temp);

                                  

           if ($rowtype == "study" && $thestate->viewer->selectionMode[1] == 's')
           {
               $rpiz = $row['patients_id'];
               if ($GLOBALS['psid_anonym_mode']  && $row['GivenName'] != "anonym")
                  $rpiz = pid_hash((object) ["type" => "sha1"] ,$rpiz) .  "#";
               $temp = $rpiz . $temp;
           }
           $addStyle =   "font-size:10px;text-align:right;";
        }
  
        if($tField =='selector') 
          $addStyle =  "margin:0px;padding:0px;"; //"border:none;margin:0px;padding:0px;";

        // --------- additional padding left for studies and files
        if($tField ==='NameCat')
        {
          $temp = trim($temp);
          if($temp=='')
              $temp = 'undefined';
          if(  substr($temp, strlen($temp)-2,1) ==',') // cut the comma if no first name is set.
              $temp = substr($temp, 0,sizeof($temp)-2) ;
        }

        // Patient/Study expanders
        $treeExpander  = "";
        $taghover = " onmouseenter='showjobinfo(event)' onmouseleave='hidejobinfo(event)' ";
        if ($rowtype == 'study' & ($key == 'NAME' || $key == 'ANAME'))
        {
            $treeExpander = "<i class='KTreeExpander fa fa-plus-square-o' ></i><i class='KTreeSymbol fa fa-user-md'></i>";
            if ($thestate->viewer->selectionMode[1] == 'p')
              $addStyle =  "padding-left:15px;";

            $piz = $row["patients_id"];
            $sid = $row["StudyID"];
            $linkAddColumn = "onclick=\" patientTableMirror.tree_click(event,'$rowid');\" ";
            $taghover = " onmouseenter='showjobinfo(event)' onmouseleave='hidejobinfo(event)' ";
            $tagspan = "<span  " . $taghover . " class='KTag KTagRunning'>1</span><span " . $taghover . "  class='KTag KTagWaiting'>1</span><span " . $taghover . " class='KTag KTagError'>1</span><span  " . $taghover . " class='KTag KTagSuspended'>1</span>";
            $temp = $tagspan . renderTags($row["STag"],'KTagPatient'). $temp ;

        }
        if ($rowtype == 'patient' &($key == 'NAME' || $key == 'ANAME'))
        {
            $treeExpander = "<i class='KTreeExpander fa fa-plus-square-o' ></i>";
            $linkAddColumn = "onclick=\" patientTableMirror.tree_click(event,'$rowid');\" ";
            $tagspan = "<span  " . $taghover . "class='KTag KTagRunning'>1</span><span  " . $taghover . "class='KTag KTagWaiting'>1</span><span  " . $taghover . "class='KTag KTagError'>1</span><span  " . $taghover . "class='KTag KTagSuspended'>1</span>";
            $temp = $tagspan . renderTags($row["PTag"],'KTagPatient') . "&nbsp" . $temp;
        }


        // --------  format dates
        if (strpos($tField,'Date'))
        {
          if($temp=='0') $temp = ' &nbsp;N/A&nbsp;  ';
          else     $temp = sprintf('%s.%s.%s', substr($temp, 6,2),substr($temp, 4,2),substr($temp, 0,4));
        }
        

        if ($temp != "" && $key !='selector' )
        {
            if (strlen($content) > 100)
              $temp = "<span class='large'> $temp </span>";
            else
              $temp = "<span $edithandler > $temp </span>";
        }

        if ($temp == "")
            $temp = "<span $edithandler class='ANULL'> NULL </span>";
            
        $addClass .= " " .  (($rowtype === 'patientTableHeaderSearch')?"":"td_$tField");

        $out .= "<td class ='".$rowtype."Cell $addClass' $linkAddColumn style='$addStyle'>$treeExpander $temp </td>\n\r";
      }
    }

    $out .= "</tr>";
    return $out;
  }




  function renderTags($str,$class)
  {
       

       $tags = (explode("/",$str));
       sort($tags);
       $str = "";
       $temp = "";
       for ($k=0; $k < sizeOf($tags);$k++)
       {
          $class_ = $class;
          $add = " ";
          if ($tags[$k] == 'FirstAngi' || $tags[$k] == 'FirstPerf' || $tags[$k] == '1stPerf' || $tags[$k] == '1stAngi') // temporary exclusion of some tags for ctperfusion
	           continue;
          
          if (strlen($tags[$k])>0) 
          {
            if (substr($tags[$k],0,1) == '#')
            {
              $add .= "aggregateTag ";
              $tags[$k] = substr($tags[$k],1);
            }
          }
          if ($tags[$k] == 'TCKSEL')
            $add .= "fiberTag ";
          if ($tags[$k] == 'workstate')
            $add .= "workstateTag ";
          if ($tags[$k] == 'FORM')
            $add .= "FormTag ";
          if ($tags[$k] == 'mask')
            $add .= "MaskTag ";
          if ($tags[$k] == 'atlas')
            $add .= "AtlasTag ";
          if ($tags[$k] == 'ANO')
            $add .= "AnoTag ";
          if (substr($tags[$k],0,1) == '$')
          {
              $add .= "UserTag ";
              $tags[$k] = substr($tags[$k],1);
              $class_ = "";
          }
          if ($tags[$k] != "")
             $temp .= "<span oncontextmenu='tagcontextmenu(event);' class='" . $class_. $add . "'>" . $tags[$k] . "</span>";
       }
       return $temp;
  }




  /**********************************************************************************
  * translation
  ***********************************************************************************/

  function errorquery_to_sql($q)
  {
    $project = $_GET['project'];   
    $thestate = $_SESSION['state'][$project]; 

    if ($q == "")
    {
        if ($thestate->viewer->selectionMode[1] == "s")
             return "  (concat(tp.PIZ,ts.StudyID) NOT IN (SELECT concat(patients_id,studies_id) from DPX.gridjobs ) ) ";
        else if ($thestate->viewer->selectionMode[1] == "p")
             return "  (tp.PIZ NOT IN (SELECT patients_id from DPX.gridjobs) ) ";
        else
            return "";
    }
    else
    {
      if ($thestate->viewer->selectionMode[1] == "s")
         return "  (concat(tp.PIZ,ts.StudyID) IN (SELECT concat(patients_id,studies_id) from DPX.gridjobs where " . $q . ") ) ";
      else if ($thestate->viewer->selectionMode[1] == "p")
         return "  (tp.PIZ IN (SELECT patients_id from DPX.gridjobs where ".$q.") ) ";
      else
          return "";
    }
  }

  function WC_array_to_sql($field,$arr,$compop,$inner,$outer)
  {
     $field_combined = $GLOBALS['field_combined'];
     if (isset($field_combined[$field]))
        $field = $field_combined[$field];



     $WCLAUSE = "";
     for ($k=0;$k < sizeOf($arr);$k++)
     {
        $comp = $compop;

        $anyending = '%';
        if ($arr[$k][strlen($arr[$k])-1] == '!')
        {
            $anyending = '';
            $arr[$k] = substr($arr[$k],0,strlen($arr[$k])-1);
        }

        if ($arr[$k][0] == '>' | $arr[$k][0] == '<')
        {
           $comp = $arr[$k][0];
           $anyending = '';
           $arr[$k] = substr($arr[$k],1);
           $inner = true;
        }


       if (strpos($field,"Tag") !== false)
          $theclause =  $field . " " . $comp . " '%" . $arr[$k] . "%'";
       else if (strpos($field,"Filename") !== false)
       {

          $pos = strrpos($arr[$k],"/");
          if ($pos !== false)
            $theclause = "(subFolder LIKE '" . substr($arr[$k],0,$pos) . "' AND Filename LIKE '". substr($arr[$k],$pos+1) . $anyending . "')";
          else
            $theclause = "(Filename LIKE '". $arr[$k]  . $anyending . "')";
       }
       else
          $theclause = $field . " " . $comp . " '" . $arr[$k] . $anyending . "'";

       if ($inner)
          $WCLAUSE .= " AND " . $theclause;
       else
          $WCLAUSE .= " OR  " . $theclause;
     }
     if ($outer)
        $WCLAUSE = " AND (" . substr($WCLAUSE,4) . ")";
     else
        $WCLAUSE = " OR  (" . substr($WCLAUSE,4) . ")";
     return $WCLAUSE;
  }


  function WCfile_array_to_sql($field,$arr,$comp,$inner,$outer)
  {
    
     $field_combined = $GLOBALS['field_combined'];
     if (isset($field_combined[$field]))
        $field = $field_combined[$field];

     if ($outer)
        $WCLAUSE =  "";

     for ($k=0;$k < sizeOf($arr);$k++)
     {
       $theclause = "";

       $anyending = '%';
       if ($arr[$k][strlen($arr[$k])-1] == '!')
       {
           $anyending = '';
           $arr[$k] = substr($arr[$k],0,strlen($arr[$k])-1);
       }

       if (strpos($field,"Tag") !== false)
         $theclause = " (SELECT concat(patients_id,studies_id) from files WHERE Tag LIKE '%/" . $arr[$k] . "/%')";
       else if (strpos($field,"Filename") !== false)
       {

          $pos = strrpos($arr[$k],"/");
          if ($pos !== false)
            $theclause = " (SELECT concat(patients_id,studies_id) from files WHERE subFolder LIKE '" . substr($arr[$k],0,$pos) . "' AND Filename LIKE '". substr($arr[$k],$pos+1) . $anyending . "')";
          else 
            $theclause = " (SELECT concat(patients_id,studies_id) from files WHERE Filename LIKE '". $arr[$k] . $anyending ."')";
       }
       if ($inner)
          $WCLAUSE .= " AND (concat(tp.PIZ,ts.StudyID) " . $comp . $theclause . ")";
       else
          $WCLAUSE .= " OR  (concat(tp.PIZ,ts.StudyID) " . $comp . $theclause . ")";
     }
     if ($outer)
        $WCLAUSE = " AND (" . substr($WCLAUSE,4) . ")";
     else
        $WCLAUSE = " OR  (" . substr($WCLAUSE,4) . ")";
     return $WCLAUSE;
  }




?>
