

//  this is the end body of
//  function KView_standalone($parent,callback) 


    setNORAenv({})


    stateManager.setDefaultState(); 
    var KViewer = new KView($parent);

    KViewer.crosshairMode = true;
    KViewer.showInfoBar = true;
    KViewer.globalCoordinates = true;
    KViewer.startImageLoader = startImageLoader;

    addKeyboardShortcuts()

    var defaultOpenPath

    if (application == "webview")
    {

        ViewerSettings.nVisibleCols = 1
        ViewerSettings.nVisibleRows = 1
        ViewerSettings.nVisibleBarports = 0;

        KViewer.ViewerSettings = ViewerSettings;
        KViewer.defaultFOV_mm = 220;
        KViewer.setViewPortLayout();
        if (typeof KViewer_init_callback != "undefined")
            KViewer_init_callback(KViewer);

    }
    else 
    {



        process.on("uncaughtException", (err) => {
            var ipc = require('electron').ipcRenderer;
            ipc.send('consoleLog', err.stack);
            throw err;
        });





        var remote = require('electron').remote;
        if (remote == undefined)
        {
           remote = require('@electron/remote')
        }
        var path = require('path');        
        var args = remote.getGlobal('sharedObject').args                 // these are the command line arguments
        var scriptdir = remote.getGlobal('sharedObject').scriptdir;      // this is the location of the electron script

        if (args.length > 2)
            application = args[2];




        if  (application == "CVR" || application == "CVRstats" || application == "CVRfull")  
        {
            var base = scriptdir + '/../../morph';
    	    
         	report_creator(args,base)
        }
        else // if (application == "viewer")
        {


            fs = require('fs');
            dialog = require('electron').remote.dialog;


            ViewerSettings.nVisibleCols = 3
            ViewerSettings.nVisibleRows = 2
            ViewerSettings.nVisibleBarports = 0;

            KViewer.ViewerSettings = ViewerSettings;
            KViewer.defaultFOV_mm = 220;
            KViewer.setViewPortLayout([ViewerSettings.nVisibleRows,ViewerSettings.nVisibleCols]);  
            
            setTimeout(function(){
           //     KViewer.cacheManager.show(KViewer.viewports[15]);
                KViewer.roiTool.show(KViewer.viewports[6]);
//                KViewer.obj3dTool.show(KViewer.viewports[15]);
                KViewer.cacheManager.show(KViewer.viewports[4]);
            },0);

            loadSettings();

            KViewer.setViewPortLayout();  

            var settingsDialog 		 = new SettingsDialog();

            if (args.length > 1)
            {
                if (path.resolve(args[1]) == path.dirname(__filename))
                    args = args.slice(2);
                else 
                    args = args.slice(1);
            }

           KViewer.cacheManager.loadFile(args.map(function(r) { return path.resolve(r) }))


        }
     
     
    }















function loadSettings()
{
    try
    {
        var state = JSON.parse(fs.readFileSync("./noraview.settings.json"))
        stateManager.applyState(state);
        KToolWindow.reestablishToolState(state.toolstate);
    }
    catch(err)
    {
        console.warn(err);

    }        
}



function ASyncSerial(funs)
{
     if (funs.length > 0)
     {
         var f = funs[0];
         funs = funs.slice(1);

         if (f.length > 0)
         {
            setTimeout(function()
            {
                f(function(cb) {
                 if (cb != "break")
                    ASyncSerial(funs); 

                 });
            },0);
         }
         else
         {
            setTimeout(function()
            {
                if (f() != "break")
                    ASyncSerial(funs);
            },0);
         }


     }

}


function logProcess(obj)
{
    if (typeof require != "undefined")
    {
        var ipc = require('electron').ipcRenderer;
        $("#KLoadingFrameTypeString").text(obj)
        ipc.send('consoleLog',obj);
    }
    console.log(obj);
}



