var runningJobcnt = 0;


function KCommandDialogProxy() {


    function buildCommandDialog() {
        commandDialog = new KCommandDialog();
        commandDialog.establishState(state.batchtool);
        commandDialog.selectionModeChanged();
        commandDialog.updategridStats();
        //setTimeout(function() { commandDialog.thrashLayout(); },0);
        console.log("batchtool started");
    }


    return {
        buildCommandDialog: buildCommandDialog,
        visible: false,
        toggle: function() {
            buildCommandDialog();
            var ret = commandDialog.toggle();
            return ret;


        },
        submitCommandBatch: function(a, b, 
                                     c) {
            buildCommandDialog();
            commandDialog.submitCommandBatch(a, b, c);
        }
    };

}

function KCommandDialog() {


    var that = new dialog_generic();
    that.$frame.find(".fa-window-restore").hide()
    that.visible = true;
    function fitIntoVP()
    {
        var ptablewid = $('#patientTableWrap').width();
        that.$frame.css('left', ptablewid + 40);
        that.$frame.css('top', 40);
        that.$frame.width($(window).width() - ptablewid - 50);
        that.$frame.height($(window).height() - 50);
        sepResizer();
    }
    that.fitIntoVP = fitIntoVP
    fitIntoVP();

    that.$container.addClass('sbox_vert');

    // we need this for list and batches
    var $inner = $("<div class='sbox_horz sbox_resizable' style='padding-top:4px'></div>").appendTo(that.$container);
    sbox.appendResizer($inner);

    var $listdiv = $("<div class='KCommandDialogListDIV sbox_resizable'></div>").appendTo($inner);
    that.$inner = $inner;
    that.$listdiv = $listdiv;

    function sepResizer(e)
    {
       var w = $(".KCommandDialog").width()
       $("#KCmdHeadSeparator").width(w) 
       $("#KCmdHeadSeparatorAggregate").width(w-10) 

    }
    that.sepResizer = sepResizer;
    sbox.appendResizer($listdiv,sepResizer);


    that.codeMirrors = {}


    var $divcmd = $("<div class='KCommandDialog sbox_resizable'></div>").appendTo($inner);
    that.$divcmd = $divcmd;

    that.batchmodified = false;
    that.batchchanged = function(state, event) {

        if (state == undefined)
            return that.batchmodified
        else {
            if (state == true) {
                if (event) {
                    if (event.ctrlKey | event.altKey)
                        return;
                }
                that.batchmodified = true;
                if (last_selection != "current") {
                    that.saveButton.find(".KCmdToolSaveButton").addClass("modified")
                    BatchList[last_selection].addClass('unsaved')
                }
            } else {
                that.batchmodified = false;
                that.saveButton.find(".KCmdToolSaveButton").removeClass("modified")
            }
        }
    }

    function thrashLayout() {
        $divcmd.width($divcmd.width())
        $divcmd.height($divcmd.height())
        sepResizer();


    }
    that.thrashLayout = thrashLayout;

    // ********************* grid container with tools and content*******************
    var $gridcontainer = $("<div class='KCommandDialogGridContainer sbox_resizable'></div>").appendTo(that.$container);
    $gridcontainer.hide();
    $gridcontainer.height(200);
    that.grid_visible = false;

    var $gridtools = $("<div class=''></div>").appendTo($gridcontainer);
    $gridtools.append($("<div class='KCmdGridButton'> <i class='fa fa-refresh'></i></div>").click(function(e) {
        updateGridjobTable(undefined, e);
    }));
    $gridtools.append($("<div class='KCmdGridButton'> <i class='fa fa-bars'></i></div>").click(function(e) {
        that.gridActions(e);
    }));


    // ****************************************
    that.$gridtablediv = $("<div class=''></div>").appendTo($gridcontainer);

    var $griddivshowbutton = $("<div class='KCmdGridButton' style='bottom:0px;position:absolute;z-index:100;' ><i class='fa fa-arrow-up'></i> <div> Grid </div></div>").appendTo(that.$frame)
    $griddivshowbutton.click(
        function(e) {
            e.stopPropagation();
            if (!that.grid_visible) {
                that.grid_visible = true;
                gridjobsDialog.searchstate.fields.module = currentModule;
                $gridcontainer.show();
                $listdiv.height($divcmd.height() - $gridcontainer.height());
                $divcmd.height($divcmd.height() - $gridcontainer.height());
                updateGridjobTable();
                $gridcontainer.css('max-height',"inherit")

                $griddivshowbutton.find('i').removeClass('fa-arrow-up');
                $griddivshowbutton.find('i').addClass('fa-arrow-down');
            } else {
                that.grid_visible = false;
                $gridcontainer.hide();
                //$gridcontainer.height('0px');
                $griddivshowbutton.find('i').addClass('fa-arrow-up');
                $griddivshowbutton.find('i').removeClass('fa-arrow-down');
                $listdiv.height($inner.height());
                $divcmd.height($inner.height());
            }

        });


     var $gridinfo = $("<div class='KCmdGridinfo'> helllllllleeeeeeeoooooo </div>").appendTo($gridcontainer)
     that.gridinfo = $gridinfo;
     that.gridActions = KContextMenu(
        function() {
            var $menu = $("<ul class='menu_context'>")

            $menu.append($("<li onchoice='kill'>Send kill signal </li>"))
            $menu.append($("<li onchoice='hold'>Send hold signal </li>"))
            $menu.append($("<li onchoice='unhold'>Send unhold signal </li>"))            
            $menu.append($("<li onchoice='suspend'>Send suspend signal </li>"))
            $menu.append($("<li onchoice='unsuspend'>Send unsuspend signal</li>"))
            $menu.append($("<li onchoice='clearerror'>Clear errorenous jobs</li>"))
            $menu.append($("<li onchoice='clearall'>Kill all  jobs</li>"))

            return $menu;
        },
        function(str, ev) {
            if (str != undefined) {
                if (str == "hold")
                    gridjobs_sendhold();
                else if (str == 'unhold')
                    gridjobs_sendunhold();
                else if (str == 'kill')
                    gridjobs_sendkill();
                else if (str == 'suspend')
                    gridjobs_sendsuspend();
                else if (str == 'unsuspend')
                    gridjobs_sendunsuspend();
                else if (str == 'clearerror')
                    gridjobs_cleardead();
                else if (str == 'clearall')
                    gridjobs_killall()

            }
        });


    //// BATCH load/save interface ///////////////////////////////////////

    var last_selection = "current";
    var last_clicked_batch;
    var current_batch;
    var modified_batches = {};
    var batches_scrollstate = {};
    var $pastebutton;
    var loadUserCmd = function(e, callback) {
        batches_scrollstate[last_selection] = { scrolltop: $(".KCommandDialog").scrollTop() };
        if (e.uid == "KCURRENTUID") {

            if (last_selection != "current") {
                if (that.batchchanged()) {
                    modified_batches[last_selection] = getCommandDiv("");
                    change();

                } else {
                    change();
                }

            } else
                callback(e)


            function change() {
                callback(e)
                that.batchchanged(false);
                $pastebutton.addClass("inactive");

                if (last_selection != "current") {
                    clear();
                    last_selection = "current";
                    if (current_batch != undefined)
                        addCommandArray(current_batch);
                    if (batches_scrollstate[last_selection] != undefined)
                        $(".KCommandDialog").scrollTop(batches_scrollstate[last_selection].scrolltop)

                }
            }
        } else if (e.klistgroup_id != undefined) {
            if (e.klistgroup_state)
                BatchList.groupsexpanded[e.klistgroup_id] = 1;
            else
                delete BatchList.groupsexpanded[e.klistgroup_id];

        } else {
            if (that.batchchanged() && last_selection != "current") {
                modified_batches[last_selection] = getCommandDiv("");
                BatchList[last_selection].addClass('unsaved')
                change()
            } else
                change();

            function change() {
                callback(e)
                var cmd = e.uid;

                that.batchchanged(false);
                $pastebutton.removeClass("inactive");
                if (last_selection == "current")
                    current_batch = getCommandDiv("");
                last_selection = cmd;
                last_clicked_batch = cmd;
                clear();
                if (modified_batches[cmd] != undefined) {
                    addCommandArray(modified_batches[cmd]);
                    that.batchchanged(true);
                } else {
                    addCommand("user", cmd);
                    that.batchchanged(false);
                }
                if (batches_scrollstate[cmd] != undefined)
                     $(".KCommandDialog").scrollTop(batches_scrollstate[cmd].scrolltop)

            }
        }

        return "donotcall";
    }

    var updateBatchList = function() {
        BatchList.clear();
        BatchList.append("KCURRENTUID", "current", undefined, loadUserCmd);

        $pastebutton = $("<div class='batchbutton' ><i class='fa fa-arrow-up'></i></div>").click(function() {
            current_batch = getCommandDiv("");
            BatchList['KCURRENTUID'].trigger('click');
        }).appendTooltip('paste as current').appendTo(BatchList.$ul);
        $pastebutton.addClass("inactive");

        var $refreshbutton = $("<div class='batchbutton' ><i class='fa fa-refresh'></i></div>").click(function() {
        		$(document.body).addClass("wait");		
                refreshUserBatches(function() {
                    updateBatchList();
            		$(document.body).removeClass("wait");		
                });

        }).appendTooltip('refresh from remote').appendTo(BatchList.$ul);

        var $newbutton = $("<div class='batchbutton' ><i class='fa fa-plus'></i></div>").click(function() {
            saveUserCommand(undefined, [], "newbatch")
        }).appendTooltip('create new batch').appendTo(BatchList.$ul);

  

        // sort by name
        var keys = Object.getOwnPropertyNames(usercmdlist)
        keys.sort(function(a, b) {
            if (a.toLowerCase() < b.toLowerCase()) return -1;
            else return 1
        })

        keys.sort(function(a, b) {
            if (a.search("/") == -1 && b.search("/") !== -1) return -1;
            else return 0
        })

        // clean possibly deleted or renamed batches
        var blist = BatchList.groupsexpanded;
        for (var u in blist) {
            var wasfound = false;
            for (var z = 0; z < keys.length; z++)
                if (keys[z].split('/')[0] == u)
                    wasfound = 1;
            if (!wasfound)
                delete blist[u];

        }


        for (var k = 0; k < keys.length; k++)
        {
            var cmd = keys[k];
            var title = cmd;
            var c = usercmdlist[keys[k]];
            var addon = ""
            if (c.user != undefined)
                addon =  " <p class=username> (" + c.user + ") </p>";
            BatchList.append(cmd, {title:title,addon:addon}, undefined, loadUserCmd, function(uid, $li) {
                var cmd = uid;
                if (modified_batches[cmd] != undefined | (that.batchmodified & last_selection == cmd))
                    $li.addClass('unsaved')
                if (BatchList.activeID == uid)
                    $li.addClass('active')

                $li['jsontable_id'] = usercmdlist[uid].id;


                var undo = $("<i class='fa cmdsavebut fa-reply'></i>").appendTo($li).click(function(ev) {
                    ev.stopPropagation();
                    alertify.confirm('Are you sure to revert to old state, you will loose your changes?',function(e) { 
                       if (e)
                       {
                            modified_batches[uid] = undefined;
                            if (BatchList.activeID == uid) {
                                clear();
                                addCommand("user", uid);
                                that.batchchanged(false);
                            }

                            updateBatchList();
                       }
                    });

                });


                var savebut = $("<i class='fa cmdsavebut fa-save'></i>").appendTo($li).click(function(ev) {
                    ev.stopPropagation();
                    if (BatchList.activeID == uid)
                        saveUserCommand("");
                    else {
                        if (modified_batches[uid] == undefined)
                            console.error("nothing to save!!")
                        else
                            saveUserCommand(undefined, modified_batches[uid], uid)
                    }

                });



                var star = $("<i class='fa fa-bars'></i>").appendTo($li).click(function(ev) {
                    ev.stopPropagation();

                    var context_menu = KContextMenu(
                        function(ev) {

                            var $menu = $("<ul class='menu_context'>")
                            if (usercmdlist[cmd].fav == "ON")
                                $menu.append($(" <li onchoice='nofav'>Remove from favourites  </li>"));
                            else
                                $menu.append($(" <li onchoice='fav'>Add to favourites  </li>"));

                            if (usercmdlist[cmd].wrap == "ON")
                                $menu.append($(" <li onchoice='nowrap'>Remove from user commands  </li>"));
                            else
                                $menu.append($(" <li onchoice='wrap'>Add as user command </li>"));
                            $menu.append($(" <li onchoice='rename'>rename command </li>"));
                            $menu.append($(" <li onchoice='delete'>delete command</li>"));

                            return $menu;

                        },
                        function(str, ev) {

                            function updateMenu() {
                                $cmdList.find(".usercmdmenu").remove();
                                createUserMenu(undefined, $cmdList.find(".advancedmenu"))
                            }

                            function save() {
                                var json = {
                                    name: cmd,
                                    fav: usercmdlist[cmd].fav,
                                    wrap: usercmdlist[cmd].wrap,
                                    def: usercmdlist[cmd].def,
                                    user: usercmdlist[cmd].user
                                };
                                jsonTable_save({ 
                                    id: usercmdlist[cmd].id,
                                    type: 'userbatch',
                                    json: json
                                }, function(e) {});
                                updateMenu()
                            }
                            if (str) {
                                if (str == "fav") {
                                    usercmdlist[cmd].fav = "ON"
                                    save()
                                }
                                if (str == "nofav") {
                                    usercmdlist[cmd].fav = "OFF"
                                    save()
                                }
                                if (str == "wrap") {
                                    usercmdlist[cmd].wrap = "ON"
                                    save()
                                }
                                if (str == "nowrap") {
                                    usercmdlist[cmd].wrap = "OFF"
                                    save()
                                }

                                if (str == "rename")
                                    renameUserCommand(uid, function() {
                                        updateMenu();
                                        updateBatchList();
                                    })
                                if (str == "delete")
                                    delUserCommand(uid, function() {
                                        updateMenu();
                                        BatchList[uid].remove();
                                    });




                            }
                        },
                        true, false
                    );
                    context_menu(ev);

                });
            });
        }

    }

    that.isModified = function() {
        for (var k in modified_batches) {
            if (modified_batches[k] != undefined)
                return true
        }
        if (that.batchmodified & last_selection != "current")
            return true;

        return false;
    }

    var BatchList = new KList({
        $targetcontainer: $listdiv,
        classes: ["vertical", "classic", "inverted", "noflex"]
    });
    BatchList.$ul.appendTo($listdiv);
 //   updateBatchList();

    ///////////////////////////////////////


    // add functions from module json
    var $cmdList = that.$menu;

    var cmdInfo = projectInfo.cmddesc;

    var $cmdhead = $("<li ><a> Batchtool </a></li> ");
    var $cmdtoolgroup = $("<ul > </ul>").appendTo($cmdhead);


    $cmdtoolgroup.append($("<li ><a> New </a></li>").click(function() {
       saveUserCommand(undefined,[],"newbatch");

    }));
    $cmdtoolgroup.append($("<li ><a> Copy </a></li>").click(function() {
        copycommand("")
    }));
    $cmdtoolgroup.append($("<li ><a> Paste </a></li>").click(function() {
        pastecommand()
    }));
    $cmdtoolgroup.append($("<li ><a> Import JSON</a></li>").click(function() {
        importcommand()
    }));
    $cmdtoolgroup.append($("<li ><a> Save </a></li>").click(function() {
        saveUserCommand("");
    }));
    $cmdtoolgroup.append($("<li ><a> Clear all </a></li>").click(function() {
        clear()
    }));

    $cmdList.append($cmdhead);

    function createCmdMenu($target, aggregate, $wheretoadd) {

        var themenu = {}
        function add(path,group,name,f)
        {
           var p = path.split(".")   
           var ob = themenu;
           for (var k = 0; k < p.length-1;k++)
           {
               if (ob[p[k]] == undefined)
                 ob[p[k]] = {}
               ob = ob[p[k]];
           }
           ob[p[p.length-1]] = f;
           f.group = group
           f.name = name
        }
        
        for (var fungroup in cmdInfo) {
          if ((aggregate && fungroup == 'aggregate') | (!aggregate && fungroup != 'aggregate')) 
            if (cmdInfo.hasOwnProperty(fungroup)) {
                var funlist = cmdInfo[fungroup];
                for (var fun in funlist) {
                    var f = funlist[fun]
                    if (f.menu != undefined)
                    {
                        if (f.menu != "OFF")
                            add(f.menu,fungroup,fun,f)
                    }
                    else if (f.funhandle != undefined)
                    {
                        add(fungroup+"."+fun,fungroup,fun,f)
                    }
                    else
                    {
                        for (var k in f)
                        {
                            if (f[k].menu != undefined)
                            {
                                if (f[k].menu != "OFF")
                                    add(f[k].menu,fungroup+"."+fun,k,f[k])
                            }
                            else
                                add(fungroup+"."+fun+"."+k,fungroup+"."+fun,k,f[k])
                        }             
                    }

                 }
             }
        }

        for (var fungroup in themenu) {
            if (themenu.hasOwnProperty(fungroup)) {
                var $cmdhead = $("<li><a> " + fungroup + " </a></li> ");
                var $cmdgroup = $("<ul > </ul>");
                if (1) // (aggregate && fungroup == 'aggregate') | (!aggregate && fungroup != 'aggregate')) 
                {

                    var funlist = themenu[fungroup];
                    var dirs = [];
                    var cmds = [];
                    for (var fun in funlist) 
                    {
                        if (funlist[fun].funhandle != undefined)
                            cmds.push(fun);
                        else
                            dirs.push(fun);
                    }
                    dirs.sort()
                    cmds.sort()
                    var list = dirs.concat(cmds)

                    
                    for (var j = 0; j < list.length;j++) {
                        var fun = list[j];
                        if (funlist[fun].funhandle != undefined)
                            $cmdgroup.append($("<li> <a>" + fun + "</a><p class=descrip>"+funlist[fun].description+"</p></li>").on("mouseup", function(x, y) {
                                return function(e) {
                                    if ($target.hasClass('menu_context'))
                                        addCommand(x, y, undefined, $wheretoadd);
                                    else
                                        scrollTo_highlight(addCommand(x, y));
                                    that.batchchanged(true);
                                };
                            }(funlist[fun].group, funlist[fun].name)));
                        else if (typeof funlist[fun] == 'object') {
                            var $subcmdhead = $("<li><a><span> " + fun + "</span> <i class='fa fa-caret-right'></i></a></li>").appendTo($cmdgroup);
                            var $subcmdgroup = $("<ul > </ul>").appendTo($subcmdhead);
                            var subfunlist = funlist[fun];
                            for (var subfun in subfunlist) {
                                $subcmdgroup.append($("<li ><a>" + subfun + "</a><p class=descrip>"+subfunlist[subfun].description+"</p></li>").click(function(x, y) {
                                    return function() {
                                        if ($target.hasClass('menu_context'))
                                            addCommand(x, y, undefined, $wheretoadd);
                                        else
                                            scrollTo_highlight(addCommand(x, y));
                                        that.batchchanged(true);


                                    };
                                }(subfunlist[subfun].group, subfunlist[subfun].name)));
                            }
                        }
                    }
                    $cmdhead.append($cmdgroup);
                    $target.append($cmdhead);
                }
            }
        }

        if (aggregate)
        {

            var $cmdhead = $("<li><a>  generic  </a></li> ");
            var $cmdgroup = $("<ul > </ul>");

            $cmdgroup.append($("<li ><a> Python </a></li>").click(function() {
                scrollTo_highlight(addCommand("aggregate", "genericPYTHONfix"));
                that.batchchanged(true)
            }));

            if (static_info.jupyter)
                $cmdgroup.append($("<li ><a> jupyter </a></li>").click(function() {
                    scrollTo_highlight(addCommand("aggregate", "jupyter"));
                    that.batchchanged(true)
                }));

            $cmdhead.append($cmdgroup);
            $target.append($cmdhead);


        }

/*

        for (var fungroup in cmdInfo) {
            if (cmdInfo.hasOwnProperty(fungroup)) {
                var $cmdhead = $("<li><a> " + fungroup + " </a></li> ");
                var $cmdgroup = $("<ul > </ul>");
                if ((aggregate && fungroup == 'aggregate') | (!aggregate && fungroup != 'aggregate')) {
                    var funlist = cmdInfo[fungroup];
                    for (var fun in funlist) {
                        if (funlist[fun].funhandle != undefined)
                            $cmdgroup.append($("<li ><a>" + fun + "</a></li>").on("mouseup", function(x, y) {
                                return function(e) {
                                    if ($target.hasClass('menu_context'))
                                        addCommand(x, y, undefined, $wheretoadd);
                                    else
                                        scrollTo_highlight(addCommand(x, y));
                                    that.batchchanged(true);
                                };
                            }(fungroup, fun)));
                        else if (typeof funlist[fun] == 'object') {
                            var $subcmdhead = $("<li><a><span> " + fun + "</span> <i class='fa fa-caret-right'></i></a></li>").appendTo($cmdgroup);
                            var $subcmdgroup = $("<ul > </ul>").appendTo($subcmdhead);
                            var subfunlist = funlist[fun];
                            for (var subfun in subfunlist) {
                                $subcmdgroup.append($("<li ><a>" + subfun + "</a></li>").click(function(x, y) {
                                    return function() {
                                        if ($target.hasClass('menu_context'))
                                            addCommand(x, y, undefined, $wheretoadd);
                                        else
                                            scrollTo_highlight(addCommand(x, y));
                                        that.batchchanged(true);


                                    };
                                }(fungroup + "." + fun, subfun)));
                            }
                        }
                    }
                    $cmdhead.append($cmdgroup);
                    $target.append($cmdhead);
                }
            }
        }*/
    }


    function createUserMenu($target, $before) {
        // add commands generic (FSL/SPM)
        var $cmdhead = $("<li class='usercmdmenu'><a> user </a></li> ");
        var $cmdgroup = $("<ul > </ul>");
        var obj = {}
        var cnt = 0
        for (var cmd in usercmdlist)
            if (usercmdlist[cmd] != undefined)
                if (usercmdlist[cmd].wrap == "ON") {
                    var s = cmd.split("/");
                    if (s.length == 1)
                        obj[cmd] = cmd;
                    else {
                        if (obj[s[0]] == undefined)
                            obj[s[0]] = []
                        obj[s[0]].push(cmd)
                    }
                }


        for (var k in obj) {
            if (Array.isArray(obj[k])) {
                var $head = $("<li><a><span> " + k + " </span> <i class='fa fa-caret-right'></i></a></li> ");
                var $group = $("<ul > </ul>");
                for (var j in obj[k]) {
                    var id = usercmdlist[obj[k][j]].id
                    var name = obj[k][j].substring(obj[k][j].indexOf('/') + 1)
                    $group.append($("<li ><a> " + name + " </a></li>").click(function(cmd) {
                        return function() {
                            scrollTo_highlight(addCommand("usercmdwrap", cmd));
                            that.batchchanged(true);
                        }
                    }(id)));
                }
                $head.append($group)
                $cmdgroup.append($head)

            } else
                $cmdgroup.append($("<li><a>" + k + "</a></li>").click(function(cmd) {
                    return function() {
                        scrollTo_highlight(addCommand("usercmdwrap", cmd));
                        that.batchchanged(true);
                        
                    }
                }(usercmdlist[k].id)));
            cnt++

        }

        if (cnt > 0) {
            $cmdhead.append($cmdgroup);
            if ($target != undefined)
                $target.append($cmdhead);
            else
                $cmdhead.insertBefore($before);

        }

    }

    function createAdvancedMenu($target, dummy, $where) {
        // add commands generic (FSL/SPM)
        $cmdhead = $("<li class='advancedmenu'><a> generic </a></li> ");
        $cmdgroup = $("<ul > </ul>");
        $cmdgroup.append($("<li ><a>BASH </a></li>").click(function() {
            scrollTo_highlight(addCommand("generic", "genericBASH"));
            that.batchchanged(true)
       }));
        $cmdgroup.append($("<li ><a>Python </a></li>").click(function() {
            scrollTo_highlight(addCommand("generic", "genericPYTHON"));
            that.batchchanged(true)
        }));
        $cmdgroup.append($("<li ><a>Matlab </a></li>").click(function() {
            scrollTo_highlight(addCommand("misc", "matlab_generic"));
            that.batchchanged(true)
        }));

        if (static_info.spmbatches != undefined) {
            $cmdgroup.append($("<li ><a>SPM </a></li>").click(function() {
                scrollTo_highlight(addCommand("generic", "genericSPM"));
                that.batchchanged(true)                
            }));

            var $spmhead = $("<li><a><span> predefined SPM </span> <i class='fa fa-caret-right'></i></a></li> ");
            var $spmgroup = $("<ul > </ul>");


            var batches = Object.keys(static_info.spmbatches);
            for (var i = 0; i < batches.length; i++) {
                $spmgroup.append($("<li ><a> " + batches[i] + " </a></li>").click(function(batchname) {
                    return function() {
                        var $thefundiv = addCommand("generic", "genericSPM",{customName:batchname,args:{cmdstring:{val:static_info.spmbatches[batchname]}}});
                        $thefundiv.find("[id^=KCmdname]").val(batchname);
                        var $cmdstring = $thefundiv.find("[id^=KCmdString]");
                        //that.codeMirrors[$cmdstring.attr("id")].setValue(static_info.spmbatches[batchname])
                           setTimeout(function() {
                            that.codeMirrors[$cmdstring.attr("id")].clearHistory();
                            that.codeMirrors[$cmdstring.attr("id")].refresh();                            }, 1);



                    }
                }(batches[i])));
            }

            $spmhead.append($spmgroup);

            $cmdgroup.append($spmhead);

        }

        $cmdhead.append($cmdgroup);
        $target.append($cmdhead);


        $cmdhead = $("<li class='advancedmenu'><a> advanced </a></li> ");
        $cmdgroup = $("<ul > </ul>");
        
        $cmdgroup.append($("<li ><a> Add Separator </a></li>").click(function() {
            scrollTo_highlight(addCommand("separator", undefined, undefined, $where));
            that.batchchanged(true)

        }));
        $cmdgroup.append($("<li ><a> Add loop (files) </a></li>").click(function() {
            scrollTo_highlight(addCommand("loop", "files", undefined, $where));
            that.batchchanged(true)
        }));
        $cmdgroup.append($("<li ><a> Add loop (string,int) </a></li>").click(function() {
            scrollTo_highlight(addCommand("loop", "string", undefined, $where));
            that.batchchanged(true)
        }));
        $cmdgroup.append($("<hr width='100%'> "))
        $cmdgroup.append($("<li ><a> Add input/output wrap </a></li>").click(function() {
            scrollTo_highlight(addCommand("wrap"));
            that.batchchanged(true)
        }));



        $cmdgroup.append($("<li ><a> Add Variable </a></li>").click(function() {
            alertify.prompt("Please enter a name", function(e, name) {
                if (e) 
                { scrollTo_highlight(addCommand("variable", name, undefined, $where));
                  that.batchchanged(true) }
            });
        }));
        $cmdgroup.append($("<li ><a> Add Study Selector </a></li>").click(function() {
            alertify.prompt("Please enter a name", function(e, name) {
                if (e) {
                    addCommand("variableSID", name, {
                        args: {
                            val: {
                                val: "[Patient]#" + name
                            }
                        }
                    });
                    updateFilerefCombo();
                    that.batchchanged(true)
                    
                }
            })
        }));
        $cmdhead.append($cmdgroup);
        $target.append($cmdhead);
    }

    function createSelectorMenu($target) {
        var $cmdhead = $("<li><a> Selectors </a></li> ");
        var $cmdgroup = $("<ul > </ul>");
        $cmdhead.append($cmdgroup);
        $target.append($cmdhead);
    }


    //$("<li class='KMenuSeparator menu_generic_labelname'> </li> ").appendTo($cmdList)

    var $testtoggle = $("<li style='float:right'><a> <i > <span  class='KTextButton'> DEBUG </span></i></a></<li>").click(toggleTestMode)
        .appendTooltip('batchtestmode');
    $cmdList.append($testtoggle);

    var ALL_queues = KCommandDialog.getQueues()


    var queue = "";
    var nice_val = "";
    var max_subj_val = "";

    if (ALL_queues.length >= 1) {

        var choices = [2,5,10,20,"no limit"]
        var default_choice = 10;
        
        var $MaxSelector = $("<li class='nohover' style='float:right'><a> max  </a></<li>").appendTooltip("maximal number of parallel subjects processed in parallel")
            .appendTo($cmdList);
        var optlist = "";
        for (var i = 0; i < choices.length; i++)
        {
            if (choices[i] == default_choice)
                optlist += "<option selected value='" + choices[i] + "'>" + choices[i] + "</option>";
            else
                optlist += "<option value='" + choices[i] + "'>" + choices[i] + "</option>";
        }
        var $sel = $("  <select > " + optlist + " </select>").on('change', function(e) {
            max_subj_val = $(e.currentTarget).find('option:selected').val();
        }).click(function(e) {
            e.preventDefault();
            e.stopPropagation()
        });
        $($MaxSelector.children()[0]).append($sel);
        max_subj_val = default_choice;


        var choices = ["",10,100,1000]
        var default_choice = 100;
        var default_choice_admin = "";

        if (static_info.SLURM_NICECONF)
        {
            choices = static_info.SLURM_NICECONF.choices ;
            default_choice = static_info.SLURM_NICECONF.default;
            default_choice_admin = static_info.SLURM_NICECONF.default_admin;
        }

        if (userinfo.isadmin == "1")
            default_choice = default_choice_admin

        
        var $NiceSelector = $("<li class='nohover' style='float:right'><a> nice  </a></<li>").appendTooltip("slurms nice value used for all job submissions.")
            .appendTo($cmdList);
        var optlist = "";
        for (var i = 0; i < choices.length; i++)
        {
            if (choices[i] == default_choice)
                optlist += "<option selected value='" + choices[i] + "'>" + choices[i] + "</option>";
            else
                optlist += "<option value='" + choices[i] + "'>" + choices[i] + "</option>";
        }
        var $sel = $("  <select > " + optlist + " </select>").on('change', function(e) {
            nice_val = $(e.currentTarget).find('option:selected').val();
        }).click(function(e) {
            e.preventDefault();
            e.stopPropagation()
        });
        $($NiceSelector.children()[0]).append($sel);
      

        var $QueueSelector = $("<li class='nohover' style='float:right'><a> Queue  </a></<li>")
        //$QueueSelector.appendTo($cmdList);
        var optlist = "";
        var choices = ALL_queues;
        for (var i = 0; i < choices.length; i++)
            optlist += "<option value='" + choices[i] + "'>" + choices[i] + "</option>";
        var $selqueue = $("  <select > " + optlist + " </select>").on('change', function(e) {
            queue = $(e.currentTarget).find('option:selected').val();
        }).click(function(e) {
            e.preventDefault();
            e.stopPropagation()
        });
        $($QueueSelector.children()[0]).append($selqueue);

        function setQueue(q) {

            if (ALL_queues.filter((x) => x==q).length >= 1)
            { 
                $selqueue.find("option[value='" + q + "']").prop('selected', true);
                queue=q;
            }
            else
            {
                 if (ALL_queues.filter((x) => x==static_info.DEFAULTQUEUE).length >= 1)
                 {
                    $selqueue.find("option[value='" + static_info.DEFAULTQUEUE + "']").prop('selected', true);
                    queue = static_info.DEFAULTQUEUE;
                 }
                 else
                 {
                     queue = ALL_queues[0]
                 }
            }
        }
    } else {
        function setQueue(q) {
            queue = ALL_QUEUES[0] | "";
            console.log(">>" + queue);
        }
    }



    var testMode = false;
    var jupyter_debug = false; 

    function toggleTestMode() {
        testMode = !testMode;
        if ($QueueSelector) {
            if (testMode)
                $QueueSelector.addClass("inactive");
            else
                $QueueSelector.removeClass("inactive");
        }
        $testtoggle.find("span").toggleClass("selected");
    }

    that.getDebugbutton = function()
    {
       return $testtoggle.find("span").hasClass("selected")
    }

    that.getTestMode = function()
    {
        return testMode;
    }



    var batchexpanded = true;
    var $batchtoggle = $("<li><a> <i class='KCmdToolHead fa fa-minus' ></i></a></<li>").click(toggleBatchGroup);
    function toggleBatchGroup(ev) {
        batchexpanded = !batchexpanded;
        $batchtoggle.find(".fa").toggleClass("fa-minus");
        $batchtoggle.find(".fa").toggleClass("fa-plus");
        $("#KCmdHeadSeparator").nextUntil("#KCmdHeadSeparatorAggregate").toggle();
    }
    var $batch_icon = $("<li class='batchicon'><a> <i class='KCmdToolHead fa fa-random' ></i> Processing </a></<li>");

    var aggrexpanded = true;

    var $aggrtoggle = $("<li><a> <i class='KCmdToolHead fa fa-minus' ></i> </a></<li>").click(toggleAggregateGroup);
    $aggrtoggle.hide();
    function toggleAggregateGroup(ev) {
        aggrexpanded = !aggrexpanded;
        $aggrtoggle.find(".fa").toggleClass("fa-minus");
        $aggrtoggle.find(".fa").toggleClass("fa-plus");
        $("#KCmdHeadSeparatorAggregate").nextAll().toggle();
    }
    var $aggr_icon = $("<li class='batchicon'><a> <i class='KCmdToolHead fa fa-bar-chart' > </i> Analysis </a></<li>"
                       )


    function getState() {
        if (last_selection == "current")
            current_batch = getCommandDiv("");
        return {
            batches: current_batch,
            testMode: testMode,
            queue: queue,
            aggregateQueue : that.aggregateQueue,
            batchexpanded: batchexpanded,
            aggrexpanded: aggrexpanded,
            batchlistexpanded: BatchList.groupsexpanded
        };
    }
    that.getState = getState;

    function establishState(s) {
        if (s.batches)
            for (var k = 0; k < s.batches.length; k++)
                commandDialog.addUserCommand(s.batches[k]);
        if (s.testMode)
            if (s.testMode != testMode)
                toggleTestMode();
        setQueue(s.queue);
        that.setAggregateQueue(s.aggregateQueue);
        

        /*
        if (s.batchexpanded != undefined)
            if (s.batchexpanded != batchexpanded)
                toggleBatchGroup();
        if (s.aggrexpanded != undefined)
            if (s.aggrexpanded != aggrexpanded)
                toggleAggregateGroup();
        */

        BatchList.setGroupsExpanded(s.batchlistexpanded);

        updateBatchList();

        last_selection = "current";
        BatchList['KCURRENTUID'].trigger('click');
    }
    that.establishState = establishState;



    function clear() {
        $(".KCmdArgListTable").not(".KCmdvariablePID").not(".KCmdvariableSID").not("div[funref='0/variableANALYSISDEST/Analysis']").remove();
        $(".KCmdvariableSID").filter(':visible').remove();
        
    }

    function defaulttype_submission(parallel)
    {
        if (max_subj_val != "no limit")
        {
            var max = max_subj_val
            var subjectlist = getObjectList();
            if (subjectlist.length > max)
                parallel = "fullbasket_" + max;
        }
        return parallel;
    }




    var batchcontext_menu = KContextMenu(
        function(ev) {

            batchcontext_menu.$target = undefined;
            var $tr = $(ev.target)

            var oncmd = !$(ev.target).hasClass("KCommandDialog");
            if (1) //$(ev.target).hasClass("KCommandDialog"))
            {
                var cmds = that.$divcmd.find(".KCmdArgListTable")
                var ydists = cmds.map((y,x)=> ($(x).offset().top - ev.clientY)).toArray();
                ydists = ydists.map((x) => (x>0)?Infinity:Math.abs(x));
                var miny = math.max(ydists);
                var idx = ydists.indexOf(miny)
                $tr = $(cmds[idx-1]);
                if ($tr.length == 0)
                {
                    $tr = "empty"
                }
            }
            else
            {
                for (var k = 0; k < 5; k++)
                    if ($tr.hasClass("KCmdArgListTable"))
                        break
                else
                    $tr = $tr.parent();
                if (k > 5)
                    $tr = undefined;
            }
            if (1) {
                var $where;
                if ($tr == "empty")
                {

                }
                else
                    $where = $tr.next();
                batchcontext_menu.$target = $tr;
                //var group = $tr.attr('funref').split("/")[1]
                if (1) // group.substring(0, 8) != "variable") 
                {
                    var $menu = $("<ul class='menu_context'>")
                    $menu.append($(" <i style='margin-top:10px;margin-left:10px;' class='fa leftaligned fa-cog fa-1x'></i> Add a command  </span>"));
                    $menu.append($("<hr width='100%'> "));
                    createAdvancedMenu($menu, undefined, $where);
                    createCmdMenu($menu, false, $where);
                    $menu.append($("<hr width='100%'> "));
                }
                if (oncmd)
                {
                    $menu.append($("<li onchoice='delete'> delete  </li>"))
                    $menu.append($("<li onchoice='copy'> copy  </li>"))
                    $menu.append($("<li onchoice='duplicate'> duplicate  </li>"))
                    $menu.append($("<li onchoice='save'> save  </li>"))
                    $menu.append($("<li onchoice='validate'> validate  </li>"))
                }
                $menu.append($("<li onchoice='paste'> paste  </li>"))


                return $menu;
            }
        },
        function(str, ev) {
            if (str) {
                if (str == "paste") {
                    if (that.myownclipboard != undefined) {
                        if (!pasteit(that.myownclipboard, batchcontext_menu.$target))
                            alertify.alert("Nora not able to understand your clipboard contents (you can currently only paste batch jobs)");
                    } else
                        alertify.alert("Nothing to paste, use Ctrl-V to paste content from external editor/tab/browser.");
                }
                else
                {
                    var frefstr = batchcontext_menu.$target.attr("funref");
                    var fref = frefstr.split("/");
                    if (str == 'delete') {
                        batchcontext_menu.$target.remove();
                    } else if (str == "copy")
                        copycommand(frefstr, ev);
                    else if (str == "validate")
                        validate(frefstr, ev)
                    else if (str == "save")
                        saveUserCommand(funref(fref[1], fref[2], fref[0]));
                    else if (str == "ban/disable")
                        banCommand(frefstr);
                    else if (str == "duplicate") {
                        var tmp = getCommandDiv(frefstr);
                        addCommand(fref[1], fref[2], tmp[tmp.length-1],batchcontext_menu.$target);
                        that.batchchanged(true)                    
                    }
                }
            }            
        },
        true, false
    );

    that.$divcmd.on('contextmenu', function(e)
     { 
        batchcontext_menu(e);
     });


    that.$divcmd.on('click', function()
    {
        that.$container.find(".KCmdArgListTable.KCmdmarked").removeClass("KCmdmarked");
        $bigplaybutton.removeClass("KCmdmarkedPlay")        
    });


    // here comes the functions
    var $headsep = $("<div class='KCmdHeadSeparatorStyle' id='KCmdHeadSeparator'>");
    var $headsepmenu = $("<ul class = 'menu_generic'> </ul>").appendTo($headsep);
//    $headsepmenu.append($batchtoggle);
    $headsepmenu.append($batch_icon);


    var $bigplaybutton = $("<li><a> <i class='fa fa-play' ></i></a></li>")
    $headsepmenu.append($bigplaybutton.appendTooltip("run all processing jobs")
        .click(function() {
            if ($bigplaybutton.hasClass("KCmdmarkedPlay"))
                
                submitCommand("batch_subset", defaulttype_submission("sequential"));
            else 
                submitCommand("batch", defaulttype_submission("sequential"));
        })
        .on("contextmenu", submitContextMenu("batch",$bigplaybutton)));

    createCmdMenu($headsepmenu, false);

    createUserMenu($headsepmenu);
    createAdvancedMenu($headsepmenu);

    $("<li class='KMenuSeparator menu_generic_labelname'> </li> ").appendTo($cmdList)

  //  $headsepmenu.append($("<li class='menu_generic_labelname'>Batches<li>"));
    that.saveButton = $("<li><a> <i class='fa fa-save KCmdToolSaveButton' > </i></a><li>").click(function() {
        saveUserCommand("");
    }).appendTooltip("save all")
    $cmdList.append(that.saveButton);




    var AggregateSep_scroll = 0
    $(".KCommandDialog").on("scroll",function(e)
    {
       var $x = $("#KCmdHeadSeparatorAggregate");
       var scrolltop = $(".KCommandDialog").scrollTop()
       if (AggregateSep_scroll > 0)
       {
           
           if (scrolltop -AggregateSep_scroll < -30)
           {
               
               setTimeout(function() {
                $("#KCmdHeadSeparator").removeClass('inactive')               
                $x.css('position','relative')
                AggregateSep_scroll = 0;
               },10);
           }

       }
       else 
       if ( $x.position().top < 20)
       {
           $("#KCmdHeadSeparator").addClass('inactive')
           AggregateSep_scroll = $(".KCommandDialog").scrollTop()
           $(".KCommandDialog").scrollTop(AggregateSep_scroll-30)
           $x.css('position','absolute')
       }
    })







    function submitContextMenu(funref,$initiator) {
        return KContextMenu(
            function() {
                var $menu = $("<ul class='menu_context'>")

                $menu.append($("<li onchoice='chunked'>split into single jobs</li>"))
                $menu.append($("<li onchoice='chunkedpara'>split into single jobs, ignore dependencies</li>"))
                $menu.append($("<li onchoice='basket'>group as one job per patient</li>"))
                var $njob = $("<input style='width:30px' min=1 type=number onchoice='preventSelection'  >");
                if ($cmdList.attr("njob") != undefined)
                    $njob.val($cmdList.attr("njob"));
                else
                    $njob.val(1);
                $njob.on("keyup change", function() {
                    $cmdList.attr("njob", $njob.val())
                });

                var $njob2 = $("<i  onchoice='single2' class='fa button rightaligned' style='right:30px;'>2</i> ")
                var $njob5 = $("<i  onchoice='single5' class='fa button rightaligned' style='right:30px;'>5</i> ")
                var $njob10 = $("<i  onchoice='single10' class='fa button rightaligned' style='right:30px;'>10</i> ")

                $menu.append($("<li onchoice='single'>run everything in n jobs, n:</li>").append($njob).append($njob2).append($njob5).append($njob10))
                if (static_info.jupyter)
                {
                    if (funref.search("\/genericPYTHON") > -1 | funref.search("\/genericBASH") > -1 | funref.search("matlab_generic") > -1)
                        $menu.append($("<li onchoice='debug'>open jupyter for debug </li>"))
                }
                //$menu.append($("<li onchoice='immediate'>run everything in 'immediate' queue </li>"))

                return $menu;
            },
            function(str, ev) {

                if (str == undefined)
                    return;

                if ($initiator != undefined && $initiator.hasClass("KCmdmarkedPlay"))
                    funref = "batch_subset";
                
                if (str == "chunked")
                    submitCommand(funref, 'sequential');
                else if (str == "chunkedpara")
                    submitCommand(funref, 'parallel');
                else if (str == "basket")
                    submitCommand(funref, 'basket');
                else if (str == "single")
                    submitCommand(funref, 'fullbasket_' + $cmdList.attr("njob"))
                else if (str == "single2")
                    submitCommand(funref, 'fullbasket_2')
                else if (str == "single5")
                    submitCommand(funref, 'fullbasket_5')
                else if (str == "single10")
                    submitCommand(funref, 'fullbasket_10')
                else if (str == "debug")
                {
                    jupyter_debug = true;
                    submitCommand(funref, 'sequential');
                    jupyter_debug = false;
                }
                else if (str == "immediate")
                    submitCommand(funref, 'immediate');

                if ($initiator != undefined && $initiator.hasClass("KCmdmarkedPlay"))
                {
                    that.$container.find(".KCmdArgListTable.KCmdmarked").removeClass("KCmdmarked");
                    $bigplaybutton.removeClass("KCmdmarkedPlay")                            
                }
                    
            }, true, false)
    }



    
    $cmdList.append($("<li><a> <i class='fa fa-stop' ></i></a></li>").appendTooltip("kill all batches of this user/project")
        .click(gridjobs_killall)
    )

/*
    $headsepmenu.append($(" <i class='KCmdTool KValidate fa'  >validate</i>")
        .click(function() {
            return function(e) {
                validate("", e);
            };
        }()));*/
    var $validate_full = ($("<span class='KCmdvalidate KCmdvalidatefull'></span>"));
    //$headsepmenu.append($validate_full);

    $QueueSelector.appendTo($headsepmenu);


    that.$patselectinfo = $("<div class='menu_generic_labelname KCommandPatientSelection'>no patient selected for processing</div>");
    that.$container.append(that.$patselectinfo);

    $divcmd.append($headsep);

    that.setPatSelInfo = function() {
        var objs = getObjectList();

        that.$patselectinfo.removeClass("missing");
        if (state.viewer.selectionMode[1] == 'p') {
            if (objs.length == 0) {
                that.$patselectinfo.text("no patients selected for processing");
                that.$patselectinfo.addClass("missing");
            } else if (objs.length == 1)
                that.$patselectinfo.text("patient id " + objs[0].piz + " selected for processing");
            else
                that.$patselectinfo.text(objs.length + " patient(s) selected for processing");
        } else {
            if (objs.length == 0) {
                that.$patselectinfo.text("no studies selected for processing");
                that.$patselectinfo.addClass("missing");
            } else if (objs.length == 1)
                that.$patselectinfo.text("study " + objs[0].piz + objs[0].sid + " selected for processing");
            else
                that.$patselectinfo.text(objs.length + " study(s) selected for processing");
        }

    }

    that.setPatSelInfo();


    var $aggregatesep = $("<div class=KCmdHeadSeparatorStyle id='KCmdHeadSeparatorAggregate'>");
    var $aggregatesepmenu = $("<ul class = 'menu_generic'> </ul>").appendTo($aggregatesep);
//    $aggregatesepmenu.append($aggrtoggle);
    $aggregatesepmenu.append($aggr_icon);
//    $aggregatesepmenu.append($("<li class='menu_generic_labelname'>Analysis<li>"));



    var $bigplaybuttonaggr = $("<li><a> <i class='fa fa-play' ></i></a></li>")
    $aggregatesepmenu.append($bigplaybuttonaggr.appendTooltip("run all aggregate jobs")
        .click(function() {
//            if ($bigplaybuttonaggr.hasClass("KCmdmarkedPlay"))
  //              submitCommand("batch_subset", "sequential");
    //        else 
                submitCommand("aggregate", "sequential");
        }))
     //   .on("contextmenu", submitContextMenu("batch")));


    createCmdMenu($aggregatesepmenu, true);



    function aggregateQueueSelector()
    {

        var $QueueSelector = $("<li class='nohover' style='float:right'><a> Queue  </a></<li>").appendTo($aggregatesepmenu);
        var optlist = "";
        var choices = ALL_queues;
        for (var i = 0; i < choices.length; i++)
            optlist += "<option value='" + choices[i] + "'>" + choices[i] + "</option>";
        var $selqueue = $("  <select > " + optlist + " </select>").on('change', function(e) {
            that.aggregateQueue = $(e.currentTarget).find('option:selected').val();
        }).click(function(e) {
            e.preventDefault();
            e.stopPropagation()
        });
        $($QueueSelector.children()[0]).append($selqueue);
        function setQueue(q) {

            if (ALL_queues.filter((x) => x==q).length >= 1)
            { 
                $selqueue.find("option[value='" + q + "']").prop('selected', true);
                that.aggregateQueue=q;
            }
            else
            {
                 if (ALL_queues.filter((x) => x==static_info.DEFAULTQUEUE).length >= 1)
                 {
                    $selqueue.find("option[value='" + static_info.DEFAULTQUEUE + "']").prop('selected', true);
                    that.aggregateQueue = static_info.DEFAULTQUEUE;
                 }
                 else
                 {
                     that.aggregateQueue = ALL_queues[0]
                 }
            }
        }
        that.setAggregateQueue = setQueue;

    }


    aggregateQueueSelector()






    $divcmd.append($aggregatesep);

    var $finalspacer = $("<div class=KCmdHeadSeparatorStyle id='KCmdHeadFinalSpacer'>");
    $divcmd.append($finalspacer);


    $aggregatesep.on("dragenter", function() {
        $(that.dragged).insertBefore($(this));
    });


    var defaultPSID = ["Patient", "Study", "Analysis"];
    addCommand("variablePID", defaultPSID[0]);
    addCommand("variableSID", defaultPSID[1]);
    addCommand("variableSID","Patient#OLDEST",{funhandle:"Study",type:"variableSID", args:{val:{val:"[Patient]#OLDEST"}}});
    addCommand("variableSID","Patient#LATEST",{funhandle:"Study",type:"variableSID", args:{val:{val:"[Patient]#LATEST"}}});
    addCommand("variableSID","Patient#LOOP",{funhandle:"Study",type:"variableSID", args:{val:{val:"[FILELOOPPSID]"}}});
    addCommand("variableANALYSISDEST", "Analysis");


    that.ontoggle = function() {
        if (that.$frame.css("display") != "none") {
            stateManager.saveCurrentState();
            that.visible = false;
        } else
        {
            that.visible = true;
            that.fitIntoVP();
            if (that.grid_visible)
                updateGridjobTable();

        }
    };


    that.onPastToggle = function(res) {
        if (res)
            setTimeout(function() {
                that.thrashLayout();
            }, 0);

    }




    function funref(group, fun, runningJobcnt) {
        return runningJobcnt + "/" + group + "/" + fun;
    }

    // ==================== add a command div

    function addUserCommand(userfun) {
        if (userfun.name.substring(0, 7) == "generic")
            addCommand('generic', userfun.name, userfun);
        else {
            var splitfunref = userfun.name.split("/");
            var group = splitfunref[1];
            var fun = splitfunref[2];
            addCommand(group, fun, userfun);
        }
    }
    that.addUserCommand = addUserCommand;




    var moveup = function(x, y, z) {
        return function() {
            var d = $("div[funref='" + funref(x, y, z) + "']");
            var prev = d.prev();
            if (prev.length > 0)
                if ($(prev[0]).hasClass("KCmdArgListTable")) {
                    d.fadeOut("medium", function() {
                        d.detach();
                        d.insertBefore(prev);
                        d.fadeIn();
                    });
                }
        };
    }

    var movedown = function(x, y, z) {
        return function() {
            var d = $("div[funref='" + funref(x, y, z) + "']");
            var prev = d.next();
            if (prev.length > 0)
                if ($(prev[0]).hasClass("KCmdArgListTable")) {
                    d.fadeOut("medium", function() {
                        d.detach();
                        d.insertAfter(prev);
                        d.fadeIn();
                    });
                }
        };
    }



    function togglejobdiv(x, y, z, e) {
        if (e != undefined && e.ctrlKey)
            return;
        if (x == 'separator' | x == 'loop') {
            var $sep = that.$container.find("div[funref='" + funref(x, y, z) + "']")
            $($sep.find(".KCmdTool")[0]).toggleClass("fa-minus");
            $($sep.find(".KCmdTool")[0]).toggleClass("fa-plus");
            $sep.nextUntil(".KCmdBatchgroup,.KCmdHeadSeparatorStyle").toggle();
        } else {
            var $rows = that.$container.find("div[funref='" + funref(x, y, z) + "']").first().children().first().next();
            var $parent = $rows.parent();
            $($parent.find(".KCmdTool")[0]).toggleClass("fa-plus");
            $($parent.find(".KCmdTool")[0]).toggleClass("fa-minus");
            $parent.find(".tr:not(.KCmdArgListTable_titleRow)").toggle();
        }
        for (var k in that.codeMirrors)
            that.codeMirrors[k].refresh();

    }




    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// ADDING commands 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////


    function addCommandArray(arr) {
        for (var k = 0; k < arr.length; k++) {
            var name = arr[k].name;
            var details = name.split("/");
            addCommand(details[1], details[2], arr[k]);
        }

    }

    function addCommand(group, fun, overload, $wheretoadd) {


        if (fun == "Patient#OLDEST" | fun == "Patient#LATEST" | fun == "Patient#LOOP")
        {
            if (overload.name != undefined)
                return;
        }

        var cnt = 0;

        var $argsDiv;

        function createArgumentNode(thearg, arg, arg_overload, depth, singlvaluesel) {
            var multi = thearg.multi;
            var vals = thearg['default'];
            if (vals == undefined)
                vals = "";
            if (arg_overload) {
                vals = arg_overload.val;
                multi = arg_overload.multi;
            }


            var argnamepref = "";
            for (var k = 0; k < depth.length; k++)
                argnamepref += depth[k] + ".";




            var numargs = (multi != undefined) ? multi : 1;

            if (singlvaluesel != undefined)
                vals = vals[singlvaluesel];

            var $args = [];

            for (var k = 0; k < numargs; k++) {
                var $thisargs = [];
                var val;
                if (multi == undefined)
                    val = vals;
                else if (vals != undefined)
                    val = vals[k];

                if (val == undefined)
                    val = [];

                if (thearg.name == "[]" || thearg.name == "")
                    thearg.name = arg;

                var ref = "(" + thearg.type + ") ";
                if (isReferenceArg(thearg.type)) {
                    if (!Array.isArray(val))
                    {
                        val = val.trim().split(/\ (.+)/)
                        if (val.length == 1)
                            val = ["",val];
                        else
                            val = [val[0],val.splice(1).join(" ")]
                    }
                    if (val.length != 2 && !Array.isArray(val[0]))
                        val = ["", val];
                    if (val.length == 1)
                        val = val[0];
                    ref += createFilerefCombo(val[0], thearg.type, thearg.name,thearg.constraint);
                    val = val[1];
                }



                var props = " argtype='" + thearg.type + "' argname='" + argnamepref + arg + "'  id='KCmd" + arg + runningJobcnt + "_"+ k+ "' value='" + val + "' argnum=" + cnt;
                var $thearg = createArgument(thearg, props, ref, val, depth);
                //   if ($thearg == undefined)
                //   	return;

                $thearg.get(0).ondrop = dropOnArgument(thearg.type);
                if (thearg.type == "FILE")
                    draghint($thearg.get(0),"drop file")
                else
                    $thearg.get(0).ondragover = function(ev) {
                        ev.preventDefault();
                    }

                var $fileref = $thearg.find(".KCmdFileref");
                if (thearg.type == 'ATLAS') {
                    $fileref.click(function($thearg) {
                        return function(e) {
                            var $sel = $thearg.find("select[class!='KCmdFileref']");
                            var $input = $thearg.find("input")
                            if (this.value == "ATLAS") {
                                $sel.show().attr("argname", argnamepref + arg).show();
                                $input.hide().attr("argname", "NONE").hide();
                            } else {
                                $sel.attr("argname", "NONE").hide();
                                $input.attr("argname", argnamepref + arg).show();
                            }

                            if ($fileref.find("option:selected").hasClass('optionerror'))
                                $fileref.addClass("optionerror");
                            else
                                $fileref.removeClass("optionerror");
                        }
                    }($thearg));
                } else {
                    $fileref.click(function($thearg) {
                        return function(e) {
                            if ($fileref.find("option:selected").hasClass('optionerror'))
                                $fileref.addClass("optionerror");
                            else
                                $fileref.removeClass("optionerror");
                        }
                    }($thearg));

                }

                cnt = cnt + 1;

                $thisargs.push($thearg);

                if (thearg.type == 'NODE' && multi != undefined && numargs > 1)
                    $thisargs = $thisargs.concat(iterateOverArgList(thearg, thearg.children, arg_overload, depth.concat([arg]), k));
                else if (thearg.type == 'NODE')
                    $thisargs = $thisargs.concat(iterateOverArgList(thearg, thearg.children, arg_overload, depth.concat([arg])));


                if (thearg.multi != undefined) {
                    var $parent = $($thearg.children()[$thearg.children().length - 1]);
                    var $add = $("<i class='KCmdTool fa fa-plus'></i>");
                    var $lastarg = $thisargs[$thisargs.length - 1];
                    $add.click(function(ta, a, d, $where) {
                        return function() {
                            if (thearg.multi != undefined)
                                thearg.multi = 1;
                            var $addarg = createArgumentNode(thearg, arg, undefined, depth);
                            for (var j = $addarg.length - 1; j >= 0; j--)
                                $addarg[j].insertAfter($where);
                            var $others = $argsDiv.find("[argname='" + arg + "']")
                            $others.parent().find(".fa-trash").removeClass('inactive')

                            that.batchchanged(true)

                        }
                    }(thearg, arg, depth, $lastarg));
                    $parent.append($add);
                    if (1) { // $argsDiv.find("[argname='" + arg + "']").length > 0) {
                        var $minus = $("<i class='KCmdTool fa fa-trash'></i>");
                        if ((arg_overload != undefined & multi == 1) | (arg_overload == undefined & $argsDiv.find("[argname='" + arg + "']").length ==0))
                            $minus.addClass("inactive")
                        $minus.click(function($what,$argsDiv,arg) {
                            return function() {

                                for (var j = 0; j < $what.length; j++)
                                    $what[j].remove();
                                var $others = $argsDiv.find("[argname='" + arg + "']")
                                if ($others.length == 1)
                                    $others.parent().find(".fa-trash").addClass('inactive')
                                that.batchchanged(true)
                                    
                            }
                        }($thisargs,$argsDiv,arg));
                        $parent.append($minus);
                    }
                }


                $args = $args.concat($thisargs);

            }

            return $args;

        }




        //////////////// if command is a saved user command, get this function and overload with saved values
        if (group == "user") {
            userfuns = usercmdlist[fun].def;
            for (var i = 0; i < userfuns.length; i++)
                addUserCommand(userfuns[i]);
            return;
        }

        var jobnumref = runningJobcnt;
        if (group.search("variable") != -1)
            jobnumref = 0;


        var $titlerow = $("<div class='tr' style='font-size:17px;' > </div>");
        $titlerow.attr("draggable", 'true').on("dragover", function(ev) {
            ev.preventDefault();
            return false;
        }).on("dragstart", function(x, y, z) {
            return function(ev) {
                that.dragged = $("div[funref='" + funref(x, y, z) + "']");
                that.dragged.addClass("isDragged");
                ev.originalEvent.dataTransfer.setData("frombatchtool", "yea");

            }
        }(group, fun, jobnumref));
        $titlerow.on("dragend", function(e) {
            that.dragged.removeClass("isDragged");
        });
        $titlerow.on("drop", function(e) {
            if (!isDragFromBatchtool(e.originalEvent))
                return;
            that.dragged.removeClass("isDragged");
            $(this).removeClass("isDraggedOver");

        });

        $titlerow.on("dragenter", function(e) {
            if (!isDragFromBatchtool(e.originalEvent))
                return;
            $(this).addClass("isDraggedOver");
            $(that.dragged).insertBefore($(this).parent());



        });
        $titlerow.on("dragleave", function(e) {
            $(this).removeClass("isDraggedOver");
        });


        var $lefthand = $("<div class='td'>");

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////// VARIABLES

        if (group.search("variable") != -1) {
            var varname = fun;
            var val = "";

            if (overload)
                val = overload.args.val.val;


            $argsDiv = $("div.KCmdArgListTable[funref='" + funref(group, varname, 0) + "']");
            if ($argsDiv.length > 0) {

                var theinput = $argsDiv.find('input[refarg=1]');
                if (theinput.length > 0) {
                    var fref = $argsDiv.find(".KCmdFileref")
                    var cbs = fref.find('option');
                    for (var i = 0; i < cbs.length; i++)
                        $(cbs[i]).removeAttr('selected')
                    fref.find('option[value="' + val[0] + '"]').prop('selected', true)
                    theinput.val(val[1]);
                    //console.log(val[0]);
                } else

                    $($argsDiv.find(".Kinputvar")).attr('value', val);



            } else {
                var placeholder = "";
                var addClass = "";
                if (group == "variablePID") {
                    var pidtype = "(PID)";
                    if (fun == 'Patient') {
                        placeholder = "placeholder='[selection]'";
                        pidtype = "(ITERATOR)";
                    }
                    addClass = " KCmdvariablePID";
                    $lefthand.append($("<div class='flexlr'><div data-toggle='tooltip' title='tooltip'> " + varname + "</div><div>" + pidtype + "</div></div>"));
                    var $content = $("<div class='td' style='text-align:left'><input readonly " + placeholder +
                                  "  type='text' class ='Kinputvar' argtype='variable' argname='varname'  id='KCmd" + varname + 0 + "' value='" + val + "' /></div>");
                    $content.click(function() {
                        $.notify("Select patients/studies to process in the patient table on the left")
                    })

                } else if (group == "variableSID") {
                    var sidtype = "(SID)";
                    if (fun == 'Study') {
                        placeholder = "placeholder='[selection]'";
                        sidtype = "(ITERATOR)";
                    }
                    addClass = " KCmdvariableSID";
                    $lefthand.append($("<div class='flexlr'><div data-toggle='tooltip' title='tooltip'> " + varname + "</div><div>" + sidtype + "</div></div>"));
                    var $content = $("<div class='td' style='text-align:left'><input  " + placeholder + "  type='text' class ='Kinputvar' argtype='variable' argname='varname'  id='KCmd" + varname + 0 + "' value='" + val + "' /></div>");
                    //$content.click(function(){ $.notify("Select patients/studies to process in the patient table")})
                } else if (group == "variableANALYSISDEST") {

                    var $argnode = createArgumentNode({
                        default: "",
                        help: 'some',
                        name: 'Analysisfolder',
                        val: undefined,
                        'type': 'PATHOUT'
                    }, 'ANALYSISDEST', undefined, [], undefined)[0];
                    $lefthand = $argnode.children()[0];
                    $content = $($argnode.children()[1]);
                } else {

                    $lefthand.append($("<span data-toggle='tooltip' title='tooltip'> " + varname + "</span>"));
                    var $content = $("<div class='td' style='text-align:left'>" +
                        "<textarea " + placeholder + " spellcheck='false' class ='Kinputvar' argtype='variable' argname='varname'  id='KCmd" + varname + 0 + "' value='" + val + "' /></textarea></div>");
                    $content.find("textarea").html(val);


                }

                $titlerow.append($lefthand);

                var $contentTools = $("<div class='td KCmdToolBar '></div>");
                if (varname != defaultPSID[0] & varname != defaultPSID[1] & varname != defaultPSID[2]) {
                    var $argdetail = argDetailButton($content.find("textarea"))
                    $argdetail.appendTo($contentTools);


                    $contentTools.append($("<i class='KCmdTool fa fa-trash'></i>").click(function(x, y, z) {
                        return function() {
                            $("div[funref='" + funref(x, y, z) + "']").remove();
                            updateFilerefCombo();
                        };
                    }(group, varname, 0)));

                    
                }

                $titlerow.append($content);
                $titlerow.append($contentTools)



                $argsDiv = $("<div class ='KCmdArgListTable" + addClass + "'  funref='" + funref(group, varname, 0) + "'></div>");
                $argsDiv.append($titlerow);


                $($argsDiv.find("textarea")).each(function(x, y) {
                    y.onkeydown = function(e) {
                        that.batchchanged(true, e)
                    }
                });


                $content.get(0).ondrop = dropOnArgument(group);
                $content.get(0).ondragover = function(ev) {
                    ev.preventDefault();
                }

                if (group == "variablePID" | group == "variableSID") {
                    $argsDiv.insertBefore($("#KCmdHeadSeparator"));
                    if (fun == "Patient" | fun == "Study" | fun == "Patient#OLDEST" | fun == "Patient#LATEST" | fun == "Patient#LOOP")
                        $argsDiv.hide();
                } else if (group == "variableANALYSISDEST")
                    $argsDiv.insertAfter($("#KCmdHeadSeparatorAggregate"));
                else {

                    if ($wheretoadd != undefined)
                        $argsDiv.insertBefore($wheretoadd);
                    else
                        $argsDiv.insertBefore($("#KCmdHeadSeparatorAggregate"));

                    //	$argsDiv.insertAfter($("#KCmdHeadSeparator"));
                    if (!batchexpanded) $argsDiv.fadeOut(500);
                }
            }


            return $argsDiv;
        }



        ////////////////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////// other commands
        
        var tooldesc;
        var visfunname;
        if (group == "generic") {
            tooldesc = "generic function for passing  code";
            visfunname = group + "/" + fun.replace("generic", "");
        } else {
            var tmp = getFun(group, fun);
            if (tmp == undefined) {
                alertify.error("function " + group + "/" + fun + " not defined.")
                return;
            }
            tooldesc = tmp['description'];
            var name = group + "/" + fun;
            if (tmp.menu != undefined)
            {
               if (tmp.menu == "OFF")
                 name = name + "(deprecated)"
               else
                 name = tmp.menu
            }
            if (group == 'separator' || group == "loop")
                name = "";
            if (group == 'usercmdwrap') {
                var s = tmp.funhandle.split(" ")
                var id = s.splice(0, 1)
                name = "user/" + s.join(" ") + " (" + id[0].split("_")[1] + ")";
            }
            if (group == 'wrap')
                name = "Parameter definitions"
            visfunname = name + " <span class='KTag KTagRunning'>1</span>" +
                " <span class='KTag KTagWaiting'>1</span>" + " <span class='KTag KTagError'>1</span>";
        }


        $titlerow.addClass('KCmdArgListTable_titleRow');

        $lefthand.append($("<span data-toggle='tooltip' title='" + tooldesc + "'><i class='KCmdTool fa fa-minus '></i> " + visfunname + "</span>").click(function(x, y, z) {
            return function(e) {
                togglejobdiv(x, y, z,e);
            };
        }(group, fun, runningJobcnt)));

   

        var $righthand = $("<div class='td' style='text-align:right'></div>");
        $titlerow.append($lefthand);
        $titlerow.append($righthand);


        var $customName = $("<span class='KCustomName'>  </span>");
        if (group == 'separator' || group == 'loop')
            $lefthand.append($customName);
        else
            $righthand.append($customName);

        $customName.on("input",function() { that.batchchanged(true)});

        // play single job
        $righthand.append($(" <i class='KCmdTool fa fa-play'  style='float:left;'   ></i>").appendTooltip("run this job")
            .click(function(x, y, z) {
                return function() {
                    submitCommand(funref(x, y, z), defaulttype_submission("sequential"));
                };
            }(group, fun, runningJobcnt))
            .on("contextmenu", submitContextMenu(funref(group, fun, runningJobcnt)))
        );

        // ban single job
        $righthand.append($(" <i class='KCmdTool fa fa-save'  ></i>").appendTooltip("save this job")
            .click(function(x, y, z) {
                return function() {
                    saveUserCommand(funref(x, y, z));
                };
            }(group, fun, runningJobcnt)));
        $righthand.append($(" <i class='KCmdTool fa fa-ban'   ></i>").appendTooltip("disable in batch")
            .click(function(x, y, z) {
                return function() {
                    banCommand(funref(x, y, z));
                };
            }(group, fun, runningJobcnt)));
        $righthand.append($(" <i class='KCmdTool fa fa-copy' style='float:left;'  ></i>").appendTooltip("copy job to clipboard")
            .click(function(x, y, z) {
                return function(e) {
                    copycommand(funref(x, y, z), e);
                };
            }(group, fun, runningJobcnt)));
        
         if (group != "wrap" && group != "separator" && group != "loop" && group != "variable")
         $righthand.append($(" <i class='KCmdTool fa fa-expand' style='float:left;'  ></i>").appendTooltip("expand job")
            .click(function(x, y, z) {
                return function(e) {
                    zoomBatch(funref(x,y,z),$(e.target))
                };
            }(group, fun, runningJobcnt)));


        var $settings = $(" <i class='KCmdTool fa fa-bars KCmdsettings' style='float:left;'  ></i>").appendTooltip("job (cluster) settings")
        var thefun = getFun(group, fun)
        if (fun == "genericSPM" || (thefun != undefined && thefun['path'] != undefined))
            $settings.attr("matlabjob",1)
        $righthand.append($settings
            .click(KContextMenu(function() {
                    var $menu = $("<ul class='menu_context'>")

                    $menu.append($("<hr width='100%'> "));
                    $menu.append($("<span> &nbsp Error handling</span>"));
                    $menu.append($("<hr width='100%'> "));

                    var sel1 = 'check-';
                    var sel2 = '';
                    var sel3 = '';
                    var handling = $settings.attr("error_handling");
                    if (handling == "report_error") {
                        sel1 = '';
                        sel2 = 'check-';
                        sel3 = '';
                    }
                    if (handling == "ignore_error") {
                        sel1 = '';
                        sel3 = 'check-';
                        sel2 = '';
                    }
                    $menu.append($("<li onchoice='error_break'>break on error  <i onchoice='error_break' class='fa fa-" + sel1 + "circle-o'></i> </li>"))
                    $menu.append($("<li onchoice='report_error'>report error and continue  <i onchoice='report_error' class='fa fa-" + sel2 + "circle-o'></i> </li>"))
                    $menu.append($("<li onchoice='ignore_error'>ignore error  <i onchoice='ignore_error' class='fa fa-" + sel3 + "circle-o'></i> </li>"))

                    $menu.append($("<hr width='100%'> "));
                    $menu.append($("<span> &nbsp Success handling</span>"));
                    $menu.append($("<hr width='100%'> "));
                    var sel = '';
                    if ($settings.attr('notify') == 1)
                        sel = 'check-';
                    $menu.append($("<li onchoice='notify'> notify success  <i onchoice='notify' class='fa fa-" + sel + "square-o'></i> </li>"))
                    // add study tag
                    var $studytag = $("<textarea onchoice='preventSelection'  >");
                    $studytag.val($settings.attr("tagstudy"));
                    $studytag.on("input", function() {
                        $settings.attr("tagstudy", $studytag.val())
                        that.batchchanged(true)                        
                    });
                    $menu.append($("<li class='KStudyTagOnSuccess'  onchoice='preventSelection'> add studytag </li>").append($studytag))

                    $menu.append($("<hr width='100%'> "));

                    // grid parameters
                    var $nice = $("<input type=number onchoice='preventSelection'  >");
                    $nice.val($settings.attr("nice"));
                    $nice.on("input", function() {
                        $settings.attr("nice", $nice.val())
                        that.batchchanged(true)
                    });

                    var $gridparams = $("<textarea onchoice='preventSelection'  >");
                    $gridparams.val($settings.attr("gridparams"));
                    $gridparams.on("input", function() {
                        $settings.attr("gridparams", $gridparams.val())
                        that.batchchanged(true)
                    });
                    // matlab parameters
                    var $matlabparams = $("<textarea onchoice='preventSelection'  >");
                    $matlabparams.val($settings.attr("matlabparams"));
                    $matlabparams.on("input", function() {
                        $settings.attr("matlabparams", $matlabparams.val())
                        that.batchchanged(true)
                    });

                    var $uniqueID = $("<textarea onchoice='preventSelection'  >");
                    $uniqueID.val($settings.attr("uniqueID"));
                    $uniqueID.on("input", function() {
                        $settings.attr("uniqueID", $uniqueID.val())
                        that.batchchanged(true)
                    });

                    
                    $menu.append($("<li class='niceinput'  onchoice='preventSelection'> nice value </li>").append($nice).appendTooltip("set here your nice value (slurm)"))
                    $menu.append($("<li class='KStudyTagOnSuccess'  onchoice='preventSelection'> grid param. </li>").appendTooltip("parameters/resources of job (for slurm e.g. --nodelist god --cpus-per-task 666)").append($gridparams))
                    if ($settings.attr("matlabjob"))
                        $menu.append($("<li class='KStudyTagOnSuccess'  onchoice='preventSelection'> matlab param. </li>")
                        .appendTooltip("Matlab code which is executed before function is called. Use leading %ver2012b to choose matlab version. "+
                        "Use %octave for using octave. "+
                        "Or use e.g. #opt _JAVA_OPTIONS=-Xmx2048m to set env. variables." ).append($matlabparams))
                    $menu.append($("<li class='KStudyTagOnSuccess'  onchoice='preventSelection'> UID </li>").append($uniqueID))

                    var sel = '';
                    if ($settings.attr('preserve_logs') == 1)
                        sel = 'check-';
                    $menu.append($("<li onchoice='preserve_logs'> preserve logs  <i onchoice='preserve_logs' class='fa fa-" + sel + "square-o'></i> </li>"))

                    return $menu;
                },
                function(str, ev) {
                    if (str != undefined) {
                        if (str == "error_break" || str == "report_error" || str == "ignore_error")
                            $settings.attr('error_handling', str)
                        if (str == "notify") {
                            if ($settings.attr('notify') == undefined | $settings.attr('notify') == 0)
                                $settings.attr('notify', 1);
                            else if ($settings.attr('notify') == 1)
                                $settings.attr('notify', 0);
                        }
                        if (str == "preserve_logs") {
                            if ($settings.attr('preserve_logs') == undefined | $settings.attr('preserve_logs') == 0)
                                $settings.attr('preserve_logs', 1);
                            else if ($settings.attr('preserve_logs') == 1)
                                $settings.attr('preserve_logs', 0);
                        }
                        that.batchchanged(true)                        

                    }
                }, undefined, true)));



        $righthand.append($(" <i class='KCmdTool fa' style='float:left;'  >validate</i>").appendTooltip("validate input on selected items")
            .click(function(x, y, z) {
                return function(e) {
                    validate(funref(x, y, z), e);
                };
            }(group, fun, runningJobcnt)));


        $righthand.append($("<span  class='KCmdvalidate KCmdvalidate_top'> </span>"));

        // remove job from batch
        $righthand.append(
            $("<i class='KCmdTool fa fa-trash'></i>").appendTooltip("remove job from batch").click(function(x, y, z) {
                return function() {
                    $("div[funref='" + funref(x, y, z) + "']").remove();
                    that.batchchanged(true);
                };
            }(group, fun, runningJobcnt)));


        $argsDiv = $("<div class ='KCmdArgListTable'  funref='" + funref(group, fun, runningJobcnt) + "'></div>");

        if (group == "separator" | group == "loop") {
            $argsDiv.addClass("KCmdBatchgroup");
            if (group == "loop")
                $argsDiv.addClass("KCmdLoopgroup");
            $settings.hide();
            $righthand.find('.fa-ban').hide()

        }
        if (group == "wrap") {
            $settings.hide();
            $righthand.find('.fa').hide()
            $righthand.find('.fa-trash').show()

        }
        if (group == 'wrap')
            $argsDiv.addClass("KCmdwrap");

        $argsDiv.append($titlerow);


        $lefthand.click(function($x) { return function(e)
        {
            if (e.ctrlKey)
            {
                e.stopPropagation();
                e.preventDefault();
                $x.toggleClass("KCmdmarked");

                if (that.$container.find(".KCmdArgListTable.KCmdmarked").length > 0)
                    $bigplaybutton.addClass("KCmdmarkedPlay");
                else
                    $bigplaybutton.removeClass("KCmdmarkedPlay");

                return ;    
            }
            
        }}($argsDiv))


        KSetContentEditable($customName, function() {}, "");
        if (overload && overload.customName)
            $customName.text(overload.customName)
        else if (group == "separator") {
            $customName.text("batch group");
        } else if (group == "loop") {
            $customName.text("LOOP " + fun);
        } else if (group == "wrap")
            $customName.text("");


        // create argument list
        if (group !== "generic") {
            var args = getFun(group, fun)['args'];



            function iterateOverArgList(argstruct, argnames, argstruct_overload, depth, singlvaluesel) {
                var $theargs = [];
                for (var k = 0; k < argnames.length; k++) {
                    if (argstruct_overload != undefined)
                    {
                        if (argstruct.multi != undefined && argstruct_overload.multi == undefined)
                            $theargs = $theargs.concat(createArgumentNode(argstruct[argnames[k]], argnames[k], 
                                    {multi:1,val:[argstruct_overload.val]}, depth, singlvaluesel));
                        else
                            $theargs = $theargs.concat(createArgumentNode(argstruct[argnames[k]], argnames[k], argstruct_overload[argnames[k]], depth, singlvaluesel));
                    }
                    else
                        $theargs = $theargs.concat(createArgumentNode(argstruct[argnames[k]], argnames[k], undefined, depth, singlvaluesel));
                }
                return $theargs;
            }

            var ovlargs = undefined;
            if (overload != undefined)
                ovlargs = overload.args;

            var argkeys = Object.keys(args);
            if (argkeys.length>0 && args[argkeys[0]].idx != undefined)
                argkeys = argkeys.sort((x,y) => args[x].idx-args[y].idx);

            var $theargs = iterateOverArgList(args, argkeys, ovlargs, []);

            for (var k = 0; k < $theargs.length; k++)
                $argsDiv.append($theargs[k]);


            if (group.substring(0, 9) == "aggregate") {
                $argsDiv.insertBefore($("#KCmdHeadFinalSpacer"));
                if (!aggrexpanded) {
                    $argsDiv.hide();
                    toggleAggregateGroup();
                }

            } else if (group == "wrap")
                $argsDiv.insertBefore($("#KCmdHeadSeparator"));
            else {
                if ($wheretoadd != undefined)
                    $argsDiv.insertBefore($wheretoadd);
                else
                    $argsDiv.insertBefore($("#KCmdHeadSeparatorAggregate"));
                if (!batchexpanded) {
                    $argsDiv.hide();
                    toggleBatchGroup();
                }

            }

        } else if (fun.substring(0, 7) == 'generic') {
            var name = "untitled";
            var env = "";
            if (static_info.defaultenvs)
            {
                var defenv = []
                if (fun.substring(7) == 'PYTHON')
                    defenv = static_info.defaultenvs.python

                if (defenv.length == 1)
                    env = defenv[0]

            }
            if (overload) {
                if (overload.args.name)
                    name = overload.args.name.val;
                if (overload.args.environment)
                    env = overload.args.environment.val;
            }

            var $thearg = $("<div class='tr KChildRow0 hidden'><div class='td'> Name </div><div class='td'><input type='text' argtype='NAME' argname='name'" +
                "id='KCmdname" + runningJobcnt + "' value='" + name + "' argnum=0 /></div></div> ").hide();
            $thearg.get(0).ondrop = dropOnArgument("PSID");
            $thearg.get(0).ondragover = function(ev) {
                ev.preventDefault();
            }
            $($thearg.find("input")).each(function(x, y) {
                y.onkeydown = function(e) {
                    that.batchchanged(true, e)
                }
            });
            $argsDiv.append($thearg);


            var ontextchange = function(x, y, z, manual) {
                if (!manual)
                    that.batchchanged(true);
                var $argsDiv = $("div.KCmdArgListTable[funref='" + funref(y, z, x) + "']");

                var codemirror = that.codeMirrors["KCmdString" + x];
                var cmd = codemirror.getValue();


                var argid = "KCmdFSL_" + x;
                var argnames = new Object();
                var argcnt = 0;
                // look for parameters to be added to the div list
                while (true) {
                    var argname;
                    var argname_vis;

                    var argnotion = 0;

                    var match = false;
                    while (true) {
                        var regex = /[~$][mfosnlp]\d/;
                        if ((result = regex.exec(cmd))) {
                            argnotion = "dollar"
                            argname = cmd.substring(result.index + 1, result.index + 3);
                            argname_vis = argname
                            argnames[argname] = 1;
                            cmd = cmd.slice(0, result.index) + cmd.slice(result.index + 3);
                            match = true;
                            break;
                        }

                        var regex = /\w+ = ['`"]<UNDEFINED>['`"]/;
                        var regex = /(\w+)\s*=\s*{*['`"]<UNDEFINED>['`"]}*/;
                        if ((result = regex.exec(cmd))) {
                            argnotion = "spm"
                            argname = result.toString();
                            argname = argname.substring(0, argname.length - 16);
                            argname = result[1];
                            argname_vis = argname;
                            argname = argname + '_' + argcnt;
                            argnames[argname] = 1;
                            cmd = cmd.slice(0, result.index) + cmd.slice(result.index + result[0].length);
                            match = true;
                            break;
                        }

                        break;
                    }

                    if (!match)
                        break;

                        

                    if ($("[cid='" + argid + "'][argname='" + argname + "']").length == 0) // not yet in divlist
                    {
                        var val = "";
                        var issel = new Object();
                        var frefval = defaultPSID[0];
                        // we should take the current selection mode as default!
                        var frefval = state.viewer.selectionMode[1] == "p" ? defaultPSID[0] : defaultPSID[1];

                        if (overload) {
                            if (overload.args[argname]) {
                                if (isReferenceArg(overload.args[argname].type)) {
                                    frefval = overload.args[argname].val[0]
                                    val = overload.args[argname].val[1];
                                } else {
                                    val = overload.args[argname].val;
                                }
                                issel[overload.args[argname].type[0].toLowerCase()] = "selected";
                            }
                        } else if (codemirror.deletedArgs != undefined && codemirror.deletedArgs[argname] != undefined) {
                            val = codemirror.deletedArgs[argname];
                        }
                        //else
                        {
                            // shortcuts are for the $ notation values only
                            //if (argname[0] == 'f' || argname[0] == 'o' || argname[0] == 'p'  || argname[0] == 's' || argname[0] == 'n' || argname[0] == 'l')
                            if (argnotion == 'dollar') {
                                if (argname[0] == 'f' || argname[0] == 'o' || argname[0] == 'p' || argname[0] == 's' || argname[0] == 'n' || argname[0] == 'l' || argname[0] == 'm')
                                    issel[argname[0]] = "selected";
                            } else if (argnotion == 'spm') {
                                if (argname.search('source') > -1 || argname.search('ref') > -1 || argname.search('other') > -1)
                                    issel["f"] = "selected";
                            }
                        }

                        if (Object.keys(issel).length == 0)
                            issel["f"] = "selected";

                        var argtype = "";
                        if (issel["f"]) argtype = 'FILE';
                        if (issel["o"]) argtype = 'OUT';
                        if (issel["p"]) argtype = 'PATHOUT';
                        if (issel["s"]) argtype = 'STRING';

                        var $thearg = $("<div class='tr KChildRow0' argname='" + argname + "'  cid='" + argid + "'  ></div>");
                        var $lhs = $(" <div class='td'>" + argname_vis + "" +
                            "              <select class='KArgTypeSelector' id='type" + argid + "' argname='" + argname + "'>" +
                            "<option value='FILE' " + issel["f"] + ">FILE</option>" +
                            "<option value='OUT' " + issel["o"] + ">OUT</option>" +
                            "<option value='PATHOUT' " + issel["p"] + ">PATHOUT</option>" +
                            "<option value='STRING' " + issel["s"] + ">STRING</option>" +
                            "<option value='NUMERIC' " + issel["n"] + ">NUMERIC</option>" +
                            "<option value='LOGICAL' " + issel["l"] + ">LOGICAL</option>" + " </select> </div>").appendTo($thearg)
                        var $rhs = $("<div class='td'>  <input type='text' argtype='"+argtype+"'  argname='" + argname + "'  cid='" + argid + "' value='" + val + "' argnum='' /><span  class='KCmdvalidate'> </span> </div>  </div> ").appendTo($thearg);

                        var $rhs_input = $rhs.find("input")
                        $rhs_input.on("input",function() {that.batchchanged(true) });

                        if (issel["f"])
                         {
                                var $argdetail = argDetailButton($rhs_input);
                                $argdetail.appendTo($rhs);
                         }
                        if (issel["o"])
                         {
                                var $argdetail = outDrag($rhs_input.parent().parent());
                                $argdetail.appendTo($rhs);
                         }

                         if (!manual)
                            that.batchchanged(true)



                        var $argtypeselector = $thearg.find(".KArgTypeSelector");
                        $argtypeselector.click(function(e,manual) {
                            var type = $(e.currentTarget).find('option:selected').val();
                            $(e.target).parent().find(".KCmdFilerefSpan").remove();
                            if (!manual)
                                that.batchchanged(true)

                            if (isReferenceArg(type)) {
                                var frcombo = "<span class='KCmdFilerefSpan'>(" + type + ") " + createFilerefCombo(frefval, type) + "</span>";
                                $(e.target).parent().append(frcombo);
                            }

                        });
                        $argtypeselector.trigger("click",[1]);


                        $thearg.get(0).ondrop = dropOnArgument("");
                        $thearg.get(0).ondragover = function(ev) {
                            ev.preventDefault();
                        }
                        $($thearg.find("input")).each(function(x, y) {
                            y.input = function(e) {
                                that.batchchanged(true, e)
                            }
                        });
                        $argsDiv.append($thearg);
                    }
                    argcnt = argcnt + 1;
                }
                // delete parameters from the div list which are not present in the cmdstring
                var presentargs = $("[cid='" + argid + "']");
                for (var i = 0; i < presentargs.length; i++) {
                    if (argnames[presentargs[i].getAttribute("argname")] == null) {
                        if (codemirror.deletedArgs == undefined)
                            codemirror.deletedArgs = {}
                        var val_ = $(presentargs[i]).find("input").val();
                        if (val_ != undefined)
                            codemirror.deletedArgs[presentargs[i].getAttribute("argname")] = val_;
                        presentargs[i].remove();
                    }
                }

                var presentargsrows = $(".tr[cid='" + argid + "']");
                var result =presentargsrows.sort(function (a, b) {
                      var contentA =$(a).attr("argname")
                      var contentB =$(b).attr("argname")
                      return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
                   });
                $argsDiv.append(result);


            }

            var $thefundiv = $("<div class='tr'><div class='fullspan'> <textarea spellcheck='false' rows='2' cols='50'" +
                " argtype='FSLCMD' id='KCmdString" + runningJobcnt + "'></textarea></div></div> ").bind('keyup',
                function(x, y, z) {
                    return function() {
                        ontextchange(x, y, z);
                    };
                }(runningJobcnt, group, fun));

            var mode = 'shell';
            if (fun == 'genericSPM')
                mode = 'octave';


            var $textarea = $thefundiv.find("textarea");
            var editor = CodeMirror.fromTextArea($textarea.get(0), {
                lineNumbers: true,
                lineWrapping: true,
                mode: mode,
                matchBrackets: true,
                extraKeys: {
                    Tab: betterTab
                },
                height: "auto",
            });

            var CodeMirrorDiv = $thefundiv.find(".CodeMirror");
            addCustomResizer(CodeMirrorDiv, {
                x: false
            });
            appendFoldbutton(CodeMirrorDiv,editor)

            CodeMirrorDiv.on('paste', function(x, y, z) {
                return function(e) {
                    e.stopPropagation()
                    ontextchange(x, y, z);
                };
            }(runningJobcnt, group, fun));

            that.codeMirrors["KCmdString" + runningJobcnt] = editor
            if (overload) {
                var str = overload.args.cmdstring.val.replace(/\\\\/g, "\\")
                str = str.replace(/\\t/g, "\t")
                editor.setValue(str);
                editor.clearHistory();
            } else {
                if (fun == "genericBASH") {
                    editor.setValue("# a simple bash call \necho $f1\necho $o1");
                }

                if (fun == "genericPYTHON") {
                    editor.setValue("# a simple python call \nprint($f1)\nprint($o1)");
                }
                if (fun == "genericSPM") {
                    editor.setValue("% paste here spm batch structure");
                }

            }
            setTimeout(function() {
                editor.refresh();
            }, 1);


            $argsDiv.append($thefundiv);

            if (fun == "genericPYTHON" | fun == "genericSPM") {
                var optstr;
                if (fun == "genericPYTHON")
                    optstr = "Precall shell command"
                if (fun == "genericSPM")
                    optstr = "MATLAB option"
                var $thearg = $("<div class='tr KChildRow0'><div class='td'>  " + optstr + "</div><div class='td'><input type='text' argtype='ENVIRONMENT' argname='environment'" +
                    "id='KCmdenv" + runningJobcnt + "' value='" + env + "' argnum=0 /></div></div> ");
                $thearg.get(0).ondragover = function(ev) {
                    ev.preventDefault();
                }
                $($thearg.find("input")).each(function(x, y) {
                    y.onkeydown = function(e) {
                        that.batchchanged(true, e)
                    }
                });

                $argsDiv.append($thearg);
            }



            var ovloutfod;
            if (overload && overload.args)
                ovloutfod = overload.args['OUTPUTFOLDER'];
            var outfold = createArgumentNode({
                default: "",
                help: 'After finishing the job this folder is browsed for new files.',
                name: 'Outputfolder',
                val: undefined,
                'type': 'PATHOUT'
            }, 'OUTPUTFOLDER', ovloutfod, [], undefined)[0]
            outfold.attr('argname', 'OUTPUTFOLDER')
            $argsDiv.append(outfold);

            $argsDiv.insertBefore($("#KCmdHeadSeparatorAggregate"));

            ontextchange(runningJobcnt, group, fun, true);

        }

        var settings = $argsDiv.find('.KCmdsettings');
       
        settings.attr('uniqueID', Math.random().toString(36).substring(2, 15))

        if (overload) {
            if (settings.length > 0) {
                if (overload.send_notification == true)
                    settings.attr('notify', overload.send_notification);
                if (overload.preserve_logs == true)
                    settings.attr('preserve_logs', overload.preserve_logs);
                if (overload.error_handling)
                    settings.attr('error_handling', overload.error_handling);
                if (overload.tag_study)
                    settings.attr('tagstudy', overload.tag_study);
                if (overload.nice)
                    settings.attr('nice', overload.nice);
                if (overload.grid_params)
                    settings.attr('gridparams', overload.grid_params);
                if (overload.matlab_params)
                    settings.attr('matlabparams', overload.matlab_params);
                if (overload.uniqueID)
                    settings.attr('uniqueID', overload.uniqueID);
            }



            if (overload.banned == true) {
                var banbutton = $argsDiv.find('.fa-ban');
                $argsDiv.addClass("banned");
                $(banbutton).css('color', 'red');
                $(banbutton).attr('banned', true);
            }
            if (overload.folded) {
                if (group != "separator" && group != "loop")
                    togglejobdiv(group, fun, runningJobcnt);
                else
                    setTimeout(function(x, y, z) {
                        return function() {
                            togglejobdiv(x, y, z);
                        }
                    }(group, fun, runningJobcnt), 0);
            }

        }
        overload = undefined; // important, otherwise ontextchange callback still refers to the overload

        runningJobcnt += 1;

        updateFilerefCombo($argsDiv);


        if ($wheretoadd != undefined) {
            $argsDiv.addClass("KCmd_successfully_created");
            setTimeout(function() {
                $argsDiv.removeClass("KCmd_successfully_created");
            }, 300);
        }

        return $argsDiv;

    }




    function createArgument(argument, props, ref, val, depth) {

        var $thearg = $("<div style='width=150px' class='tr'>");

        if (argument.type == 'NODE') {
            ref = "";
            $thearg.addClass("KNodeRow");
        } else {
            $thearg.addClass("KChildRow" + depth.length);
        }


        var spacer = "";
        for (var k = 0; k < depth.length; k++)
            spacer += ""; // <i class='fa fa-arrow-right'> </i> ";

        var help = argument.help || "";


        var $lhs = $("<div class='td ' data-toggle='tooltip' title='" + help.replace(/<br>/g, "&#10") + "'><div class= 'flexlr'><div class='Kargtitle'>" + argument.name + "</div><div class=Kargtype>" + ref + "</div> </div></div>").appendTo($thearg);
        var refsel = $lhs.find(".Kargtype")
        refsel[0].oninput = function() { that.batchchanged(true) }

        var $rhs = $("<div class='td'></div>").appendTo($thearg);


        if (argument.type == 'FORM') {
            var forms = KViewer.formManager.forms;
            var optlist = "";
            for (var i = 0; i < forms.length; i++) {
                var selected = "";
                if (i == val)
                    selected = "selected";
                optlist += "<option value='" + forms[i].name + "' " + selected + ">" + forms[i].name + "</option>";
            }

            function getColsFromForm(form, $target) {
                var i = KViewer.formManager.getIndexFromName($target.val());
                var content = KForm.getFormContent(forms[i]);
                var fields = $(Object.keys(content)).not(["KForm_name"]);
                $target.parent().parent().next().
                find("[argname='cols']").val(fields.toArray().toString());
            }

            var $sel = $("  <select " + props + "> " + optlist + " </select>").appendTo($rhs)
                .click(function(e) {
                    getColsFromForm(forms[i], $(e.currentTarget));
                });



        } else if (argument.type == 'ATLAS') {
            if (static_info.atlas != undefined) {
                var atlas = static_info.atlas.available.slice(0);
                var optlist = "";
                for (var i = 0; i < atlas.length; i++) {
                    var selected = "";
                    if ("BUILTIN_" + atlas[i].ID == val)
                        selected = "selected";
                    optlist += "<option value='BUILTIN_" + atlas[i].ID + "' " + selected + ">" + atlas[i].SubFolder + "/" + atlas[i].Filename + "</option>";
                }
            }
            var $sel = $("  <select " + props + "> " + optlist + " </select>").appendTo($rhs);
            var $file = $("<input  type='text' " + props + "/>").appendTo($rhs);

            if (ref.search("value='ATLAS' selected") != -1)
                $file.attr("argname", "NONE").hide();
            else
                $sel.attr("argname", "NONE").hide();

        } else if (argument.type == 'OPTION') {
            var choices = argument.choices.split(",")
            for (var i = 0; i < choices.length; i++) {
                var selected = "";
                if (choices[i] == val)
                    selected = "selected";
                optlist += "<option value='" + choices[i] + "' " + selected + ">" + choices[i] + "</option>";
            }
            var $sel = $("  <select " + props + "> " + optlist + " </select>").appendTo($rhs);
            $sel.on("change", function() {
                that.batchchanged(true);
            });
        } else if (argument.type == 'NUMERIC')
            $("<input type='number' " + props + "/>").appendTo($rhs);
        else if (argument.type == 'LOGICAL') {
            var optlist;
            if (val == 1)
                optlist = "<option value=1 selected>true</option><option value=0 >false</option>"
            else
                optlist = "<option value=1>true</option><option value=0 selected >false</option>"
            var $sel = $("  <select " + props + "> " + optlist + " </select>").appendTo($rhs);
            $sel.on("change", function() {
                that.batchchanged(true);
            });
        } else if (argument.type == 'STRING') {
            var $textarea = $("<textarea spellcheck='false' style='width:95%' " + props + "></textarea>")
            if (argument.mode != "" && argument.mode != undefined)
                $textarea.appendTo($lhs)
            else
                $textarea.appendTo($rhs)
            if (argument.mode != undefined) {
                $lhs.removeClass('td').addClass('fullspan')
                var editor = CodeMirror.fromTextArea($textarea.get(0), {
                    lineNumbers: true,
                    mode: argument.mode,
                    matchBrackets: true,
                    lineWrapping: true,
                    extraKeys: {
                        Tab: betterTab
                    },
                    indentUnit: 4,
                });
                if (val.length > 0)
                    editor.setValue(val.replace(/\\\\/g, "\\"));
                editor.clearHistory();

                var CodeMirrorDiv = $lhs.find(".CodeMirror");
                addCustomResizer(CodeMirrorDiv, {
                    x: false
                });
                appendFoldbutton(CodeMirrorDiv,editor)

                editor.on('keyup', function() {
                    that.batchchanged(true);
                })
                that.codeMirrors[$textarea.attr("id")] = editor
                setTimeout(function() {
                    editor.refresh();
                }, 1);


            } else {
                if (Array.isArray(val))
                    $textarea.html(val[0]);
                else
                    $textarea.html(val);

                $textarea.on('input', function() {
                    that.batchchanged(true);
                })
            }
        } else if (argument.type == 'NODE') {
            $("<span " + props + "/></span>").appendTo($rhs);
        } else {
            var $in
            if (isReferenceArg(argument.type)) {
                $in = $("<input refarg=1 type='text' " + props + "/>").appendTo($rhs);
                if (argument.type == 'FILE')
                {
                    $("<span class='KCmdvalidate'></span>").appendTo($rhs);
                    var $argdetail = argDetailButton($in)
                    $argdetail.appendTo($rhs);
                }
                if (argument.type == 'OUT')
                {
                    $("<span class='KCmdvalidate'></span>").appendTo($rhs);
                    var $argdetail = outDrag($thearg)
                    $argdetail.appendTo($rhs);
                }
            } else
                $in = $("<input  type='text' " + props + "/>").appendTo($rhs);
        }

        $($thearg.find("input")).each(function(x, y) {
            y.oninput = function(e) {
                that.batchchanged(true, e)
            }
        });

        return $thearg;
    }




    function getFun(group, funname) {
        if (group == "separator") {
            return {
                description: "sep",
                args: []
            };
        }
        if (group == "wrap") {
            return {
                description: "input/output wrap",
                args: {
                    description: {
                        name: "Description",
                        type: "STRING"
                    },
                    parameters: {
                        type: "NODE",
                        name: "Parameters",
                        multi: 1,
                        children: ['thename', 'thedefault', 'thetype'],
                        thename: {
                            name: "Name",
                            type: "STRING"
                        },
                        thedefault: {
                            name: "Default",
                            type: "STRING"
                        },
                        thetype: {
                            name: "Type",
                            type: "OPTION",
                            choices: 'FILE,OUT,PATHOUT,STRING,NUMERIC,LOGICAL'
                        }

                    }
                }
            }
        }
        if (group == "usercmdwrap") {
            return createUserCmd(funname)
        }


        if (group == "aggregate" && funname == "jupyter")
         return {
                "funhandle": "aggregate_python",
                "description": "starts a jupyter with all selected data file information",
                "args": {
                    "inputs": {
                        "name": "Input data",
                        "type": "FILE",
                        "help": "Choose here your input data.",
                        "val": [],
                        "multi": 1,
                        "default": []
                    },
                    "notebook": {
                        "name": "Notebook",
                        "type": "OUT",
                        "help": "The name of the notebook",
                        "val": [],
                        "constraint": "analysis",
                        "default": []
                    },
                    "language": {
                        "name": "Language",
                        "type": "OPTION",
                        "help": "which language the kernel should run with",
                        "choices": "python,matlab",
                        "val": "python" 
                    },

 

                    "environment": {
                        "name": "environment",
                        "type": "ENVIRONMENT",
                        "help": "",
                        "val": [],
                        "default": "source <(echo $(/software/defaultenv))"
                    }
                },
                "run": "jupyter",
                "menu": "generic.jupyter",
                "path": "aggregate.jupyter",
                "group": "aggregate",
                "name": "jupyter"
            }



        if (group == "aggregate" && funname == "genericPYTHONfix")
         return {
                "funhandle": "aggregate_python",
                "description": "starts python with all selected data file information",
                "args": {
                    "inputs": {
                        "name": "Input data",
                        "type": "FILE",
                        "help": "Choose here your input data.",
                        "val": [],
                        "multi": 1,
                        "default": []
                    },
                    "outputs": {
                        "name": "Output data",
                        "type": "OUT",
                        "help": "Choose here your output data.",
                        "val": [],
                        "multi": 1,
                        "constraint": "analysis",
                        "default": []
                    },
                    "cmdstring": {
                        "name": "Expression",
                        "type": "STRING",
                        "help": "The name of the notebook",
                        "val": [],
                        "mode": "octave",
                        "default": "# the variables provided by NORA:\n# dpxconf - the nora config information # print(json.dumps(dpxconf,indent=4))\n# inputs - the input files # print(json.dumps(inputs,indent=4))\n# outputs - all outputs info. # print(json.dumps(outputs,indent=4))\n# subjects - subject information\n# project - the nora project\n\n# write here your custom python code\n"
                    },
                    "environment": {
                        "name": "environment",
                        "type": "ENVIRONMENT",
                        "help": "",
                        "val": [],
                        "default": "source <(echo $(/software/defaultenv))"
                    }
                },
                "run": "#source",
                "menu": "generic.python",
                "path": "aggregate.python",
                "group": "aggregate",
                "name": "python"
            }



        if (group == "loop") {
            if (funname == 'files')
                return {
                    description: "file loop",
                    args: {
                        'iteratorname': {
                            type: "STRING",
                            name: "Iterator name",
                            default: "FILEITERATOR1",
                            help: 'use the iterator name as a variable, Refer by square brackets \nlike [FILEITERATOR1]'
                        },
                        'range': {
                            type: "FILE",
                            name: "Files",
                            help: "use an ordinary file selector to select multiple files"
                        }
                    }
                };
            if (funname == 'string')
                return {
                    description: "string loop",
                    args: {
                        'iteratorname': {
                            type: "STRING",
                            name: "Iterator name",
                            default: "STRINGITERATOR1",
                            help: 'use the iterator name as a variable, Refer by square brackets \nlike [FILEITERATOR1]'
                        },
                        'range': {
                            type: "STRING",
                            name: "Range",
                            help: 'use a comma or a space spearated list \n' +
                                "e.g. A,B,C or A B C \n Specify a range of numbers by colon notation \n" +
                                "e.g. 1:10 or 0:0.2:1"
                        }
                    }
                };
        } else {
            var subs = group.split(".");
            var fun = cmdInfo[subs[0]];
            for (var k = 1; k < subs.length; k++)
                fun = fun[subs[k]];
            if (fun != undefined)
                return $.extend(true,{},fun[funname]);
        }

    }

    function createUserCmd(cmdid) {
        var cmd;
        for (var j in usercmdlist)
            if (usercmdlist[j].id == cmdid)
                cmd = usercmdlist[j]
        if (cmd == undefined)
            return
        for (var k = 0; k < cmd.def.length; k++) {
            if (cmd.def[k].type == "wrap") {
                var description = cmd.def[k].args.description
                var parameters = cmd.def[k].args.parameters
                var args = {}
                for (var j = 0; j < parameters.multi; j++) {
                    var name = parameters.thename.val[j]
                    var type = parameters.thetype.val[j]
                    var def = parameters.thedefault.val[j]
                    args[name] = {
                        name: name,
                        type: type,
                        default: def
                    }
                }
                return {
                    funhandle: "usercmd_" + cmd.id + " " + cmd.name,
                    description: description,
                    args: args
                };


            }
        }

    }


    function createFilerefCombo(frefval, target, name,constraint) {

        var option = "";
        if (name == 'Analysisfolder' | constraint == "analysis")
            option = 'onlyAnalysis=1';
        var fileref = "<select class=KCmdFileref type=" + target + " " + option + ">";
        var psidargs = $("#KCmdHeadSeparator").prevAll(".KCmdArgListTable");
        var selfound = false;


        var choices = [];
        var inactive = [];
        for (var k = psidargs.length - 1; k >= 0; k--) {
            choices.push($(psidargs[k]).attr("funref").split("/")[2])
            inactive.push($(psidargs[k]).hasClass('inactive'))

        }
        if (target == 'ATLAS')
            choices.push("ATLAS");

        var afolders = getCurrentAnalysisFolders();

        for (var k = 0; k < afolders.length; k++) {
            choices.push("ANALYSIS" + afolders[k].substring(0));
        }


        for (var k = 0; k < choices.length; k++) {
            var fref = choices[k];
            var isselected = "";
            if (frefval == fref | (k <= 1 & frefval == "" & !inactive[k])) {
                isselected = "selected";
                selfound = true;
            }
            if (inactive[k])
                fileref += "<option class='optionerror' value='" + fref + "' " + isselected + ">" + fref + "</option>";
            else
                fileref += "<option value='" + fref + "' " + isselected + ">" + fref + "</option>";
        }


        fileref += "</select>";
        return fileref;
    }

    that.zoomBatch = zoomBatch
    function zoomBatch(funref,zoombut)
    {
            if (funref == undefined)
            {
                var $placeholder = $(".Kzoomplaceholder")
                if ($placeholder.length == 0)
                    return "notzoomed";
                var funref = $placeholder[0].id.substr(11);
                var $div = $("div[funref='" + funref + "']");
                var zoombut = $div.find(".fa-compress")
                
            }
            else
            {
                var $placeholder = $("div[id='placeholder"+funref+"']")    
            }

            
            if ($placeholder.length == 0)
            {          

                var $div = $("div[funref='" + funref + "']");
                if ($div.find(".KCmdArgListTable_titleRow").find(".fa-plus")[0] != undefined)
                {
                    var s = funref.split("/")
                    togglejobdiv(s[1], s[2], s[0]);
                    zoomBatch.last_was_hidden = true
                }             
                else
                   zoomBatch.last_was_hidden = undefined;
                zoombut.removeClass("fa-expand").addClass("fa-compress")        
                var $absdiv = $("<div class='Kzoomedbatch'> </div>").appendTo($(document.body))
                $div.find(".fa-trash").hide()
                var $placeholder = $("<div class='Kzoomplaceholder' id=placeholder"+funref+"> </div>").insertBefore($div)
                $div.detach();
                $absdiv.append($div)

                var $but =  $div.find(".textarea_foldbutton")
                if (!$but.hasClass("open"))
                    $div.find(".textarea_foldbutton").trigger("click");
                var $trg = $but.parent()
                $trg.height($(document.body).height()*0.8);

            }
            else
            {


                zoombut.addClass("fa-expand").removeClass("fa-compress")
                var $div = $("div[funref='" + funref + "']");
                var $absdiv = $(".Kzoomedbatch");
                $div.insertBefore($placeholder)
                $div.find(".fa-trash").show()                
                $placeholder.remove();   
                $absdiv.remove();    
                var $but =  $div.find(".textarea_foldbutton")                                        
                if ($but.hasClass("open"))
                    $div.find(".textarea_foldbutton").trigger("click");
                 
                if (zoomBatch.last_was_hidden)
                {
                    var s = funref.split("/")
                    togglejobdiv(s[1], s[2], s[0]);
                }
                zoomBatch.last_was_hidden = undefined;
            }
    }

    that.updateFilerefCombo = updateFilerefCombo

    function updateFilerefCombo(scope) {
        var choices = [];
        var inactive = [];
        var psidargs = $("#KCmdHeadSeparator").prevAll(".KCmdArgListTable");
        for (var k = psidargs.length - 1; k >= 0; k--) {
            choices.push($(psidargs[k]).attr("funref").split("/")[2]);
            inactive.push($(psidargs[k]).hasClass('inactive'));
        }


        var afolders = getCurrentAnalysisFolders()
        for (var k = 0; k < afolders.length; k++) {
            choices.push("ANALYSIS" + afolders[k].substring(0));
            inactive.push("ana")
        }


        var fileref;
        if (scope == undefined)
            fileref = $(".KCmdFileref");
        else
            fileref = scope.find(".KCmdFileref");


        for (var j = 0; j < fileref.length; j++) {
            var selectedfref = $(fileref[j]).find('option:selected').val();
            $(fileref[j].children).remove();
            $(fileref[j]).removeClass("optionerror");
            var selfound = false;

            var choices_ = choices.slice(0);
            var inactive_ = inactive.slice(0);
            if ($(fileref[j]).attr("type") == 'ATLAS') {
                choices_.unshift("ATLAS");
                inactive_.unshift(false);
            }
            var onlyAnalysis = $(fileref[j]).attr("onlyAnalysis") == '1';

            for (var k = 0; k < choices_.length; k++) {
                var fref = choices_[k];
                var isselected = "";
                if (selectedfref == fref | (k == choices_.length - 1 & !selfound)) {
                    isselected = "selected";
                    selfound = true;
                    if (inactive_[k] && inactive_[k] != "ana") {
                        $(fileref[j]).addClass("optionerror");
                    }
                }
                if (!onlyAnalysis || inactive_[k] == 'ana')
                    $(fileref[j]).append($("<option " + ((inactive_[k] == true) ? "class='optionerror'" : "class='noerror'") + " value='" + fref + "' " + isselected + ">" + fref + "</option>"));
            }
            if ($(fileref[j]).children().length == 0)
            {
                $(fileref[j]).append($("<option class='optionerror'  value=''> Create an Analysisfolder </option>"));                
            }
        }


    }


    function getVariablesDiv() {
        FunRefs = new Array();
        that.$container.find(".KCmdArgListTable").each(function(index, element) {
            FunRefs.push(element.getAttribute('funref'));
        });
        var allfuns = new Array();
        var lastfunref = "";
        for (var f = 0; f < FunRefs.length; f++) {
            // find function
            var splitfunref = FunRefs[f].split("/");
            var group = splitfunref[1];
            var fun = splitfunref[2];
            var subdiv = $("div[funref='" + FunRefs[f] + "']");
            if (group.search("variable") != -1) // & $(subdiv).css('display') != 'none' )
            {
                var thefun = new Object();
                thefun.type = group;
                thefun.funhandle = fun;
                thefun.name = FunRefs[f];
                thefun.args = new Object();
                if (subdiv.find("input[refarg=1]").length > 0) {
                    var $theinput = subdiv.find("input[refarg=1]");
                    var ref = subdiv.find(".KCmdFileref").find('option:selected').val();
                    var val = $theinput.val();
                    thefun.args['val'] = {
                        type: $theinput.attr("argtype"),
                        val: [ref, val]
                    };
                } else
                    thefun.args['val'] = {
                        type: "value",
                        val: subdiv.find(".Kinputvar").val()
                    };
                allfuns.push(thinning_and_pack(thefun));
            }
            else
            {
                var outputs = subdiv.find("input[argtype='OUT']");
                var settings = $(subdiv).find(".KCmdsettings");
                var id = settings.attr("uniqueID");
                var ncnt ={}
                for (var k = 0; k< outputs.length;k++)
                    {
                    var thefun = new Object();
                    thefun.type = "variableRef";
                    thefun.name = FunRefs[f];
                    thefun.args = new Object();
                    var outdiv = $(outputs[k]).parent().parent();
                    var ref = outdiv.find(".KCmdFileref").find('option:selected').val();
                    var $theinput = $(outputs[k])
                    var val = $theinput.val();
                    var num =$theinput.attr("argnum").replace(/\//g,"")
                    var aname = $theinput.attr("argname");
                    if (ncnt[aname] == undefined) ncnt[aname] = 0; else ncnt[aname]++;
                    thefun.funhandle = "REFERENCE_"+id+"_"+aname+"_"+ncnt[aname]

                    thefun.args['val'] = {
                        type: "outref",
                        val: [ref, val]
                    };
                    allfuns.push(thinning_and_pack(thefun));

              
                    }

                
            }

        }
        return allfuns;
    }


    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// get all jobinfo from GUI
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////

    that.getCommandDiv = getCommandDiv;

    function getCommandDiv(funref,skipPSIDvariables) {

        var $absdiv = $(".Kzoomedbatch");
        if ($absdiv.length >0)
        {
            zoomBatch()
        }

        function isAggregateJob(element)
        {
            var a = element.getAttribute('funref').split("/")[1];
            if (a == undefined)
                return false;
            else if (a.substring(0,9) == 'aggregate')
                return true;
        }


        var FunRefs = new Array();
        if (funref == "") // used for collecting everything
        {
            that.$container.find(".KCmdArgListTable").each(function(index, element) {
                FunRefs.push(element.getAttribute('funref'));
            });
        } else if (funref == "batch") {
            that.$container.find(".KCmdArgListTable").each(function(index, element) {
                if (!isAggregateJob(element))
                    FunRefs.push(element.getAttribute('funref'));
            });
        } else if (funref == "batch_subset") {
            that.$container.find(".KCmdArgListTable.KCmdmarked").each(function(index, element) {
              //  if (!isAggregateJob(element))
                    FunRefs.push(element.getAttribute('funref'));
            });
        } else if (funref == "aggregate") {
            that.$container.find(".KCmdArgListTable").each(function(index, element) {
                if (isAggregateJob(element))
                    FunRefs.push(element.getAttribute('funref'));
            });
        } else {

            if (skipPSIDvariables)
                ;
            else
                that.$container.find(".KCmdArgListTable.KCmdvariablePID,.KCmdArgListTable.KCmdvariableSID").each(function(index, element) {
                    FunRefs.push(element.getAttribute('funref'));
                });

            var splitfunref = funref.split("/");
            if (splitfunref[1] == 'separator' | splitfunref[1] == 'loop') {
                if (splitfunref[1] == 'loop')
                    FunRefs.push(funref);

                $("div[funref='" + funref + "']")
                    .nextUntil(".KCmdBatchgroup,.KCmdHeadSeparatorStyle").each(function(index, element) {
                        FunRefs.push(element.getAttribute('funref'));
                    });

            } else
                FunRefs.push(funref);
        }

        var allfuns = new Array();
        var used_refs = {};
        var used_vars = {};
        var regexpvar = /\[[\w]+\]/g;

        var lastfunref = "";
        for (var f = 0; f < FunRefs.length; f++) {
            // find function
            var splitfunref = FunRefs[f].split("/");
            var runningcnt = splitfunref[0];
            var group = splitfunref[1];
            var fun = splitfunref[2];
            //console.log(FunRefs[f]);
            var subdiv = $("div[funref='" + FunRefs[f] + "']");


            if ((group == "generic" & fun.substring(0, 7) == "generic") ) {
                var cmdname = $(subdiv.find("input[argtype='NAME']")).val();
                var cmdenv = $(subdiv.find("input[argtype='ENVIRONMENT']")).val();

                var $cmdstrdivs = subdiv.find("textarea[argtype='FSLCMD']");
                var $argdivs = subdiv.find("input[cid='KCmdFSL_" + runningcnt + "'],input[argname='OUTPUTFOLDER']");
                var $customName = subdiv.find(".KCustomName");
                //var cmdstring = $cmdstrdivs.val();
                var cmdstring = that.codeMirrors[$cmdstrdivs.attr("id")].getValue().replace(/\\/g, "\\\\");
                cmdstring = cmdstring.replace(/\t/g, "\\t")
                thefun = new Object();
                thefun.type = "generic";
                thefun.funhandle = fun;
                thefun.name = FunRefs[f];
                thefun.customName = $customName.text().trim();
                thefun.args = new Object();

                thefun.args["name"] = Arg(cmdname, "NAME");
                if (cmdenv != undefined)
                    thefun.args["environment"] = Arg(cmdenv, "ENVIRONMENT");

                thefun.args["cmdstring"] = Arg(cmdstring, "FSLCMD");
                for (var i = 0; i < $argdivs.length; i++) {
                    var argname = $argdivs[i].getAttribute("argname");
                    var $argtypediv = $("select[id='typeKCmdFSL_" + runningcnt + "'][ argname='" + argname + "'] option:selected");
                    var argtype = $argtypediv.text();
                    if (argtype == "")
                        argtype = $argdivs[i].getAttribute("argtype");
                    if (isReferenceArg(argtype)) {
                        //var fref = $( $("select[id='typeKCmdFSL_"+runningcnt+"'][ argname='"+argname+"']").next().find(".KCmdFileref option:selected")).val();
                        var fref = subdiv.find("[argname='" + argname + "']").find(".KCmdFileref").val();
                        thefun.args[$argdivs[i].getAttribute("argname")] = Arg([fref, $argdivs[i].value], argtype);
                    } else
                        thefun.args[$argdivs[i].getAttribute("argname")] = Arg($argdivs[i].value, argtype);
                }
                thefun.dep = lastfunref;

                args = thefun.args;
            } else if (group.search("variable") != -1) {
                thefun = new Object();
                thefun.type = group;
                thefun.funhandle = fun;
                thefun.name = FunRefs[f];
                thefun.args = new Object();

                var theinput;
                theinput = subdiv.find('input[refarg=1]');
                if (theinput.length > 0) {
                    var ref = subdiv.find(".KCmdFileref").find('option:selected').val();
                    var val = theinput.val();
                    thefun.args['val'] = {
                        type: theinput.attr("argtype"),
                        val: [ref, val]
                    };
                } else
                {
                    if (subdiv.find(".Kinputvar").length > 0)
                    {
                        thefun.args['val'] = {
                            type: "value",
                            val: subdiv.find(".Kinputvar").val()
                        };
                    }
                    else
                       continue;
                }
            } else {
                thefun = getFun(group, fun);
                if (thefun == undefined) {
                    if (group == "usercmdwrap")
                        alertify.error("user command (id='" + fun + "') undefined")
                    continue;
                }
                var $customName = subdiv.find(".KCustomName");
                thefun.customName = $customName.text().trim();
                thefun.name = FunRefs[f];
                thefun.dep = lastfunref;

                if (group == 'separator')
                    thefun.type = "separator";
                else if (group == "loop")
                    thefun.type = "loop";
                else if (group == "wrap")
                    thefun.type = "wrap";
                else
                    thefun.type = "normal";

                // set arguments

                function iterateOverArgs(Args, argnames, depth) {
                    var argnamepref = "";
                    for (var k = 0; k < depth.length; k++)
                        argnamepref += depth[k] + ".";

                    for (var k = 0; k < argnames.length; k++) {
                        if (Args[argnames[k]].type == 'NODE') {
                            var elem = subdiv.find("[argname='" + argnamepref + argnames[k] + "']");
                            if (Args[argnames[k]].multi != undefined)
                                Args[argnames[k]].multi = elem.length;
                            iterateOverArgs(Args[argnames[k]], Args[argnames[k]].children, depth.concat([argnames[k]]));
                        } else {
                            var elem = subdiv.find("[argname='" + argnamepref + argnames[k] + "']");
                            if (Args[argnames[k]].multi != undefined)
                                Args[argnames[k]].multi = elem.length;
                            if (isReferenceArg(Args[argnames[k]].type)) // resolve references in case of file/out
                            {
                                Args[argnames[k]].val = [];
                                for (var j = 0; j < elem.length; j++) {
                                    var ref = $(elem[j]).parent().parent().find(".KCmdFileref").find('option:selected').val();
                                    used_refs[ref] = 1;
                                    var val = $(elem[j]).val();
                                    while (matches = regexpvar.exec(val)) {
                                        used_vars[matches[0]] = 1; }
                                                                                                        
                                    if ((Args.type == 'NODE' & Args.multi != undefined) | Args[argnames[k]].multi != undefined)
                                        Args[argnames[k]].val.push([ref, val]);
                                    else
                                        Args[argnames[k]].val = [ref, val];
                                }
                            } else {
                                Args[argnames[k]].val = [];
                                for (var j = 0; j < elem.length; j++) {
                                    var val;
                                    var id = $(elem[j]).attr("id");
                                    if (that.codeMirrors[id] != undefined)
                                        val = that.codeMirrors[id].getValue().replace(/\\/g, "\\\\");
                                    else
                                        val = $(elem[j]).val();
                                    if ((Args.type == 'NODE' & Args.multi != undefined) | Args[argnames[k]].multi != undefined)
                                        Args[argnames[k]].val.push(val);
                                    else
                                        Args[argnames[k]].val = val;
                                }
                            }
                        }
                    }


                }

                var args = thefun['args'];
                iterateOverArgs(args, Object.keys(args), []);

            }



            var settings = $(subdiv).find(".KCmdsettings");
            if (settings.length > 0) {
                thefun.error_handling = settings.attr("error_handling");
                thefun.send_notification = settings.attr("notify");
                thefun.preserve_logs = settings.attr("preserve_logs");
                thefun.tag_study = settings.attr("tagstudy");
                thefun.grid_params = settings.attr("gridparams");
                thefun.nice = settings.attr("nice");
                thefun.matlab_params = settings.attr("matlabparams");
                thefun.uniqueID = settings.attr("uniqueID");
            }

            var banbutton = $(subdiv).find(".fa-ban");
            if (banbutton.length > 0) {
                if ($(banbutton).attr("banned") == "true")
                    thefun.banned = true;
                else
                    thefun.banned = false;
            }

            if (!thefun.banned && (thefun.type != "separator" && thefun.type != "loop"))
                lastfunref = FunRefs[f];


            if (subdiv.find(".fa-minus").length == 0)
                thefun.folded = true;
            else
                thefun.folded = false;




            allfuns.push(thinning_and_pack(thefun));
        }

        if (funref != "")
        {
            var references = Object.keys(used_refs)
            references = references.filter(function (x) { return x !="Study" & x != "Patient" & x.search("#") == -1})
            for (var k = 0; k < references.length;k++)
               allfuns= getCommandDiv("0/variableSID/" + references[k]).concat(allfuns);

            var vars = Object.keys(used_vars)
            for (var k = 0; k < vars.length;k++)
            {
                var v = vars[k]
                allfuns= getCommandDiv("0/variable/" + v.substring(1,v.length-1)).concat(allfuns);
            }
        }

        return allfuns;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// SUBMISSION commands
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////


    function getObjectList() {
        var objlist = new Array();

        if (state.viewer.selectionMode[1] == 'f')
            prepObjectInfoFromFileSelection(undefined, objlist)
        else {
            var info = patientTableMirror.getCurrentUniquePSID();
            if (!state.viewer.levelMode || !info)
                prepObjectInfoFromPatientSelection(objlist);

            if (objlist.length == 0 && info && info.patients_id != undefined)
                objlist.push({
                    piz: info.patients_id,
                    sid: info.studies_id,
                    tag: info.tag
                });

        }
        return objlist;

    }


    function submitCommand(funref, parallel) {

        that.submit_uid = Math.random().toString(36).substring(2, 15);

        var allfuns = getCommandDiv(funref);

        var subjectlist = getObjectList();

        var funref_splitted = funref.split("/");
        if (funref == 'aggregate' || (funref_splitted[1] != undefined && funref_splitted[1].substring(0, 9) == 'aggregate'))
            parallel = 'aggregate';

   
        if (submitCommandBatch(allfuns, subjectlist, parallel))
            commandDialog.toggle();
        
        clearInterval(that.updater_gridtable)
        that.numupdates = 0;
        that.updater_gridtable = setInterval(function()
        {
            if (that.numupdates > 4)
                clearInterval(that.updater_gridtable)
            that.numupdates++;
            updateGridjobTable();
        },2000);

    }

    that.runningSubmitCnt = 0;


    function submitCommandBatch(allfuns, subjectlist, parallel, via_action_button, simulate, tqueue) {



        if (parallel == undefined)
            parallel = 'sequential';


        var simulation
        if (simulate)
            simulation = [];



        var variables = [];
        if (via_action_button) {
            for (var k = 0; k < allfuns.length; k++) {
                if (allfuns[k].type.substring(0, 8) == 'variable')
                    variables.push(allfuns[k]);
            }
        } else
            variables = getVariablesDiv();

/*
        if (via_action_button && 
            (subjectlist[0].type == "study" 
            || subjectlist[0].type == "patient"))
            via_action_button = false;
*/

        var openselection = false;
        // get piz/sid selector fields
        var psidvars = [];


        var direct_apply_on_analysis = false

        if (state.viewer.selectionMode[1] == 'a') {
            if (subjectlist[0]) {
                if (subjectlist[0].tag == undefined || subjectlist[0].tag.replace(/\//g, "") == "")
                    direct_apply_on_analysis = true;
            }
        }



        for (var i = 0; i < variables.length; i++) {
            if (state.viewer.selectionMode[1] == 's' | direct_apply_on_analysis | via_action_button) {
                if (variables[i].type == "variableSID") {
                    if (variables[i].args.val.val == "")
                        variables[i].args.val.val = "[selection]";
                    if (variables[i].args.val.val.search("\\[selection\\]") > -1)
                        openselection = true;
                    psidvars.push(variables[i]);
                }
                if (variables[i].type == "variablePID") {
                    if (variables[i].args.val.val == "")
                        variables[i].args.val.val = "[selectionpatient]";
                    if (variables[i].args.val.val.search("\\[selectionpatient\\]") > -1)
                        openselection = true;
                    psidvars.push(variables[i]);
                }
            } else if (state.viewer.selectionMode[1] == 'a') {
                if (variables[i].type == "variableSID") {
                    if (variables[i].args.val.val == "") {
                        var selector = "";
                        for (var k = 0; k < subjectlist.length; k++) {
                            if (subjectlist[k].tag.split("/").length > 1)
                                selector += ' STAG:' + subjectlist[k].tag.split("/").filter(function(x) {
                                    return (x != "");
                                }).join(" STAG:");
                            else
                                selector += ' ' + subjectlist[k].piz + subjectlist[k].sid;
                        }
                        variables[i].args.val.val = selector.trim();
                    }
                    openselection = false;
                    psidvars.push(variables[i]);
                }
            } else if (state.viewer.selectionMode[1] == 'p' | via_action_button) {
                if (variables[i].type == "variablePID") {
                    if (variables[i].args.val.val == "")
                        variables[i].args.val.val = "[selection]";
                    if (variables[i].args.val.val.search("\\[selection\\]") > -1)
                        openselection = true;
                    psidvars.push(variables[i]);
                }
            }
            if ((variables[i].type == "variableSID" | variables[i].type == "variablePID") & !(variables[i].funhandle == "Patient" | variables[i].funhandle == "Study")) {
                psidvars.push(variables[i]);
            }
        }
        if (state.viewer.selectionMode[1] == 'f') {
            openselection = true;
            psidvars.push({
                funhandle: null,
                type: 'variableSID',
                args: {
                    val: {
                        type: 'value',
                        val: '??'
                    }
                }
            });
        }
        if ((subjectlist.length == 0) & (openselection | state.viewer.selectionMode[1] == 'a')) {
            alertify.alert("Error: you have to select some study/patient");
            return false;
        }

        if (!openselection) {
            subjectlist = [];
            var mainSelectorName, subjectlist_field, mainvar;
            if (state.viewer.selectionMode[1] == 'p') {
                mainSelectorName = 'Patient';
                subjectlist_field = 'piz';
            } else {
                mainSelectorName = 'Study';
                subjectlist_field = 'sid';
            }
            for (var k = 0; k < psidvars.length; k++) {
                if (psidvars[k].funhandle == mainSelectorName)
                    mainvar = psidvars[k];
            }
            var ids = mainvar.args.val.val.trim();
            ids = ids.replace(/\*/g, '%');
            var ids = ids.split(" ");

            var onPSIDs_received = function(ids) {
                mainvar.args.val.val = "[selection]";
                for (var k = 0; k < ids.length; k++) {
                    if (ids[k] != "") {
                        var subjecttobeadded = {
                            piz: "",
                            sid: ""
                        };
                        subjecttobeadded[subjectlist_field] = ids[k];
                        subjectlist.push(subjecttobeadded);
                    }
                }
                if (ids.length == 0) {
                    alertify.error("No patients/studies found matching Patient/Study expression!");
                } else {
                    doSubmission(allfuns, variables, psidvars);
                    if (simulate)
                        simulate(subjectlist, simulation)

                }
            }

            resolve_psid_query(ids, onPSIDs_received);

        } else {
            doSubmission(allfuns, variables, psidvars, via_action_button);
            if (simulate)
                simulate(subjectlist, simulation)
        }




        function doSubmission(allfuns, variables, psidvars, via_action_button) {

            if (tqueue == undefined)
            {
                // if triggered by action button, take default queue
                if(via_action_button != undefined)
                   tqueue = "DEFAULT"
                else
                   tqueue = queue;
            }

            var templatefuns = prepareFuns(allfuns, variables, psidvars, via_action_button, tqueue);
            if (templatefuns.length == 0) {
                alertify.error('No jobs to submit (skip/ban button pressed?)');
                return;
            }

            if (nice_val != "")
            {
                for (var k = 0; k < templatefuns.length;k++)
                {
                    if (templatefuns[k].nice == undefined | templatefuns[k].nice == "")
                        templatefuns[k].nice = nice_val;
                }
            } 

            if (parallel == 'aggregate') {

                var destanalysis;
                var variables = getVariablesDiv(true);
                for (var k = 0; k < variables.length; k++) {
                    if (variables[k].type == "variableANALYSISDEST") {
                        destanalysis = variables[k].args.val.val;
                        break;
                    }
                }
    
                var funs = JSON.parse(JSON.stringify(templatefuns));

                substRefVars(funs, {
                    piz: "[PIZ]",
                    sid: "[SID]"
                }, psidvars, that.runningSubmitCnt, parallel, simulate);


                var itemname = 'idset-' + (that.runningSubmitCnt++);
                for (var k = 0; k <funs.length;k++)
                {
                    if (funs[k].args.model != undefined)
                        itemname = funs[k].args.model.val;
                }



                var aqueue = _i(that.aggregateQueue,queue);

                var aggregate_fun_coll = []

                for (var k = 0 ;k < funs.length;k++)
                {
                    funs[k].uid=funs[k].uid+k;
                    var aggregatefun = {
                        funhandle: parallel + '_eval',
                        name: parallel + '_evaluation',
                        queue: aqueue,
                        psid: itemname,
                        dep: '',
                        args: {
                            aggregators: [funs[k]],
                            dest: destanalysis,
                            subjects: subjectlist
                        }
                    };


                    if (templatefuns[0].funhandle == "aggregate_python" |
                        templatefuns[0].funhandle == "aggregate_node") {
                        aggregatefun.funhandle = templatefuns[0].funhandle
                        aggregatefun.name = templatefuns[0].name
                    }
                    aggregate_fun_coll.push(aggregatefun);

                }

                if (aggregate_fun_coll[0].name.substring(aggregate_fun_coll[0].name.length-17) == "aggregate/jupyter")
                {
                     launchJupyter_debug(aggregate_fun_coll,'aggregate_jupyter')
                }
                else
                {

                    console.log("job basket/aggregate submitted")
                    var jsonString = encodeURIComponent(JSON.stringify(aggregate_fun_coll));
                    ajaxRequest('command=submit_job&testMode=' + testMode + '&json=' + jsonString, function(ev) {

                        if (ev.demonInfo.nosubmit == 1)
                        {
                            var msg = "Currently no submission possible! Contact system admin."
                            if (ev.demonInfo.msg)
                              msg = ev.demonInfo.msg;
                            alertify.alert(msg);
                            return
                        }

                        if (!testMode & !ev.demonInfo.isrunning) {
                            alertify.alert(templatefuns.length * subjectlist.length + " jobs(s) submitted, but the Daemon seems to be down. " +
                                " Contact system admin or start on your own via DPX_demon(-2).");
                            return;
                        }
                        if (testMode)
                            alertify.error("command basket submitted in testmode");
                        else
                            alertify.success("command basket submitted");
                        that.runningSubmitCnt++;
                    });

                }
            } else {
                if (templatefuns.length > 0) {
                    var hasLoop = false
                    for (var i = 0; i < templatefuns.length; i++)
                        if (templatefuns[i].type == 'loop') {
                            hasLoop = true;
                            break;
                        }
                    if (hasLoop)
                    {
                        if (parallel.substring(0,10) == 'fullbasket')
                           ;
                        else 
                           parallel = "basket";
                    }

                    var allfuns = [];
                    for (var i = 0; i < subjectlist.length; i++) {
                        var obj = subjectlist[i];

                        var funs = JSON.parse(JSON.stringify(templatefuns));

                        var res = substRefVars(funs, obj, psidvars, that.runningSubmitCnt, parallel, simulate);

                        if (res == false)
                            return;
                        if (parallel == "sequential")
                            allfuns = allfuns.concat(funs);
                        else
                           allfuns.push(funs); 

//                        if (parallel == "basket" || parallel == "immediate" || )
//                            allfuns.push(funs);
  //                      else
    //                        allfuns = allfuns.concat(funs);

                    }



                    var chunk_sz = 50; // number of chunks just referering how the job packages are submitted daemon.
                    
                    var chunksize_limit = 2000; // if the number of jobs per chunk are larger than this, 
                                              // split the chunks in even smaller pieces and use slurm dependencies
                                            // or: the maximal number of jobs per IDSET
                    if (parallel.substring(0,10) == 'fullbasket')
                    {
                        var Ns = parseInt(parallel.substring(11));
                        if (isNaN(Ns))
                            Ns = 1;

                        chunk_sz  = 5;                      


                        var numperchunk = Math.ceil(allfuns.length/Ns);
                        

                        var dep_interval = undefined;
                        if (numperchunk > chunksize_limit)
                        {
                            var origNs = Ns
                            Ns = Math.ceil(allfuns.length/chunksize_limit)
                            numperchunk = chunksize_limit
                            dep_interval = Math.ceil(Ns/origNs);
                        }

                        
                        var allfuns_ =[]
                        for (var k = 0; k < Ns;k++)
                        {
                            var bunch = allfuns.slice(k*numperchunk,(k+1)*numperchunk).flat();
                            if (bunch.length == 0)
                                break;
                            bunch[0].basketset = "IDSET"+(k+1)+"/"+Ns+"(" + bunch.length + ")_" + (runningJobcnt++);
                            if (dep_interval != undefined)
                            {
                                if (k>0 & k%dep_interval != 0)
                                    bunch[0].dep = "PREVIOUSSET";
                            }
                            allfuns_.push(bunch)
                        }
                         
                         allfuns = allfuns_;
                    }

                    //if (parallel == "fullbasket") {
                    //    allfuns[0].basketset = "IDSET" + (runningJobcnt++);
                    //    allfuns = [allfuns];
                    //}



                    if (simulate)
                        simulation.push(allfuns)
                    else if ((jupyter_debug | testMode) && allfuns[0].funhandle == "genericPYTHON" && static_info.jupyter)
                    {
                        launchJupyter_debug(allfuns,'python')
                    }  
                    else if (jupyter_debug && allfuns[0].funhandle == "genericBASH" && static_info.jupyter)
                    {
                        launchJupyter_debug(allfuns,'bash')
                    }
                    else if (jupyter_debug && allfuns[0].funhandle == "DPX_PROCESS_matlab_generic" && static_info.jupyter)
                    {
                        launchJupyter_debug(allfuns,'matlab')
                    }
                    else {
                        var pbar = KProgressBar("preparing to submit", "fa-submit", function() {
                            stopsubmission = true;
                        });


                        var stopsubmission = false;

                        function iterate_chunks(cnt) {
                            var tmode = testMode;
                            if (parallel == "immediate")
                                tmode = 2;
                            pbar.progress(cnt * chunk_sz / allfuns.length * 100, "submitting");
                            var jsonString = encodeURIComponent(JSON.stringify(allfuns.slice(cnt * chunk_sz, (cnt + 1) * chunk_sz)));
                            ajaxRequest('command=submit_job&testMode=' + tmode + '&json=' + jsonString, function(ev) {
                                if (stopsubmission) {
                                    pbar.done("aborted");
                                    return
                                } else if ((cnt + 1) * chunk_sz >= allfuns.length) {

                                    if (ev.demonInfo.nosubmit == 1)
                                    {
                                        var msg = "Currently no submission possible! Contact system admin."
                                        if (ev.demonInfo.msg)
                                          msg = ev.demonInfo.msg;
                                        alertify.alert(msg);
                                        pbar.done("aborted");
                                        return
                                    }


                                    if (!testMode & !ev.demonInfo.isrunning) {
                                        alertify.alert(templatefuns.length * subjectlist.length + " jobs(s) submitted, but the Daemon seems to be down. " +
                                            " Contact system admin.");
                                    }

                                    if (testMode)
                                        pbar.done(templatefuns.length * subjectlist.length + " jobs(s) submitted in testmode");
                                    else
                                        pbar.done(templatefuns.length * subjectlist.length + " jobs(s) submitted");
                                    that.runningSubmitCnt++;

                                } else {

                                    iterate_chunks(cnt + 1);
                                }
                            });
                        }
                        iterate_chunks(0);


                    }


                }
            }
        }

        return;


    }
    that.submitCommandBatch = submitCommandBatch;





    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// helpers
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////


    ///////////////// rename a user batch/command
    function renameUserCommand(name, callback) {
        alertify.prompt("Please enter new name. Use '/' (slash) for subfolder grouping.",
            function(e, newname) {
                if (e && newname != name) {
                    usercmdlist[name].name = newname;
                    usercmdlist[newname] = usercmdlist[name];
                    delete usercmdlist[name];
                    jsonTable_save({
                            id: usercmdlist[newname].id,
                            json: usercmdlist[newname]
                        },
                        function(e) {
                            if (e.msg != '')
                                $.notify("problems while changing name!", "error");
                        });
                    callback();
                }
            }, name);
    }

    ///////////////// remove a user batch/command
    function delUserCommand(name, callback) {
        alertify.confirm("About to delete " + name + ". Are you sure?",
            function(e) {
                if (e) {
                    jsonTable_delete({
                            id: usercmdlist[name].id
                        },
                        function(e) {
                            if (e.msg == '') {
                                delete usercmdlist[name];
                                modified_batches[name] = undefined;
                                $("[id='KCmdUserMenu_" + name + "']").remove();
                                $.notify("deleted " + name, "success");
                                that.batchchanged(false);
                            } else
                                $.notify("problems while removing!", "error");
                        });
                    callback();
                }
            });
    }

    function banCommand(funref) {
        var splitfunref = funref.split("/");
        var subdiv = $("div[funref='" + funref + "']");
        var banbutton = $(subdiv).find('.fa-ban');
        if ($(banbutton).attr("banned") == "true") {
            $(banbutton).css('color', '');
            $(banbutton).attr('banned', false);
            $(subdiv).removeClass("banned");

        } else {
            $(banbutton).css('color', 'red');
            $(banbutton).attr('banned', true);
            $(subdiv).addClass("banned");
        }
        that.batchchanged(true);

    }

    that.onpaste = function(e) {
        if (that.$frame.css('display') != "none" && !that.pasteDisabled) {
            var toinsert = e.clipboardData.getData("Text");
            if (pasteit(toinsert))
                e.preventDefault();
        }

    }


    function pastecommand() {
        alertify.alert("Browser security policy does not allow for paste by click. <br> Please use <b>ctrl+v</b> instead to paste a copied command.")
    }

    function importcommand() {
        that.pasteDisabled = 1;
        alertify.prompt('Please insert JSON String from your clipboard and press enter', function(a, b) {
            if (a) {
                if (!pasteit(b))
                    alertify.alert("Nora not able to understand your clipboard contents (you can currently only paste batch jobs)");

            }
            that.pasteDisabled = 0;
        });
    }



    function pasteit(toinsert, $where) {
        try {

            toinsert = toinsert.replace(/\“/g, "\"");
            toinsert = toinsert.replace(/\”/g, "\"");
            var obj = JSON.parse(toinsert);
        } catch (err) {
            console.log("cmddlg: parsing of pasted content failed");
            return;
        }
        var funref = obj.funref;
        var thefun = obj.thefun;

        if (thefun == undefined)
            return;


        for (var k in thefun) {
            try {

                var name = thefun[k].name;
                if (name == "aggregate_evaluation")
                {
                    name = thefun[k].args.aggregators[0].name
                    var details = name.split("/");
                    var $thediv = addCommand(details[details.length - 2], details[details.length - 1],  thefun[k].args.aggregators[0], $where);
                    if ($thediv != undefined)
                        scrollTo_highlight($thediv);
                }
                else
                {
                    var details = name.split("/");
                    var $thediv = addCommand(details[details.length - 2], details[details.length - 1], thefun[k], $where);
                    if ($thediv != undefined)
                        scrollTo_highlight($thediv);
                }

            } catch (err) {
                alertify.error("Definition of " + details[details.length - 2] + "/" + details[details.length - 1] + " not found!!!");

            }
        }
        that.batchchanged(true);
        return true;


    }

    function scrollTo($div) {
        commandDialog.$divcmd.scrollTop($div.position().top-100);
    }

    function scrollTo_highlight($thediv) {
        function checkVisible(elm) {
            var rect = elm.getBoundingClientRect();
            var viewHeight = Math.max(document.documentElement.clientHeight, window.innerHeight);
            return !(rect.bottom < 0 || rect.top - viewHeight >= 0);
        }
        if (!checkVisible($thediv[0]))
            scrollTo($thediv);
        $thediv.addClass("KCmd_successfully_created");
        setTimeout(function() {
            $thediv.removeClass("KCmd_successfully_created");
        }, 500);
    }

    function copycommand(funref) {

        var thefun
        if (that.$container.find(".KCmdArgListTable.KCmdmarked").length>0)
            thefun = getCommandDiv("batch_subset",true);
        else            
            thefun = getCommandDiv(funref,true);
        var objToCopy = {
            funref: funref,
            thefun: thefun
        };

        var $temp = $("<textarea style='position:absolute; display:block;z-index:99999;top:0px'>" + JSON.stringify(objToCopy) + "</textarea>").appendTo($body).select();
        var successful = document.execCommand('Copy');
        $.notify(" Copied to clipboard", "success");
        $temp.remove();

        that.myownclipboard = JSON.stringify(objToCopy);

    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// VALIDATION
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////

    function validate(funref, e) {
        var allfuns = getCommandDiv(funref);
        if (allfuns.length == 0)
            return;

        var subjectlist = getObjectList();


        var simulation = submitCommandBatch(allfuns, subjectlist, "basket", undefined, function(subjectlist, simulation) {
            if (simulation == undefined || simulation.length == 0)
                return;

            simulation = transpose_array(simulation[0]);

            $(e.target).addClass("inprogress");

            function push(args,argname,v,pref,opt)
            {                
                    if (pref == undefined)
                        pref = ""
                    if (args[pref+argname] == undefined)
                        args[pref+argname] = {
                            sels: [v]
                        };
                    else
                        args[pref+argname].sels.push(v);
                    if (opt)
                        args[pref+argname].optional = 1
            }

            var argarr = [];
            for (var j = 0; j < simulation.length; j++) {

                var args = {
                    funref: simulation[j][0].name
                };

                function digest(fun,argname,pref)
                {
                        if (fun.args[argname].type == 'NODE') {
                            for (var i = 0; i < fun.args[argname].children.length;i++)
                            {
                                var an = fun.args[argname].children[i];
                                fun.args[argname][an].multi = fun.args[argname].multi
                                digest({args: fun.args[argname]},an,pref + "#"+ argname + "_" )
                            }                            
                        }
                        else 
                        if (fun.args[argname].type == 'FILE') 
                        {
                             if (fun.args[argname].multi) {
                                for (var i = 0; i < fun.args[argname].multi; i++) {
                                    push(args,argname,fun.args[argname].val[i],pref + "$" + i + "_")
                                }
                            } 
                            else 
                               push(args,argname,fun.args[argname].val,pref,fun.args[argname].optional)                           
                        }
                }

                for (var k = 0; k < simulation[j].length; k++) {
                    var fun = simulation[j][k];
                    for (var argname in fun.args) {
                        digest(fun,argname,"")
                    }

                }
                argarr.push(args);
            }

            var jsonString = JSON.stringify(argarr);



            var mapFileSel2rowid = function(x) {
                if (Array.isArray(x))
                    x = x[0];
                x = x.split(" ")[0];
                x = x.split("#");
                if (x.length == 2)
                {
                    if (ViewerSettings.selectionMode[1] == 'p')
                        return x[0];
                    else
                        return x[0] + riddelim + '#' + x[1];
                }
                else
                    return x;
            }

            ajaxRequest('command=validate_files&json=' + jsonString, function(ev) {
                function attachShortcutSelect(toselect, arg) {
                    $(arg).off('click')
                    $(arg).on('click', function(toselect) {
                        return function() {
                            patientTableMirror.selectedItems = [].concat.apply([], toselect);
                            patientTableMirror.mirrorState();
                        }
                    }(toselect));
                }


                var errors_superall = {};

                for (var j = 0; j < ev.res.length; j++) {
                    var result = ev.res[j]
                    var fref = result.funref.split("/").slice(1).join("/")
                    var subdiv = $("div[funref='" + fref + "']");
                    var errors_all = {};
                    var psid_all = {};
                    for (var a in result) {
                        if (a == 'funref')
                            continue;

                        var arg;
                        if (a[0] == "#") {
                            var s = a.substring(1).split("_")
                            var nom;
                            if (s[1][0] == '$')
                            {
                                var index = s[1].substring(1)
                                nom =[s[0]].concat(s.slice(2)).join(".")
                                arg = subdiv.find("[argname='" + nom + "']").parent();
                                arg = $(arg[index]).find(".KCmdvalidate")
                            }
                            else
                            {
                                nom = s.join(".")
                                arg = subdiv.find("[argname='" + nom + "']").parent();
                                arg = $(arg).find(".KCmdvalidate")
                            }
                        }
                        else if (a[0] == "$") {
                            var index = a.substring(1, a.indexOf("_"));
                            var arg = subdiv.find("[argname='" + a.substring(a.indexOf("_") + 1) + "']").parent().find(".KCmdvalidate");
                            arg = $(arg[index]);
                        } else {
                            var arg = subdiv.find("[argname='" + a + "']").find(".KCmdvalidate");
                            if (arg.length == 0)
                                arg = subdiv.find("[argname='" + a + "']").parent().find(".KCmdvalidate");
                        }
                        var r = result[a];
                        var num = 0;
                        var errors = [];
                        if (r.optional &&
                            r.resolved.reduce((x,y)=>x+y,0) == 0
                            && r.sels[0].trim().split(" ").length ==1)
                        {
                            arg.text("optional");
                            arg.addClass("KCmdok");

                        }
                        else
                        {
                            for (var k = 0; k < r.resolved.length; k++) {
                                var psid;
                                if (Array.isArray(r.sels[k]))
                                    psid = r.sels[k][0].split(" ")[0];
                                else {
                                    psid = r.sels[k].split(" ")[0];
                                    if (state.viewer.selectionMode[1] == 'p')
                                        psid = psid.split("#")[0];
                                }
                                psid_all[psid] = true;
                                if (r.resolved[k] == 1) {
                                    num++
                                } else {
                                    errors_all[psid] = true;
                                    errors.push(r.sels[k]);
                                }
                            }
                            if (num == r.resolved.length) {
                                arg.text(num + "/" + r.resolved.length);
                                arg.addClass("KCmdok");
    
                            } else {
                                arg.text(num + "/" + r.resolved.length);
                                arg.removeClass("KCmdok");
                                var toselect = errors.map(mapFileSel2rowid);
                                attachShortcutSelect(toselect, arg);
    
                            }
                        }
    
                    }

                    if (psid_all['ANALYSIS'])
                        delete psid_all['ANALYSIS']


                    var subdiv = $("div[funref='" + fref + "']");
                    var cmvalidate = subdiv.find(".KCmdvalidate")[0];
                    var errors = Object.keys(errors_all);

                    if (errors.filter((x) => x.substr(0,8)=='ANALYSIS').length >0)
                    {
                        $(cmvalidate).text("0/" + subjectlist.length);                    
                    }
                    else
                    {
                        $(cmvalidate).text((subjectlist.length - errors.length) + "/" + subjectlist.length);                                            
                    }
                    if (errors.length == 0) {
                        $(cmvalidate).addClass("KCmdok");

                    } else {
                        $(cmvalidate).removeClass("KCmdok");
                        attachShortcutSelect(Object.keys(diff(psid_all, errors_all)).map(mapFileSel2rowid), cmvalidate);
                    }
                    errors_superall = union(errors_superall, errors_all);
                }

                if (funref == "") {
                    var numerr = Object.keys(errors_superall).length;
                    var numpats = subjectlist.length;
                    if (numerr == 0)
                        $validate_full.addClass("KCmdok");
                    else
                        $validate_full.removeClass("KCmdok");
                    $validate_full.text((subjectlist.length - numerr) + "/" + subjectlist.length);
                    attachShortcutSelect(Object.keys(diff(psid_all, errors_superall)).map(mapFileSel2rowid), $validate_full[0]);

                }

                $(e.target).removeClass("inprogress");


            });

        });


        return;

    }


    function refreshUserBatches(callback)
    {
        ajaxRequest('command=getuserbatches', function(ev) {
            var remotecmdlist = ev.content;
            for (var k in remotecmdlist)
            {
                modified_batches
                if (usercmdlist[k] == undefined)
                    usercmdlist[k] = remotecmdlist[k];
                else
                {

                    if ( (that.batchmodified  && last_selection == k) | 
                          (modified_batches[k] != undefined) )
                    {
                        alertify.error("cannot refresh " + k + " because it was locally modified")
                    }
                    else
                    { 
                        usercmdlist[k] = remotecmdlist[k];
                    }

                }
            }                       
            callback();
            
            BatchList[BatchList.activeID].trigger("click");

                 
        });
            
    }
    that.refreshUserBatches = refreshUserBatches;

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// SAVE commands
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////

    function saveUserCommand(funref, allfuns, defaultv) {
        if (allfuns == undefined)
            allfuns = getCommandDiv(funref);
        var default_ = "";
        if (funref != undefined) {
            var splitted = funref.split("/");
            if (splitted[1] == 'separator')
                default_ = $("div[funref='" + funref + "']").find(".KCustomName").text();
            else
                default_ = splitted.slice(0).splice(1).join("/");
        }
        if (default_ == "") {
            if (BatchList.activeID == "KCURRENTUID")
                default_ = "newbatch";
            else
                default_ = last_clicked_batch;
        }
        if (defaultv != undefined)
            default_ = defaultv;


        alertify.prompt("Please enter a name", function(e, name) {
            if (e) {
                var addtolist = true;
                var fav = "";
                if (usercmdlist[name] != undefined && usercmdlist[name].fav != undefined)
                    fav = usercmdlist[name].fav;
                var wrap = "";
                if (usercmdlist[name] != undefined && usercmdlist[name].wrap != undefined)
                    wrap = usercmdlist[name].wrap;

                var project = currentModule;
                var id = "0";
                if (usercmdlist[name] != undefined && usercmdlist[name].id != undefined)
                    id = usercmdlist[name].id;

                var saveit = function(update) {
                    var json = {
                        name: name,
                        fav: fav,
                        wrap: wrap,
                        def: allfuns,
                        rights: 'r-',
                        project: project,
                        user:userinfo.username
                    };
                    jsonTable_save({
                            id: id,
                            type: 'userbatch',
                            json: json
                        },
                        function(result) {
                            if (result.msg !== '')
                                $.notify("problems while saving!!", "error");
                            else {
                                if (addtolist) {
                                    $cmdgroup = $("#KCmdUserMenu");
                                    $cmdgroup.append(userCommandEntry(name, ""));
                                }
                                usercmdlist[name] = {
                                    name: name,
                                    def: allfuns,
                                    fav: fav,
                                    wrap: wrap,
                                    id: result.json[0].id,
                                    user:userinfo.username                                    
                                };
                                if (updateBatchList && update) {
                                    updateBatchList();
                                    if (last_clicked_batch != name) {
                                        if (BatchList[name] != undefined)
                                            BatchList[name].trigger("click");
                                    }
                                }
                                $.notify("saved " + name, "success");
                                that.batchchanged(false);
                                modified_batches[name] = undefined;
                                modified_batches[last_clicked_batch] = undefined;
                                BatchList[name].removeClass('unsaved');
                                if (BatchList[last_clicked_batch] != undefined)
                                    BatchList[last_clicked_batch].removeClass('unsaved');
                            }
                        });
                }

                if (usercmdlist[name] && BatchList.activeID != name) // this one exists already
                {
                    id = usercmdlist[name].id;
                    addtolist = false;
                    fav = usercmdlist[name].fav;
                    project = usercmdlist[name].project;

                    alertify.confirm("The batch " + name + " already exists. Overwrite?",
                        function(e) {
                            if (e)
                                saveit(false)
                        });
                } else
                    saveit(true);
            }
        }, default_);
    }




    function userCommandEntry(name, fav) {
        $entry = $("<li id='KCmdUserMenu_" + name + "' ><a>" + name + " </a> </li>").click(function(x) {
            return function() {
                clear();
                addCommand("user", x);
            };
        }(name));
        $entry.append($("<i class='usercmdshortcut fa fa-trash'></i>").click(function(x) {
            return function(ev) {
                ev.stopPropagation();
                delUserCommand(x);
            };
        }(name)));
        return $entry;
    }



    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////// drop
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////

    function dropOnArgument(intype,append) {
        return function(ev) {
            $(this).parent().removeClass("isDragged");
            var argvalinput;
            var type;
            if (intype == "") // if called from generic SPM/FSL and not PSID
            {
                argvalinput = this.childNodes[1].childNodes[1];
                var xx = this.children[0].childNodes[1];
                type = xx.options[xx.options.selectedIndex].text;
            } else if (intype == 'variable') {
                type = 'FILE';
                argvalinput = this.children[0];
            } else if (intype == 'ATLAS') {
                type = 'FILE';
                argvalinput = this.lastChild.childNodes[1];
            } else if (intype == 'variableSID' | intype == 'variablePID') {
                type = intype;
                argvalinput = this.children[0];
            } else {
                if (append)
                {
                    argvalinput = $(this).prev().prev()[0]
                    if (argvalinput == undefined)                    
                        argvalinput = $(this).parent().parent().find("textarea")[0]
                }
                else
                    argvalinput = this.lastChild.childNodes[0];
                type = intype;
            }
            if (type == "STRING")
            {
                var element = this.lastChild.childNodes[0];             
                var txt = ev.dataTransfer.getData('text');
                if (txt != undefined && txt.trim() != "")
                    element.value = txt;
                return;
            }
            if (tempObjectInfo == undefined)
                return;

            var content = {};

            function split(x)
            {
                return x.split(/[\ \n]/g);
            }
            if (append) 
            {
                var x = split(argvalinput.value)
                for (var k in x)
                {
                    if (x[k] != "")
                        content[x[k]] = true;
                }
            }
            for (var k = 0; k < tempObjectInfo.length; k++) {
                if (type == "FILE" | type == "ATLAS") {
                    if (tempObjectInfo[0].type == "file")
                        content[tempObjectInfo[k].filename] = 1
                    else if (tempObjectInfo[0].type == "subfolder")
                        content[tempObjectInfo[k].subfolder + "/*"] = 1;

                } else if (type == "variableSID") {
                    if (tempObjectInfo[0].type == "study")
                        content[tempObjectInfo[k].piz + tempObjectInfo[k].sid] = 1;
                } else if (type == "variablePID") {
                    if (tempObjectInfo[0].type == "patient")
                        content[tempObjectInfo[k].piz] = 1;
                }
            }
            var ks = Object.keys(content)
            if (ks.length > 0)
                argvalinput.value = ks.join(" ");

            if (tempObjectInfo[0].piz == "ANALYSIS") {
                var op = tempObjectInfo[0].piz + tempObjectInfo[0].sid;
                $(this).find(".KCmdFileref").val(op)
            } else {
                var xx = $(this).find(".KCmdFileref");
                var ops = xx.find("option").map(function() {
                    return $(this).val();
                }).get();
                for (var k = 0; k < ops.length; k++) {
                    if ("#" + ops[k] == tempObjectInfo[0].sid)
                        xx.val(ops[k]);
                }

            }


            ev.preventDefault();
            ev.stopPropagation();
        };
    }


    function argDetailButton($parentfield)
    {
        var $argdetail = $("<span class='KCmdargdetail'><i class='fa fa-bars'></i></span>");
        $argdetail.click(function(e) {

            var val = $parentfield.val();
            var c = val.split(/[\ \n]/g).filter((x) => (x!=""));
            var $content = $("<textarea onchoice='preventSelection'  >");
            $content.val(c.join("\n"));
            $content.on("mouseleave", function() {
                 var c = $content.val().split(/[\ \n]/g);
                 $parentfield.val(c.join(" "));
                 this.remove();
            });
            $content.appendTo($(e.target))
        });

        $argdetail.get(0).ondrop = dropOnArgument("FILE",true);
        draghint($argdetail.get(0),"append")
        return $argdetail;
    }
                    
    function outDrag($parentfield)
    {
        var $argdetail = $("<span draggable=true class='KCmdargdetail'><i class='fa fa-link'></i></span>");
        $argdetail.appendTooltip("drag output reference onto input")
        $argdetail.on("dragstart",function($parentfield) { return function(e) {
            var $parent = $parentfield.parent();
            
            var $input = $parentfield.find("input")
            var all = $parentfield.parent().find("input[argtype='OUT'][argname='"+$input.attr("argname")+"']")
            var num = 0;
            for (;num<all.length;num++)
                if (all[num] == $input[0])
                    break;

            var $settings = $parent.find(".KCmdsettings");
            var title = $parentfield.find(".Kargtitle").text()
            if (title == "")
                title = $parentfield.attr("argname")
            var funref = $parent.attr("funref").split("/")
            var txt 
            if (all.length > 1)
                txt = "from " + title + "." + (num+1) + " of " + funref[2];
            else
                txt = "from " + title + " of " + funref[2];
            var ref = $settings.attr("uniqueID") + "_" + $input.attr("argname") + "_" + num;
            tempObjectInfo = [{
                type : "file",
                filename : txt + " [REFERENCE_"+ref+"]"
            }]           
            e.originalEvent.dataTransfer.setData("frombatchtool", "yea");

            
        }}($parentfield))
        
        return $argdetail;
    }
                    



    function thinning_and_pack(thefun) {
        var newfun = new Object();
        newfun.funhandle = thefun.funhandle;
        newfun.type = thefun.type;
        newfun.path = thefun.path;
        newfun.name = thefun.name;
        newfun.customName = thefun.customName;
        newfun.preserve_logs = thefun.preserve_logs;
        newfun.send_notification = thefun.send_notification;
        newfun.error_handling = thefun.error_handling;
        newfun.tag_study = thefun.tag_study;
        newfun.grid_params = thefun.grid_params;
        newfun.nice = thefun.nice;
        newfun.matlab_params = thefun.matlab_params;
        newfun.uniqueID = thefun.uniqueID;
        newfun.dep = thefun.dep;
        newfun.folded = thefun.folded;
        newfun.args = new Object();
        newfun.uid = that.submit_uid;
        if (thefun.banned == true)
            newfun.banned = true;

        function packArgs(Args, argnames) {
            var args = {};
            for (var k = 0; k < argnames.length; k++) {
                var theval = Args[argnames[k]].val; //.replace(/\n/g," ");
                args[argnames[k]] = {
                    val: theval,
                    type: Args[argnames[k]].type
                };
                if (Args[argnames[k]].optional)
                    args[argnames[k]].optional = 1;
                if (Args[argnames[k]].multi != undefined)
                    args[argnames[k]].multi = Args[argnames[k]].multi;
                if (Args[argnames[k]].type == 'NODE') {
                    var children = packArgs(Args[argnames[k]], Args[argnames[k]].children);
                    $.extend(true, args[argnames[k]], children);
                    args[argnames[k]].children = Args[argnames[k]].children;
                }
            }
            return args;
        }
        newfun.args = packArgs(thefun.args, Object.keys(thefun.args));

        return newfun;
    }

    function Arg(val, type) {
        a = new Object;
        a.val = val;
        a.type = type;
        return a;
    }

    function selectionModeChanged() {
        if (state.viewer.selectionMode[1] == "s" || state.viewer.selectionMode[1] == "a") {
            $(".KCmdvariablePID[funref='0/variablePID/Patient']").addClass('inactive');
            $(".KCmdvariableSID[funref='0/variableSID/Study']").removeClass('inactive');
        } else if (state.viewer.selectionMode[1] == "p") {
            $(".KCmdvariablePID[funref='0/variablePID/Patient']").removeClass('inactive');
            $(".KCmdvariableSID[funref='0/variableSID/Study']").addClass('inactive');
        }

        updateFilerefCombo();
    }
    that.selectionModeChanged = selectionModeChanged;


    that.updategridStats = updategridStats;

    function updategridStats() {
        $(".KCommandDialog").find('.KTag').hide();
        for (var f in currentJobs.funrefs_error)
            $(".KCommandDialog").find("[funref='" + f + "']").find(".KTagError").text(currentJobs.funrefs_error[f]).show();
        for (var f in currentJobs.funrefs_waiting)
            $(".KCommandDialog").find("[funref='" + f + "']").find(".KTagWaiting").text(currentJobs.funrefs_waiting[f]).show();
        for (var f in currentJobs.funrefs_running)
            $(".KCommandDialog").find("[funref='" + f + "']").find(".KTagRunning").text(currentJobs.funrefs_running[f]).show();

    }


    that.pasteit = pasteit;

    function appendFoldbutton($trg,editor)
    {
        var foldh = 30;
        var deflh = 300;
        $trg.height(foldh);

        var $i = $("<i class='fa fa-arrow-down'></i>")
        var $but = $("<div class='textarea_foldbutton'></div>")
        $trg.append($but.append($i));
        $trg.find(".dialog_generic_resizeTriangle").hide()

        $but.click(function(){
            if ($trg.height() > foldh+10)
            {
                $trg.height(foldh);
                $but.removeClass("open")
                $i.addClass("fa-arrow-down").removeClass("fa-arrow-up")
                $trg.find(".dialog_generic_resizeTriangle").hide()
            }
            else
            {
                $trg.height(deflh);
                $but.addClass("open")                
                $i.removeClass("fa-arrow-down").addClass("fa-arrow-up")
                $trg.find(".dialog_generic_resizeTriangle").show()
                setTimeout(function() {
                    editor.refresh();
                },0);
            }


        })

    }


    selectionModeChanged();
    return that;
}


KCommandDialog.getQueues = function() {

    var ALL_queues = [];
    if (static_info.SGE_QUEUES != undefined)
        ALL_queues = ALL_queues.concat(static_info.SGE_QUEUES)
    if (static_info.SLURM_QUEUES != undefined)
        ALL_queues = ALL_queues.concat(static_info.SLURM_QUEUES)
    if (static_info.MATLAB_QUEUES != undefined)
        ALL_queues = ALL_queues.concat(static_info.MATLAB_QUEUES)

    function filterAdmin()
    {
            if (static_info.ADMIN_QUEUES != undefined)
            {
                for (var k = 0;k < static_info.ADMIN_QUEUES.length;k++)
                    ALL_queues = ALL_queues.filter(function (x) { return x != static_info.ADMIN_QUEUES[k]});
            }
        
    }
    if (userinfo.isadmin != "1")
    {
        if (static_info.RESTRICT_QUEUE_RIGHTS)
        {
            if (static_info.available_queues.length == 0)
                ALL_queues = [static_info.DEFAULTQUEUE]    
            else
            {
                if (static_info.available_queues.find((x) => x=="[ALL]") != undefined)
                    filterAdmin();
                else
                    ALL_queues = static_info.available_queues    
            }
        }
        else        
            filterAdmin()                                   
    }
    return ALL_queues
}


function betterTab(cm) {
    if (cm.somethingSelected()) {
        cm.indentSelection("add");
    } else {
        cm.replaceSelection(cm.getOption("indentWithTabs") ? "\t" :
            Array(cm.getOption("indentUnit") + 1).join(" "), "end", "+input");
    }
}
/*
CodeMirror.fromTextArea(document.getElementById("the-editor"), {
  extraKeys: { Tab: betterTab }
});
*/


function launchJupyter_batch(objinfo)
{
   var batch = {
      "funhandle": "aggregate_python",
      "name": "1/aggregate/jupyter",
      "args": {
        "aggregators": [
          {
            "funhandle": "aggregate_python",
            "type": "normal",
            "path": "aggregate.jupyter",
            "name": "1/1/aggregate/jupyter",
            "uniqueID": "someid",
            "args": {
              "inputs": {
                "val": [
                  "[PIZ][SID] m*"
                ],
                "type": "FILE",
                "multi": 1
              },
              "notebook": {
                "val": "ANALYSIS#PGdlf mybbok.ipynb",
                "type": "OUT"
              },
              "environment": {
                "val": "source <(echo $(/software/defaultenv))",
                "type": "ENVIRONMENT"
              }
            },
            "uid": "p0un503i0db0",
            "psid": "[PIZ][SID]"
          }
        ],
        "dest": [
          "ANALYSIS#allen",
          ""
        ]
      }
    }
    var selector = objinfo.piz + objinfo.sid + " " + objinfo.filename
    batch.args.aggregators[0].args.notebook.val = selector;    
    launchJupyter_debug([batch],"aggregate_jupyter")
}

function launchJupyter_debug(batch,typ)
{


    var thejob = batch[0];
    if (thejob.args.aggregators)
    {
        thejob.customName= thejob.args.aggregators[0].customName;
        thejob.uid = thejob.args.aggregators[0].uid;
    }
    var deftok = thejob.uid;
    var customName = thejob.customName;
    if (customName)
        customName = customName.replace(/\ /g,"_")

    
    var nbext = static_info.jupyter.nbext;
    if (nbext == undefined)
        nbext = ".ipynb"

    var nbname
    var debugnotebooks
    if (typ == "aggregate_jupyter")
    {
        debugnotebooks = "$NOTEBOOKDIR/"
        nbname = thejob.args.aggregators[0].args.notebook.val.split(" ")[1];
        if (nbname.search(/\./) == -1)
        {
            nbname += nbext
            thejob.args.aggregators[0].args.notebook.val = thejob.args.aggregators[0].args.notebook.val.trim() + nbext;
        }
    }
    else
    {
        debugnotebooks = static_info.jupyter.notebookdir + "/" +  userinfo.username + "/";
        nbname =  "debug/" + userinfo.username + "_" + deftok + customName +
                 "/job_"+ (new Date()).toISOString().replace(/\:/g,"_").replace(/\./g,"_").replace(/\-/g,"_") + nbext    
    }

    var args = thejob.args;

    var job = {
            "funhandle": "genericBASH",
            "type": "generic",
            "name": "99/99/generic/jupyter",
            "customName": "Jupyter Debug",
            "dep": "",
            "args": {
              "accomp_data": {"dest" : debugnotebooks+ nbname},
              "cmdstring": {
                "val": ""
              },
              "hook": {
                "val": "jupyter_debug",
                "data": nbname
              },
            },
            "psid": "nan#nan"
          }



    var cmd;
    if (typ == "python")
    {
        var prequel = "%load_ext autoreload\n%autoreload 2\n# get file locations from NORA\n\nimport os\nimport sys\nsys.path.append(os.environ['DPXROOT'] + '/src/python')\n"
        if (static_info.PYTHON_ADDPATH)
        {
            for (var k = 0; k < static_info.PYTHON_ADDPATH.length;k++)
            {
                prequel += "sys.path.append('"+static_info.PYTHON_ADDPATH[k]+"')\n";
            }
        }
        prequel += "from DPX_core import *\n"

        var outs = [];
        for (var k in args)    
        {
                if (k != "cmdstring" & k != "OUTPUTFOLDER" & k != "environment" & k != "name")
                {
                    if (k[0] == 'o' | k[0] == 'p')
                    {
                        outs.push(k)
                        var s = args[k].val.split(" ");
                        prequel += k + " = DPX_getOutputLocation('"+currentModule+"','"+s[0]+"','"+s.slice(1).join(" ")+"')\nprint('"+k+"='+"+k+")\n"
                    }
                    else if (k[0] == 'n')
                    {
                        prequel += k + " = " + args[k].val + "\n";
                    }
                    else if (k[0] == 's')
                    {
                        prequel += k + " = '" + args[k].val + "'" + "\n";
                    }
                    else 
                        prequel += k + " = DPX_selectFiles('"+currentModule+"','"+args[k].val+"',True)[0]\nprint('"+k+"='+"+k+")\n"
                }
        }
        var sequel = "# add files to NORA\n\n";
        for (var i = 0; i < outs.length;i++)
                sequel += "DPX_addFiles('"+currentModule+"',["+outs[i]+"])\n"
        cmd = thejob.args.cmdstring.val.replace(/\%/g,"\\\\X37").replace(/\$/g,"")

    }
    if (typ == "bash")
    {
        var prequel = "# get file information from NORA\n";
        prequel += 'alias nora="$DPXROOT/src/node/nora"\n';
        prequel += "dpxproject=" + currentModule + "\n";
        cmd = thejob.args.cmdstring.val.replace(/\%/g,"\\X37").replace(/\\t/g," ")

        var outs = [];

        var sequel = "# add files to NORA\n\n";
        for (var k =0;k < 10;k++)
        {
            if (args["f"+k] != undefined)
                prequel += "f"+k+"=$(nora -s '" + args["f"+k].val + " NTH(1)')\n";
            if (args["o"+k] != undefined)
            {
                prequel += "o"+k+"=$(nora -o '" + args["o"+k].val + "')\n";
                sequel += "nora -a $o" + k + "\n";                
            }
            if (args["p"+k] != undefined)
            {
                prequel += "p"+k+"=$(nora -pa '" + args["p"+k].val + "')\n";
                sequel += "nora -a $p" + k + "\n";                
            }
         }

    }    
    if (typ == "matlab")
    {
        var prequel = "run([getenv('DPXROOT') '/src/matlab/DPX_startup.m']);\n"
        prequel += "DPX_Project " + currentModule + "\n";
        cmd = thejob.args.expression.val.replace(/\%/g,"\\X37");

        var outs = [];
        for (var k in args.inputs.val)    
            prequel += "input" + (1+parseInt(k)) + " = DPX_selectFiles('" + args.inputs.val[k] + "');\n";
        for (var k in args.outputs.val)    
            prequel += "output" + (1+parseInt(k)) + " = DPX_getOutputLocation('" + args.outputs.val[k] + "');\n";
        var sequel = "% add files to NORA\n\n";
        for (var k in args.outputs.val)            
             sequel += "DPX_addFiles(output1);\n"

    }
    if (typ == "aggregate_jupyter")
    {
        prequel = ""
        cmd = ""
        sequel = ""
        job.args.aggregators = batch[0].args.aggregators
        job.args.subjects = batch[0].args.subjects;
    }


    

    var cellid = 0;
    function cell(content)
    {
        cellid++    
        return {
           "cell_type": "code",
           "execution_count": 0,
           "id": "cell"+cellid,
           "metadata": {},
           "outputs": [
            {
             "name": "stdout",
             "output_type": "stream",
             "text": [
              ""
             ]
            }
           ],
           "source": [ content.replace(/\+/g,"\\X43") ]
          }
     }


     var kspec

     if (static_info.jupyter.kspec != undefined)
     {
         var sel = typ;
         if (sel == 'aggregate_jupyter')
            sel = "python"
         kspec = static_info.jupyter.kspec[sel];

         if (thejob.args.aggregator && thejob.args.aggregators[0] && thejob.args.aggregators[0].args.language.val)
            kspec = static_info.jupyter.kspec[thejob.args.aggregators[0].args.language.val];

     }

     var cells = [];
     if (prequel != "")
        cells.push(cell(prequel))
     if (cmd != "")
        cells.push(cell(cmd))
     if (sequel != "")
        cells.push(cell(sequel))
     if (cells.length == 0)
        cells.push(cell("# write your code here"));

     

     job.args.accomp_data.content =  {
     "cells": cells,
     "metadata": {
      "kernelspec": kspec,
      "language_info": {
       "codemirror_mode": {
        "name": "ipython",
        "version": 3
       },
       "file_extension": ".py",
       "mimetype": "text/x-python",
       "name": "python",
       "nbconvert_exporter": "python",
       "pygments_lexer": "ipython3",
       "version": "3.8.8"
      }
     },
     "nbformat": 4,
     "nbformat_minor": 5
    }




  
//    var deftok = Math.random().toString(36).substring(2, 15);
    var deftok = ['--time=2-0']

    if (launchJupyter_debug.grid_params_default != undefined)
        deftok[0] = launchJupyter_debug.grid_params_default
    if (launchJupyter_debug.queue_default != undefined)
        deftok.push(launchJupyter_debug.queue_default);

    var prompt = [
                  {msg:"Launch your jupyter notebook with the following SLURM/SGE parameters.<br> "+
                  "<p style='float:left;'>"+
                  "Please use a time limit (--time=days-hours)! <br>"+
                  "</p>" }
                  ]
    prompt[0].opt = KCommandDialog.getQueues(),
    prompt[0].optMsg = "Queue";

    alertify.prompt(prompt,          
    function(e,res)
	 {
		if(e)			
		{
			if (res != "")
			{
                if (job.args.aggregators)
                {
                    job.uid = job.args.aggregators[0].uid
                }
                else
                    job.uid = Math.random().toString(36).substring(2, 15);
                var call = static_info.jupyter.call;
                if (debugnotebooks != "$NOTEBOOKDIR/")
                   call = call.replace(/\$NOTEBOOKDIR/g,debugnotebooks)


                job.args.cmdstring.val = call;
                job.grid_params = res.str;
                job.queue = res.option;
                launchJupyter_debug.grid_params_default = res.str;
                launchJupyter_debug.queue_default =  res.option;

                submitSingleJob(job,function(logRequester,errRequester,pbar)
                {
                    if (errRequester != undefined)
                    {
                        var cnt = 0;
                        var maxcnt = 80;
                        function waiting()
                        {
                            cnt++;
                            errRequester(function(ev)
                            {
                                pbar.progress(cnt/maxcnt*100,"waiting for jupyter")     
                                var p = ev.content.search("Or copy and paste one of these URLs:")
                                if (p > -1)
                                {
                                    var response = ev.content.substring(p).split("<br>").map(function(x) {return x.trim()})

                                    var url = response[1]
                                    var x = url.split("/")
                                    x.splice(3,0,"notebooks/"+nbname)
                                    url = x.join("/")
                                    window.open(url,'_blank')
                                    console.log(url);
                                    alertify.success("juypter is there")
                                    pbar.done("success")
                                }
                                else
                                {
                                    if (cnt > maxcnt)
                                    {
                                        alertify.error("jupyter timed out, check grid stats for log")
                                        pbar.done("time out")
                                    }
                                    else
                                        setTimeout(waiting,1000)
                                }

                            })
                        }
                        pbar.progress(-1,"running")                        
                        setTimeout(waiting,1000);
                    }

                },function() {
                    cnt = 99;
                });


			}
		}
	 },deftok);

}


function launchJupyter()
{
 
    var job = {
            "funhandle": "genericBASH",
            "type": "generic",
            "name": "99/99/generic/genericBASH",
            "customName": "Jupyter",
            "dep": "",
            "args": {
              "cmdstring": {
                "val": ""
              },
              "hook": {
                "val": "jupyter"
              },

            },
            "psid": "nan#nan"
          }
  
//    var deftok = Math.random().toString(36).substring(2, 15);
    var deftok = ['--time=2-0']

    var prompt = [
                  {msg:"Launch your jupyter notebook with the following SLURM/SGE parameters.<br> "+
                  "<p style='float:left;'>"+
                  "Please use a time limit (--time=days-hours)! <br>"+
                  "</p>" }
                  ]

    prompt[0].opt = KCommandDialog.getQueues(),
    prompt[0].optMsg = "Queue";

    var defaulty;
    if (userinfo.isadmin == "1")
    {
        prompt.push({msg:"User directory" })
        defaulty = [deftok[0], prompt[0].opt[0],userinfo.username]
    }
    else
    {
        defaulty = deftok;        
    }



    if (launchJupyter.grid_params_default != undefined)
        defaulty[0] = launchJupyter.grid_params_default
    if (launchJupyter.dir_default != undefined)
        defaulty[2] = launchJupyter.dir_default;
    if (launchJupyter.queue_default != undefined)
        defaulty[1] = launchJupyter.queue_default;
    



    alertify.prompt(prompt,          
    function(e,res)
	 {
		if(e)			
		{
			if (res != "")
			{
               // job.uid = res.str[0];
                job.uid = Math.random().toString(36).substring(2, 15);
                var userdir
                var gridparams
                if (Array.isArray(res.str))
                {
                    userdir = res.str[1];
                    gridparams = res.str[0];
                }
                else
                {
                    userdir = userinfo.username;
                    gridparams = res;
                }
                var call = static_info.jupyter.call.replace(/\$NOTEBOOKDIR/g,static_info.jupyter.notebookdir + "/" + userdir)
                job.args.cmdstring.val = call;
                job.grid_params = gridparams;
                job.queue = res.option;

                launchJupyter.grid_params_default = gridparams;
                launchJupyter.dir_default = userdir
                launchJupyter.queue_default = res.option
                    
                submitSingleJob(job,function(logRequester,errRequester,pbar)
                {
                    if (errRequester != undefined)
                    {
                        var cnt = 0;
                        var maxcnt = 50;
                        function waiting()
                        {
                            cnt++;
                            errRequester(function(ev)
                            {
                                pbar.progress(cnt/maxcnt*100,"waiting for jupyter")     
                                var p = ev.content.search("Or copy and paste one of these URLs:")
                                if (p > -1)
                                {
                                    var response = ev.content.substring(p).split("<br>").map(function(x) {return x.trim()})

                                    var url = response[1]
                                    window.open(url,'_blank');
                                    
                                    console.log(url);
                                    alertify.success("juypter is there")
                                    pbar.done("success")
                                }
                                else
                                {
                                    if (cnt > maxcnt)
                                    {
                                        alertify.error("jupyter timed out, check grid stats for log")
                                        pbar.done("time out")
                                    }
                                    else
                                        setTimeout(waiting,1000)
                                }

                            })
                        }
                        pbar.progress(-1,"running")                        
                        setTimeout(waiting,1000);
                    }

                },function() {
                    cnt = 99;
                });


			}
		}
	 },defaulty);

}



function submitSingleJob(job,callback,onabort,timeout)
{
    var grid_entry;
    var cnt = 1;
    var maxcnt = 20;
    if (timeout != undefined)
        maxcnt = timeout

    function kill()
    {
        if (onabort != undefined)
            onabort();
        var jsonString = JSON.stringify([grid_entry.jobid]);
        console.log("job kill request:" + jsonString);
        ajaxRequest('command=kill_job&json=' + jsonString, function(e) {
             updateGridjobTable(); } );        
    }

    var pbar = KProgressBar("submitting", "fa-submit", function() {
        cnt = 99;
        if (grid_entry != undefined)
        {
            console.log(grid_entry);
            kill();
        }
    },true);

    ajaxRequest('command=submit_job&testMode=0&json=' + JSON.stringify([job]), function(ev) {

        if (ev.demonInfo.nosubmit == 1)
        {
            var msg = "Currently no submission possible! Contact system admin."
            if (ev.demonInfo.msg)
              msg = ev.demonInfo.msg;
            alertify.alert(msg);
            return
        }

        setTimeout(waiting,1000)
        function waiting()
        {

            ajaxRequest('command=get_gridstats', function(result) {
                var jobs = result.content
                for (var k in jobs)
                {
                    var j = jobs[k]
                    if (j.jobname.substring(j.jobname.length-job.uid.length)== job.uid)
                    {
                        grid_entry = j;
                        if (j.state == "r")
                        {
                            function logfun(itscallback)
                            {
                                ajaxRequest('command=showlog&logfile=logs/' + encodeURIComponent(j.jobname+".log"),function(ev)
                                {
                                    itscallback(ev)
                                });
                            }
                            function errfun(itscallback)
                            {
                                ajaxRequest('command=showlog&logfile=logs/' + encodeURIComponent(j.jobname+".error"),function(ev)
                                {
                                    itscallback(ev)
                                });
                            }
                            if (callback != undefined)
                                callback(logfun,errfun,pbar);
                            else
                                pbar.done("running")
                            return;
                        }
                        else
                        {
                            pbar.progress(100*cnt/maxcnt,"queued")
                            //console.log("queued " +  j.state);
                        }
                    }
                }
                if (cnt++ > maxcnt)
                {
                    alertify.error("time out, killing queued job")
                    kill();
                    pbar.done("timeout")
                    console.log("timeout")
                    callback();
                }
                else
                    setTimeout(waiting,1000);


                });
        }
    });
}


function popup_jupyter(jobname)
{
        ajaxRequest('command=showlog&logfile=logs/' + encodeURIComponent(jobname+".error"),function(ev)
        {
                var p = ev.content.search("Or copy and paste one of these URLs:")
                if (p > -1)
                {
                                    var response = ev.content.substring(p).split("<br>").map(function(x) {return x.trim()})

                                    var url = response[1]
                                    var x = url.split("/")
                                    //x.splice(3,0,"notebooks/"+nbname)
                                    url = x.join("/")
                                    window.open(url,'_blank')

                    var url = response[1]
                    window.open(url,'_blank');
                }
        });


}