

var scripturl_reading  = window.location.href.substr(0, window.location.href.lastIndexOf('/')) + '/KReading.php' ;


/***************************************************************************************
The reading tool (select a reading, start / stop etc)
***************************************************************************************/
function KReadingTool(master)
{

	var $topBar =   $("<div class='KView_tool '><i class='fa fa-comment-o fa-1x'></i></div>").append( $("<ul class='KView_tool_menu'></ul>").append($("<li>Navigation/Annotation</li>") ));


	var that = new KToolWindow(master, $topBar);
	that.name = 'ReadingTool';

	that.$leftToolistDiv.hide()
	

	//that.customToggle = customToggle ;
	/***************************************************************************************
	Main Menu etc
	****************************************************************************************/
	// remove some of the standard tools first
	that.$topRow.find('.fa-bars').parent().parent().remove();
	var $closebtn = that.$closebtn = that.$topRow.find('.fa-close').parent().parent();

	var $newreadingbutton = that.$newreadingbutton = $("<li class=''><i class='fa fa-plus'></i>&nbsp;Create New Reading</li>").appendTo(that.$topRow);
	$newreadingbutton.click(function(){
		KViewer.formManager.createNewForm()
	});

	var $readinglist = $("<ul></ul>");
	//var $dummy = $("<li><a>Readings</a></li>").append($readinglist).appendTo(that.$topRow);
	var $title = $("<li class='menu_generic_disabled menu_generic_labelname'></li>").appendTo(that.$topRow);
	var $title_header;
	var $title_progress ;
    var $timerDIV; 

	that.state = {};
	that.currentsolution = {};
	that.currentFormItem = -1;

	/***************************************************************************************
	The menu
	****************************************************************************************/
	// to be implemented
	//KViewer.formManager.createNewForm()

	/***************************************************************************************
	Get the reading List from the server and update
	****************************************************************************************/
	that.forms = {};
	var $detachedMode;
 	that.updateReadingsList = function()
 	{
		$readingContainer.empty();
		$welcomeContainer = $("<div class=''></div>").appendTo($readingContainer);
		var $topRow = ( $("<div class='' style='height:20px;font-size:15px;'></div>") ).appendTo($welcomeContainer);
		$topRow.append( $("<span class='' >Select a reading:</span>") );

		var $topOpts= $("<span style='float:right;background:none;font-size:12px'></span>").appendTo($topRow);
		//$detachedMode= $("<input type='checkbox' class='' " + (that.anonymize?"checked":"") + "/>").appendTo($("<label style=''  class=''>start detached</label>").appendTo($topOpts)).click( function(){}  );

		$("<a><span class='' style='margin-left:20px;cursor:pointer;color:gray;'>[Refresh list from Server]</span></a>").appendTo($topOpts).click( function(z) {that.updateReadingsList() } );


		window.setTimeout(function() {
			that.getReadingStatistics({}, that.renderWelcomeWindow)
		},10);
 	}

	/***************************************************************************************
	get statistics from server
	****************************************************************************************/
 	that.statistics = undefined;
 	that.getReadingStatistics = function(obj, whendone)
 	{
		ajaxRequest('command=getReadingProgress&json='+ JSON.stringify({project:currentModule}), function(res)
		{
			//console.log(res.json);
			that.statistics = res.json.stats;
			that.forms = res.json.forms;
			for(var k in that.forms)
			{
				var temp = {};
				temp.id = k;
				temp.content = JSON.parse(that.forms[k]);
				temp.writable = (temp.content && (temp.content.rights[0] == "w" || temp.content.owner == userinfo.username) );
				that.forms[k] = temp;
			}

			if(whendone)
				whendone(res);

		}, scripturl_reading);

 	}

	/***************************************************************************************
	Create Table of Readings for selection
	****************************************************************************************/
	that.renderWelcomeWindow = function()
	{	
		
		var $rtable = $("<table class='KReading_welcometable'></table>").appendTo($welcomeContainer);
			var $row = $("<tr></tr>").appendTo($rtable);
		$("<td></td><td>Test</td><td>Serious</td><td>Detached</td><td></td><td></td><td></td>").appendTo($row);
		$("<td></td><td>Test</td><td>Serious</td><td></td><td></td><td></td>").appendTo($row);

		// sort, and put readings of current module on top
		var ulist = [];
		var ulist = Object.getOwnPropertyNames(that.forms);

		ulist.sort(function(a,b) { 
				if(that.forms[a].content.project == currentModule )
					return -1;
				else if( that.forms[a].content.name < that.forms[b].content.name )	
					return -1;
				else 
					return 1;
			});



		//for(var k in that.forms)
		for(var j=0; j<ulist.length; j++)
		{
			var k=ulist[j];
			var temp = that.forms[k].content;
			if(temp.reading == undefined)
				continue;
			
			var stats = that.statistics[temp.id];
			function renderProgress(mode)
			{
				var progress_perc = Math.round( parseInt(stats[mode].count) / (parseInt(stats[mode].numcases_total)+0.0001) *100);	
				var ptext = stats[mode].count + "/" + stats[mode].numcases_total;
				var $pline = $("<div class='progressrow'><div>"+ ptext + "</div></div>");
				$("<div  class='progressrowbar' ><div style='width:"+ progress_perc  + "%'></div></div>").appendTo($pline);
				return $pline;
			}
			
			var $row = $("<tr></tr>").appendTo($rtable);
			//var $td  = $("<td>"+  temp.id + " " + temp.name + "</td>").appendTo($row);
			var $td  = $("<td><span style='font-weight:normal; font-size:10px; width:15px;display:inline-block;'>"+  temp.id + "</span> " + temp.name + "</td>").appendTo($row);
			//var $td  = $("<td>"+ temp.name +   "<span style='font-weight:normal; font-size:10px;'>  "+  temp.id + " </span> "  + "</td>").appendTo($row);

			if(temp.project != currentModule )
			{
				$td.css('color', 'gray');
				$row.css('opacity', .5);
			}

			var $temp = $("<div class='KReading_button green'></div>").appendTo( $("<td></td>").appendTo($row).click( function(z) { return function(ev){that.selectReading(z, 'mode_training',ev) } }(that.forms[k].id)) ).append( renderProgress('mode_training') );
			var $temp = $("<div class='KReading_button'      ></div>").appendTo( $("<td></td>").appendTo($row).click( function(z) { return function(ev){that.selectReading(z, 'mode_serious', ev)} }(that.forms[k].id)) ).append( renderProgress('mode_serious') );

			var $temp = $("<div class='KReading_button orange'      ></div>").appendTo( $("<td></td>").appendTo($row).click( function(z) { return function(ev){that.selectReading(z, 'mode_serious',1 )} }(that.forms[k].id)) ).append( renderProgress('mode_serious') );
			
			$("<td><div class='KReading_button darkgray'><i class='fa fa-fw  fa-info-circle'></i><span>"+ "" +"</span></div></td>").appendTo($row).click( function(z) { return function(ev){that.showInstruction(z)} }(that.forms[k].id));

			if( isadmin || projectInfo.role == 'admin' || that.forms[k].writable == true )
			{
				$row.append($("<td> <i class=' fa fa-fw  fa-wrench'></td>").click(function(k) { return function(e) 
				{  new KFormDesigner(that.forms[k]); } }(k) ) );
				$row.append($("<td> <i class=' fa fa-fw  fa-list'></td>").click(function(k) { return function(e) 
				{  that.getResultsSummary(that.forms[k], k); } }(k) ) );
			}
			
			$("<td style='width:100%'></td>").appendTo($row);

		}
	}


	
	var $readingContainer = $("<div class='KReading_container'></div>").appendTo(that.$container);
	
	var $welcomeContainer

	/***************************************************************************************
	Create the Buttons Layout and buttons
	****************************************************************************************/
	var $caseInfo, $caseForm, $readingTopRow, $caseSolution;
	var $nextUnratedCaseButton, $resolveCaseButton, $resetThisCaseButton, $pauseButton, $stopReading, $showInstructionButton, $restartButton, $prevCaseButton, $nextCaseButton, $saveCaseResultsButton, $readingTools_admin
	that.renderReadingBody = function()
	{	
		$readingContainer.empty();
		$readingTopRow = ( $("<div class='KReading_topRow'></div>") ).appendTo($readingContainer);
		$caseInfo = ( $("<div class='KReading_caseInfo'></div>") ).appendTo($readingContainer);
		$caseSolution = ( $("<div class='KReading_caseSolution'></div>") ).appendTo($readingContainer).hide();
		$caseForm=  ( $("<div class='KFormVertical'></div>") ).appendTo($readingContainer);

		var $readingTools = $("<div class='KReading_tools'></div>").appendTo($readingContainer);
			$nextUnratedCaseButton = ($("<div class='KReading_button green' ><i class=' fa fa-play'></i>Next</div>").click(function(){ that.gotoCase('nextunrated'); }) ).appendTo($readingTools);
			$resolveCaseButton = ($("<div class='KReading_button green' ><i class=' fa fa-check'></i>Submit</div>").click(function(){ that.resolveCase(''); }) ).appendTo($readingTools).hide();

			$resetThisCaseButton = ($("<div class='KReading_button blue' ><i class=' fa fa-refresh'></i>Reload</div>").click(function(){ that.reload_rdef(); }) ).appendTo($readingTools);
			$pauseButton = ($("<div class='KReading_button ' ><i class=' fa fa-coffee'></i>Pause</div>").click(function(){ that.togglePause(); }) ).appendTo($readingTools);
			$stopReading = ($("<div class='KReading_button orange' ><i class='fa fa-power-off'></i>Quit</div>").click(function(){ that.stopReading(); }) ).appendTo($readingTools);
			$showInstructionButton = ($("<div class='KReading_button darkgray' >Instruction</div>") ).click(function(){ that.showInstruction(); }).appendTo($readingTools);

			if(rdef.currentmode=='mode_training' && rdef.reading.allowRestartOfTraining)
				$restartButton = ($("<div class='KReading_button red' ><i class=' fa fa-warning'></i>Restart</div>") ).click(function(){ that.restartReading(); }).appendTo($readingTools);
			
			if(rdef.currentmode=='mode_serious' && rdef.reading.allowRestartOfSerious)
				$restartButton = ($("<div class='KReading_button red' ><i class=' fa fa-warning'></i>Restart</div>") ).click(function(){ that.restartReading(); }).appendTo($readingTools);

			$prevCaseButton = ($("<div class='KReading_button gray' ><i class=' fa fa-step-backward'></i>TPrev</div>").click(function(){ that.gotoCase('prev'); }) ).appendTo($readingTools);
			$nextCaseButton = ($("<div class='KReading_button gray' ><i class=' fa fa-step-forward'></i>TNext</div>").click(function(){ that.gotoCase('next'); }) ).appendTo($readingTools);
			if (!(isadmin | rdef.reading.allowPatientBrowsing))
			{
				$prevCaseButton.hide();
				$nextCaseButton.hide();
			}
			$saveCaseResultsButton = ($("<div class='KReading_button green' ><i class=' fa fa-save'></i>Save case</div>").click(function(){ that.saveCaseResults(); alertify.success("cases saved successfully.");}) ).appendTo($readingTools);

			$readingTools_admin = $("<div class='KReading_tools'></div>").appendTo($readingContainer);
			
			if(isadmin)
			{
				//var $saveCaseResultsButton_random = ($("<div class='KReading_button yellow' ><i class=' fa fa-save'></i>Save Rand</div>").click(function(){ that.saveCaseResults(undefined, undefined, {saverandoms:true}); }) ).appendTo($readingTools_admin);
				that.$whoami = $("<select class='KReading_button'>"
						+ "<option value='"+ userinfo.username + "'>"+ userinfo.username + " </option>"
						+ "<option value='#rand#' "+ (that.state.whoami=='#rand#'?"selected":"") +" >#rand#</option>"
						+ "<option value='#teacher#' "+ (that.state.whoami=='#teacher#'?"selected":"") +" >#teacher#</option>"
						+"</select>").appendTo($readingTools_admin).click(function(){ that.state.whoami=that.$whoami.val() });	


			}			
			if(isadmin || that.forms[rdef.formid].writable == true)
			{
				var $configButton = $("<div class='KReading_button KReading_button_edit gray' ><i class=' fa fa-fw  fa-wrench'></i>Config</div>").click(function(){ new KFormDesigner(that.forms[rdef.formid])}).appendTo($readingTools_admin);
				var $resultsButton = $("<div class='KReading_button gray' ><i class=' fa fa-fw  fa-list'></i>Results</div>").click(function(){ that.getResultsSummary(that.forms[rdef.formid], rdef.formid) }).appendTo($readingTools_admin);
			}


			//var $devtool = ($("<div class='' ><i class='fa fa-exchange'></i>debug</div>").click(function(){ that.devtool(); }) ).appendTo($readingTools);


	}

 

	
	/***************************************************************************************
	the case structure: this is essentially the dbrow (with all relevant info)
	****************************************************************************************/
	function createEmtpyCase()
	{
		var dbrow = 
		{
			user:userinfo.username,
			formid: rform==undefined?undefined:rform.id,
			//reading: rdef==undefined?undefined:rdef.readingname,
 			patients_id:undefined,
 			studies_id:undefined,
			timestamp: createSQLDate(),
			duration:  0,
			repetition:0,
			iterator: 1,
			json: "{}",
		}
		
		var results = 
		{
			formcontent: {},
			rois:{},
			annotations:{}
		}

		var out = 
		{
			dbrow:dbrow,
			patientinfo:{},
			progress:{},
			results:results
		}
		return out;
	};

	
	/***************************************************************************************
	objects
	****************************************************************************************/
	var ccase = createEmtpyCase();
	
	var rdef;
	var rform;

	that.timerobj = undefined;
	that.markerset = undefined;


	/***************************************************************************************
	select a reading
	****************************************************************************************/
	var lastviewport = -2;
	that.selectReading = function(id, mode, ev)
	{
		var detachedMode = ((ev && ev.ctrlKey) || ev===1)

		function superwhendone()
		{
			if(that.readingIsActive)
				that.stopReading();

			that.selectReading_helper(id,mode, 0, detachedMode)
		}

		if(  that.forms[id].content.project !== currentModule )
		{
			//alertify.alert('The reading "' + that.forms[id].content.name + '"" is associated with project "' + that.forms[id].content.project+ '". Please select that project first. '  );
			//return;
			selectProject(that.forms[id].content.project, superwhendone)
		}
		else
		{
			superwhendone();
		}

	}

	/***************************************************************************************
	Set the reading Def
	****************************************************************************************/
	that.selectReading_helper = function(id, mode, reloadOnly, detachedMode)
	{
			
		function whenloaded(res)
		{
			that.forms = res;
			//that.setReadingDef(id, res,mode)


			rform = $.extend(true, {}, that.forms[id].content);
			rdef  = rform.reading;
			that.rdef = rdef;
			rdef.readingname = that.forms[id].content.name;
			rdef.formid = id;

			rdef.currentmode = mode || rdef.currentmode;
				
			
			// set this into another viewport defined by rdef?
			lastviewport = that.tstate.target;
			that.show( rdef.reading.viewport );

			that.renderReadingBody();
			$title.html("");
			$title_header   = $("<span></span>").appendTo($title);
			$title_progress = $("<span></span>").appendTo($title);	
    	    $timerDIV 	     = $("<span class=''></spam>" ).appendTo($title);



			var template = KReadingTool_templateDefintion();


			// extend the template with rdef reading
			rdef.reading = $.extend(true, template.reading, rdef.reading  );
			
			// do NOT extend the autoloaders of the template
			template.viewer.autoloaders = [];

			// extend the template with viewer
			rdef.viewer = $.extend(true, template.viewer, rdef.viewer   );

			// for training mode, take serious mode as basis and extend the training so we have all necessary variables set
			rdef.reading.mode_training = $.extend(true, $.extend(true, {}, rdef.reading.mode_serious), rdef.reading.mode_training);

			if(rdef.reading.jointreading)
				var joint = "JOINT - ";
			else
				var joint = "";

			if(detachedMode)
				joint = " DETACHED - " +joint;

			$title_header.html( '<b> ' + that.forms[id].content.name + " - " + joint +  rdef.currentmode.substr(5) + " </b>") ;
			$caseInfo.html("Click 'next / reload' or click on a patient in table to start.")

			/***************************************************************************************
			current user- state variables of the reading
			****************************************************************************************/
			// put this into the main structure
			rdef.showothers = (rdef.reading[rdef.currentmode].showothers),
			that.state = 
			{
				showothers: rdef.showothers.when,
				whoami: that.state.whoami || userinfo.username
			}

			
			that.detachedMode = detachedMode;
			
			// start it
			if(reloadOnly)
				that.selectCase();
			else
				that.startReading();
			
			if(detachedMode)
			{
				that.detachedMode = rdef;
				rdef.viewer.autoloaders	= [];
				that.buttonsVisible = $readingContainer.find('.KReading_button:visible');
				that.buttonsVisible.hide();

				$saveCaseResultsButton.show();
				$stopReading.show();
				$resetThisCaseButton.show();

				(".KReading_button_edit").show;
				//$("#patientTableEditMode").show();
				$prevCaseButton.show();
				$nextCaseButton.show();
				if(isadmin)
					$readingTools_admin.children().show();

			}
		}

		// refresh all reading structures from server first (maybe it changed)
		jsonTable_loadFormattedList('form', whenloaded);

	}

	/***************************************************************************************
	Reload Reading def
	****************************************************************************************/
	that.reload_rdef = function()
	{

		that.selectReading_helper(rdef.formid, rdef.currentmode, 1, that.detachedMode)
		
		/*
		state.viewer = $.extend(true, {}, rdef.viewer);
		stateManager.applyState(state);
		*/
	}


	/***************************************************************************************
	Render current case
	****************************************************************************************/
	that.setCase = function()
	{

		// confirmations that must be made before submit
		that.confirmations = {}; 
		ccase.time_started = new Date().getTime() / 1000;

		$readingTopRow.empty();
		$caseForm.empty();
		var props = rdef.reading[rdef.currentmode];

		/***************************************************
		General progress, case and patient info
		****************************************************/	  
		var percentage = Math.round(ccase.progress.numcases_rated/ccase.progress.numcases_total*100);
		$title_progress.html("&nbsp|&nbsp" + (parseInt(ccase.progress.numcases_rated)+1) + '/' + ccase.progress.numcases_total + " ("+percentage +"%) | &nbsp" ); 

		if(ccase.patientinfo.patients_id == undefined )
			return
			
		if(props.show_timer)
		{
			if (that.timerobj != undefined)
				clearInterval(that.timerobj);
			$timerDIV.text("0s");	
			that.timerobj = window.setInterval(function(){
				$timerDIV.text("" + Math.round(new Date().getTime() / 1000 - ccase.time_started) + "s");
			},1000)
		}
		
		function setPatientInfo()
		{
			$caseInfo.empty();
			for(var a in props.showmetafields)
			  if(props.showmetafields[a])
				$caseInfo.append($("<div>" + a + ": "  + ccase.patientinfo[a]  +"</div>" ) );
			if(ccase.isOccupied)
			{
				$caseInfo.append($("<div style='background:red;'>"+ " Case is currently occupied by <b>" + ccase.dbrow.user +"<b>. Please go to another case.</div>" ))
				return;
			}
			if(ccase.hasPreviousResults)
			{
				$caseInfo.append($("<span style='background:green;float:right'>"+ "&nbsp rated by <b>" + ccase.dbrow.user +"<b> &nbsp </span>" ) );
			}

			if(props.showSexAndAge == 'sex_and_age')
			{

				var bd = ccase.patientinfo.BirthDate;
				if(bd && bd.length == 8)
					var age = (new Date().getFullYear() - parseInt( bd.substr(0,4) ))+' years';
				else
					var age = "-- years";

				var sex =  ccase.patientinfo.Sex.length == 0?'--':ccase.patientinfo.Sex;

				var sexandage = "" + sex + " / " + age;
				$caseInfo.append($("<div>"   + sexandage  + "</div>" ) );	
			}

			var $useroptions= $("<div class='KReading_tools_small' style='position:absolute;right:20px;top:50px;color:hsl(0,0%,50%);font-size:11px;'></div>").appendTo($caseInfo) ;

			if(props.showName)
			{
				if(!that.anonymize)
					var namestr = ccase.patientinfo.FamilyName + ', '+ccase.patientinfo.GivenName;
				else
					var namestr = "Smith, John";
				$caseInfo.append($("<div class=''>" + namestr +"</div>" ) )

				
				//var $anonymize= $("<input type='checkbox' class='' " + (that.anonymize?"checked":"") + "/>").appendTo($("<label class=''>anonymize</label>").appendTo($useroptions)).click( function(){toggleAnonymization()}  );

				function toggleAnonymization()
				{
					that.anonymize = !that.anonymize;
					switchAnonym(that.anonymize)
					setPatientInfo();
				}
			}
			
			

				function setShowOthers(newstate)
				{
					if(newstate!=undefined)
						that.state.showothers = newstate;
					if(that.markerset_others)
					{
						if(that.state.showothers && rdef.showothers.showmarkerpanel)
							that.markerset_others.markerPanel.show();
						else
							that.markerset_others.markerPanel.hide();
					}
				}

			if( rdef.showothers.when == 1  )
			{
				var $showothers= $("<input type='checkbox' "+ (that.state.showothers?"checked":"")  +" class='' />").appendTo($("<label class=''>show other raters</label>").appendTo($useroptions)).click( function(){setShowOthers(!that.state.showothers)}  );
				setShowOthers();
			}
			else if( rdef.showothers.when == 2  )
			{
				if(that.markerset_others && that.markerset_others.markerPanel)
					that.markerset_others.markerPanel.hide();
			}
			

			/***************************************************
			Admin info
			****************************************************/	  
			if(projectInfo.role == 'admin')
			{
				//$caseInfo.append($("<div class=''>psid: " + ccase.dbrow.patients_id +"  :  "+ ccase.dbrow.studies_id   + "</div>" ) )
				//$caseInfo.append($("<div class=''>Repetition: "+ ccase.dbrow.repetition+"</div>" ) )
				//$caseInfo.append($("<div class=''>Iterator: "+ ccase.dbrow.iterator+"</div>" ) )
			}

		}

		setPatientInfo();



		/****************************************************
		Form
		****************************************************/	  
		var formcontent = KForm.getFormContent( rform ,ccase.results.formcontent);
		KForm.createForm(rform, formcontent , $caseForm,  function(){});

		// arrow shortcuts are reserverd, prevent them from changing something!
		$caseForm.find('input[type!="text"]').on('keydown', function(ev){ return false });
		
		that.currentFormItem = -1;
		
		if(that.markerset_others != undefined)
			that.markerset_others.deleteAllPoints();

		/****************************************************
		Show results from other raters / the ground truth
		****************************************************/	  
		if(ccase.results_others && rdef.showothers.when && rdef.showothers.showforms && that.state.showothers)
		{	
			/****************************************************
			Forms
			****************************************************/	  
			that.currentsolution = {};

			function parseline(tline) {  var out;
				try        { out = JSON.parse(tline);			}
				catch (err){console.log(err); 			}
				return out;			}

			var histos = {};
			// parse all jsons
			for(var k=0; k < ccase.results_others.length; k++)
			{
				ccase.results_others[k].json  = parseline(ccase.results_others[k].json);
			}

			for(var f=0; f<rform.layout.length; f++)
			{
				var name = rform.layout[f].name;
				var ids = rform.layout[f].ids;
				if(ids==undefined)
					continue;
				var $ctarget = $caseForm.find( "[name='" + rform.layout[f].name +  "']" );
				histos[name] = {};
				var count = 0;	
				$items = [];
				for(var z=0; z<ids.length; z++)
				{
					for(var k=0; k < ccase.results_others.length; k++)
					{
						if(ccase.results_others[k].user == userinfo.username)
							continue;
						if(histos[name][ids[z]]==undefined)
							histos[name][ids[z]] = 0;
						var xval = ccase.results_others[k].json.formcontent[name];
						if(xval != undefined)
						{
							if(ids[z] == xval)
							{
								histos[name][ids[z]]++;
								count++;
							}	
						}
					}
				}
				if(count > 0 )  // show all raters percentage as number
				{
					// future: must distinguish between counting own previous answers or not, repetitions, stage etc
					for(var z=0; z<ids.length; z++)
					{
						var $xtarget = $ctarget.find( "input[value='" +ids[z]+  "']" ).parent();
						var perc = ((histos[name][ids[z]] / count)*100).toFixed(0) + "";
						var $statsbar = $("<div class='KReading_livestats'>"+ "" +"</div>").hide();
						//if(rdef.showothers.users!='#teacher#')
						if(ccase.results_others.length > 1) // for many other raters, show percentage
							$statsbar.text(perc);

						$items.push($statsbar);
						$xtarget.append($statsbar); 	
					}
					var maxind = 0;
					for(var z=0; z<ids.length; z++)
						if(histos[name][ids[z]] > histos[name][ids[maxind]])
							var maxind = z;
					$items[maxind].addClass( 'KReading_livestats_max'  )

					that.currentsolution[name] = rform.layout[f].ids[maxind];		
				}
			}
			if(rdef.showothers.when == 1 )
			{
				// cannot resolve immediately
				//that.resolveCase() 
				$('.KReading_livestats').show();
			}


			/****************************************************
			Markersets
			****************************************************/	  

			// collect all annos in one, prepend username
			var stacked = undefined;
			if(rdef.showothers.when && rdef.showothers.showannotations && that.state.showothers)
			{
				for(var k=0; k < ccase.results_others.length; k++)
				{
					if(ccase.results_others[k].user == userinfo.username)
						continue

					if(Array.isArray(ccase.results_others[k].json.annotations) && ccase.results_others[k].json.annotations.length > 0)
					{
							function addpoints(stacked, obj, points )
							{
								for(var p=0; p<points.length; p++ ) 
								{
									points[p].name = ccase.results_others[k].user + "_" + points[p].name;
									points[p].color = "#00BBBB88";
									stacked[0].points.push( points[p] );
								}
							}

						if(stacked == undefined )
							stacked = ccase.results_others[k].json.annotations;

						addpoints(stacked, ccase.results_others[k], ccase.results_others[k].json.annotations[0].points.splice(0) );
					}
				}
			}
			
			if(stacked != undefined )
			{
				that.markerset_others = markerProxy.import( stacked, that.markerset_others );// we pass that.markerset, so it will be "reused"
				that.markerset_others.setState(that.markerset_others.state_initial);

			}
			
		}
		
		if(that.markerset_others &&rdef.showothers.showmarkerpanel && rdef.showothers.when == 0 )
			that.markerset_others.markerPanel.hide();
		if(that.markerset_others && rdef.showothers.showmarkerpanel && rdef.showothers.when  == 1) // show always
			that.markerset_others.markerPanel.show();

		
		if(rdef.showothers.when  == 2 ) // show only after submit
		{
			if(rdef.tools.markers.enabled)
				that.markerset_others.markerPanel.hide();
			$caseSolution.empty().show();
			$nextUnratedCaseButton.hide();
			$resolveCaseButton.show();
			$resetThisCaseButton.css('visibility', '');
			//$resetThisCaseButton.hide();
			//$pauseButton.hide();
			//$restartButton.hide()
			if($prevCaseButton)
			{
				$prevCaseButton.hide();
				$nextCaseButton.hide();
			}

		}


	}
	/* end render case */

	
	/***************************************************************************************
	Save the result, but do not finalize case, (intermediate, or for having a break or so)
	****************************************************************************************/
	that.saveCaseResults = function(nextCaseID, callback)
	{
		// what to do after case is saved?
		function whendone(res)
		{
			markerProxy.modified = false;
			if(callback)
				callback(res);

			markerProxy.modified = false;

		}
		
		// check if all required fields have been filled out
		var notFilledReqFields= [];
		var rflag = rdef.reading[rdef.currentmode].required_flag
		if(rflag != 0) // -1: as in form, 0: disable for all, 1 enable for all
		{
			for(var f in rform.layout)
			{
				if(rform.layout[f].required || rflag == 1)
				{
					if(rform.layout[f].type=='rating')
					{
						var $array = $caseForm.find( "[name='" + rform.layout[f].name +  "']" )
						var $rows = $array.find('tr')
						for(var i=1;i<$rows.length;i++)
						{
							var isfilled = $rows.eq(i).find('input:checked').length;
							if(!isfilled)
							{
								notFilledReqFields.push([rform.layout[f].name,  $rows.eq(i)]);
								 $rows.eq(i).css('background', 'red');
							}
							else
							{
								 $rows.eq(i).css('background', 'initial');
							}
						}
					}
					else
					{
						var $array = $caseForm.find( "[name='" + rform.layout[f].name +  "']" )
						if(rform.layout[f].type == "input")
						{
							var isfilled = ccase.results.formcontent[rform.layout[f].name].length;
						}
						else
						{
							var $selected = $array.find('input:checked');
							var isfilled = $selected.length;
						}
						if(isfilled == 0)
						{
							notFilledReqFields.push([rform.layout[f].name, $array]);
							$array.css('background', 'red');
						}
						else
						{
							$array.css('background', 'initial');
						}
					}
				} // end if
			} // end for
		}
		
		
		if(notFilledReqFields.length > 0 )
			return;

		if(that.markerset != undefined) 
		{
			if( Object.getOwnPropertyNames(that.markerset.markerpoints).length > 0 ) 
				ccase.results.annotations = [that.markerset.objectify()];
			else
				ccase.results.annotations = {};
			markerProxy.modified = false;
		}

		var cres = ccase.results;
				
		// set relevant fields before saving to database
		ccase.dbrow.json = JSON.stringify(cres);


		// keep first timestamp
		if(ccase.dbrow.timestamp != null)
			ccase.dbrow.timestamp = createSQLDate();

		// keep first time
		if(ccase.dbrow.duration <= 0)
			ccase.dbrow.duration = Math.round( (new Date().getTime() / 1000 - ccase.time_started)*100) /100; 

		
		var obj = 
		{
			dbrow:ccase.dbrow,
			rdef:rdef,
			patients_id: ccase.dbrow.patients_id,
			studies_id:  ccase.dbrow.studies_id,
			project: 	currentModule,
			nextCaseID: nextCaseID
		}

		// create random results (for the teaching)
		if( that.$whoami && that.$whoami.val() == '#rand#' )
		{
			var tlist = [];
			var temp = ccase.dbrow; 
			var nrandoms = 5;
			for(var z=0;z<nrandoms; z++)
				tlist.push(createRandomAnswer(temp,z+1));
			obj.dbrow_randomlist = tlist;
		}
		else if( that.$whoami && that.$whoami.val() == '#teacher#' )
		{
			//obj.dbrow = $.extend(true, {}, ccase.dbrow);	
			//delete obj.dbrow.ID;
			obj.dbrow.user = '#teacher#';
		}
		
		// for next case selection
		if(that.$whoami && that.$whoami.val() != userinfo.username)
			obj.whoami = that.state.whoami;


		function createRandomAnswer(dbrow,ind)
		{	
			dbrow = $.extend(true, {}, ccase.dbrow);	
			delete dbrow.ID;
			dbrow.user =  that.$whoami.val() + (ind || Math.round(Math.random()*100));
			var temp = $.extend(true, {}, ccase.results); temp.formcontent  = KForm.getFormContentRandom(rform);
			// randomize annotations
			for(var k=0; k<temp.annotations.length; k++)
			{
				var a=temp.annotations[k];
				for(var p=0; p<a.points.length; p++)
				{
					for(var x=0; x<3; x++)
						a.points[p].coords[x] +=  Math.random()*10;
					if(a.points[p].subpoints)
					{
						for(var s=0; s<a.points[p].subpoints.length; s++)
						{
							for(var x=0; x<3; x++)
								a.points[p].subpoints[s][x] += Math.random()*10;
						
						}
					}
				}

			}

			dbrow.json = JSON.stringify(temp);
			return dbrow;
		}


		//***************** useastag ******************
		obj.tagstoremove = [];
		obj.tagstoadd = [];
		for(var f in rform.layout)
		{
			if(rform.layout[f].useastag)
			{
				var val = ccase.results.formcontent[rform.layout[f].name];
				if(rform.layout[f].type == 'check')
				{
					if(val)	
						obj.tagstoadd.push(rform.layout[f].name);
					else
						obj.tagstoremove.push(rform.layout[f].name);
				}
				else
				{
					// can use individual radio items as tags, are exclusive
					var ids = rform.layout[f].ids;
					for(var z=0; z<ids.length; z++)
					{
						if(ids[z] != val)
						{
							obj.tagstoremove.push(ids[z])
						}
						else
						{
							obj.tagstoadd.push(ids[z]);
						}
					}
				}
					
			}
		}

		// append tags in frontend, without backend. 
		// backend add tag will be performed in saveCaseResults of KReading.php !!!!!
		if(obj.patients_id != undefined)
		{
			if(obj.tagstoadd.length  || obj.tagstoremove.length > 0)
			{
				if(state.viewer.selectionMode[1] == 'p')
					tempObjectInfo = [{type: 'patient', piz: obj.patients_id}]
				else if(state.viewer.selectionMode[1] == 's')
					tempObjectInfo = [{type: 'study', piz: obj.patients_id, sid: obj.studies_id}]


				for(var k=0; k<obj.tagstoadd.length; k++)
					modifyTag(obj.tagstoadd[k],"", 1)

				for(var k=0; k<obj.tagstoremove.length; k++)
					modifyTag(obj.tagstoremove[k],"_del", 1)

				delete tempObjectInfo;
			}
		}

		if(obj.tagstoadd.length==0)
			delete obj.tagstoadd;
		if(obj.tagstoremove.length==0)
			delete obj.tagstoremove;

		
		ajaxRequest('command=saveCaseResults&json='+ JSON.stringify(obj), whendone,  scripturl_reading);
	}



	/***************************************************************************************
	Save case results and resolve solution 
	****************************************************************************************/
	that.resolveCase = function()
	{
		// show the form answers,  markers / rois an overall rating message
		$nextUnratedCaseButton.show();
		if(rdef.showothers.when == 2)
		{
			$resolveCaseButton.hide()
			if(!isadmin)
				$resetThisCaseButton.css('visibility', 'hidden');
			
			if($prevCaseButton)
			{
				$prevCaseButton.show();
				$nextCaseButton.show();
			}

		}
		if( that.$whoami && that.$whoami.val() == '#teacher#' )
		{
			that.gotoCase('nextunrated'); 
		}
		// find overall rating / answer was correct?
		var performance = 0;
		var count = 0;
		for(var f=0; f<rform.layout.length; f++)
		{
				var name = rform.layout[f].name;
				var $ctarget = $caseForm.find( "[name='" + rform.layout[f].name +  "']" );
				var $xtarget = $ctarget.find( "input[value='" + ccase.results.formcontent[name] +  "']" ).next();
				if( rform.layout[f].choices != undefined && that.currentsolution[name] !=undefined && ccase.results.formcontent[name]  == that.currentsolution[name])
				{
					performance++ ;
					//if(rdef.showothers.users=='#teacher#')
					$xtarget.css('background', 'green'); 
				}
				else
				{
					$xtarget.css('background', 'rgb(200,0,0)'); 
				}
				if(that.currentsolution[name] != undefined)
					count++;

		}
		
		//if(performance/count > .51)
		if(rdef.showothers.users=='#teacher#')
			var crit = 1;
		else
			var crit = .51;

		if(performance/count >= crit )
		{
			var msg = "Well done! Good answers!"
			var xclass = "KReading_caseSolution_goodperformance"
		}
		else
		{
			var msg  = "Buuuh! Bad performance! Go home!"
			var xclass = "KReading_caseSolution_badperformance"
		}
		
		var $div = $("<div class='"+xclass+"'>"+msg+"</div>").hide();
		$caseSolution.empty();		
		$caseSolution.append($div); 
		$div.slideDown();
		$('.KReading_livestats').show();
		
		$caseSolution.show();
		
		if(rdef.tools.markers.enabled && rdef.showothers.when && rdef.showothers.showmarkerpanel)
			that.markerset_others.markerPanel.show();		
		
		if (that.timerobj != undefined)
			clearInterval(that.timerobj);


	
		
	}

	
	/***************************************************************************************
	Goto to case case 
	****************************************************************************************/
	that.gotoCase = function(nextCaseID)
	{
		// if detachedMode, use the patient table handler, otherwise different way
		if(that.detachedMode && nextCaseID != "nextunrated")
		{
			if(nextCaseID == 'next')
				patientTable_gotoRow(1)
			if(nextCaseID == 'prev')
				patientTable_gotoRow(-1)
		}
		else
		{
			if(!that.readingIsActive)
				that.startReading();
	
			// save before proceeding to next?
			if(ccase.patientinfo.patients_id != undefined)
			{
				// do not save if currently occupied
				if(!ccase.isOccupied)
					that.saveCaseResults(nextCaseID, that.selectCaseFromAjaxReturn );
			}
			else
			{
				that.selectCase(nextCaseID);
			}

		}

	}


	/***************************************************************************************
	select (reload) a case
	****************************************************************************************/
	that.selectCaseFromAjaxReturn = function(res)
	{
		//************** existing results for THIS user
		var theresults;
		if(res.json.dbrow.json)
		{
			try
			{
				theresults = JSON.parse(res.json.dbrow.json);
				//console.log(theresults);
				delete res.json.dbrow.json;
			}
			catch(err)
			{
				console.log(err);
			}
		}
		
		if(res.json.patientinfo == null)
			delete res.json.patientinfo;
		
		ccase = $.extend(true, createEmtpyCase(), res.json);
		that.ccase = ccase;

		// check if we are done
		if( res.json.progress.numcases_rated >= res.json.progress.numcases_total && parseInt(res.json.rownum_in_ptable) > res.json.progress.numcases_total-1)
		{
			$caseSolution.empty();
			that.setCase();

			if(that.timerobj)
				clearInterval(that.timerobj);
			if(rdef.reading.allowPatientBrowsing)
			{
				$caseInfo.html('<span style="font-size:18px">All cases rated. You can still change them, clicking on case and using TPrev/TNext.</span>')
			    //var $first = ($("<div class='KReading_button green' ><i class=' fa fa-play'></i>First</div>").click(function(){ that.gotoCase('1'); }) );
				//$nextUnratedCaseButton.replaceWith($first)
				return;
			}
			else
			{
				$caseInfo.html('<span style="font-size:18px">Well done! Reading finished!</span>')
				return;
			}
		}

		// nothing to do without a valid patient id
		if(ccase.patientinfo.patients_id == undefined )
		{
			$caseSolution.empty();
			that.setCase();
			$caseInfo.html('<span style="font-size:18px">Something went wrong. No case found, case occupied, or you are done.</span>')
			return
		}

		// if previous results have been stored in dbrow, extend
		if(theresults)
		{
			ccase.results = $.extend(true, ccase.results, theresults);
			ccase.hasPreviousResults = true;
			// case is currently read by another user
		}
		if(ccase.dbrow.user && ccase.dbrow.user != userinfo.username && ccase.dbrow.duration == -1)
			ccase.isOccupied = 1;			

		// if previous results have been stored in dbrow, extend
		ccase.results_others = res.json.dbrow_others;

		// handle patient table stuff
		var psid = ccase.patientinfo.patients_id ;
		if(ccase.patientinfo.studies_id != undefined)
			psid+= (riddelim + ccase.patientinfo.studies_id);
		
		ccase.psid = psid;

		var offset_new = Math.floor(parseInt(res.json.rownum_in_ptable ) / parseInt(state.viewer.numberDisplayedItems)  )*parseInt(state.viewer.numberDisplayedItems) ;
		//var offset_new = parseInt(res.json.rownum_in_ptable ) %  parseInt(state.viewer.numberDisplayedItems) ;
		if(offset_new > Math.floor(parseInt(res.json.progress.numcases_total) ))
			offset_new 	= 0;
		
		// open tree item of case
		if(!that.detachedMode)
		{
			if(state.viewer.displayOffset != offset_new ) 
			{
				state.viewer.displayOffset = offset_new;
				refreshButton( function(){patientTableMirror.tree_single_toggle_default(psid, 1, function(){}, 1)} );
			}
			else
			{
				patientTableMirror.tree_single_toggle_default(psid, 1, function(){}, 1)
			}
		}
		else
        {
				patientTableMirror.tree_single_toggle_default(psid, 1, function(){}, 1)
        }
		
		// unfortunatley, must reset the markerset in markerTool
		if(rdef.tools.markers.enabled & that.markerset !=undefined)
		{
			markerProxy.appendSet(that.markerset, true );
			markerProxy.appendSet(that.markerset_others, false );
		}

		// find all markersets created by readingform and close
		var openSets = KForm.findFormItem(rform, "type", "markerset");
		for(var z=0; z<openSets.length; z++)
			if(markerProxy.markersets[openSets[z]])
				markerProxy.markersets[openSets[z]].deleteAllPoints();
		
		if(that.markerset != undefined)
			that.markerset.deleteAllPoints();

		if(that.detachedMode)
			var autoloaders = state.viewer.autoloaders
		else
			var autoloaders = rdef.viewer.autoloaders


		if(autoloaders)// && autoloaders.length > 0 )
		{	
			// do not close the markers
			function when_autoloaded()
			{
				// set the info for the case, prepare the form etc
				that.setCase()

			}
			startAutoloader(autoloaders, {piz:ccase.patientinfo.patients_id, sid:ccase.patientinfo.studies_id}, undefined, when_autoloaded);
		}
		else
		{
			// set the info for the case, prepare the form etc
			that.setCase()
		}



		// load previous annotation results, push into the markerpanel of this reading
		if(rdef.tools.markers.enabled && ccase.results.annotations)
		{
			
			that.markerset = markerProxy.import( ccase.results.annotations, that.markerset );// we pass that.markerset, so it will be "reused"
			that.markerset.drawAllPoints();
		}			
	}


	/***************************************************************************************
	select (reload) a case by ajax query
	****************************************************************************************/
	that.selectCase = function(nextCaseID)
	{	
		if(nextCaseID == undefined)
			var nextCaseID = patientTableMirror.getCurrentUniquePSID();

		// why ???
		/*
		if( typeof(psid) == "string" )
			nextCaseID = psid;
		else
			nextCaseID = "current";
		*/

		var obj = 
		{
			project:currentModule,
			rdef:rdef,
			//patients_id: psid.patients_id || "nopid",
			//studies_id:  psid.studies_id  || "nosid",
			nextCaseID: nextCaseID
		}
		
		if(that.$whoami && that.$whoami.val() != userinfo.username)
			obj.whoami = that.state.whoami;

		markerProxy.modified = false;
		// workaround, need to escape special chars in help links, otherwise php json decode will fail
		var xstr = JSON.stringify(obj).replace(/&/g, '');
		ajaxRequest('command=selectCase&json='+ xstr, that.selectCaseFromAjaxReturn,  scripturl_reading);

	}



	/***************************************************************************************
	Have a pause / break 
	****************************************************************************************/
	that.togglePause = function()
	{
		var pauseStartTime = Date.now();
		if (that.timerobj != undefined)
			clearInterval(that.timerobj);
		var $pauseDIV = $("<div class='KReading_dialog' >Have a break ...<br /> <br /> <br /> <i class='fa fa-coffee fa-5x'></i><br /> <br /> <br /> <span style='font-size:19px;padding:20px'>Click to continue</span> </div>").appendTo(document.body);
		$pauseDIV.click(function()
		{
			$pauseDIV.remove();
			ccase.time_started += (Date.now() - pauseStartTime)/1000;
	 		that.timerobj = window.setInterval(function(){  
	 		if($timerDIV) 
	 			$timerDIV.text(" " + Math.round(new Date().getTime() / 1000 - ccase.time_started) + " s");  
	 			},1000)

		});
		return $pauseDIV;

	}



	/***************************************************************************************
	Start reading
	****************************************************************************************/
	that.oldstate = state;

	that.startReading = function()
	{

		/****************************************************
		Prepare Tools: markers, rois, etc
		****************************************************/	  
		if(rdef.tools.markers.enabled)
		{
			var mtool = rdef.tools.markers;

			// a markerset for the groundtruth / all other ratings
			var optsgt = $.extend(true, {}, mtool.options); 
				optsgt.name = "other_raters"; 
				delete optsgt.templates;
				optsgt.state.cyclecolors = 0;
				optsgt.state.locked = 1;
				optsgt.state.createonclick = false;
				optsgt.state.keepalive = true;

			that.markerset_others = markerProxy.newSet(  optsgt );
			that.markerset_others.state_initial =optsgt.state;

			if(rdef.tools.markers.options.showPanel && rdef.showothers.when > 0)
			{
				that.markerset_others.markerPanel.$close.hide();
				that.markerset_others.markerPanel.$saveMarkers .hide();
				that.markerset_others.markerPanel.$fileRow.hide();
				that.markerset_others.markerPanel.$toolsRow.children().hide();
				that.markerset_others.markerPanel.$container.off('click');
				that.markerset_others.markerPanel.btns.$visible.show();
				that.markerset_others.markerPanel.$container.css('top', that.markerset_others.markerPanel.$container.position().top + 200);
				
			}

			if(rdef.showothers.when > 0 && rdef.showothers.showmarkerpanel)
				that.markerset_others.markerPanel.show();
				//that.markerset_others.showPanel();
			else
				that.markerset_others.markerPanel.hide();
				//that.markerset_others.hidePanel();

			// the users own markerset 
			var opts = $.extend(true, {}, mtool.options); 
			optsgt.state.zIndex = 20;
			opts.state.keepalive = true;
			that.markerset = markerProxy.newSet( opts );

			if(rdef.tools.markers.options.showPanel)
			{
				that.markerset.showPanel();
				that.markerset.markerPanel.$close.hide();
				that.markerset.markerPanel.$saveMarkers .hide();
				
			}

		}


		/****************************************************
		Overwrite patient click handler	
		What to do?
			- save current case results (ONLY in some edit mode)
			- open case where we clicked on

		****************************************************/	  

		patientTableMirror.tree_single_toggle = function(a,b,c,d)
		{
			if(rdef.reading.allowPatientBrowsing || that.detachedMode)
			{
				var psid = a.split(riddelim);
				var psid = {patients_id:psid[0], studies_id:psid[1]};
				// clicked on a study, or patient in patient mode
				if(rdef.viewer.selectionMode[1] == "s" || (  rdef.viewer.selectionMode[1] == "p" && psid.studies_id == undefined )) 
				{
					// save the case results before selecting next case?
					// can only save is a case was select
					if(ccase.patientinfo.ID != undefined)//that.detachedMode == undefined)
					{
						that.saveCaseResults(psid, that.selectCaseFromAjaxReturn );
					}
					else
					{
						// just select a case, do not save
						that.selectCase(psid);
					}
				}
				else if( rdef.viewer.selectionMode[1] == "p" && psid.studies_id != undefined) // clicked on a study in patient sel mode
				{
					patientTableMirror.tree_single_toggle_default(a, 0, function(){}, 1)
				}
			}
			else
			{
				return false;
			}
		}

		that.readingIsActive = true;
		$newreadingbutton.hide();

		if(that.detachedMode)
			return

		// hide some stuff
 		hideTopMenu();
 		
		$closebtn.hide();
		$("#patientTableTopTools").hide();
		//$("#patientTableEditMode").hide();
 		//$("#KView_toolBarLeft").append( $("<div class='KView_toolbarLeft_disableDIV'></div>")  );
 		if(!rdef.reading.showVerticalToolbar)
 			$("#KView_toolBarLeft").hide();
 		
 		$(".KSearchFieldContainer").append( $("<div class='KView_toolbarTop_disableDIV'></div>")  );

		//if( !rdef.reading.allowPatientBrowsing  )
		if( !rdef.reading.showPatientTable  )
			hidePatientTable();

		
		/****************************************************
		Prepare the state and the viewer		
		****************************************************/	  
		that.oldstate = $.extend(true, {}, state);
		state.viewer = $.extend(true, {}, rdef.viewer);

		// disable autoloaders (we define them directly in the reading)
		state.viewer.enableAutoloaders = false;
		stateManager.applyState(state);
		//$('.leveltab').removeClass('current');		$('#modeSelector_' + state.viewer.selectionMode[1]).addClass('current');
		//switchtoLevel(state.viewer.selectionMode[1]);
		
		/****************************************************
		Clear and set the patient filter	
		****************************************************/	  
		patientTableMirror.deselectAllElements()
		that.oldsearchfields = [];
		var sdivs = $(".KSearchFields");
		for (var k = 0; k < sdivs.length;k++)
		{
			that.oldsearchfields.push( $(sdivs[k]).val() );
			$(sdivs[k]).val("");
		}
		that.oldsearchfields.push( $('#KSearchFieldGeneral').val() );
		
		var SQLCondition = rdef.reading[rdef.currentmode].SQLCondition.trim();
		if( rdef.reading.users && rdef.reading.users[userinfo.username] && rdef.reading.users[userinfo.username].SQLCondition )
			SQLCondition = SQLCondition + " AND " +  rdef.reading.users[userinfo.username].SQLCondition.replace("s.", "ts.");
		if( ( SQLCondition == "1" || SQLCondition =="")  )
			$('#KSearchFieldGeneral').val("");
		else
			$('#KSearchFieldGeneral').val("SQL:" + SQLCondition);


		patientSearch({keyCode:13},undefined, {sortOrder:state.viewer.sortOrder, sortDirection:state.viewer.sortDirection, numberDisplayedItems:state.viewer.numberDisplayedItems} );

	}

	/***************************************************************************************
	Stop / Finish the reading
	****************************************************************************************/
	that.stopReading = function()
	{
		
		
		if(rdef.tools.markers.enabled)
		{
			if(that.markerset != undefined)
				markerProxy.delSet( that.markerset.uuid);
			
			if(that.markerset_others != undefined)
				markerProxy.delSet( that.markerset_others.uuid);

			markerProxy.reset()
		}
		
		// find all markersets created by readingform and close
		var openSets = KForm.findFormItem(rform, "type", "markerset");
		for(var z=0; z<openSets.length; z++)
			markerProxy.delSet(openSets[z])	
		if(openSets.length > 0)
			markerProxy.reset()

		that.readingIsActive = false;

		if (that.timerobj != undefined)
			clearInterval(that.timerobj);


 		showTopMenu();

		patientTableMirror.deselectAllElements();
		$("#patientTableTopTools").show();
		//$("#patientTableEditMode").show();
 		//$(".KView_toolbarLeft_disableDIV").remove();
 		$("#KView_toolBarLeft").show();
 		$(".KView_toolbarTop_disableDIV").remove();
		
		
//		if(!rdef.reading.allowPatientBrowsing)
		if(!rdef.reading.showPatientTable)  //reestablish pt only when was hidden
			showPatientTable();

		// restore the old patient table handler
		patientTableMirror.tree_single_toggle = patientTableMirror.tree_single_toggle_default;


		if(!that.detachedMode)
		{
			if(that.oldstate )
			{
				state = that.oldstate;
				that.oldstate = undefined;

				patientSearch({keyCode:13},undefined, {sortOrder:state.viewer.sortOrder, sortDirection:state.viewer.sortDirection, numberDisplayedItems:state.viewer.numberDisplayedItems} );

				$('.leveltab').removeClass('current');		$('#modeSelector_' + state.viewer.selectionMode[1]).addClass('current');
				stateManager.applyState(state);

			}
			KViewer.closeAll();

		}
		else
		{
			that.buttonsVisible.show();
			that.detachedMode = undefined;
		}

		
		$title.html("");

		// reload everything
		that.updateReadingsList();

		$('#KSearchFieldGeneral').val("");
		var sdivs = $(".KSearchFields");
		if(that.oldsearchfields)
		{
			for (var k = 0; k < sdivs.length;k++)
				$(sdivs[k]).val(that.oldsearchfields[k]);

			$('#KSearchFieldGeneral').val( that.oldsearchfields[that.oldsearchfields.length-1]   );
		}

		rdef = undefined;
		rform = undefined;
		ccase = createEmtpyCase();
		that.ccase = ccase;
		
		$newreadingbutton.show();
		$closebtn.show();

		that.show( lastviewport );

	}

	/***************************************************************************************
	restartReading
	****************************************************************************************/
	that.restartReading = function()
	{
		var obj = 
		{
			project:currentModule,
			rdef:rdef,
			patients_id: "nopid",
			studies_id:  "nosid",
			nextCaseID: "nextunrated",
			whoami: that.state.whoami
		}
		if(obj.whoami.search('#rand#')==0)
			obj.whoami = '#rand#%';
		alertify.confirm('This will delete ALL previous results of user <b>'+ obj.whoami + '</b> in the <b>' + rdef.currentmode.substring(5) +'</b> mode. <br>Are you sure to continue?', function(res)
		{
			if(res)
				ajaxRequest('command=restartReading&json='+ JSON.stringify(obj), that.selectCaseFromAjaxReturn,  scripturl_reading);
		});		
	}





	/***************************************************************************************
	instruction link or window
	****************************************************************************************/
	that.showInstruction = function(id)
	{
		
		if(id != undefined )
			var rrdef = that.forms[id].content.reading.reading;
		else		
			var rrdef = rdef.reading;

		if(rrdef.instruction_link !== undefined && rrdef.instruction_link !== "" ) 
		{
			window.open(rrdef.instruction_link);	
		}
		else
		{
			alertify.alert("There are no instructions for this reading available.");		
		}
	}

	/***************************************************************************************
	Key codes
	****************************************************************************************/
	that.handleKeyEvent = function(evt)
	{
		if(0 & that.detachedMode)
			return false;
			
		var ttype1 = $(document.activeElement).prop('nodeName')
		var ttype2 = $(evt.target).prop('nodeName')
		
		// if we edit something editable, prevent shortcuts!
		if(ttype1 == 'TEXTAREA'  || ttype1 == 'DIV') 
			return;
		
		// return if enter on alertify was triggered
		if($(evt.target).hasClass('alertify-text'))
			return
		
		if(ttype1 == 'INPUT' ||  ttype2 == 'INPUT') 
		{

			var tt = $(document.activeElement).prop('type');
			if(tt == 'text' || tt == 'number')
				return
		}
		
		if(evt.keyCode == 16) //0 shift up only
			return;
		
		var thecode = evt.keyCode;
		//console.log(evt.keyCode);return;
		// shift + numpad results in arrow up down etc
		if( evt.getModifierState('NumLock') &&  evt.shiftKey )
		{
				 if(evt.keyCode == 45) thecode = 48;
			else if(evt.keyCode == 35) thecode = 49;
			else if(evt.keyCode == 40) thecode = 50;
			else if(evt.keyCode == 34) thecode = 51;
			else if(evt.keyCode == 37) thecode = 52;
			else if(evt.keyCode == 12) thecode = 53;
			else if(evt.keyCode == 39) thecode = 54;
			else if(evt.keyCode == 36) thecode = 55;
			else if(evt.keyCode == 38) thecode = 56;
			else if(evt.keyCode == 33) thecode = 57;
		}	
		if(thecode == 40)
			that.gotoCase("next");
		else if(thecode == 38)
			that.gotoCase("prev");
		else if(thecode == 13 || thecode == 32 ) // enter or space bar
			that.gotoCase("nextunrated");
		/*
		else if(thecode == 32) // space bar
			that.gotoFormItem(1);
		else if(thecode == 192) // ^ sign upper left before 1
			that.gotoFormItem(-1);
			*/
		else if( (thecode >= 48 && thecode <= 57) || (thecode>=96 && thecode <= 96+9)  || thecode == 192 ) // any number
		{
			if(thecode<95)
				var num = thecode - 48 ;
			else
				var num = thecode - 96 ;

			if(thecode == 192)
				num=0;
			if(evt.shiftKey || evt.ctrlKey || evt.getModifierState('CapsLock'))
				num+=10;
			//console.log(num);
			that.toggleFormItemByNumber(num);
		}
	}

	/***************************************************************************************
	select next form item codes
	****************************************************************************************/
	that.toggleFormItemByNumber = function(num)
	{
		//$caseForm.find(".KReading_currentFormItem").removeClass("KReading_currentFormItem");
		if(ccase.patientinfo.patients_id == undefined)
			return false; 

		function findItem(layout, offs, objpath)
		{
			if(offs==undefined)
				offs = 0;
			var u = 0;	
			for(var k=0; k<layout.length; k++ )
			{
				if( layout[k].type == 'option' || layout[k].type == 'check' ) 
				{
					if( u+offs == num )
						return {item: layout[k], objpath:objpath};
					u++;
				}
				else if(layout[k].type == 'markerset')
				{
					var ret = findItem(layout[k].layout, k-1, objpath[layout[k].name].markerset) 
					if(ret !== undefined )
						return ret;
				}
			}

		}
		var tempstruct = findItem(rform.layout,0, ccase.results.formcontent )
		//console.log(temp);
		
		if(tempstruct != undefined)
		{
			temp = tempstruct.item;

			ftarget =tempstruct.objpath

			//var $ctarget = $caseForm.find( "[shortcutid='shortcut_" + num +  "']:visible" );
			var $ctargetL = $caseForm.find( "[shortcutid='shortcut_" + num +  "']" );
			var $ctarget
			for(var c=0; c<$ctargetL.length; c++)
			{
				if( $ctargetL.eq(c).is(':visible') )
				{
					$ctarget = $ctargetL.eq(c);
					if(ftarget.points != undefined) // is a markerset 
						ftarget = ftarget.points[c].formcontent

				}	
			}
			
			if($ctarget == undefined)
				return

			//$ctarget.addClass('KReading_currentFormItem');
			var foundOne = 1;
			if(temp.type == "option")
			{
				var $options = $ctarget.find('input');
				var nextItem = 0;
				for(var k=0; k<$options.length; k++)
				{
					if( $options.eq(k).prop('checked')  )
						nextItem = k+1;
					if(nextItem >= $options.length)
						nextItem = -1;
				}
				$options.prop('checked', false)
				if(nextItem >=0)
				{
					$options.eq(nextItem).prop('checked', true)
					ftarget[temp.name]  = temp.ids[nextItem];
					$ctarget = $options.eq(nextItem);
				}
				else
				{
					ftarget[temp.name]  = "";
					$ctarget = $options.eq(0);
					foundOne = 0;
				}
			}
			else if(temp.type == "check")
			{
				var $options = $ctarget.find('input');
				var newstate = $options.eq(0).prop("checked")?0:1;
				$options.eq(0).prop("checked", newstate);
				ftarget[temp.name]  = newstate;
				$ctarget = $options.eq(0);
			}

			var $blinker = $("<div class='KReading_ItemBlinker'></div>").appendTo(document.body);
			if(!foundOne)
				$blinker.css('border-color', 'white');
				
			var pp = $ctarget.offset();
			//console.log(pp);
			$blinker.offset( $blinker.css({'top': pp.top , 'left': pp.left }) );
// 			if(ccase.results.formcontent[temp.name] != "" || ( temp.type == "check" &&  ccase.results.formcontent[temp.name] === true) )
// 				$blinker.css('border-color','darkgreen');	
			$blinker.animate({width: 100, height: 100, opacity:0.2}, 500, function(){$blinker.remove()} )


		}
	}

	/***************************************************************************************
	select next form item codes
	****************************************************************************************/
	that.gotoFormItem = function(dir)
	{
		$caseForm.find(".KReading_currentFormItem").removeClass("KReading_currentFormItem");
		var nextitem = that.currentFormItem+dir*0;
		if(nextitem + dir > rform.layout.length || nextitem + dir < 0)
			return false;
		
		var wasfound = false;
		for(var c=0; math.abs(c)<rform.layout.length; c+=dir)
		{
			if(rform.layout[nextitem + c])
			{
				nextitem += dir;
				if(rform.layout[nextitem] == undefined)
					break;
				var ttt = rform.layout[nextitem].type;
				if(ttt == 'option' || ttt == "check")
				{
					wasfound = true;
					break;
				}
			}
		}
		if(nextitem < 0 )
			nextitem = 0;
		if(nextitem > rform.layout.length-1 )
			nextitem = rform.layout.length;
 		
 		that.currentFormItem  = nextitem;

		if(rform.layout[nextitem] == undefined || !wasfound)
			return false;
				
			
		var name = rform.layout[nextitem].name;
		//var ids = rform.layout[nextitem].ids;
		if(1)//ids != undefined)
		{
			//console.log(ids);
			var $ctarget = $caseForm.find( "[name='" + rform.layout[nextitem].name +  "']" );
			$ctarget.addClass('KReading_currentFormItem');

		}
		
	}

	/***************************************************************************************
	Misc functions
	****************************************************************************************/
	that.resize = function(hei)
	{
		that.$container.height(hei);
	}
  

	/***************************************************************************************
	Get the summary
	****************************************************************************************/
	that.getResultsSummary = function(obj_, formid)
	{
		var resultsdialog = new dialog_generic();
		resultsdialog.$frame.width(1250).offset({left:0, top:0} );
		resultsdialog.$menu.append( $("<li><a> <i class='fa fa-reload' ></i></a>reload</li>").click(loadContent ));
		resultsdialog.$menu.append( $("<li><a> <i class='fa fa-download' ></i></a>downloadcsv</li>").click(downloadresults ));
		var results_csv_string;
		var obj = {
			formid:formid,
			project:obj_.content.project
		};

		function loadContent()
		{		
				resultsdialog.$container.empty();
				ajaxRequest('command=createSummaryTable&json='+ JSON.stringify(obj), whendone,  scripturl_reading);
		}

		function downloadresults()
		{
			if(results_csv_string)
			{
				var filename = "reading_" + obj.project + "_";
					filename+= new Date().toISOString().replace(/-/g, '').replace(/T/g, '-').replace(/:/g, '').substring(0,15);
				downloadString(results_csv_string, "text/csv", filename + ".csv")
			}

			function downloadString(text, fileType, fileName) 
			{
			  var blob = new Blob([text], { type: fileType });

			  var a = document.createElement('a');
			  a.download = fileName;
			  a.href = URL.createObjectURL(blob);
			  a.dataset.downloadurl = [fileType, a.download, a.href].join(':');
			  a.style.display = "none";
			  document.body.appendChild(a);
			  a.click();
			  document.body.removeChild(a);
			  setTimeout(function() { URL.revokeObjectURL(a.href); }, 1500);
			}	
		}

		function whendone(res)
		{
			results_csv_string = undefined;
			if(res.json)
			{
			
				

				if(res.json.csv)
				{
					popupView({content:res.json.csv,contentType:"tab"},{intent:{singleview:true}})
				}
				
				if (0)
				{
					results_csv_string =res.json.csv;

					var rows = res.json.csv.split('\n');
					resultsdialog.$frame.show();
					var $rtable = $("<table class='localfiletable KReading_resultsTable'></table>").appendTo(resultsdialog.$container);
					var $thead = $("<thead></thead>").appendTo($rtable);
					var $tbody = $("<tbody></tbody>").appendTo($rtable);

					// render header
					var $row = $("<tr></tr>").appendTo($thead);
					var trow = rows[0].split(';');
					for(var t=0; t<trow.length; t++)
					{
						$("<td>"+ trow[t] + "</td>").appendTo($row);
					}

					for(var k=1; k<rows.length; k++)
					{
						var $row = $("<tr></tr>").appendTo($tbody);
						var trow = rows[k].split(';');
						for(var t=0; t<trow.length; t++)
						{
								$("<td>"+ trow[t] + "</td>").appendTo($row);
						}
					}
					attachTableOperator($rtable, undefined, true);

				}

			}

		}
		loadContent();

	}



	/***************************************************************************************
	Developement / debug
	****************************************************************************************/
	// create a template reading (debug:)
	that.devtool = function()
	{
		that.startReading();
	}

	// that.resize(500);
	// that.show();
	that.updateReadingsList();

	return that;
}











/***************************************************************************************
The generic readingDefinition
****************************************************************************************/
function KReadingTool_templateDefintion()
{

    var reading =
       {
		   description :  "blabla",
		   showPatientTable: 1,
		   allowPatientBrowsing:0,
		   showVerticalToolbar:0,	
		   allowRestartOfTraining: 1,
		   allowRestartOfSerious: 0,
		   viewport:-2, // -2 is patientTable
		   instruction_link:"",
		   jointreading:0,

		   mode_serious:
		   {
				 enabled:true,
				 stage:0,
				 numStages: 1,
				 randomize:"none",
				 numOfPatientsWithRepetitions:110,
				 numRepetitionsForPatientsWithRepetitions:1,

				 showSexAndAge:'sex_and_age',
				 showName:1,
				 show_timer:1,
		   		 required_flag:-1,

				 showothers:
				 {
				 	when: 0, // 0: never,  1 == immediately, 2 == after resolve button
				 	users:"%",
				 	showforms:true,
				 	showannotations:true,
				 	showmarkerpanel:true,
				 	//rois:true,

				 },

				 SQLCondition: " 1 ",

		   },
		   // will be extended, all variables from mode_serious are also there 
		   mode_training:
		   {
				 enabled:true,
				 randomize: "none",
				 numOfPatientsWithRepetitions:0,
		   		 required_flag:-1,
				 SQLCondition: " STAG LIKE '%Training%'   "
		   }
       };


     
    var readingform =
    { 
      tag: "FORM",
      name : "my first reading form  #666",
      editor : "mr. X",
      lastchange : "jan2016",
      layout:
      [ 
		  { type: 'formarray',  name:"otherarray", title:'mysubform', createbutton:'Add new markerpoint',  
			 layout: 
			 [
			   { type: 'markerpoint',  name:"mypoint", title: "",
				 /*
				 'form':{ 
				   name:"pointreading", title:'mysubform',
				   layout:[
							{type: 'option', name:"myoption",  title: "some option", 
							style:"radio vert", 
							tooltip:"here give some help",
							choices: ["sure","not so sure", "maybe"], 
							ids: ["0","1","2"] , 
							defaultval:"" 
							}
					  ]
				 }
				 */

			   }							    
			 ]
		  },

          { type: '__markerpoint',  name:"superpoint",   title: "Markerpoint fixed" },
          { type: 'option', name:"myoption",  title: "some option", 
			  style:"radio", 
			  tooltip:"here give some help",
			  choices: ["never","always", "maybe"], 
			  ids: ["0","1","2"] , 
			  defaultval:"1" },
/*
          { type: 'rating',  name:"myrate",   title: "tumor grading", 
                          ratings:['low','med','high','severe'],                                 
                          items:['CC','IFO','AF','OR','SLF'],
                          defaultval:['low','low','med','high','severe']},
                          */
          { type: 'separator'},
          { type: 'placeholder', id: "markers" },
          { type: 'input',  name:"myinput",   title: "some text",   defaultval: "good"}
       ]
    } 


	//////////////////////////// a form example form markers
	var  tools =
	{
		 rois: 
		 {
		   tumor: 0,
		 },
		 markers: 
		 {
		   enabled:0,	
		   options:
		   {
				showPanel:true,
				type:'circles',
				state:
				{
					locked: false,
					createonclick : true,
					cyclecolors   : true,
					defaultradius : 5,
					delSetOnPanelClose: false,
					pointROIthresh: 300,
					showThroughSlice:true,
					hoverdetails: false,
					showOnAllImages:false,
					showresizer:true,
				},
				__templates : 
				{
					Eins:{color:'#AA0000', radius:40},	
					Zwei:{color:'#00AA00', radius:40},
				},				
		   },
		   form:undefined,
		   tastkdesc: "Please draw 6 markers indicating blabla",
		 }
	};

    //////////////////////////// a form example form markers
    var markerform =
    { 
      tag: "FORM",
      layout:
      [ 
             { type: 'option', name:"myoption",  title: "some option", 
                          style:"radio vert", 
                          tooltip:"here give some help",
                          choices: ["sure","not so sure", "maybe"], 
                          ids: ["0","1","2"] , 
                          defaultval:"" },

      ]
    };
    //tools.markers.form = markerform;



   	var viewer = $.extend({}, true, state.viewer);
    var template = 
    {
    	reading: reading,
    	//readingform:  readingform,
    	tools: tools,
    	viewer : viewer,

    
    }
    

    return template;
}














/***************************************************************************************
css beautify
****************************************************************************************/
/*
	here was css_beautify code
	was unused, check in old git if needed again	
*/ 




/***************************************************************************************
KFormDesigner: A popup window to design forms
****************************************************************************************/
function KFormDesigner( form )
{
	// this tool can manage and edit
	//	Form
	//  Reading (= forms + some extras like autoloaders ...)
	var thistype = 'reading';
	//var thistype = 'form';

	// type = 'reading';
	// type = 'form';

	var content = form.content;
 
	var that = new dialog_generic();
	that.$frame.width(1050).offset({left:0, top:0} );

	that.$frame.show();

	/***************************************************************************************
	The editor + preview view
	****************************************************************************************/
	var $dummy = $("<div class='KListView'></div>").appendTo(that.$container)
	that.$editContainer = $("<div style='min-width:50%	;' class=''></div>").appendTo($dummy);
	that.$previewContainer = $("<div class='' style='position:relative'></div>").appendTo($dummy);
	that.$previewContainerInner = $("<div style='padding:10px'>Form Preview</div>").appendTo(that.$previewContainer);
	var $leftresizer = $("<div class='resizer_vertical'><div><div></div></div></div>").appendTo(that.$previewContainer).mousedown(resizeSplitter);
	function resizeSplitter(ev)
	{
		ev.preventDefault();
    	var x = ev.clientX;

    	var $target  = that.$editContainer;
		var w = $target.width();

	    $body.on("mouseup mouseleave",   mymouseup);
  		$body.on("mousemove", moveUnlagger(mymousemove)) ;
		function mymousemove(ev)
		{
			   var nx =  ev.clientX;
			   var neww = w-(x - nx)
			   if (neww > 100)
			   	$target.width(w- (x - nx));
		}

		function mymouseup(ev)
		{
			$body.off("mousemove mouseup mouseleave");
			ev.preventDefault();
		}
	}

 	that.$container = that.$editContainer;
  
	/***************************************************************************************
	The main dialog
	****************************************************************************************/


 // that.$menu.append( $("<li><a> <i class='fa fa-play' ></i></a></li>").click( ));
	var title = "Form Designer";
	var $filemenuli = $("<li class='inactive'><a>"+title+"</a></li>").appendTo(that.$menu);

	/***************************************************************************************
	
	****************************************************************************************/
	var TList = undefined;  // the inner tabber
	var PList = undefined;	// the template list on left side
	var MList = undefined;
	var jsoneditor = undefined;
	var templates = KForm.templates();


		
	/***************************************************************************************
	renderTemplateList
	****************************************************************************************/
	function renderTemplateList()
	{	
		PList = PList || new KList({ classes:["vertical", "classic" ,"inverted"] });
		PList.clear();
		$("<div class='placeholder small' style='text-align:center;font-size:17px;padding:3px;'> Template Elements </div>")
		.click( function(){copyElement()}).appendTo(PList.$ul);

		PList.$ul.appendTo( that.$listDIV );
		for(var id in templates)
		{
			var $e = PList.append(id, id, undefined, function(id){return function(){template_copyCode(id)}}(id));
			$("<span class='flexright'></span>").appendTo($e)
				.append($("<i class='fa fa-arrow-right'></i>").click( function(id){return function(ev){template_pasteCode(id); ev.stopPropagation();}}(id) )) ;
			
		}
	}


	/***************************************************************************************
	renderMainDialog
	****************************************************************************************/
	function renderMainDialog()
	{

		var $innerContainer = $("<div class='KListView'></div>");
		var $listDIV = $("<div></div>").appendTo($innerContainer);
		that.$listDIV = $listDIV;
		var $rightDIV = $("<div class='KFlexVertical'></div>").appendTo($innerContainer);

		// title and so on
		var $tDIV = $("<div style='background:hsl(0, 0%,16%);display:flex;flex-wrap:wrap;'></div>").appendTo($rightDIV);
		if(1)
		{	var $tools = $("<div class='modernbuttongroup' style=''></div>").appendTo($tDIV);
			var $nametab = $("<div class='' style='padding:15px; font-size:18px; font-weight:bold'></div>").appendTo($tools);
			var $name = $("<span>"+ form.content.name +"<span>").appendTo($nametab);
			var $modified = $("<span>" + (form.modified===true?"*":"") + "<span>").appendTo($nametab);
			
			var $temp = $("<span style='font-size:15px'> ( id " + form.content.id +")<span>").appendTo($nametab);

			makeEditableOnDoubleClick($name, function()
			{ 
				form.content.name = $name.text().replace("\n", "");
				renderInnerContent(); 
			});
		}
		if (1)
		{
		
			var $delete = $("<div class='modernbutton small red'><i class='fa fa-trash'></i>delete</div>").appendTo($tools).click( function(){deleteObject()}  );
			var $save   = $("<div class='modernbutton small green'><i class='fa fa-save'></i>save</div>").appendTo($tools).click( function(){saveObject()}  );
		}
		//var $cDIV = $("<div  class='KListView_vertical'></div>").appendTo($rightDIV);

		
		// the editor content
		var $cDIVupper = $("<div style='background:hsl(0, 0%,16%);' class=''></div>").appendTo($rightDIV);
		var $cDIVLower = $("<div class='' style='position:relative;'></div>").appendTo($rightDIV);



		/////// viewer List and so on
		TList = TList || KList({ $targetcontainer:$cDIVLower, classes:["horizontal", "roundish"]   });
		TList.activeID = TList.activeID || "layout";
		TList.settarget($cDIVLower)
		TList.clear();
		TList.$ul.appendTo( $cDIVupper );

		/*****************  the general tab *****************/
		var tab_general = 
		{ 
			name 		: "general",
			layout: 
			[
			 { type: 'title', val: "General Properties of this form"}
				,{name:"name"  					, type: 'input',     defaultval:"untitled"  }
				,{name:"project"				, type: 'input',     defaultval:""  }
				,{name:"rights"   	    , type: 'option',  style:"radio vert", ids:[ "--","r-","rw"],  choices: ["private", "readable", "read/writable" ]}
				
			]
		}


		TList.append('general', 	'general', 	 renderInnerContent);
		TList.append('layout', 		'form', 	 renderInnerContent);
		
		if(thistype == 'reading')
		{
 			TList.append('reading',  	'reading', renderInnerContent  );
 			TList.append('reading_template',  	'reading_template', renderInnerContent  );
			TList.append('readers', 	'readers', 	renderInnerContent);
		}
		TList.updateOrSelectByID('layout');


		function renderInnerContent(tabid)
		{
			// the 100 percents are important here
			var $formDIV = $("<div class='' style='position:absolute;width:100%;height:100%;'></div>");
			if(tabid == "general")
			{
				 (KForm.createForm(tab_general, form.content, $formDIV, function(){form.modified=true;}) );
			}
			else if(tabid == "layout")
			{
				var $preview= $("<div class='modernbutton small green' style='position:absolute;top:0;right:10px'> preview <i class='fa fa-arrow-right'></i></div>")
					.click(function(){ jsoneditor.JSONparse(); that.previewForm(); }).appendTo($formDIV);
				 jsoneditor = new KJSONEditor(form.content, tabid,  { parseonblur:false });
				 $formDIV.append(jsoneditor.$container);
			}
			else if(tabid == "reading")
			{
				 if( form.content.reading == undefined)
				 	form.content.reading = {};

				 jsoneditor = new KJSONEditor(form.content, tabid,  { parseonblur:true });
				 $formDIV.append(jsoneditor.$container);
			}
			else if(tabid == "reading_template")
			{
				 var ttt = {ttt: KReadingTool_templateDefintion()};
				 
				 jsoneditor = new KJSONEditor(ttt, 'ttt',  { parseonblur:false });
				 $formDIV.append(jsoneditor.$container);
			}
			return $formDIV;
		}

  	   that.$container.empty().append( $innerContainer );		
	   renderTemplateList();
	}
	/***************************************************************************************
	END OF renderPresetDialog
	****************************************************************************************/
    



	/***************************************************************************************
	Interpret and check the reading Definition locally in preview container
	****************************************************************************************/
	that.previewForm = function()
	{
	  var temp = KForm.getFormContent(form.content);
	  that.$previewContainerInner.empty();
	  var $formdiv = KForm.createForm(form.content, temp, that.$previewContainerInner, undefined, true);
	  form.modified = true;
	}

 

	/***************************************************************************************
	saveObjectOnClick
	****************************************************************************************/
	function saveObjectOnClick(saveas)
	{
		if(saveas)
		{
			copyElement(activePreset);
		}
		else
		{
			saveObject(form)
		}	
	}

	/***************************************************************************************
	saveObject
	****************************************************************************************/
	function saveObject(whendone)
	{
		if(form.id == "0")
			return;
	// 		if(!form.modified)
	// 			return	

		// verify json 
		if(jsoneditor)
		{
			if(!jsoneditor.JSONparse())
			{
				alertify.error("Your json could not be parsed, it must be valid before saving.")
				return false;
			}
		}
		function whendone(result)
		{
			if(result.msg=='')
			{
				alertify.success("Saved successfully.");
				form.modified = false;

				// this should be in manager ...?
				KViewer.formManager.update();

			}
		}
		// if this is reading, tag as reading
		if(form.content.reading !=undefined && Object.getOwnPropertyNames(form.content.reading).length > 0)
		{
			form.content.tag = 'READING';

			// For the reading: we must fix / disallow the working mode and sorting settings, some are not compatible
			//form.content.reading.viewer.selectionMode[0] = "w";
			//form.content.reading.viewer.selectionMode[1] = "s";
			//form.content.reading.viewer.sortOrder     = "PIZ";
			//form.content.reading.viewer.sortDirection = "ASC";

			
		}
// 		if(form.content.rights == "readable")
// 			form.content.rights = "r-";
// 		if(form.content.rights == "writable")
// 			form.content.rights = "r-";

		jsonTable_save({ type:form.type, id: form.id, json:form.content } , whendone);

	} 

	/***************************************************************************************
	deleteObject
	****************************************************************************************/
	function deleteObject(id)
	{
		if(id == "0")
			return;
		jsonTable_delete( {id:form.id}, whendone);

		function whendone(result) 
		{
			if(result.msg=='')
			{
				alertify.success("Object deleted.");
				that.$frame.remove();

				// this should be in manager ...?
				var l = KViewer.formManager.forms;
				for(var k=0;k<l.length;k++)
					if(l[k].id == form.id)
						l.splice(k,1);
				KViewer.formManager.update();
					
			}
			else
			{
				alertify.error("Could not delete Object in jsonTable");
			}
		}
	}

	/***************************************************************************************
	Templates
	****************************************************************************************/
	function template_copyCode(id)
	{
		if(jsoneditor == undefined || jsoneditor.$textarea == undefined)
			return;
		var $ta = jsoneditor.$textarea;
		var ta = $ta.get(0);
		var s = ta.selectionEnd || 0;

		var str  = "\n " + myJSONStringify( templates[id] ) + "\n";
		// must copy text with a virtual textarea
		var $temp = $("<textarea style='position:absolute; display:block;'>"+str+"</textarea>").appendTo($body).select();
		var successful = document.execCommand('copy');
		$temp.remove();
		var $notification = $("<div style='position:absolute;color:green'>code copied to clipboard. Use ctrl+v to paste.</div>").appendTo(jsoneditor.$log.empty());
		window.setTimeout(function(){ $notification.fadeOut(900, function(){$notification.remove()})}, 800);

		$ta.focus();
		ta.selectionStart = s;
		ta.selectionEnd = s; 

		// could also paste the text directly (see below, but then ctrl+z does not work.
	}

	function template_pasteCode(id)
	{
		var templates = KForm.templates();
		var str  = "" + myJSONStringify( templates[id] ) + "";
		jsoneditor.pasteText(str, 1);

	}

	// custom toggler here
	that.ontoggle = function()
	{
		if(form.modified)
		{
			alertify.confirm("There might be unsaved changes in your form. <br> If you want to save them press 'cancel' and save manually.", function(a)
			{
				if(!a) 
					return false
				else 
					that.$frame.remove();	
			});
		}
		else
		{
			that.$frame.remove();
		}
		return false;
	}

	/***************************************************************************************
	Load Items on creation
	****************************************************************************************/
	renderMainDialog();

	return that;

}
//********************* END OF KFormDesigner ********************************
