<?php 
$html = renderMain();

echo $html;


function renderMain()
{
  $instances = array();

  // custom settings for this instance selector
  $custom = array();
  
  $custom['title'] = "Welcome to NORA, the medical imaging platform";
  $custom['subtitle'] = "";
  $custom['css'] = "";


  require_once('./instances.php');

  $html =
    "<!DOCTYPE html      PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'     'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml'>
    <head>
        <title> Nora - Uniklinik Freiburg </title>
        <link rel='icon' href='favicon.ico' >    
        <meta http-equiv='Content-Style-Type' content='text/css' />
        <link rel='stylesheet' href='styles.css' type='text/css' />
        
        <style>$custom[css]</style>
        

        <link rel='stylesheet' href='font-awesome-4.5.0/css/font-awesome.min.css' type='text/css'/>
    </head>

    <body>";

   $html .= " <div id='frame'>";

       $html .= "<div class='topRow'>
                    <div><img style='height:35px' src='logo_inverted.svg'/></div>
                    <div>UNIKLINIK FREIBURG</div>
                    <div><img class = 'institutionlogo' src='logo_ukl.png'/></div>
                 </div> 
                    ";

       $html .= "<div class=''>
                    <div>
                    <!--         <img src='./logo.svg' height=200 />  -->

                    <br>
                    <h3>". $custom['title'] . "</h3>
                      Please select your server / application. 
                        <hrrr />
                    </div>
                 </div> 
                    ";
      // ---------------------------------  
      $html .= " <div id='container'>";
              $html .= " <div class ='instancebox'>";

                foreach($instances as $i)
                {
                    $path =  basename(dirname($_SERVER['PHP_SELF']))  . '/' .   $i['id'] . '/' ;
                    if( substr($i['id'],0,4) == "http" )
                      $html .= "<a href='$i[id]/$i[add]'>";
                    else
                      $html .= "<a href='http://$_SERVER[HTTP_HOST]/$i[id]/$i[add]'>";

                    $html .=  "<div class='instanceelement '>  
                          <div class='icon $i[cssclass]'></div>  
                          <div><h2> $i[title]</h2></div>
                          <div> $i[descr]</div>   
                          <div class='url'> $i[url]$i[add]</div>   
                       </div>
                    </a>";
                }
            $html .= "</div>"; // instancebox

        $html .= "</div>";  // container


    $html .= " </div>"; //frame





$html .= "</body></html>   ";


return $html;
}


?>