// Modules to control application life and create native browser window
const {app, BrowserWindow, Menu,ipcMain} = require('electron')

// Keep a global reference of the window object, if you don't, the window will
// be closed automatically when the JavaScript object is garbage collected.
var mainWindow

function createWindow () {
  // Create the browser window.
  mainWindow = new BrowserWindow({width: 800, height: 600,icon: __dirname+'/norasicon.png',
  webPreferences: {nodeIntegration:true}})



  // Open the DevTools.
   //mainWindow.webContents.openDevTools()

 // global.sharedObject = {args: process.argv, scriptdir:__dirname}


    var spawn = require( 'child_process' ).spawn;
    
    ants = spawn('php'  , ['-S','localhost:8989'], {cwd:__dirname} );

    ants.stdout.on( 'data', data => {
                        
                    console.log(data.toString("utf8"));
    } );

    ants.stderr.on( 'data', data => {
                console.log(data.toString("utf8"));
    } );

    ants.on( 'close', code => {
                console.log("Done with code " + code + "!!");
    } );
            
   setTimeout(function() { mainWindow.loadURL("http://localhost:8989") },100);
            
            

  // Emitted when the window is closed.
  mainWindow.on('closed', function () {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    mainWindow = null
  })
}

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.on('ready', createWindow)

// Quit when all windows are closed.
app.on('window-all-closed', function () {
  // On macOS it is common for applications and their menu bar
  // to stay active until the user quits explicitly with Cmd + Q
  if (process.platform !== 'darwin') {
    app.quit()
  }
})

app.on('activate', function () {
  // On macOS it's common to re-create a window in the app when the
  // dock icon is clicked and there are no other windows open.
  if (mainWindow === null) {
    createWindow()
  }
})

// In this file you can include the rest of your app's specific main process
// code. You can also put them in separate files and require them here.




app.on('will-quit', function() {
  if (ants != undefined)
  	ants.kill();

  console.log('will quit !');
  event.preventDefault();
  
});

buildMenu();

function buildMenu(event, arg) {


var template = [
    {
      label: 'File',
      submenu: [
        {
          label: 'Load Files',
          click() { mainWindow.webContents.send('loadfiles'); }
        },
        {
          label: 'Load Folders',
          click() { mainWindow.webContents.send('loaddirs'); }
        },
        {
          label: 'Recent',
          submenu: [
            {
              label: 'Load Files',
              click() { mainWindow.webContents.send('loadfiles'); }
            } ]
        },
        {
          label: 'Save workstate',
          accelerator: 'Ctrl+S',
          click() { mainWindow.webContents.send('saveworkstate'); }
        },
        { type: 'separator' },
        {
          label: 'Settings',
          click() { mainWindow.webContents.send('settings'); }
        },
        {
          label: 'Toggle Fullscreen',
          accelerator: 'F11',
          click() {
                    mainWindow.setFullScreen(!mainWindow.isFullScreen());
                  }
        },
        {
          label: 'Toggle Devtools',
          accelerator: 'Ctrl+Shift+J',
          click() {
              mainWindow.webContents.toggleDevTools();
          }
        },
        { type: 'separator' },
        {
          label: 'Restart view',
          accelerator: 'F5',
          click() {
              mainWindow.reload();
          }
        },
        {
          label: 'Quit',
          click() {
              app.quit();
          }
        }
      ]
    }
  ];


let resetMenu = Menu.buildFromTemplate(template);
Menu.setApplicationMenu(resetMenu);



}



